set define off

create or replace package body byte_code_maint as

rpt_title$	constant varchar2(200) := 'Byte Code Maintenance';

-- *********************************************************************************************************
-- *********************************************************************************************************

procedure save (code varchar2, html varchar2, usr varchar2, gif varchar2, spires varchar2) is

begin

   common.get_gbl_pid;

   if common.common.valid_role (common.conf_admin$) then
      update	byte_codes
      set	html_code	= html,
		user_code	= usr,
		gif_file	= gif,
		spires_code	= spires
      where	byte_code	= code;

      common.redirect_URL ('byte_code_maint.html');
   end if;

end save;

-- *********************************************************************************************************
-- *********************************************************************************************************

procedure upd (code integer) is

cursor	driver is
select	*
from	byte_codes
where	byte_code = code;

driver_rec	driver%ROWTYPE;

begin

   common.get_gbl_pid;

   if common.common.valid_role (common.conf_admin$) then
      open driver;
      fetch driver into driver_rec;
      close driver;

      common.header (rpt_title$);
      htp.formOpen ('byte_code_maint.save', 'POST');
      htp.formHidden ('code', code);
      htp.tableOpen;

      common.show_data_row ('Byte Code',	driver_rec.byte_code);
      common.show_data_row ('HTML Code',	htf.formText ('html', 20, 20, htf.escape_sc (driver_rec.html_code))
							|| driver_rec.html_code);
      common.show_data_row ('User Code',	htf.formText ('usr', 20, 20, driver_rec.user_code));
      common.show_data_row ('GIF File',		htf.formText ('gif', 20, 20, driver_rec.gif_file)
							|| htf.img (common.graphics_folder$ || driver_rec.gif_file));
      common.show_data_row (null,		'Note: Filenames are case sensitive on UNIX systems.');
      common.show_data_row ('SPIRES Code',	htf.formText ('spires', 20, 20, driver_rec.spires_code));

      common.show_data_row (null,	htf.formSubmit);
      htp.tableClose;
      htp.formClose;
      common.footer;
   end if;

end upd;

-- *********************************************************************************************************
-- *********************************************************************************************************

procedure html is

cursor	driver is
select	*
from	byte_codes
order by byte_code;


begin

   common.get_gbl_pid;

   if common.common.valid_role (common.conf_admin$) then
      common.header (rpt_title$);
      htp.para;

      htp.tableOpen ('BORDER');
      htp.tableHeader ('Byte Code');
      htp.tableHeader ('HTML Code', ccolspan=>'2');
      htp.tableHeader ('User Code');
      htp.tableHeader ('GIF File', ccolspan=>'2');
      htp.tableHeader ('Spires Code');
      htp.tableRowClose;

      for driver_rec in driver LOOP
         htp.tableRowOpen ('LEFT', 'TOP');
         htp.tableData (htf.anchor ('byte_code_maint.upd?code=' || driver_rec.byte_code,
				driver_rec.byte_code));
         htp.tableData (htf.escape_sc (driver_rec.html_code));
         htp.tableData (driver_rec.html_code, 'CENTER');
         htp.tableData (driver_rec.user_code);
         htp.tableData (driver_rec.gif_file);
         htp.tableData (htf.img (common.graphics_folder$ || driver_rec.gif_file));
         htp.tableData (driver_rec.spires_code);
         htp.tableRowClose;
      end loop;

      htp.tableClose;
      common.footer;
   end if;

end html;

-- ****************************************************************************************

end byte_code_maint;
/
show error

set define on

--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
