create or replace package body charts as

i	integer;
Q$	char(1) := chr(34);

-- **************************************************************************************************

procedure JS_chart(chart chart_type) is

sep	varchar2(2) := ',';

begin

   htp.p('function ' || chart.name || '() {');
   htp.p('');
   htp.p('   var data = new google.visualization.DataTable();');
   htp.p('   data.addColumn("string", ' || Q$ || chart.cols.name  || Q$ || ');');
   htp.p('   data.addColumn("number", ' || Q$ || chart.cols.value || Q$ || ');');

   htp.p('   data.addRows([');
   for i in 1..chart.rows.COUNT loop
      htp.p('      [' || Q$ || chart.rows(i).name || Q$ || ', ' || chart.rows(i).value || '],');
   end loop;
   htp.p('      ]);');

   htp.p('');
   htp.p('   var options = {');
   for i in 1..chart.options.COUNT loop
      if i = chart.options.COUNT then
         sep := '};';
      end if;

      htp.p('               '	|| chart.options(i).name	|| ':'
				|| chart.options(i).value	|| sep);
   end loop;

   htp.p('');
   htp.p('   var chart = new google.visualization.PieChart(document.getElementById(' ||
			Q$ || chart.DOM_ID || Q$ || '));');
   htp.p('   chart.draw(data, options);');
   htp.p('}');
   htp.p('');

end JS_chart;

-- **************************************************************************************************

function chart_total_zero(rows numb_collection_type) return boolean is

begin

   for i in 1..rows.COUNT loop
      if rows(i).value > 0 then
         return false;
      end if;
   end loop;

   return true;

end chart_total_zero;

-- **************************************************************************************************

procedure JS is

begin

   htp.p('<script type="text/javascript">');
   htp.p('google.charts.load("current", {"packages":["corechart"]});');

   chart_name := chart.FIRST;
   LOOP
      exit when chart_name is null;

      if NOT chart_total_zero(chart(chart_name).rows) then
         htp.p('');
         htp.p('google.charts.setOnLoadCallback(' || chart_name || ');');
         htp.p('');
         JS_chart(chart(chart_name));
      end if;

      chart_name := chart.NEXT(chart_name);
   end loop;

   htp.p('</script>');

end JS;

-- **************************************************************************************************

function header(this_title	varchar2,
		js_src		common.ident_arr default common.mt_ident_arr$,
		css_src		common.ident_arr default common.mt_ident_arr$)
		return boolean is

java_scripts	common.ident_arr := js_src;

begin

   common.get_gbl_pid;

   java_scripts(java_scripts.COUNT+1) := 'https://www.gstatic.com/charts/loader.js';
   if common.has_privs_to_page then
      common.public_header (this_title, false, false, java_scripts, 0, css_src);
      JS;
      htp.headClose;
      common.header_body_open(this_title, false, null, null);
      return true;
   end if;

   return false;
end header;

-- **************************************************************************************************
-- **************************************************************************************************

procedure init_chart(chart_name varchar2, DOM_ID varchar2) is

begin

   chart(chart_name).name	:= chart_name;
   chart(chart_name).DOM_ID	:= DOM_ID;

end init_chart;

-- **************************************************************************************************

procedure add_option(chart_name varchar2, name varchar2, value varchar2) is

begin

   i := chart(chart_name).options.COUNT + 1;
   chart(chart_name).options(i).name	:= name;
   chart(chart_name).options(i).value	:= value;

end add_option;

-- **************************************************************************************************

procedure add_row(chart_name varchar2, label varchar2, value number) is

value2	number := NVL(value,0);

begin

   if value2 < 0 then
      value2 := 0;
   end if;

   i := chart(chart_name).rows.COUNT + 1;
   chart(chart_name).rows(i).name  := label;
   chart(chart_name).rows(i).value := value2;

end add_row;

-- **************************************************************************************************

procedure add_column(chart_name varchar2, group_name varchar2, value_name varchar2) is


begin

   chart(chart_name).cols.name  := group_name;
   chart(chart_name).cols.value := value_name;

end add_column;

-- **************************************************************************************************
-- **************************************************************************************************
procedure test is

begin

   init_chart('TestChart1', 'chart1_div');

   add_option('TestChart1', 'width',		'225');
   add_option('TestChart1', 'height',		'225');
   add_option('TestChart1', 'colors',		'["RED","YELLOW","GREEN"]');
   add_option('TestChart1', 'pieSliceText',	'"none"');
   add_option('TestChart1', 'is3D',		'true');
   add_option('TestChart1', 'legend',		'{position:"none"}');

   add_column('TestChart1', 'Status', 'Papers');
   add_row('TestChart1', 'Red', 10);
   add_row('TestChart1', 'Yellow', 20);
   add_row('TestChart1', 'Green', 30);

   if header('Chart Test') then
      htp.p('<div id="chart1_div"></div>');
      common.footer;
   end if;

end test;

-- **************************************************************************************************

end charts;
/
show error
