create or replace package charts as

chart_name	varchar2(50);

type	char_rec_type is record (
		name	varchar2(50),
		value	varchar2(500) );		
type	char_collection_type is table of char_rec_type index by pls_integer;

type	numb_rec_type is record (
		name	varchar2(50),
		value	number );		
type	numb_collection_type is table of numb_rec_type index by pls_integer;

type	chart_type is record (
		name		chart_name%TYPE,
		DOM_ID		varchar2(50),
                options		char_collection_type,
		cols		char_rec_type,
		rows		numb_collection_type );

type	chart_types is table of chart_type index by chart_name%TYPE;

chart	chart_types;

-- ************************************************************************************************

procedure test;

procedure init_chart (chart_name varchar2, DOM_ID varchar2);
procedure add_option(chart_name varchar2, name varchar2, value varchar2);
procedure add_row(chart_name varchar2, label varchar2, value number);
procedure add_column(chart_name varchar2, group_name varchar2, value_name varchar2);

function header(this_title	varchar2,
		js_src		common.ident_arr default common.mt_ident_arr$,
		css_src		common.ident_arr default common.mt_ident_arr$)
		return boolean;

end charts;
/
show error
