--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

set define off

create or Replace PACKAGE common as

   gbl_pid		integer			:= null; -- set at login time and in every call to header
   gbl_priv_pid		integer			:= null; -- set at login time and in every call to header
   admin_pid$		constant integer	:= -1;
   cookie_name$		constant char(5)	:= 'JACoW';
   cookie_priv$		constant char(9)	:= 'JACoWADMN';

   repository_page$	constant char(12)	:= 'repository.%';
   repository_URL$	constant char(15)	:= 'repository.html';
   jacow_admin$		constant char(15)	:= 'repository.jobs';
   editor_page$		constant char(11)	:= 'editor.html';
   sort_file_page$	constant char(19)	:= 'abstract_maint.edit';
   QA_page$		constant char(9)	:= 'editor.qa';
   final_QA_page$	constant char(15)	:= 'editor.qa_paper';
   poster_police_page$	constant char(18)	:= 'poster_police.html';
   email_page$		constant char(9)	:= 'email.one';
   reg_admin_page$	constant char(17)	:= 'regist_maint.html';
   iorals_page$		constant char(15)	:= 'prog_cmtte.html';
   iorals_admin_page$	constant char(25)	:= 'prog_cmtte.accept_present';
   set_proposal_page$	constant char(23)	:= 'prog_cmtte.set_proposal';
   reg_readonly_page$	constant char(16)	:= 'regist_maint.xls';
   authors_page$	constant char(17)	:= 'JACoW.abs_authors';
   propose_invited$	constant char(20)	:= 'invited_extract.html';

   type ident_arr	is table of varchar2(5000) index by binary_integer;
   type int_arr		is table of integer index by binary_integer;
   type num_arr		is table of number index by binary_integer;
   type bool_arr	is table of boolean index by binary_integer;
   type date_arr	is table of date index by binary_integer;

   type popup_type is record (
	code	varchar2(100),
	name	varchar2(1000) );
   type popups_type is table of popup_type index by pls_integer;

   mt_ident_arr$	ident_arr;
   mt_int_arr$		int_arr;
   mt_num_arr$		num_arr;
   mt_bool_arr$		bool_arr;
   mt_date_arr$		date_arr;

   charset$		constant char(10)	:= 'ISO-8859-1';
   mdash$		constant char(9)	:= ' &mdash; ';
   dquote$		constant char(1)	:= chr(34);
   quote$		constant char(1)	:= chr(39);
   eol$			constant char(1) 	:= chr(10);
   eol2$		constant char(2) 	:= chr(10) || chr(10);
   crlf$		constant char(2)	:= chr(13) || chr(10);
   cr$			constant char(1)	:= chr(13);
   tab$			constant char(1)	:= chr(9);
   sp32$		constant char(1) 	:= ' ';
   space$		constant char(6) 	:= '&nbsp;';
   space2$		constant char(7)	:= '&nbsp; ';
   space3$		constant char(13)	:= '&nbsp; &nbsp;';
   checkbox$		constant char(1)	:= 'C';
   name$		constant integer	:= 1;
   email$		constant integer	:= 2;
   click_back$		constant varchar2(100)	:= 'Please click the back button on your browser to correct this error.' || htf.para;

   insufficient_privs$	constant varchar2(100)	:= htf.header (2, 'You do not have sufficient priveleges to run this procedure.');
   page_break$		constant char(37)	:= '<p style="page-break-before: always">';
   no_err_msg$		constant boolean	:= false;
   time$		constant char(5)	:= to_char (sysdate, 'sssss');

   html_fmt$		constant char(1)	:= 'H';
   byte_fmt$		constant char(1)	:= 'B';
   decimal_fmt$		constant char(1)	:= 'D';
   spires_fmt$		constant char(1)	:= 'S';

   search_for_null$	constant char(13)	:= '** Is NULL **';
   back2editor$		constant char(19)	:= 'Back to Editor Page';
   red$			constant char(17)	:= 'STYLE="COLOR:RED"';
   highlight$		constant char(32)	:= 'STYLE="BACKGROUND-COLOR:#EEEE00"';
   table_hover$		constant char(19)	:= ' CLASS="hoverTable"';

   oral$		constant presentation_type_codes.presentation_type_code%TYPE := 'O';
   poster$		constant presentation_type_codes.presentation_type_code%TYPE := 'P';
   invited$		constant presentation_option_codes.presentation_option_code%TYPE := 'IO';
   contributed$		constant presentation_option_codes.presentation_option_code%TYPE := 'CO';

-- Author Types
   author$		constant author_types.author_type%TYPE	:= 'AUTH';
   present$		constant author_types.author_type%TYPE	:= 'PRES';

-- Author Codes
   primary_author$	constant author_codes.author_code%TYPE	:= 'PRI';
   co_author$		constant author_codes.author_code%TYPE	:= 'COA';
   speaker$		constant author_codes.author_code%TYPE	:= 'PRE';
   presenter$		constant author_codes.author_code%TYPE	:= 'PRE';

-- Log Code Constants

   abstract_QA$		constant log_codes.log_code%TYPE := 'AB';
   copyright_received$	constant log_codes.log_code%TYPE := 'CF';
   paper_copy_received$	constant log_codes.log_code%TYPE := 'R';
   paper_assigned$	constant log_codes.log_code%TYPE := 'A';
   paper_reassigned$	constant log_codes.log_code%TYPE := 'PR';
   edit_complete$	constant log_codes.log_code%TYPE := 'E';
   black_dot_assigned$	constant log_codes.log_code%TYPE := 'BD';
   dot_reassignment$	constant log_codes.log_code%TYPE := 'DR';
   final_QA_passed$	constant log_codes.log_code%TYPE := 'FQ';
   final_QA_failed$	constant log_codes.log_code%TYPE := 'QAF';
   abstract_created$	constant log_codes.log_code%TYPE := 'AC';
   abstract_updated$	constant log_codes.log_code%TYPE := 'AU';
   abstract_withdrawn$	constant log_codes.log_code%TYPE := 'AW';
   file_uploaded$	constant log_codes.log_code%TYPE := 'FUP';
   file_removed$	constant log_codes.log_code%TYPE := 'FREM';
   abs_owner_change$	constant log_codes.log_code%TYPE := 'AOC';
   referee$		constant log_codes.log_code%TYPE := 'REF';
   poster_police$	constant log_codes.log_code%TYPE := 'POST';
   trans_complete$	constant log_codes.log_code%TYPE := 'TRAN';
   trans_assigned$	constant log_codes.log_code%TYPE := 'TASS';
   trans_reassigned$	constant log_codes.log_code%TYPE := 'TRAS';
   reject_ed_change$	constant log_codes.log_code%TYPE := 'REDC';

   referee_dot$		constant char(1)	:= 'R';
   editor_dot$		constant char(1)	:= 'E';
   transp_dot$		constant char(1)	:= 'T';

   transp_file$		constant file_type_codes.file_type_code%TYPE	:= 'TRAN';
   PDF_file$		constant file_type_codes.file_type_code%TYPE	:= 'PDFS';
   source_file$		constant file_type_codes.file_type_code%TYPE	:= 'SRC';

   logged_in		boolean := true;

   assigned$		constant char(1) := 'A';
   unassigned$		constant char(1) := 'U';
   uploadable$		constant char(1) := 'Y';
   not_uploadable$	constant char(1) := 'N';
   declined$		constant char(1) := 'D';

   fname$		constant char(1) := 'F';
   lname$		constant char(1) := 'L';
   out_html$		constant char(4) := 'HTML';
   out_csv$		constant char(3) := 'CSV';


-- Formally constanst for the conference parameters; now functions

params	common.ident_arr;

function abs_book_initials_only$	return varchar2;
function abs_submission_end_date$	return varchar2;
function abs_submission_start_date$	return varchar2;
function abstract_instr_url$		return varchar2;
function accept_abstracts$		return varchar2;
function accept_file_uploads$		return varchar2;
function acct_instr$			return varchar2;
function agenda_public_access$		return varchar2;
function author_upload_script$		return varchar2;
function auto_session_ids$		return varchar2;
function cancelImg$			return varchar2;
function cc_all_email$			return varchar2;
function cc_new_affil_reqs$		return varchar2;
function cc_vendor$			return varchar2;
function chairs_email$			return varchar2;
function conf_len_days$			return number;
function conf_location$			return varchar2;
function conf_start_monday$		return date;
function conf_title$			return varchar2;
function contributions_end_date$	return varchar2;
function copyright_required$		return varchar2;
function credits_footer$		return varchar2;
function CSS_URL$			return varchar2;
function CTX_rebuild_online$		return varchar2;
function currency_fmt$			return varchar2;
function currency_symbol$		return varchar2;
function date_fmt_str$			return varchar2;
function date_input_fmt_str$		return varchar2;
function delegates_reg_early$		return varchar2;
function delegates_reg_start$		return varchar2;
function deleteImg$			return varchar2;
function dtree_URL$			return varchar2;
function editImg$			return varchar2;
function editor_download_script$	return varchar2;
function editor_email$			return varchar2;
function edot_cell_font_size$		return varchar2;
function edot_column_count$		return varchar2;
function edot_hdr_back_color$		return varchar2;
function edot_hdr_font_size$		return varchar2;
function edot_hdr_text_color$		return varchar2;
function edot_instr_font_size$		return varchar2;
function edot_refresh_rate$		return varchar2;
function edot_row_count$		return varchar2;
function email_admn_new_abstracts$	return varchar2;
function email_LOC_new_abstract$	return varchar2;
function email_LOC_upd_abstract$	return varchar2;
function email_new_abstract$		return varchar2;
function email_new_accounts$		return varchar2;
function email_upd_abstract$		return varchar2;
function file_upload_instr_URL$		return varchar2;
function file_weight_threshold$		return varchar2;
function freeze_abs_present$		return varchar2;
function freeze_abs_reclass$		return varchar2;
function freeze_abs_updates$		return varchar2;
function from_email$			return varchar2;
function grace_period$			return number;
function hardcopy_required$		return varchar2;
function help_url$			return varchar2;
function hh_mail_signature$		return varchar2;
function hide_program_codes$		return varchar2;
function ht_booking$			return varchar2;
function ht_manager$			return varchar2;
function HTML_path$			return varchar2;
function http_port$ 			return number;
function invitation_only$		return varchar2;
function invite_letter$			return varchar2;
function IP_addr_list$			return varchar2;
function IP_addr_var$			return varchar2;
function JACoW_URL$			return varchar2;
function legal_footer_text$		return varchar2;
function legal_footer_URL$		return varchar2;
function LI_dot_URL$			return varchar2;
function LOC_email_address$		return varchar2;
function login_info_text$		return varchar2;
function login_info_URL$		return varchar2;
function logo_url$			return varchar2;
function max_abstract_len$		return number;
function max_footnote_len$		return number;
function max_funding_agency_len$	return number;
function max_keywords$			return number;
function minutes_between_sync$		return varchar2;
function new_affil_email$		return varchar2;
function new_profile_email$		return varchar2;
function newImg$			return varchar2;
function nextImg$			return varchar2;
function no_admin_coauthor_email$	return varchar2;
function no_payment_email_msg$		return varchar2;
function paper_id_oral_len$		return number;
function paper_id_poster_len$		return number;
function pass_phrase$			return varchar2;
function pass_phrase_paper_upload$	return varchar2;
function PC_edit$			return varchar2;
function PC_mode$			return varchar2;
function PC_present_enabled$		return varchar2;
function PC_reclassify_enabled$		return varchar2;
function pmt_prompt_notes$		return varchar2;
function post_log_file$			return varchar2;
function poster_id_assign_enabled$	return varchar2;
function poster_transparencies$		return varchar2;
function prevImg$			return varchar2;
function proceedings_base_URL$		return varchar2;
function program_download_URL$		return varchar2;
function program_interval$		return number;
function pubs_home_page$		return varchar2;
function quick_regist_passphrase$	return varchar2;
function reclass_instr_URL$		return varchar2;
function referee_assigned$		return varchar2;
function referee_auto_assign$		return varchar2;
function referee_conf$			return varchar2;
function referee_instr$			return varchar2;
function referee_notice$		return varchar2;
function referee_notify_decline$	return varchar2;
function referee_notify_revisions$	return varchar2;
function referee_PC_notify_decline$	return varchar2;
function referee_PC_notify_revision$	return varchar2;
function referees_per_paper$		return number;
function regist_list_public$		return varchar2;
function repo_db$			return varchar2;
function repo_profile_URL$		return varchar2;
function repo_URL$			return varchar2;
function repo_URL_text$			return varchar2;
function require_sub_class$		return varchar2;
function same_editor_and_qa_allowed$	return varchar2;
function server_override$		return varchar2;
function show_invoices$			return varchar2;
function smtp_host$			return varchar2;
function spires_conf_number$		return varchar2;
function spires_meeting_note$		return varchar2;
function SSL_port$			return varchar2;
function standalone_DB$			return varchar2;
function string_contacts$		return varchar2;
function string_footer$			return varchar2;
function string_header$			return varchar2;
function string_instruction$		return varchar2;
function template_guidelines$		return varchar2;
function TEXT_path$			return varchar2;
function toc_by_present$		return varchar2;
function tz_offset$ 			return number;
function use_poster_police$		return varchar2;
function use_SSL$			return varchar2;
function usedImg$			return varchar2;
function vdir_debug$			return varchar2;
function vdir_dflt$			return varchar2;
function version_string$		return varchar2;
function xtract_chk$			return varchar2;

-- * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

   function  accept_abstracts return boolean;
   function  add_time (this_date date, this_time integer) return date;
   function  build_IN_list (list ident_arr, this_var varchar2) return varchar2;
   function  build_in_list (oper varchar2, list ident_arr, varname varchar2) return varchar2;
   function  cc_admin (new_cc varchar2, subject varchar2) return varchar2;
   function  convert_date (this_date varchar2) return date;
   function  convert_text (this_text varchar2, fmt varchar2 default 'H') return varchar2;
   function  copyright_url (this_id integer) return varchar2;
   function  dad$ return varchar2;
   function  decode_value (descr_field varchar2, user_table varchar2, code_field varchar2,  code_value varchar2) return varchar2;
   function  decrypt (input_string varchar2) return varchar2;
   function  editing_as_jacow_admin return boolean;
   function  encrypt (input_string varchar2) return varchar2;
   function  favorite_author (this_profile_id integer) return boolean;
   function  file_type_uploaded (abs_id integer, file_type varchar2) return varchar2;
   function  files_uploaded return boolean;
   function  final_QA (abs_id integer) return varchar2;
   function  fmt_search_string (buffer varchar2, operator varchar2 default ' OR ') return varchar2;
   function  font2 (buffer varchar2) return varchar2;
   function  format_time (this_time integer) return varchar2;
   function  fmt_session_seq (seq integer, code varchar2) return varchar2;
   function  form_option (this_id integer, procedure_name varchar2, prompt varchar2) return varchar2;
   function  get_abstract_id (pid varchar2) return integer;
   function  get_abs_platform (abs_id integer) return varchar2;
   function  get_address (aid integer, term_char varchar2, include_country varchar2 default 'Y') return varchar2;
   function  get_affil_abbrev_list (abs_id integer, pid integer) return varchar2;
   function  get_affil_by_abs_person (abs_id integer, pid integer, abbrevs_only varchar2 default 'Y') return varchar2;
   function  get_affil_name_list (pid integer) return varchar2;
   function  get_affil_name (affil_id integer, sep_str varchar2 default ' ', incl_abbrev varchar2 default 'Y', abbrev_only varchar2 default 'N') return varchar2;
   function  get_author_list2 (abs_id integer, include_primary boolean default true, include_affils boolean default true, initials_only varchar2 default 'N') return varchar2;
   function  get_author_paper_ids (pid integer) return varchar2;
   function  get_author_profile_id (abs_id integer, code varchar2) return integer;
   function  get_conf_code return varchar2;
   function  get_cookie (cookie_name varchar2) return varchar2;
   function  get_dot_image (code varchar2, flag varchar2) return varchar2;
   function  get_keywords (this_id integer) return varchar2;
   function  get_log_date (abs_id integer, code varchar2) return varchar2;
   function  get_next_token (rec in out varchar2, byte varchar2) return varchar2;
   function  get_paper_id (abs_id integer, primary_only varchar2 default 'Y', fmt_out varchar2 default 'N') return varchar2;
   function  get_paper_ID_list (abs_id integer) return common.ident_arr;
   function  get_paper_PDF (abs_id integer) return varchar2;
   function  get_paper_seq_len (code varchar2, via varchar2 default 'presentation_codes') return integer;
   function  get_person_affil_country (pid integer, sep_char varchar2 default ', ') return varchar2;
   function  get_profile_affil (prof_id integer, abbrev_only varchar2 default 'N', include_abbrev varchar2 default 'Y') return varchar2;
   function  get_presentation_option (abs_id integer) return varchar2;
   function  get_presentation_type (abs_id integer) return varchar2;
   function  get_presentation_type (code varchar2)  return varchar2;
   function  get_presentation_type2 (code varchar2) return varchar2;
   function  get_presenter_person_id (abs_id integer) return integer;
   function  get_server_name return varchar2;
   function  get_speaker_profile_id (abs_id integer) return integer;
   function  get_user_affil_abbrev_list (pid integer, include_location varchar2 default 'N') return varchar2;
   function  get_user_affil_list (pid integer, sep_char varchar2 default htf.br) return varchar2;
   function  get_user_email (pid integer, as_links boolean default false) return varchar2;
   function  get_user_index_name (pid integer) return varchar2;
   function  get_user_name (pid integer, reverse boolean default false, translate varchar2 default 'Y', initials_only varchar2 default 'N') return varchar2;
   function  get_user_name (pid integer, reverse varchar2, translate varchar2 default 'Y', initials_only varchar2 default 'N') return varchar2;
   function  get_user_name_affiliation (pro_id integer, abbrev_only varchar2 default 'N') return varchar2;
   function  get_user_name_part (pid integer, part varchar2, translate varchar2 default 'Y') return varchar2;
   function  get_user_PID (uid varchar2) return integer;
   function  get_user_primary_addr_id (pid integer) return integer;
   function  get_user_primary_affil_id (pid integer) return integer;
   function  get_user_primary_profile_id (pid integer) return integer;
   function  get_UTC_time return date;
   function  hash (buffer varchar2) return number;
   function  has_privs_to_page (app_name varchar2 default null, show_err_msg boolean default true) return boolean;
   function  has_privs_to_URL (app_name varchar2) return varchar2;
   function  header (this_title varchar2, body_open boolean default true, print boolean default false, js_src varchar2 default null, cache_timeout integer default null, css_src varchar2 default null, test_only boolean default false) return boolean;
   function  header (this_title varchar2, body_open boolean default true, print boolean default false, js_src common.ident_arr, cache_timeout integer default null, css_src common.ident_arr, test_only boolean default false) return boolean;
   function  IFNOTNULL (str1 varchar2, str2 varchar2) return varchar2;
   function  invitee return boolean;
   function  local_time (this_date date) return varchar2;
   function  local_time_stamp (this_date date) return date;
   function  OK_to_edit_abstract (abs_id integer, for_title_change boolean default false) return boolean;
   function  OK_to_upload_files (abs_id integer) return boolean;
   function  paper_URL (paper_id varchar2) return varchar2;
   function  paper_anchor_tag (paper_id varchar2, label varchar2 default 'Download') return varchar2;
   function  paper_OK_to_publish (abs_id integer) return varchar2;
   function  pdf_required_code (code varchar2) return boolean;
   function  pdf_uploaded (abs_id integer) return boolean;
   function  popup_yes_no (var_name varchar2, var_value varchar2 default 'Y', allow_null boolean default true) return varchar2;
   function  primary_paper_id (pid varchar2) return boolean;
   function  privileged_user (pid integer) return boolean;
   function  process_is_running (process_name varchar2) return boolean;
   function  publishable_status_code (code varchar2) return boolean;
   function  publishable_referee_code (code varchar2) return boolean;
   function  radio_yes_no (var_name varchar2, var_value varchar2 default 'Y', include_not_sure boolean default true) return varchar2;
   function  red (buffer varchar2) return varchar2;
   function  referee_accepted (status varchar2) return boolean;
   function  referee_declined (status varchar2) return boolean;
   function  referee_revisions (status varchar2) return boolean;
   function  repo_is_remote return boolean;
   function  sc (buffer varchar2, i integer default 1) return varchar2;
   function  secure_login return boolean;
   function  server (override boolean default false) return varchar2;
   function  show_session_summary (this_id varchar2) return varchar2;
   function  sort_text (buffer varchar2) return varchar2;
   function  sserver return varchar2;
   function  stringTokenizer(PC$Chaine in long,PN$Pos in PLS_INTEGER, PC$Sep in varchar2 default ',') return varchar2;
   function  transp_uploadable (abs_id integer) return boolean;
   function  trans_chr (buffer varchar2) return varchar2;
   function  trim_crlf (buffer varchar2) return varchar2;
   function  uploadable_dot_status (code varchar2) return boolean;
   function  user_is_JACoW_admin return boolean;
   function  valid_entry return boolean;
   function  valid_pid (pid varchar2) return boolean;
   function  valid_referer (URL varchar2) return boolean;
   function  valid_time (itime integer) return boolean;
   function  validate_date (this_date varchar2, fmt_str varchar2 default 'mm/dd/yyyy') return boolean;
   function  validate_number (this_value varchar2) return boolean;
   function  vdir$ return varchar2;
   function  wanted_file_URL (paper_id varchar2, filename varchar2 default null) return varchar2;
   function  yes_no (yn varchar2 default 'N') return varchar2;

   procedure access_denied;
   procedure add_abs_session (aid integer, sid varchar2, pcode varchar2, pflag varchar2 default 'N', stime integer, dur integer, seq integer default null, SV_URL varchar2 default null);
   procedure blank_footer;
   procedure blank_header (rpt_title varchar2);
   procedure close_form (field_name varchar2, onclick_code boolean default false);
   procedure CSS;
   procedure delete_cookies;
   procedure display_logo (irows integer);
   procedure fmtOUT (buffer varchar2, output_type varchar2, tblHDR boolean default false, col_count varchar2 := null);
   procedure footer;
   procedure form_focus (form_name varchar2, field_name varchar2);
   procedure formTableButton (script varchar2, buffer varchar2);
   procedure get_gbl_pid (redirect boolean default true);
   procedure header_body_open (this_title varchar2, print boolean default false, JavaScript varchar2 default null, open_attribs varchar2 default null);
   procedure hidden_array (var_name varchar2, array ident_arr);
   procedure JS;
   procedure JS$;
   procedure logout;
   procedure onclick_script;
   procedure public_header (this_title varchar2, body_open boolean default true, print boolean default false, js_src varchar2 default null, cache_timeout integer default null, css_src varchar2 default null);
   procedure public_header (this_title varchar2, body_open boolean default true, print boolean default false, js_src common.ident_arr, cache_timeout integer default null, css_src common.ident_arr);
   procedure rebuild_CTX (table_name varchar2);
   procedure redirect_URL (URL varchar2);
   procedure set_process_name (process_name varchar2);
   procedure show_abstract_log (this_id integer, show_notes boolean, toggle_view boolean default false);
   procedure show_abstract_title (abs_id integer, paper_id varchar2 default null);
   procedure show_data_row (label varchar2, data_value date);
   procedure show_data_row (label varchar2, data_value varchar2);
   procedure show_data_row2 (label1 varchar2, data_value1 varchar2, label2 varchar2, data_value2 varchar2);
   procedure show_data_sep (num_cols integer, sep_str varchar2 default htf.hr);
   procedure show_title_sep (num_cols integer, sep_str varchar2 default htf.hr);
   procedure show_lookup_table (var varchar2, prompt varchar2, value varchar2 default null, where_claws varchar2 default null, onchange varchar2 default null, multiple boolean default false, show_null boolean default true, colspan integer default null, search_nulls boolean default false);
   procedure show_popup_array (var_name varchar2, recs popups_type, pre_selected varchar2 default null);
   procedure show_popup_array_row (prompt varchar2, var_name varchar2, recs popups_type, pre_selected varchar2 default null);
   procedure show_popup_list (var varchar2, value varchar2 default null, where_claws varchar2 default null, onchange varchar2 default null, multiple boolean default false, show_null boolean default true, form_var_name varchar2 default null, search_nulls boolean default false);
   procedure show_popup_table (this_code varchar2, this_descr varchar2, this_tab varchar2,
				this_prompt varchar2 default null, this_value varchar2 default null,
				where_claws varchar2 default null, cattributes varchar2 default null,
				show_blank boolean default true, var_name varchar2 default null,
				search_nulls boolean default false, order_by varchar2 default 'order by 2');
   procedure show_popup_table_row (this_code varchar2, this_descr varchar2, this_tab varchar2,
				this_prompt varchar2 default null, this_value varchar2 default null,
				where_claws varchar2 default null, cattributes varchar2 default null,
				show_blank boolean default true, var_name varchar2 default null,
				search_nulls boolean default false, order_by varchar2 default 'order by 2');
   procedure status_code_popup (code varchar2, editor_opt varchar2, referee_opt varchar2, trans_opt varchar2 default null, show_null_opt boolean default true);
   procedure write_cookie (cookie_name varchar2, cookie_string varchar2, expire_date date default null);
   procedure write_cookies (cookie_name ident_arr, cookie_string ident_arr, expire_date date default null);

   PRAGMA RESTRICT_REFERENCES (get_abs_platform, WNDS, WNPS);

end common;
/
show error

set define on
