set echo off

prompt
show user

select tablespace_name from user_tablespaces;

accept data_tbl	prompt "Enter a Tablespace for the SYNC tables  "
accept indx_tbl	prompt "Enter a Tablespace for the SYNC indexes "
accept repo	prompt "Enter schema name that owns the repository data "

-- **********

create table conferences
tablespace &data_tbl as
select	*
from	&repo..conferences
where	0 = 1;

create table conf_abstracts
tablespace &data_tbl as
select	*
from	&repo..conf_abstracts
where	0 = 1;

create table conf_abs_roles
tablespace &data_tbl as
select	*
from	&repo..conf_abs_roles
where	0 = 1;

create index conf_abs_roles_indx
	on conf_abs_roles (conf_abstract_id)
	tablespace &indx_tbl;


-- **********

var repoUID varchar2(30);

begin
   :repoUID := upper ('&repo');
end;
/

set heading off feedback off pagesize 0 termout off lines 100 verify off define off

spool T.sql

select	'create synonym ' || table_name || ' for &repo..' || table_name || ';'
from	all_tables
where	owner		= :repoUID
and	table_name	not like 'DR$%'
and	table_name	not in ('CONFERENCES', 'CONF_ABSTRACTS', 'CONF_ABS_ROLES');

select	'grant select on ' || table_name || ' to &repo' || ';'
from	user_tables;

spool off

set heading on feedback on pagesize 60 termout on lines 80 verify on define on

@T

prompt
prompt You should now revoke the resource role from this user
prompt to prevent creation of additional tables.


prompt
prompt Setup complete
prompt

sho user
