--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

-- ****************************************************************************************

spool Create_CTX_Indexes.log

@@Create_Stop_List

prompt Creating CTX Indexes
prompt 

exec ctx_ddl.create_preference ('ABSTRACT_STORAGE', 'BASIC_STORAGE');

exec ctx_ddl.set_attribute ('ABSTRACT_STORAGE', 'I_TABLE_CLAUSE', 'tablespace &&PAC_Data storage (initial 10M next 10M pctincrease 0)');
exec ctx_ddl.set_attribute ('ABSTRACT_STORAGE', 'K_TABLE_CLAUSE', 'tablespace &&PAC_Data storage (initial 100k next 100k pctincrease 0)');
exec ctx_ddl.set_attribute ('ABSTRACT_STORAGE', 'R_TABLE_CLAUSE', 'tablespace &&PAC_Data storage (initial 100k next 100k pctincrease 0)');
exec ctx_ddl.set_attribute ('ABSTRACT_STORAGE', 'N_TABLE_CLAUSE', 'tablespace &&PAC_Data storage (initial 100k next 100k pctincrease 0)');
exec ctx_ddl.set_attribute ('ABSTRACT_STORAGE', 'I_INDEX_CLAUSE', 'tablespace &&PAC_Index storage (initial 10M next 1M pctincrease 0)');

create index ABSTRACT_CTX on abstracts (search_text)
	indextype is ctxsys.context
	parameters ('memory 50M storage ABSTRACT_STORAGE STOPLIST SPMS_STOP_LIST');

-- ********************

exec ctx_ddl.create_preference ('AFFIL_STORAGE', 'BASIC_STORAGE');

exec ctx_ddl.set_attribute ('AFFIL_STORAGE', 'I_TABLE_CLAUSE', 'tablespace &&PAC_Data storage (initial 10M next 10M pctincrease 0)');
exec ctx_ddl.set_attribute ('AFFIL_STORAGE', 'K_TABLE_CLAUSE', 'tablespace &&PAC_Data storage (initial 100k next 100k pctincrease 0)');
exec ctx_ddl.set_attribute ('AFFIL_STORAGE', 'R_TABLE_CLAUSE', 'tablespace &&PAC_Data storage (initial 100k next 100k pctincrease 0)');
exec ctx_ddl.set_attribute ('AFFIL_STORAGE', 'N_TABLE_CLAUSE', 'tablespace &&PAC_Data storage (initial 100k next 100k pctincrease 0)');
exec ctx_ddl.set_attribute ('AFFIL_STORAGE', 'I_INDEX_CLAUSE', 'tablespace &&PAC_Index storage (initial 10M next 1M pctincrease 0)');

create index AFFILIATION_CTX on affiliations (search_text)
	indextype is ctxsys.context
	parameters ('memory 50M storage AFFIL_STORAGE STOPLIST SPMS_STOP_LIST');

-- ********************

exec ctx_ddl.create_preference ('ADDR_STORAGE', 'BASIC_STORAGE');

exec ctx_ddl.set_attribute ('ADDR_STORAGE', 'I_TABLE_CLAUSE', 'tablespace &&PAC_Data storage (initial 10M next 10M pctincrease 0)');
exec ctx_ddl.set_attribute ('ADDR_STORAGE', 'K_TABLE_CLAUSE', 'tablespace &&PAC_Data storage (initial 100k next 100k pctincrease 0)');
exec ctx_ddl.set_attribute ('ADDR_STORAGE', 'R_TABLE_CLAUSE', 'tablespace &&PAC_Data storage (initial 100k next 100k pctincrease 0)');
exec ctx_ddl.set_attribute ('ADDR_STORAGE', 'N_TABLE_CLAUSE', 'tablespace &&PAC_Data storage (initial 100k next 100k pctincrease 0)');
exec ctx_ddl.set_attribute ('ADDR_STORAGE', 'I_INDEX_CLAUSE', 'tablespace &&PAC_Index storage (initial 10M next 1M pctincrease 0)');

create index ADDRESS_CTX on addresses (search_text)
	indextype is ctxsys.context
	parameters ('memory 50M storage ADDR_STORAGE STOPLIST SPMS_STOP_LIST');

-- **********

spool off
