--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

-- ****************************************************************************************

spool Create_Comments.log

comment on table ABSTRACTS			is 'Holds contribution information entered by participants.';
comment on table ABSTRACT_KEYWORDS		is 'Top 5 keywords from paper.  Autogenerate in post-conference processing.';
comment on table ACTIVITIES			is 'A log of all changes to a users'' profile.';
comment on table ACTIVITY_CODES			is 'A master list of possible changes to a users'' profile.';
comment on table ADDRESSES			is 'Snail mail address for all affiliations.';
comment on table AFFILIATIONS			is 'A master list of all institutions.';
comment on table AFFIL_REQUESTS			is 'A log of all user requests to add new affiliations to the master list.';
comment on table AFFIL_TYPE_CODES		is 'A master list used to classify affiliations.';
comment on table AUTHORS			is 'Co-authors.';
comment on table BYTE_CODES			is 'A master list of non-printable charaters for various output methods.';
comment on table CLASSIFICATION_CODES		is 'A master list of Main Classification codes used to categorize abstracts.';
comment on table conditional_requirements	is 'Forces the prompt (meta_data_code) to be required only when the Yes/No question is answered Yes.';
comment on table CONFERENCE_CODES		is 'A master list of JACoW series conferences.  Used for mailing lists';
comment on table CONTROL			is 'A table used to hold miscellaneous values.';
comment on table COUNTRY_CODES			is 'A master list of countries.';
comment on table DATE_FORMAT_CODES		is 'A master list of Oracle-specific date format strings.  Users select a preferred format for viewing in their profile.';
comment on table DR$ABSTRACT_CTX$I		is 'Oracle-generated table by the Oracle-text index on Abstracts search_text field.';
comment on table DR$ABSTRACT_CTX$K		is 'Oracle-generated table by the Oracle-text index on Abstracts search_text field.';
comment on table DR$ABSTRACT_CTX$N		is 'Oracle-generated table by the Oracle-text index on Abstracts search_text field.';
comment on table DR$ABSTRACT_CTX$R		is 'Oracle-generated table by the Oracle-text index on Abstracts search_text field.';
comment on table DR$ADDRESS_CTX$I		is 'Oracle-generated table by the Oracle-text index on Addresses search_text field.';
comment on table DR$ADDRESS_CTX$K		is 'Oracle-generated table by the Oracle-text index on Addresses search_text field.';
comment on table DR$ADDRESS_CTX$N		is 'Oracle-generated table by the Oracle-text index on Addresses search_text field.';
comment on table DR$ADDRESS_CTX$R		is 'Oracle-generated table by the Oracle-text index on Addresses search_text field.';
comment on table DR$AFFILIATION_CTX$I		is 'Oracle-generated table by the Oracle-text index on Affiliations search_text field.';
comment on table DR$AFFILIATION_CTX$K		is 'Oracle-generated table by the Oracle-text index on Affiliations search_text field.';
comment on table DR$AFFILIATION_CTX$N		is 'Oracle-generated table by the Oracle-text index on Affiliations search_text field.';
comment on table DR$AFFILIATION_CTX$R		is 'Oracle-generated table by the Oracle-text index on Affiliations search_text field.';
comment on table ECLASS_CODES			is 'Joins master classifications and sub-classifications for EPAC-style conferences.';
comment on table ERROR_CODES			is 'A master list of errors found during paper processing by editors.';
comment on table FAVORITE_AUTHORS		is 'Part of a users'' profile.  The author is added each time a primary author is selected by the user for future use.';
comment on table FILES				is 'Meta data for each file uploaded by users.';
comment on table FILE_TYPE_CODES		is 'A master list of file types author can upload, such as DOC, LaTex.';
comment on table JN_ABSTRACTS			is 'A journal of withdrawn (deleted) abstracts.';
comment on table JN_AUTHORS			is 'A journal of withdrawn (deleted) authors for an abstract.';
comment on table KEYWORD_CODES			is 'A master list of keywords used to generate post-conference HTML and datafiles for JACoW and SPIRES serach engines.';
comment on table LOCATION_CODES			is 'A master list of locations for conference sessions.  The location codes is used to automatically generate session IDs.';
comment on table LOGS				is 'An activity log of all abstract activity, including creation, updates and editor actions.';
comment on table LOG_CODES			is 'A master list of possible activities for the logs.';
comment on table LOG_ERRORS			is 'A list of predefined errors found by editors during processing.  Aids in post-conference reporting.';
comment on table MAILING_LISTS			is 'Part of a users'' profile.  Specifies the conferneces a users wishes to receive mailings.';
comment on table MAIL_BLATS			is 'Email queue.';
comment on table MAIL_BLATS_ERRORS		is 'A copy of the email record with the error code.';
comment on table MAIL_SENT_BLATS		is 'A record of all email sent.';
comment on table MEMBERSHIP_CODES		is 'A master list of memebership organizations.';
comment on table MERGE_LOGS			is 'A record of all profiles merged in the master repository.  The SYNC process downloads these records to the conference database to merge profiles on the conference side.';
comment on table PARAMETERS			is 'Controls various SPMS functionality.';
comment on table PARAM_CATEGORIES		is 'Group parameters for display.';
comment on table PERSONS			is 'Part of a users'' profile.  Contains account, name and various preferences.';
comment on table PERSON_MEMBERSHIPS		is 'Part of a users'' profile.  Contains memebership and membership numbers.';
comment on table PLATFORM_CODES			is 'A master list of OS platforms for file uploading.';
comment on table POSTER_LOGS			is 'Poster Police findings.  Manned, Posted, Satisfactory.';
comment on table PRESENTATION_CODES		is 'A master list of presentation types (generaly invited oral, contributed oral and poster) used to classify abstracts.';
comment on table PRESENTATION_OPTION_CODES	is 'A master list of the part of the programme (or session) code that describes the type of presentation, i.e. invited or contributed oral, or poster, and when during the day it is presented during the conference, morning, afternoon, before or after coffee, etc.';
comment on table PRESENTATION_TYPE_CODES	is 'Oral vs. Poster.  Used to distinguish presentation codes and presentation option codes.';
comment on table PROFILES			is 'Each individual (person record) must have at least one profile record.  Used to associate persons with affilations.';
comment on table PROGRAMS			is 'Temporary table used to make easier to generation the program report.';
comment on table REFEREE_CODES			is 'A master list of referee statuses (Green, Yellow, Red dots).';
comment on table REGION_CODES			is 'A master list used to group countries for reporting purposes.';
comment on table SEARCH_DISPLAY_CODES		is 'A list used to provied the Search routine optional display values.';
comment on table SEARCH_SORT_CODES		is 'Used to provied users with various sort options on the Search page.';
comment on table SESSIONS			is 'Oral and poster sessions (date, time and location).';
comment on table SOURCE_CODES			is 'A master list of documents source types for file uploads.';
comment on table STATUS_CODES			is 'A master list of paper statuses (Green, Yellow, Red dots).';
comment on table SUB_CLASS_CODES		is 'Used to categories abstracts.';
comment on table TIME_ZONE_CODES		is 'A master list of world time zones.  Part of a users'' profile.  All dates and times are store at UTC.  The users specifies his/her time zone for display.';
comment on table VALID_REFERERS			is 'Prevents unauthorized nodes from bypassing security.  Only nodes listed in this table are allowed access.  The node upon which SPMS runs is always allowed.';
comment on table ABSTRACT_CLASSIFICATIONS	is 'Proposed re-classification by program committe.';
comment on table CREDIT_CARDS			is 'Credit card data collected during registration.';
comment on table DAILY_EVENTS			is 'Used to add recurring events for the conferenece program report such as lunch and coffee breaks.';
comment on table DATA_TYPE_CODES		is 'Used in registration to create registration page prompts.';
comment on table DISPLAY_CODES			is 'Used in registration to create registration page prompts.';
comment on table FEE_MATRIX			is 'Used in registration to link two poplist_items into one fee.';
comment on table MAIL_BLATS_ERRORS		is 'Email messages that failed.';
comment on table MENU_ITEMS			is 'Hierarchical list of links used to build the repository.html and editor.htmo pages.';
comment on table META_DATA_CODES		is 'Used in registration to create registration page prompts.';
comment on table PAGES				is 'Used in registration to to combing meta_data_codes (i.e. prompts for data) into an HTML page.';
comment on table PAYMENTS			is 'A record of all payments received by payment type.';
comment on table PAYMENT_CODES			is 'A master list of payment types.';
comment on table POPLIST_ITEMS			is 'Items used to generate a popup list for meta_data_codes (prompts).';
comment on table poster_logs			is 'Log of information gathered by the poster police.';
comment on table REGISTRANTS			is 'Used in registration to record completion of data entry.';
comment on table REGISTRATIONS			is 'Used in registration to record responses to all prompts for data.';
comment on table UNAVAILABLE_TIMES		is 'Indicates when the main repository is down.  Stops synronization and prevents job failuer.';
comment on table SPMS_JOBS			is 'A list of batch jobs to run in the dbms_job queue.';
comment on table REG_CAT_CODES			is 'A maintenance table used to group registration page field definitions.';
comment on table program_sort_fields		is 'This table controls the generation of the program code sequence number within Sessions.';
comment on table payment_vendor_codes		is 'Master list of 3rd-party, Credit Card/Bank Transfer payment processing vendors.';
comment on table payment_vendor_vars		is 'List of hidden variables passed to the vendor.';

comment on table user_functions			is 'Mapping of a person to a functional role within the conference.  Not necessarily tied to a privilege within SPMS.';
comment on table function_privileges		is 'Mapping of all persons within a functional role to a specific privilege within SPMS.  It gives peoplel the authority to run various applications/modules within SPMS.';
comment on table person_privs			is 'Used to control which privileges a users wish to activate during a login session.';

comment on table ABSTRACT_PRESENTATIONS		is 'Used during PC mode to track "votes" for changing an abstract''s presentation type.';
comment on table ABS_ATTRIBUTES			is 'Maps abstract to conferenece-defined attributes.';
comment on table ATTRIBUTE_CODES		is 'Master table of attribute codes that can be assigned to abstracts or persons.';
comment on table CHECKBOX_ITEMS			is 'Used in registration to maintain items attached to a registration question.';
comment on table CLASS_SESSIONS			is 'Maps classification codes to sessions.  Used to generate poster codes (paper IDs).';
comment on table CONF_ABSTRACTS			is 'Used by the repository in repatriation.';
comment on table CONF_ABS_KEYWORDS		is 'Used by the repository in repatriation.';
comment on table CONF_CLASSIFICATIONS		is 'Used by the repository in repatriation.';
comment on table CONF_CONFERENCES		is 'Used by the repository in repatriation.';
comment on table CONF_KEYWORDS			is 'Used by the repository in repatriation.';
comment on table CONF_PRESENTATIONS		is 'Used by the repository in repatriation.';
comment on table CONF_ROLES			is 'Used by the repository in repatriation.';
comment on table CONF_SUB_CLASSES		is 'Used by the repository in repatriation.';
comment on table DELETED_PERSONS		is 'Storage for deleted persons records in the event the data requires resurrection.';
comment on table DELETED_PROFILES		is 'Storage for deleted profile records in the event the data requires resurrection.';
comment on table EXPERTS			is 'Maps a person (expert) to an abstract classification (topic) and tracks their privilege.';
comment on table FUNCTION_CODES			is 'Master list of functional roles.';
comment on table PAGE_DATA			is 'Maps a registration page to individual questions.  This mapping generates a registration page for users.';
comment on table PAYMENT_VENDOR_IPNS		is 'Vendor Instant Payment Notifications - A list of all parameters sent back from the vendor for each payment.';
comment on table PERSON_ATTRIBUTES		is 'Maps persons to conferenece-defined attributes.';
comment on table PERSON_SCHEDULES		is 'Used to build a users'' person schedule or calendar of when an abstract is presented at the conference.';
comment on table PRESENTATION_FILE_CODES	is 'Maps a presentation (oral/poster) to a file type (source/PDF).  Used to generate popup lists on file uploads and "weight" file uploads for editor assignement purposes.';
comment on table PRIVILEGE_CODES		is 'Master list of SPMS privileges.  These codes are checked in the application code.';
comment on table REFEREE_ABSTRACTS		is 'A list of abstracts assigned to a referee.';
comment on table SPMS_VAR_CODES			is 'A list of SPMS registration data that can be sent to a payment vendor.  The intent is to map an HTML hidden form variable to a piece of registration data.';
comment on table VAR_TYPE_CODES			is 'Identifies the type of vendor variable sent to/return from the vendor.  Do not change or update these values.';
comment on table VENDOR_DELEGATES		is 'Persons and functional role of individuals identified by a vendor when registering.';
comment on table NO_LOGIN_URLS			is 'Controls which applications require login.  Do not delete records here unless you are certain you understand the side effects!';
comment on table regist_bypass_vars		is 'Mapping table for an external registration system.  Name/Value pairs are sent to the URL identified in the registration page''s BYPASS URL.';
comment on table source_codes			is 'List of file types editor may select for paper assignment.';

comment on table transparency_codes is 'List of file types editor may select for paper assignment.';

-- ********************

comment on column ABSTRACT_SESSIONS.PAPER_ID				is 'Trigger populated contatination of session_id and session_sequence.';
comment on column ABSTRACT_SESSIONS.SESSION_ID				is 'Foreign key.  The session this paper appears.';
comment on column ABSTRACT_SESSIONS.SESSION_SEQ				is 'The sequence number of the paper ID.';
comment on column ABSTRACT_SESSIONS.START_TIME				is 'Starting time for oral presentations only.  Use to generate program overview.';
comment on column ABSTRACT_SESSIONS.STREAMING_VIDEO_URL			is 'No longer used.';

comment on column program_sort_fields.field_name			is 'The data item eligible for sorting.';
comment on column program_sort_fields.sort_order			is 'Leave blank to skip.  Value must be a UNIQUE number.';
comment on column ABSTRACTS.ABSTRACT_ID					is 'Primary key. Auto generated via sequence.';
comment on column ABSTRACTS.AGENCY					is 'User entered during abstract submission.';
comment on column ABSTRACTS.ASSIGNABLE					is 'System generated.  Set to 2, 1 or null based on files uploaded.  Only abstracts that are assignable can be auto selected by editors for processing.';
comment on column ABSTRACTS.CLASSIFICATION_CODE				is 'Foreign key.  User entered during abstract submission.';
comment on column ABSTRACTS.DESCRIPTION					is 'User entered during abstract submission.';
comment on column ABSTRACTS.ECLASS_CODE					is 'Foreign key.  User entered during abstract submission.';
comment on column ABSTRACTS.EDITOR_ID					is 'The person_id of the current editor processing this abstracts'' paper.';
comment on column ABSTRACTS.FOOTNOTE					is 'User entered during abstract submission.';
comment on column ABSTRACTS.PAPER_URL					is 'Trigger populated URL to the papers'' PDF file.';
comment on column ABSTRACTS.PERSON_ID					is 'Foreign key to the abstracts'' owner.  Note; This is not necessarily the primary author.';
comment on column ABSTRACTS.PRESENTATION_CODE				is 'Foreign key.  User entered during abstract submission.';
comment on column ABSTRACTS.SEARCH_TEXT					is 'Trigger generated contatination of title and description.  Used as input for the Oracle-text index.';
comment on column ABSTRACTS.STATUS_CODE					is 'Foreign key.  Paper''s current status (greeen, yellow, red dot).';
comment on column ABSTRACTS.SUB_CLASS_CODE				is 'Foreign key.  User entered during abstract submission for EPAC-sytle conference and editor assigned for PAC-sytlye conferences.';
comment on column ABSTRACTS.TITLE					is 'User entered during abstract submission.';
comment on column ABSTRACTS.TOC_PAGE_NUM				is 'System generated based on total_pages.  Used to genearte table of contents.';
comment on column ABSTRACTS.TOTAL_PAGES					is 'Entered by editors during final QA.';

comment on column ABSTRACT_KEYWORDS.ABSTRACT_ID				is 'Foreign key.';
comment on column ABSTRACT_KEYWORDS.KEYWORD_CODE			is 'Foreign key.';

comment on column ACTIVITIES.ACTIVITY_CODE				is 'Foreign key.';
comment on column ACTIVITIES.IP_ADDRESS					is 'The IP addess of the browser that performed the update.';
comment on column ACTIVITIES.PERSON_ID					is 'Foreign key.  The ID of the account/profile updated.';
comment on column ACTIVITIES.UPDATED_BY					is 'Foreign key.  The ID of the person performing the update.';

comment on column ADDRESSES.AFFILIATION_ID				is 'Primay key.  System generated.';
comment on column ADDRESSES.COUNTRY_CODE				is 'Foreign key.';
comment on column ADDRESSES.SEARCH_TEXT					is 'Trigger-generated concatination of full address used in Oracle-text index.';
comment on column ADDRESSES.UPDATE_DATE					is 'Timestamp of update.';

comment on column AFFILIATIONS.AFFILIATION_ID				is 'Primay key.  System generated.';
comment on column AFFILIATIONS.AFFIL_ABBREV				is '';
comment on column AFFILIATIONS.AFFIL_TYPE_CODE				is 'Foreign key.';
comment on column AFFILIATIONS.DEPARTMENT				is '';
comment on column AFFILIATIONS.NAME1					is '';
comment on column AFFILIATIONS.NAME2					is '';
comment on column AFFILIATIONS.SEARCH_TEXT				is 'Trigger-generated concatination of all affiliation data used in Oracle-text index.';
comment on column AFFILIATIONS.UPDATE_DATE				is 'Timestamp.';
comment on column AFFILIATIONS.WEB_SITE					is '';

comment on column AUTHORS.ABSTRACT_ID					is 'Forign key.';
comment on column AUTHORS.PROFILE_ID					is 'Forign key.';
comment on column AUTHORS.SORT_ORDER					is 'User-defined for display purposes.  Valid only when one co-author is displayed with multiple profiles.';

comment on column CLASSIFICATION_CODES.CLASSIFICATION_CODE		is '';
comment on column CLASSIFICATION_CODES.CLASSIFICATION_DESCR		is '';

comment on column CONTROL.CONFERENCE_CODE				is 'Conference series for this database.';
comment on column CONTROL.EMAIL_RUNNING					is 'Prevents multiple instances of the email process from running.';
comment on column CONTROL.JACOW_PWD					is 'Internal password of the JACOW (backdoor) web account (not database schema).';
comment on column CONTROL.LAST_SYNC_DATE				is 'The timestamp of the last sync.';
comment on column CONTROL.SYNC						is 'Prevents multiple instances of the SYNC process from running.';
comment on column CONTROL.VERSION					is 'SPMS version number.';
comment on column CONTROL.WITHDRAWN_COUNT				is 'Running count of abstracts withdrawn.';

comment on column COUNTRY_CODES.STATE_REQ_FOR_CC			is 'Forces user to enter a state when entering Credit Card information in registration.';

comment on column DATE_FORMAT_CODES.DATE_FORMAT_CODE			is 'List of available data/time format strings.  Strings must be valid Oracle date/time format strings.';

comment on column ECLASS_CODES.CLASSIFICATION_CODE			is 'Forign key.';
comment on column ECLASS_CODES.ECLASS_CODE				is 'Forign key.';
comment on column ECLASS_CODES.SUB_CLASS_CODE				is 'Session ID assigned by the conference editor (EPAC-style).  Used to auto generate paper IDs.';

comment on column FAVORITE_AUTHORS.PERSON_ID				is 'Forign key.';
comment on column FAVORITE_AUTHORS.PROFILE_ID				is 'Forign key.';

comment on column FILES.ABSTRACT_ID					is 'Forign key.';
comment on column FILES.FILE_ID						is 'Primay key, system generated.';
comment on column FILES.FILE_TYPE_CODE					is 'Forign key.';
comment on column FILES.PLATFORM_CODE					is 'Forign key.';

comment on column KEYWORD_CODES.REGULAR_EXPRESSION			is 'Text used by the PERL script that generates paper keywords.';

comment on column LOGS.ABSTRACT_ID					is 'Forign key.';
comment on column LOGS.COMMENTS						is 'Comments viewable by editors and abstract owner.';
comment on column LOGS.EDITOR_NOTES					is 'Comments viewable by editors only.';
comment on column LOGS.LOG_CODE						is 'Forign key.';
comment on column LOGS.LOG_ID						is 'Primary key, system generated.';
comment on column LOGS.PERSON_ID					is 'Forign key.';
comment on column LOGS.STATUS_CODE					is 'Green, yellow, red dot assigned by editor.';

comment on column LOG_CODES.DO_NOT_DELETE				is 'Certain codes are required for SPMS processing.';
comment on column LOG_CODES.SRTF_FUNCTION				is 'Display on Sort/File home page.';
comment on column LOG_CODES.ACTIVITY_LOG				is 'If set to Yes, this log will display in the activity log report.';
comment on column LOG_CODES.CHART_FLAG					is 'If set to Yes, the activity will appear in the Conference Activiy Chart (in the reports section).';
comment on column LOG_CODES.PUBLISH					is 'If set to Yes, the item is requierd for publication.';

comment on column MERGE_LOGS.MERGED_BY					is 'Foreign key to persons.  The ID of the person who performed the merge.';
comment on column MERGE_LOGS.MERGED_CONF				is 'The date the merge completed on the conference side.';
comment on column MERGE_LOGS.MERGED_REPO				is 'The date the merge completed in the repository.';
comment on column MERGE_LOGS.NEW_PERSON_ID				is 'The ID of the person/profile record into which the old record was merge.';
comment on column MERGE_LOGS.OLD_PERSON_ID				is 'The ID of the merged person/profile record.';

comment on column PARAMETERS.CATEGORY_CODE				is 'Used to locically group paramters on the display page.';
comment on column PARAMETERS.COMMENTS					is 'Long description of the parameter and its use.';
comment on column PARAMETERS.DESCRIPTION				is 'A short description of the parameter and its use.';
comment on column PARAMETERS.ID						is 'Primary key.  Programmer generated.';
comment on column PARAMETERS.VALUE					is 'Administrator-assigned value.';
COMMENT ON COLUMN PARAMETERS.SORT_ORDER					is 'Number used to sort the parameters in the PARAMETERS section of the SPMS (admin)';

comment on column PERSONS.AUTHORIZATION_GIVEN				is 'Set to "Yes" if and when the user authorized JACoW to use their profile for mailings.';
comment on column PERSONS.COUNTRY_CODE					is 'Foreign key.';
comment on column PERSONS.DATE_FORMAT_CODE				is 'Foreign key.';
comment on column PERSONS.FNAME						is 'First (given) name.';
comment on column PERSONS.INVITEE					is 'Used in invitation only conferences to allow users to create abstrats.  Used in non-invitaiton only conferences to allow select users to bypass abstract creation/editing lockout.';
comment on column PERSONS.LNAME						is 'Last (family) name.';
comment on column PERSONS.MNAME						is 'Middle name.';
comment on column PERSONS.PASSWORD					is 'User entered password.  This value is encrypted in a trigger before it is saved.';
comment on column PERSONS.PERSON_ID					is 'Primary key, system generated.';
comment on column PERSONS.PNAME						is 'Preferred name.  Not currently used.';
comment on column PERSONS.SORT_FNAME					is 'Trigger-generated text for sorting the first name.';
comment on column PERSONS.SORT_LNAME					is 'Trigger-generated text for sorting the last name.';
comment on column PERSONS.SORT_MNAME					is 'Trigger-generated text for sorting the middle name.';
comment on column PERSONS.SOUNDEX_LNAME					is 'Trigger-generated text for searching.  Allows "fuzzy" search for mis-spelled last names.';
comment on column PERSONS.TITLE						is 'No used.';
comment on column PERSONS.UPDATE_DATE					is 'Timestamp.';
comment on column PERSONS.USER_ID					is 'User-generated logon ID.';

comment on column PRESENTATION_CODES.EDITOR_ONLY			is 'Limits selection of presentation codes to editors (hides it from the users).';
comment on column PRESENTATION_CODES.RECLASSIFY				is 'Set to Yes to allow program committe members to propose this classication for an abstract.';
comment on column PRESENTATION_CODES.MAX_PAGES				is 'Maximum number of pages for the final printed paper.';
comment on column PRESENTATION_CODES.PRESENTATION_TYPE_CODE		is 'Poster VS. Oral.';
comment on column PRESENTATION_CODES.INCLUDE_IN_PAPER_ID		is 'If set to Yes the presentation (short) code will be included in the paper ID between the session ID and the paper sequence number.';
comment on column PRESENTATION_CODES.PROPOSE_ORAL			is 'Set to Yes to allow program committe members to propose this presentation type for an abstract.';

comment on column PROFILES.ADDRESS_ID					is 'Foreign key.';
comment on column PROFILES.CURRENT_ADDRESS				is 'Current snail mail address.';
comment on column PROFILES.PERSON_ID					is 'Foreign key.';
comment on column PROFILES.PROFILE_ID					is 'Primary key, system generated.';
comment on column PROFILES.SORT_ORDER					is 'Default sort order for co-author display on abstracts.';
comment on column PROFILES.UPDATE_DATE					is 'Timestamp.';

comment on column SESSIONS.BEG_TIME					is 'Starting time (24-hour format)';
comment on column SESSIONS.CHAIR_PROFILE_ID				is 'Foreign key.';
comment on column SESSIONS.END_TIME					is 'Ending time (24-hour format)';
comment on column SESSIONS.LOCATION_CODE				is 'Foreign key.';
comment on column SESSIONS.PRESENTATION_OPTION_CODE			is 'Foreign key.';
comment on column SESSIONS.SESSION_ID					is 'Primary key, system generated. Day of week + presentation_code + location code.';

comment on table emails							is 'Summary of email sent by the administrator.';
comment on table email_logs						is 'Record of each email sent to individuals and tied to the mail_sent_blats table.';
comment on column ABSTRACT_CLASSIFICATIONS.abstract_id			is 'Foreign key.';
comment on column ABSTRACT_CLASSIFICATIONS.person_id			is 'Foreign key.';
comment on column ABSTRACT_CLASSIFICATIONS.classification_code		is 'Foreign key.';

comment on column CREDIT_CARDS.credit_card_id		is 'Primary key generated by system sequence.';
comment on column CREDIT_CARDS.cvv2			is 'Credit card security code located on back of card.';

comment on column DAILY_EVENTS.daily_event_id		is 'Primary key generated by system sequence.  When entering new records enter any number the SPMS will reset it with an appropriate value.';
comment on column DAILY_EVENTS.event			is 'Event title.';

comment on column FEE_MATRIX.fee_matrix_id		is 'Primary key generated by system sequence.';

comment on column MENU_ITEMS.item_id			is 'Primary key generated by system sequence.';
comment on column MENU_ITEMS.repo_only			is 'Causes link to display on the repository system only.';

comment on column META_DATA_CODES.encrypt		is 'When set to "Y" the registration data is encrypted before it is writted to the database.';

comment on column PAGES.admin_privs			is 'Only admins can export and read the data collected.  It aslo causes the registration module to use SSL.';
comment on column PAGES.available			is 'Set to N while building and testing a page.  Set to Y when ready for use.';
comment on column PAGES.login_req			is 'Y/N setting controling the need to login prior to viewing the registration data reports.';
comment on column PAGES.max_registrants			is 'Used to limit the number registering for an event.  Leave blank for unlimited registration.';
comment on column PAGES.post_info			is 'Free format text entered by the administrator that display to the user when data entry by the user is complete.';
comment on column PAGES.return_url			is 'Redirects the users'' browser to the specified URL when data entry is complete.';
comment on column PAGES.show_on_abstract		is 'When set to Y a link to the registration page displays on the standard login page (jacow.html).';
comment on column PAGES.show_on_profile			is 'When set to Y a link to the registration page displays on the standard profile page (profile.html).';
comment on column PAGES.external_URL			is 'Specify a URL for registration external to SPMS.  Also define a CC Vendor and speicify name/value pairs to pass to the external URL.';

comment on column PAYMENT_CODES.conf_option		is 'Set to Y to allow conference "employees" to select as a payment option.';
comment on column PAYMENT_CODES.email_delay		is 'Number of days to wait before sending email reminders to send in payment.';
comment on column PAYMENT_CODES.email_msg		is 'The reminder message to send to users with balances due.';
comment on column PAYMENT_CODES.instructions		is 'Displayed during registration payment process when the payment option is selected.';
comment on column PAYMENT_CODES.online_option		is 'Set to Y to allow users to select as a payment option.';

comment on column SPMS_JOBS.command			is 'The WHAT parameter in dbms_job.submit.';
comment on column SPMS_JOBS.interval			is 'The INTERVAL parameter in dbms_job.submit.';
comment on column SPMS_JOBS.no_repo			is 'Set to Y to prevent job running on the main repository.';
comment on column SPMS_JOBS.offset			is 'The numeric portion of the NEXT_DATE parameter in dbms_job.submit.  This value is added to SYSDATE to determine when the job starts.';
comment on column SPMS_JOBS.trunc_sysdate		is 'Applies to the offset.  Set to Y to truncate SYSDATE prior to adding the offset.';

comment on column status_codes.status_code		is 'Unique, one-letter code.';
comment on column status_codes.status_descr		is 'Text description of the status code.';
comment on column status_codes.sort_order		is 'No longer used.';
comment on column status_codes.email_msg		is 'Text sent to authors when paper is assigned status. The email message begins with the text: <i><b>Your contribution PAPER ID, "PAPER TITLE,"</i></b>. Format the remainder of the email message accordingly.';
comment on column status_codes.image_url		is 'Full URL to the JPG or GIF file of the dot image.';
comment on column status_codes.ok_to_upload		is 'Is it OK for authors to upload files when their paper has this status?';
comment on column status_codes.send_email_notice	is 'Enable automatic emails to authors when paper is assiged this status.';
comment on column status_codes.publishable		is 'Is a paper with this dot status publishable (if all other criteria are met)?';
comment on column status_codes.ok_to_edit		is 'Are authors allowed to edit their paper when it has this status?';
comment on column status_codes.user_validate		is 'If set to Yes <b>AND</b> Email Msg is populated, then an email will go to the user that will allow them to verify changes to their paper. This allows the user to reset the Dot status to the value in User Validate Status.';
comment on column status_codes.user_validate_status	is 'If the user validates changes to their paper, then the paper''s Dot status will change to this value, otherwise it remains unchanged.';
comment on column status_codes.pdf_required		is 'Prevents an editor from setting a paper to the status without first uploading a PDF file.';

comment on column referee_codes.referee_code		is 'Unique, one-letter code.';
comment on column referee_codes.referee_descr		is 'Text description of the referee code.';
comment on column referee_codes.sort_order		is 'No longer used.';
comment on column referee_codes.email_msg		is 'Text sent to authors when paper is assigned status.';
comment on column referee_codes.image_url		is 'Full URL to the JPG or GIF file of the dot image.';
comment on column referee_codes.ok_to_upload		is 'Is it OK for authors to upload files when their paper has this status?';
comment on column referee_codes.send_email_notice	is 'Enable automatic emails to authors when paper is assiged this status.';
comment on column referee_codes.publishable		is 'Is a paper with this dot status publishable (if all other criteria are met)?';
comment on column referee_codes.declined		is 'Paper content declinded by referee (one and only one record should be set to YES).';
comment on column referee_codes.revisions		is 'Paper content requires revision per referee (one and only one record should be set to YES).';

comment on column REG_CAT_CODES.REG_CAT_CODE		is 'A unique code for the group record.';
comment on column REG_CAT_CODES.REG_CAT_DESCR		is 'The full text seen by the users.';

comment on column payment_vendor_vars.payment_vendor_var_id	is 'Primay key.';
comment on column payment_vendor_vars.payment_vendor_code	is 'Foreign key.';
comment on column payment_vendor_vars.var_name			is 'Hidden variable sent to vendor';
comment on column payment_vendor_vars.SPMS_var_code		is 'Name of SPMS variable/data sent to vendor (value is derived by SPMS).';
comment on column payment_vendor_vars.var_text			is 'Literal sent to vendor.  VAR_TEXT and SPMS_VAR_NAME are mutually exclusive.';

comment on column payment_vendor_codes.action_URL		is 'URL supplied by the vendor to process CC payments.';
comment on column payment_vendor_codes.payment_msg		is 'Optional.  Message displayed to user when credit card payment is selected.';
comment on column payment_vendor_codes.input_tag_text		is 'Optional.  Vendor specified submit button to replace standard HTML submit button.';
comment on column payment_vendor_codes.action_URL_override	is 'When set to Yes SPMS will transfer control directly to the URL.  The URL must dispaly for form and tags necessary to transfer control to the vendor''s payment page.';
comment on column payment_vendor_codes.IPN_displays_invoice	is 'When set to Yes SPMS will generate a payment confirmation page and dispaly an updated invoice once the users'' payment is process and verified by the vendor.  When set to No the vendor dispalys the confirmaiton page.';
comment on column payment_vendor_codes.confirmation_URL		is 'Optional.  When specified SPMS will "call" this URL passing all name/value pairs specified on the Payment Vendor Variables page with a Var Type Code of "Confirmation" if the registration process succeeds.';
comment on column payment_vendor_codes.failure_URL		is 'Optional.  When specified SPMS will "call" this URL passing all name/value pairs specified on the Payment Vendor Variables page with a Var Type Code of "Confirmation" if the registration process fails.';

comment on column payment_vendor_vars.payment_vendor_var_id	is 'Primay key.';
comment on column payment_vendor_vars.payment_vendor_code	is 'Foreign key.';
comment on column payment_vendor_vars.var_name			is 'Variable name sent to/returned from vendor';
comment on column payment_vendor_vars.SPMS_var_code		is 'Name of SPMS variable/data associated with the vendor''s variable.';
comment on column payment_vendor_vars.var_text			is 'Literal sent to vendor.  VAR_TEXT and SPMS_VAR_CODE are mutually exclusive. Valid for hidden variables only.';
comment on column payment_vendor_vars.var_type_code		is 'Foreign key indicating if the variable is a hidden input variable or a return variable.';

comment on column status_codes.edot_fg_color	is 'Foreground color on the EDOT report.  Use standard color names or ###### notation only.';
comment on column status_codes.edot_bg_color	is 'Background color on the EDOT report.  Use standard color names or ###### notation only.';
comment on column status_codes.edot_board_text	is 'Instructions to authors displayed on the color key.';
comment on column status_codes.px_width		is 'Pixel width of the dot image.';
comment on column status_codes.px_height	is 'Pixel height of the dot image.';

comment on column regist_bypass_vars.bypass_id		is 'Automatically generated.  Enter any number in the data entry screen as a place holder.  SPMS will generate the next ID number.';
comment on column regist_bypass_vars.page_id		is 'The name of the registration page users see when registering.  This maps to an external registration page.';
comment on column regist_bypass_vars.var_name		is 'The variable name expected by the external registration CGI.';
comment on column regist_bypass_vars.value		is 'A literal text string sent for the name/value pair. Note: VALUE and BYPASS_VAR_CODE are mutually exclusive.';
comment on column regist_bypass_vars.bypass_var_code	is 'An SPMS generated value for the name/value pair.  Value is based on the user logged in. Note: VALUE and BYPASS_VAR_CODE are mutually exclusive.';

comment on column privilege_codes.validate_ip_address	is 'Test for IP address defined in the <a href="params.get_value?num=96">IP Address List</a> system parameter.';
comment on column privilege_codes.activity_log		is 'Set to Yes to display persons with the privilege in the Activity Log report.';
comment on column privilege_codes.privilege_code	is 'Any UNIQUE string.';
comment on column privilege_codes.privilege_descr	is 'Descriptive name of a privilege.  Applications are granted access to privileges, which in turn are granted to functional roles.';

comment on column function_codes.function_code		is 'Primay key. Any unique string.';
comment on column function_codes.function_descr		is 'Functional role description, what admins see when assign people to roles.';
comment on column function_codes.vendor_flag		is 'If set to Yes, this role will appear on the vendors'' registration screen.';
comment on column function_codes.abstract_flag		is 'No longer used.';

set define off
comment on column source_codes.source_code		is 'Primay key.  Must be unique.';
comment on column source_codes.source_descr		is 'Text editors see when selecting a file type to upload.';
comment on column source_codes.reg_exp			is 'Standard regular experession used in query to find files to upload.  Any change to the regular expression requires a change to the regular experssion in <a href="maint.tab?tab_name=file_type_codes&order_by=file_type_descr">File Types</a> as well.';

comment on column file_type_codes.file_type_code	is 'Primay key.  Must be unique.';
comment on column file_type_codes.file_type_descr	is 'Text authors see when selecting a file type to upload.';
comment on column file_type_codes.reg_exp		is 'Standard, JavaScript regular experession used to control which files an author may upload.  Any change to the regular expression for a <b>source file</b> requires a change to the regular experssion in <a href="maint.tab?tab_name=source_codes&order_by=source_descr">Editor Source File Types</a> as well.';
comment on column file_type_codes.error_msg		is 'Message displayed to authors if they attempt to upload a file where the type and extension do not match.';
comment on column file_type_codes.required		is 'If set to Yes, authors will see a message stating that they must upload a file of this type.';
comment on column file_type_codes.transparency_flag	is 'Indicates this file type contains files for oral presentation.';
comment on column file_type_codes.upload_2nd_codes	is 'Allow uploads of this file type on contributions under secondary program codes.';


comment on column transparency_codes.transparency_code	is 'Primay Key.';
comment on column transparency_codes.transparency_descr	is 'Dispaly description. Visible to users';
comment on column transparency_codes.sort_order		is 'Order displayed on reports, graphs, etc.';
comment on column transparency_codes.email_msg		is 'Standard text send to user when transparency code is assigned.';
comment on column transparency_codes.image_URL		is 'Full URL to "dot" image.';
comment on column transparency_codes.publishable	is 'Indicates if the transparency is acceptable for viewing.';
comment on column transparency_codes.edot_fg_color	is 'Foreground color on the EDOT report.  Use standard color names or ###### notation only.';
comment on column transparency_codes.edot_bg_color	is 'Background color on the EDOT report.  Use standard color names or ###### notation only.';

set define on

spool off
