--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

-- ****************************************************************************************

spool Create_Indexes.log

prompt Creating Indexes
prompt 

create unique index persons_user_id_UQ
	on persons (user_id)
	tablespace &PAC_Index;

create index PERSONS_update_date_indx
	on PERSONS (update_date)
	tablespace &PAC_Index;

create index PERSONS_sort_lname_indx
	on PERSONS (sort_lname)
	tablespace &PAC_Index;

create index PERSONS_soundex_lname_indx
	on PERSONS (soundex_lname)
	tablespace &PAC_Index;

create index persons_COUNTRY_CODE_indx
	on persons (COUNTRY_CODE)
	tablespace &PAC_Index;

-- **********

create index profiles_persons_indx
	on profiles (person_id)
	tablespace &PAC_Index;

create UNIQUE index PROFILES_ADDR_PID_UQ
	on PROFILES (address_id, person_id)
	tablespace &PAC_Index;

create index PROFILES_email_address_indx
	on PROFILES (email_address)
	tablespace &PAC_Index;

create index PROFILES_update_date_indx
	on PROFILES (update_date)
	tablespace &PAC_Index;

-- **********

create index affil_affil_type_code_indx
	on affiliations (affil_type_code)
	tablespace &PAC_Index;

create index affil_update_date_indx
	on AFFILIATIONS (update_date)
	tablespace &PAC_Index;

create index affiliation_name1_indx
	on affiliations (name1)
	tablespace &PAC_Index;

-- **********

create UNIQUE index ABSTRACT_KW_ABSTRACT_ID_UQ
	on ABSTRACT_KEYWORDS (ABSTRACT_ID, KEYWORD_CODE) 
	tablespace &PAC_Index;

create index ABSTRACT_KW_KEYWORD_CODE_indx
	on ABSTRACT_KEYWORDS (KEYWORD_CODE) 
	tablespace &PAC_Index;

-- **********

create index AUTHORS_profile_id_indx
	on AUTHORS (profile_id) 
	tablespace &PAC_Index;

create index AUTHORS_abstract_id_indx
	on AUTHORS (abstract_id) 
	tablespace &PAC_Index;

create UNIQUE index AUTHORS_UQ
	on AUTHORS (abstract_id, profile_id, author_type) 
	tablespace &PAC_Index;

-- **********

create index FILES_ABSTRACT_ID_indx
	on FILES (ABSTRACT_ID) 
	tablespace &PAC_Index;

create index files_paper_id_IDX
	on files (paper_id)
	tablespace &PAC_Index;

create BITMAP index FILES_FILE_TYPE_CODE_indx
	on FILES (FILE_TYPE_CODE) 
	tablespace &PAC_Index;

create BITMAP index FILES_PLATFORM_CODE_indx
	on FILES (PLATFORM_CODE) 
	tablespace &PAC_Index;

-- **********

create index ABSTRACTS_person_ID_indx
	on ABSTRACTS (person_ID) 
	tablespace &PAC_Index;

create index ABSTRACTS_editor_ID_indx
	on ABSTRACTS (editor_ID) 
	tablespace &PAC_Index;

create index ABSTRACTS_CLASS_CODE_indx
	on ABSTRACTS (CLASSIFICATION_CODE) 
	tablespace &PAC_Index;

create index ABSTRACTS_ECLASS_CODE_indx
	on ABSTRACTS (ECLASS_CODE) 
	tablespace &PAC_Index;

create index ABSTRACTS_SUB_CLASS_CODE_indx
	on ABSTRACTS (SUB_CLASS_CODE) 
	tablespace &PAC_Index;

create index ABSTRACTS_PRES_CODE_indx
	on ABSTRACTS (PRESENTATION_CODE) 
	tablespace &PAC_Index;

-- **********

create index sessions_chair_profile_indx
	on sessions (chair_profile_id)
	tablespace &PAC_Index;

-- **********

create index logs_abstract_id_indx
	on logs (abstract_id)
	tablespace &PAC_Index;

create index logs_log_code_indx
	on logs (log_code)
	tablespace &PAC_Index;

create index logs_person_id_indx
	on logs (person_id)
	tablespace &PAC_Index;

create index logs_log_date_indx
	on logs (log_date)
	tablespace &PAC_Index;

-- **********

create index JN_logs_abstract_id_indx
	on JN_logs (abstract_id)
	tablespace &PAC_Index;

create index JN_logs_person_id_indx
	on JN_logs (person_id)
	tablespace &PAC_Index;

-- **********

create index ADDRESSES_COUNTRY_CODE_indx
	on ADDRESSES (COUNTRY_CODE)
	tablespace &PAC_Index;

create index address_affiliation_id_indx
	on addresses (affiliation_id)
	tablespace &PAC_Index;

create index ADDRESSES_update_date_indx
	on ADDRESSES (update_date)
	tablespace &PAC_Index;

-- **********

create index country_codes_update_date_indx
	on country_codes (update_date)
	tablespace &PAC_Index;

-- **********

create index PARAMETERS_CATEGORY_CODE_indx
	on PARAMETERS (CATEGORY_CODE)
	tablespace &PAC_Index;

-- **********

create unique index log_errors_uq
	on log_errors (log_id, error_code)
	tablespace &PAC_Index;

-- **********

create unique index person_memberships_uq
	on person_memberships (person_id, membership_code)
	tablespace &PAC_Index;

-- **********

create unique index mailing_lists_uq
	on mailing_lists (person_id, conference_code)
	tablespace &PAC_Index;

-- **********

create index activities_person_indx
	on activities (person_id)
	tablespace &PAC_Index;

create index activities_updated_by_indx
	on activities (updated_by)
	tablespace &PAC_Index;

-- **********

create index affil_requests_requestor_indx
	on affil_requests (requestor_id)
	tablespace &PAC_Index;

-- **********

create UNIQUE index merge_logs_UQ
	on merge_logs (old_person_id, new_person_id)
	tablespace &PAC_Index;

create index merge_logs_person_id
	on merge_logs (merged_by)
	tablespace &PAC_Index;

-- **********

create index mail_sent_blats_indx
	on mail_sent_blats (create_date)
	tablespace &PAC_Index;

create UNIQUE index mail_sent_blats_UQ
	on mail_sent_blats (mail_id)
	tablespace &PAC_Index;

create index mail_sent_abstract_id_indx
	on mail_sent_blats (abstract_id)
	tablespace &PAC_Index;

create index mail_sent_person_id_indx
	on mail_sent_blats (person_id)
	tablespace &PAC_Index;

-- **********

create index poster_logs_abstracts_indx
	on poster_logs (abstract_id)
	tablespace &PAC_Index;

-- **********

create index email_logs_email_id
	on email_logs (email_id)
	tablespace &PAC_Index;

create index email_logs_mail_id
	on email_logs (mail_id)
	tablespace &PAC_Index;

create index email_logs_person_id_indx
	on email_logs (person_id)
	tablespace &PAC_Index;

-- **********

create UNIQUE index pages_page_name_UQ
	on pages (page_name)
	tablespace &PAC_index;

-- **********

create index registrations_person_indx
	on registrations (person_id)
	tablespace &PAC_Index;

create index registrations_meta_data_indx
	on registrations (meta_data_code)
	tablespace &PAC_Index;

create index registrations_poplist_indx
	on registrations (poplist_item_id)
	tablespace &PAC_Index;

create index registrations_payment_indx
	on registrations (payment_id)
	tablespace &PAC_Index;

-- **********

create index poplist_items_meta_data_indx
	on poplist_items (meta_data_code)
	tablespace &PAC_Index;

-- **********

create index page_data_page_id_indx
	on page_data (page_id)
	tablespace &PAC_Index;

create index page_data_meta_data_code_indx
	on page_data (meta_data_code)
	tablespace &PAC_Index;

-- **********

create index abstract_CO_indx
	on abstract_presentations (abstract_id)
	tablespace &pac_index;

create index abstract_person_id_indx
	on abstract_presentations (person_id)
	tablespace &pac_index;

-- **********

create UNIQUE index abstract_classifications_UQ
	on abstract_classifications (person_id, abstract_id)
	tablespace &pac_index;

create index abstract_class_code_indx
	on abstract_classifications (classification_code)
	tablespace &pac_index;

-- **********

create UNIQUE index fee_matrix_UQ
	on fee_matrix (poplist_item_id1, poplist_item_id2)
	tablespace &pac_index;

-- **********

create index conditional_requirements_UQ
	on conditional_requirements (yesno_meta_code, meta_data_code)
	tablespace &pac_index;

-- **********

create index payments_person_indx
	on payments (person_id)
tablespace &pac_index;

create index PAYMENTS_CREDIT_CARD_ID_IDX
	on PAYMENTS (CREDIT_CARD_ID) 
	tablespace &PAC_Index; 

-- **********

create index credit_cards_indx
	on credit_cards (person_id)
	tablespace &pac_index;

-- **********

create UNIQUE index credit_cards_UQ
	on credit_cards (person_id, card_number)
	tablespace &pac_index;

-- **********

create UNIQUE index person_schedules_UQ
	on person_schedules (person_id, abstract_id)
	tablespace &PAC_Index;

-- **********

create UNIQUE index experts_UQ
	on experts (person_id, classification_code)
	tablespace &PAC_Index;

-- **********

create UNIQUE index referee_abstracts_UQ
	on referee_abstracts (person_id, abstract_id)
	tablespace &PAC_Index;

-- **********

create unique index checkbox_items_UQ
	on checkbox_items (poplist_item_id, person_id)
	tablespace &pac_index;

create index checkbox_items_indx
	on checkbox_items (person_id)
	tablespace &pac_index;

create index checkbox_payment_indx
	on checkbox_items (payment_id)
	tablespace &PAC_Index;

-- **********

create index MENU_ITEMS_PARENT_ITEM_ID_IDX
	on MENU_ITEMS (PARENT_ITEM_ID) 
	tablespace &PAC_Index; 

-- **********

create index delete_persons_indx
	on deleted_persons (timestamp)
	tablespace &pac_index;

create index delete_profiles_indx
	on deleted_profiles (timestamp)
	tablespace &pac_index;

-- **********

create UNIQUE index vendor_delegates_UQ
	on vendor_delegates (person_id, vendor_id, function_code)
	tablespace &pac_index;

-- **********

create UNIQUE index presentation_file_codes_UQ
	on presentation_file_codes (presentation_code, file_type_code)
	tablespace &pac_index;

-- **********

create UNIQUE index abs_attributes_UQ
	on abs_attributes (abstract_id, attribute_code)
	tablespace &pac_index;

-- **********

create UNIQUE index class_sessions_UQ1
	on class_sessions (classification_code, session_id, sub_class_code, eclass_code)
	tablespace &pac_index;

create UNIQUE index class_sessions_UQ2
	on class_sessions (sub_class_code, session_id, eclass_code, classification_code)
	tablespace &pac_index;

create UNIQUE index class_sessions_UQ3
	on class_sessions (eclass_code, session_id, classification_code, sub_class_code)
	tablespace &pac_index;

-- **********

create UNIQUE index person_attributes_UQ
	on person_attributes (person_id, attribute_code)
	tablespace &pac_index;

-- **********

create UNIQUE index payment_vendor_vars_UQ
	on payment_vendor_vars (payment_vendor_code, var_name, var_type_code)
	tablespace &PAC_index;

create index payment_vendor_IPNs_indx
	on payment_vendor_IPNs (payment_id)
	tablespace &PAC_index;

create UNIQUE index function_privileges_UQ
	on function_privileges (function_code, privilege_code)
	tablespace &pac_index;

create index function_privileges_indx
	on function_privileges (privilege_code)
	tablespace &pac_index;

-- *****

create UNIQUE index user_functions_UQ
	on user_functions (person_id, function_code)
	tablespace &pac_index;

create index user_functions_indx
	on user_functions (function_code)
	tablespace &pac_index;

-- *****

create UNIQUE index person_privs_UQ
	on person_privs (person_id, privilege_code)
	tablespace &pac_index;

-- *****

create index merged_addresses_indx
	on merged_addresses (timestamp)
	tablespace &pac_index;

create UNIQUE index no_login_URLs_indx
	on no_login_URLs  (URL)
	tablespace &pac_index;

-- *****

create UNIQUE index JN_AUTHORS_UQ
	on JN_AUTHORS (abstract_id, profile_id, author_type) 
	tablespace &PAC_Index;

-- *****

create unique index regist_bypass_vars_UQ
	on regist_bypass_vars (page_id, var_name);


-- *****

create UNIQUE index applications_UQ
	on applications (application_name)
	tablespace &pac_index;

-- *****

create UNIQUE index upload_status_codes_UQ
	on upload_status_codes (editor_status_code, referee_status_code)
	tablespace &pac_index;

-- *****

create unique index menu_item_subs_uq
	on menu_item_subs (maint_tab_name, alternate_url)
	tablespace &PAC_Index;

-- *****

create index abstracts_trans_editor_indx
	on abstracts (trans_editor_id)
	tablespace &pac_index;

-- *****

create UNIQUE index abstract_proposals_UQ
	on  abstract_proposals (abstract_id, person_id)
	tablespace &PAC_Index;

-- *****

create UNIQUE index abstract_sessions_UQ
	on abstract_sessions (abstract_id, session_id)
	tablespace &pac_index;

create index abstract_sessions_IDX
	on abstract_sessions (session_id)
	tablespace &pac_index;


spool off
