set heading off feedback off pagesize 0 termout off lines 500 verify off

column current_user new_value mvalue;
select user current_user from dual;

column tbl_owner new_value syn_prefix;
select	distinct table_owner tbl_owner
from	user_synonyms;

spool &mvalue..sql

select	'create or replace synonym repo_' || table_name || ' for &syn_prefix' || '.' || table_name || ';'
from	user_tables
where	table_name		NOT like 'DR$%'
and	'REPO_' || table_name	NOT in
(	select	synonym_name
	from	user_synonyms)
and	NOT exists
(	select	1
	from	user_db_links
	where	db_link like 'JACOW_REPOSITORY%');

select	'create or replace synonym repo_sync for &syn_prefix' || '.sync;'
from	dual
where	NOT exists
(	select	1
	from	user_db_links
	where	db_link like 'JACOW_REPOSITORY%');

select	'create or replace synonym repo_' || table_name || ' for ' || table_name || '@jacow_repository;'
from	user_tables
where	table_name		NOT like 'DR$%'
and	'REPO_' || table_name	NOT in
(	select	synonym_name
	from	user_synonyms)
and	exists
(	select	1
	from	user_db_links
	where	db_link like 'JACOW_REPOSITORY%');

select	'create or replace synonym repo_sync for sync@jacow_repository;'
from	dual
where	exists
(	select	1
	from	user_db_links
	where	db_link like 'JACOW_REPOSITORY%');

spool off

set heading on feedback on termout on pagesize 999 lines 80

set define on
@&mvalue

undef syn_prefix
