--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

-- ****************************************************************************************

spool Create_PKeys.log

prompt Creating Primary Keys

alter table files
	add constraint files_pk
	primary key (file_id)
	using index
	tablespace &&PAC_Index;

alter table persons
	add constraint persons_pk
	primary key (person_id)
	using index
	tablespace &&PAC_Index;

alter table profiles
	add constraint profiles_pk
	primary key (profile_id)
	using index
	tablespace &&PAC_Index;

alter table addresses
	add constraint addresses_pk
	primary key (address_id)
	using index
	tablespace &&PAC_Index;

alter table abstracts
	add constraint abstracts_pk
	primary key (abstract_id)
	using index
	tablespace &&PAC_Index;

alter table affiliations
	add constraint affiliations_pk
	primary key (affiliation_id)
	using index
	tablespace &&PAC_Index;


alter table affil_type_codes
	add constraint affil_type_codes_pk
	primary key (affil_type_code)
	using index tablespace &&PAC_Index;

alter table status_codes
	add constraint status_codes_pk
	primary key (status_code)
	using index tablespace &&PAC_Index;

alter table referee_codes
	add constraint referee_codes_PK
	primary key (referee_code)
	using index
	tablespace &&PAC_Index;

alter table logs
	add constraint logs_pk
	primary key (log_id)
	using index tablespace &&PAC_Index;

alter table error_codes
	add constraint error_codes_pk
	primary key (error_code)
	using index tablespace &&PAC_Index;

alter table favorite_authors
	add constraint favorite_authors_pk
	primary key (person_id, profile_id)
	using index tablespace &&PAC_Index;

alter table date_format_codes
	add constraint date_format_codes_pk
	primary key (date_format_code)
	using index tablespace &&PAC_Index;

alter table region_codes
	add constraint region_codes_pk
	primary key (region_code)
	using index tablespace &&PAC_Index;

alter table conference_codes
	add constraint conference_codes_pk
	primary key (conference_code)
	using index tablespace &&PAC_Index;

alter table log_codes
	add constraint log_codes_pk
	primary key (log_code)
	using index
	tablespace &&PAC_Index;

alter table sessions
	add constraint sessions_pk
	primary key (session_id)
	using index
	tablespace &&PAC_Index;

alter table keyword_codes
	add constraint keyword_codes_pk
	primary key (keyword_code)
	using index
	tablespace &&PAC_Index;

alter table country_codes
	add constraint country_codes_pk
	primary key (country_code)
	using index
	tablespace &&PAC_Index;

alter table presentation_codes
	add constraint presentation_codes_pk
	primary key (presentation_code)
	using index
	tablespace &&PAC_Index;

alter table file_type_codes
	add constraint file_type_codes_pk
	primary key (file_type_code)
	using index
	tablespace &&PAC_Index;

alter table platform_codes
	add constraint platform_codes_pk
	primary key (platform_code)
	using index
	tablespace &&PAC_Index;

alter table presentation_type_codes
	add constraint presentation_type_codes_pk
	primary key (presentation_type_code)
	using index
	tablespace &&PAC_Index;

alter table param_categories
	add constraint param_categories_PK
	primary key (category_code)
	using index
	tablespace &&PAC_Index;

alter table parameters
	add constraint parameters_PK
	primary key (ID)
	using index
	tablespace &&PAC_Index;

alter table byte_codes
	add constraint byte_codes_pk
	primary key (byte_code)
	using index
	tablespace &&PAC_Index;

alter table membership_codes
	add constraint membership_codes_pk
	primary key (membership_code)
	using index
	tablespace &&PAC_Index;

alter table activity_codes
	add constraint activity_codes_pk
	primary key (activity_code)
	using index
	tablespace &&PAC_Index;

alter table location_codes
	add constraint location_codes_pk
	primary key (location_code)
	using index
	tablespace &&PAC_Index;

alter table affil_requests
	add constraint affil_requests_pk
	primary key (affil_request_id)
	using index
	tablespace &&PAC_Index;

alter table presentation_option_codes
	add constraint presentation_option_codes_pk
	primary key (presentation_option_code)
	using index
	tablespace &&PAC_Index;

alter table search_display_codes
	add constraint search_display_codes_pk
	primary key (search_display_code)
	using index
	tablespace &&PAC_Index;

alter table search_sort_codes
	add constraint search_sort_codes_pk
	primary key (search_sort_code)
	using index
	tablespace &&PAC_Index;

alter table JN_abstracts
	add constraint JN_abstracts_pk
	primary key (abstract_id)
	using index
	tablespace &&PAC_Index;

alter table emails
	add constraint emails_pk
	primary key (email_id)
	using index
	tablespace &PAC_Index;

alter table unavailable_times
	add constraint unavailable_times_pk
	primary key (unavailable_time_id)
	using index
	tablespace &PAC_Index;

-- **********

alter table pages
	add constraint pages_pk
	primary key (page_id)
	using index
	tablespace &PAC_Index;

alter table page_data
	add constraint page_data_pk
	primary key (page_data_id)
	using index
	tablespace &PAC_Index;

alter table meta_data_codes
	add constraint meta_data_codes_pk
	primary key (meta_data_code)
	using index
	tablespace &PAC_Index;

alter table data_type_codes
	add constraint data_type_codes_pk
	primary key (data_type_code)
	using index
	tablespace &PAC_Index;

alter table display_codes
	add constraint display_codes_pk
	primary key (display_code)
	using index
	tablespace &PAC_Index;

alter table poplist_items
	add constraint poplist_items_pk
	primary key (poplist_item_id)
	using index
	tablespace &PAC_Index;

alter table menu_items
	add constraint menu_items_pk
	primary key (item_id)
	using index
	tablespace &pac_index;

alter table daily_events
	add constraint daily_events_pk
	primary key (daily_event_id)
	using index
	tablespace &pac_index;

alter table fee_matrix
	add constraint fee_matrix_pk
	primary key (fee_matrix_id)
	using index
	tablespace &pac_index;

alter table registrants
	add constraint registrants_pk
	primary key (page_id, person_id)
	using index
	tablespace &pac_index;

alter table payment_codes
	add constraint payment_codes_PK
	primary key (payment_code)
	using index
	tablespace &pac_index;

alter table credit_cards
	add constraint credit_cards_pk
	primary key (credit_card_id)
	using index
	tablespace &pac_index;

alter table time_zone_codes
	add constraint time_zone_codes_pk
	primary key (time_zone_code)
	using index
	tablespace &pac_index;

alter table payments
	add constraint payments_pk
	primary key (payment_id)
	using index
	tablespace &pac_index;

alter table classification_codes
	add constraint classification_codes_pk
	primary key (classification_code)
	using index
	tablespace &&PAC_Index;

alter table sub_class_codes
	add constraint sub_class_codes_pk
	primary key (sub_class_code)
	using index tablespace &&PAC_Index;

alter table eclass_codes
	add constraint eclass_codes_pk
	primary key (eclass_code)
	using index
	tablespace &&PAC_Index;

alter table registrations
	add constraint registrations_pk
	primary key (registration_id)
	using index
	tablespace &&PAC_Index;

alter table checkbox_items
	add constraint checkbox_items_pk
	primary key (checkbox_item_id)
	using index
	tablespace &&PAC_Index;

alter table reg_cat_codes
	add constraint reg_cat_codes_pk
	primary key (reg_cat_code)
	using index
	tablespace &pac_index;

alter table attribute_codes
	add constraint attribute_codes_PK
	primary key (attribute_code)
	using index
	tablespace &pac_index;

alter table program_sort_fields
	add constraint program_sort_fields_PK
	primary key (field_name)
	using index
	tablespace &pac_index;

alter table class_sessions
	add constraint class_sessions_PK
	primary key (class_session_id)
	using index
	tablespace &pac_index;

alter table payment_vendor_codes
	add constraint payment_vendor_codes_pk
	primary key (payment_vendor_code)
	using index
	tablespace &pac_index;

alter table SPMS_var_codes
	add constraint SPMS_var_codes_pk
	primary key (SPMS_var_code)
	using index
	tablespace &pac_index;

alter table payment_vendor_vars
	add constraint payment_vendor_vars_pk
	primary key (payment_vendor_var_id)
	using index
	tablespace &pac_index;

alter table var_type_codes
	add constraint var_type_codess_pk
	primary key (var_type_code)
	using index
	tablespace &pac_index;

alter table privilege_codes
	add constraint privilege_code_pk
	primary key (privilege_code)
	using index
	tablespace &pac_index;

alter table function_codes
	add constraint function_code_pk
	primary key (function_code)
	using index
	tablespace &pac_index;

alter table priority_codes
	add constraint priority_codes_PK
	primary key (priority_code)
	using index
	tablespace &PAC_Index;

alter table proposal_status_codes
	add constraint proposal_status_codes_PK
	primary key (proposal_status_code)
	using index
	tablespace &PAC_Index;

alter table author_types
	add constraint author_types_PK
	primary key (author_type)
	using index
	tablespace &pac_index;

alter table author_codes
	add constraint author_codes_pk
	primary key (author_code)
	using index
	tablespace &pac_index;

-- **********

alter TABLE HOTEL_CATEGORIES 
	add CONSTRAINT HOTEL_CATEGORIES_PK
	PRIMARY KEY (HOTEL_CAT_ID)
	USING INDEX TABLESPACE &&pac_index;

alter TABLE HOTEL_PAYMENTS 
	add CONSTRAINT HOTEL_PAYMENTS_PK
	PRIMARY KEY (METHOD_ID)
	USING INDEX TABLESPACE &&pac_index;

alter TABLE HOTEL_ROOMTYPE_FEE 
	add CONSTRAINT HOTEL_ROOMTYPE_FEE_PK
	PRIMARY KEY (HRF_ID)
	USING INDEX TABLESPACE &&pac_index;

alter TABLE HOTELS 
	add CONSTRAINT HOTELS_PK
	PRIMARY KEY (HOTEL_ID)
	USING INDEX TABLESPACE &&pac_index;

alter TABLE REGISTRANTS_CHOICES 
	add CONSTRAINT REGISTRANTS_CHOICES_PK
	PRIMARY KEY (CHOICE_ID)
	USING INDEX TABLESPACE &&pac_index;

alter TABLE ROOM_DEPOSIT 
	add CONSTRAINT ROOM_DEPOSIT_PK
	PRIMARY KEY (DEPOSIT_ID)
	USING INDEX TABLESPACE &&pac_index;

alter TABLE ROOM_TYPES 
	add CONSTRAINT ROOM_TYPES_PK
	PRIMARY KEY (ROOM_TYPE_ID)
	USING INDEX TABLESPACE &&pac_index;

alter TABLE ROOMS_HOTEL 
	add CONSTRAINT ROOMS_HOTEL_PK
	PRIMARY KEY (ROOM_ID)
	USING INDEX TABLESPACE &&pac_index;

alter table TEMP_REGISTRANTS_CHOICES
	add constraint TEMP_REGISTRANTS_CHOICES_PK
	PRIMARY KEY (CHOICE_ID)
	USING INDEX 
	TABLESPACE &PAC_index;

alter table MISC_DATA_PAGE
	add CONSTRAINT MISC_DATA_PAGE_PK
	PRIMARY KEY (MISC_ID)
	USING INDEX
	tablespace &PAC_index;

alter table EXPORT_TEMPLATES
	add CONSTRAINT EXPORT_TEMPLATES_PK
	PRIMARY KEY (TEMPLATE_ID)
	USING INDEX TABLESPACE &PAC_Index;

alter table bypass_var_codes
	add constraint bypass_var_codes_PK
	primary key (bypass_var_code)
	using index
	tablespace &pac_index;

alter table regist_bypass_vars
	add constraint regist_bypass_vars_PK
	primary key (bypass_id)
	using index
	tablespace &pac_index;

alter table CTX_reserved_words
	add constraint CTX_reserved_words_PK
	primary key (word)
	using index
	tablespace &pac_index;

alter table registrations_payments
	add constraint registrations_payments_PK
	primary key (registration_id, payment_id)
	using index
	tablespace &pac_index;

alter table TYPE_DISPLAY_DATA
	add CONSTRAINT TYPE_DISPLAY_DATA_PK
	PRIMARY KEY (DATA_TYPE_CODE,DISPLAY_CODE)
	using index
	tablespace &pac_Index;

alter table applications
	add constraint applications_pk
	primary key (application_id)
	using index
	tablespace &pac_index;

alter table application_privs
	add constraint application_privs_pk
	primary key (application_id, privilege_code)
	using index
	tablespace &pac_index;

alter table editor_status_codes
	add constraint editor_status_codes_pk
	primary key (editor_status_code)
	using index
	tablespace &pac_index;

alter table referee_status_codes
	add constraint referee_status_codes_pk
	primary key (referee_status_code)
	using index
	tablespace &pac_index;

alter table source_codes
	add constraint source_codes_pk
	primary key (source_code)
	using index
	tablespace &PAC_Index;

alter table transparency_codes
	add constraint transparency_codes_PK
	primary key (transparency_code)
	using index
	tablespace &&PAC_Index;

alter table abstract_sessions
	add constraint abstract_sessions_PK
	primary key (abstract_session_id)
	using index
	tablespace &&PAC_Index;

alter table abstract_sessions
	add constraint abstract_sessions_UK
	UNIQUE (paper_id)
	using index
	tablespace &&PAC_Index;

alter table super_region_codes
	add constraint super_region_codes_PK
	primary key (super_region_code)
	using index
	tablespace &&PAC_Index;

-- *****************************************************************************************************
-- ** Sync Tables -- Not used in conference instances
/*
alter table sync_data
	add constraint sync_data_PK
	primary key (sync_id)
	using index tablespace &PAC_Index;

alter table sync_persons
	add constraint sync_persons_PK
	primary key (sync_id)
	using index tablespace &PAC_Index;

alter table sync_profiles
	add constraint sync_profiles_PK
	primary key (sync_id)
	using index tablespace &PAC_Index;

alter table sync_addresses
	add constraint sync_addresses_PK
	primary key (sync_id)
	using index tablespace &PAC_Index;

alter table sync_affiliations
	add constraint sync_affiliations_PK
	primary key (sync_id)
	using index tablespace &PAC_Index;

alter table sync_person_memberships
	add constraint sync_person_memberships_PK
	primary key (sync_id)
	using index tablespace &PAC_Index;

alter table sync_mailing_lists
	add constraint sync_mailing_lists_PK
	primary key (sync_id)
	using index tablespace &PAC_Index;

alter table sync_merge_persons
	add constraint sync_merge_persons_PK
	primary key (sync_id)
	using index tablespace &PAC_Index;

alter table sync_merge_profiles
	add constraint sync_merge_profiles_PK
	primary key (sync_id)
	using index tablespace &PAC_Index;

*/
spool off
