--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

-- ****************************************************************************************

spool Create_Schema_Owner.log

prompt 
prompt This script creates the schema that will own the SPMS database and application.
prompt This script should run under a privileged account.
prompt 

accept SPMSUID	prompt "Enter the Schema Owner for SPMS Database "
accept SPMSpwd	prompt "Enter the Password for SPMS Schema Owner " hide

select tablespace_name from dba_tablespaces;

accept dflt_tbl	prompt "Enter the Default Tablespace for SPMS Schema Owner   "
accept tmp_tbl	prompt "Enter the Temporary Tablespace for SPMS Schema Owner "

create user &SPMSUID identified by &SPMSpwd
	default tablespace &dflt_tbl
	temporary tablespace &tmp_tbl;

set echo on verify off

grant connect,resource			to &SPMSUID;
grant create database link		to &SPMSUID;
grant create view			to &SPMSUID;
grant create synonym			to &SPMSUID;

grant SELECT	on v_$session		to &SPMSUID;
grant SELECT	on CTXSYS.DR$PENDING	to &SPMSUID;
grant EXECUTE	ON CTXSYS.CTX_DDL	to &SPMSUID;

grant EXECUTE	ON UTL_TCP		to &SPMSUID;
grant EXECUTE	ON UTL_SMTP		to &SPMSUID;
grant EXECUTE	ON UTL_HTTP		to &SPMSUID;
grant EXECUTE	ON DBMS_LOB		to &SPMSUID;

set echo off verify on

prompt 
prompt The creation of the SPMS database and application owner is complete.
prompt Log into the &SPMSUID account and run the script Create_Repository
prompt 
