--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.JACoW.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

-- ****************************************************************************************

set heading off feedback off pagesize 0 termout off lines 500 verify off define off

spool t.sql

select	'create or replace synonym repo_' || object_name || ' for JACoW.' || object_name || '@JACOW_REPOSITORY;'
from	user_objects
where	object_name	not like 'DR$%'
and	object_type	in ('TABLE', 'VIEW')
and	exists (select 1 from user_db_links where db_link like 'JACOW_REPOSITORY%')
UNION
select	'create or replace synonym repo_' || object_name || ' for JACoW.' || object_name || '@JACOW_REPOSITORY;'
from	user_objects
where	object_name = 'SYNC'
and	object_type = 'PACKAGE'
and	exists (select 1 from user_db_links where db_link like 'JACOW_REPOSITORY%')
UNION
select	'create or replace synonym repo_' || object_name || ' for JACoW.' || object_name || ';'
from	user_objects
where	object_name	not like 'DR$%'
and	object_type	in ('TABLE', 'VIEW')
and	NOT exists (select 1 from user_db_links where db_link like 'JACOW_REPOSITORY%')
UNION
select	'create or replace synonym repo_' || object_name || ' for JACoW.' || object_name || ';'
from	user_objects
where	object_name = 'SYNC'
and	object_type = 'PACKAGE'
and	NOT exists (select 1 from user_db_links where db_link like 'JACOW_REPOSITORY%')
UNION
select	'create or replace synonym repatriate for JACoW.repatriate@JACOW_REPOSITORY;'
from	DUAL
where	exists (select 1 from user_db_links where db_link like 'JACOW_REPOSITORY%')
UNION
select	'create or replace synonym repatriate for JACoW.repatriate;'
from	DUAL
where	NOT exists (select 1 from user_db_links where db_link like 'JACOW_REPOSITORY%')
UNION
select	'create or replace synonym repo_XML_PKG for JACoW.XML_PKG@JACOW_REPOSITORY;'
from	DUAL
where	exists (select 1 from user_db_links where db_link like 'JACOW_REPOSITORY%')
UNION
select	'create or replace synonym repo_XML_PKG for JACoW.XML_PKG;'
from	DUAL
where	NOT exists (select 1 from user_db_links where db_link like 'JACOW_REPOSITORY%')
UNION
select	'create or replace synonym repo_XML_DATA for JACoW.XML_DATA@JACOW_REPOSITORY;'
from	DUAL
where	exists (select 1 from user_db_links where db_link like 'JACOW_REPOSITORY%')
UNION
select	'create or replace synonym repo_XML_DATA for JACoW.XML_DATA;'
from	DUAL
where	NOT exists (select 1 from user_db_links where db_link like 'JACOW_REPOSITORY%');

spool off

set heading on feedback on termout on pagesize 999 lines 80

set define on

spool Create_Synonyms.log
@t
spool off
