--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

-- ****************************************************************************************

spool Create_Tables.log

set verify off

select tablespace_name from user_tablespaces order by 1;

prompt 
prompt Enter the tablespaces that will hold the JACoW data and indexes.
prompt 

accept PAC_Data  prompt 'Tablespace for Tables: '
accept PAC_Index prompt 'Tablespace for Indexes: '
prompt 

create table DST_codes (
database_name		varchar2(20),
month			number,
week_number		number )
tablespace &&PAC_Data;

create table persons (
person_id		number,
user_id			varchar2(30),
password		number,
fname			varchar2(40),
mname			varchar2(40),
lname			varchar2(40)	not null,
pname			varchar2(40),
initials		varchar2(20),
title			varchar2(10),
sort_fname		varchar2(164),
sort_mname		varchar2(164),
sort_lname		varchar2(164),
soundex_lname		varchar2(10),
country_code		varchar2(4),		
date_format_code	varchar2(30),
authorization_given	varchar2(1),
update_date		date		not null,
invitee			varchar2(1),
tz_name			varchar2(64),
requires_invitation	varchar2(1),
admin_comments		varchar2(4000),
gender			char(1) )
tablespace &PAC_Data;

create table profiles (
profile_id		number,
person_id		number		not null,
address_id		number		not null,
email_address		varchar2(100),
mail_stop		varchar2(30),
po_box			varchar2(10),
phone_number		varchar2(80),
fax_number		varchar2(50),
sort_order		number,
current_address		varchar2(1),
update_date		date		not null,
deleted			date)
tablespace &PAC_Data;

create table favorite_authors (
person_id	number,
profile_id	number )
tablespace &pac_data;

create table addresses (
address_id		number,
address1		varchar2(80),
address2		varchar2(80),
address3		varchar2(80),
po_box			varchar2(40),
town			varchar2(40),
postal_code		varchar2(40),
zip_code		varchar2(40),
country_code		varchar2(4),
search_text		varchar2(4000),
affiliation_id		number		not null,
update_date		date		not null )
tablespace &PAC_Data;

create table affiliations (
affiliation_id		number,
affil_abbrev		varchar2(25),
name1			varchar2(200)	not null,
name2			varchar2(200),
department		varchar2(200),
web_site		varchar2(100),
search_text		varchar2(4000),
affil_type_code		varchar2(4),
update_date		date		not null,
admin_comments		clob )
tablespace &PAC_Data;

create table authors (
abstract_id		number		not null,
profile_id		number		not null,
sort_order		number,
on_leave		varchar2(1),
author_code		varchar2(4)	not null,
author_type		varchar2(4)	not null )
tablespace &PAC_Data;

create table JN_authors (
abstract_id		number		not null,
profile_id		number		not null,
sort_order		number,
on_leave		varchar2(1),
author_code		varchar2(4)	not null,
author_type		varchar2(4)	not null )
tablespace &PAC_Data;

-- **********

create table sessions (
session_id			varchar2(10),
title				varchar(80)	not null,
session_date			date		not null,
location_code			varchar2(4)	not null,
chair_profile_id		number,
beg_time			number(4)	not null,
end_time			number(4)	not null,
sort_order			number,
presentation_option_code	varchar2(4)	not null )
tablespace &pac_data;

create table location_codes (
location_code		varchar2(4),
location_descr		varchar2(80)	not null,
capacity		number		not null)
tablespace &pac_data;

create table abstracts (
abstract_id		number,
person_id		number		not null,
title			varchar2(200)	not null,
description		varchar2(4000),
classification_code	varchar2(8)	not null,
sub_class_code		varchar2(4),
eclass_code		number,
presentation_code	varchar2(2)	not null,
agency			varchar2(4000),
paper_URL		varchar2(200),
status_code		varchar2(1),
editor_id		number,
assignable		number default 0,
total_pages		number,
toc_page_num		number,
search_text		clob,
footnote		varchar2(4000),
poster_status		varchar2(1),
referee_code		varchar2(1),
transparency_code	varchar2(1),
trans_editor_id		number )
tablespace &PAC_Data;

create table JN_abstracts (
withdraw_date		date		not null,
withdrawn_by		number		not null,
abstract_id		number,
person_id		number		not null,
title			varchar2(200)	not null,
description		varchar2(4000),
classification_code	varchar2(8),
sub_class_code		varchar2(4),
eclass_code		number,
presentation_code	varchar2(2),
agency			varchar2(4000),
paper_URL		varchar2(200),
status_code		varchar2(1),
editor_id		number,
assignable		number default 0,
total_pages		number,
toc_page_num		number,
search_text		clob,
footnote		varchar2(4000),
poster_status		varchar2(1),
referee_code		varchar2(1),
transparency_code	varchar2(1),
trans_editor_id		number )
tablespace &PAC_Data;

create table logs (
log_id			number,
abstract_id		number		not null,
log_code		varchar2(4)	not null,
status_code		varchar2(1),
referee_code		varchar2(1),
person_id		number		not null,
log_date		date		not null,
comments		varchar2(4000),
editor_notes		varchar2(4000),
transparency_code	varchar2(1) )
tablespace &PAC_Data;

create table JN_logs (
log_id			number,
abstract_id		number		not null,
log_code		varchar2(4)	not null,
status_code		varchar2(1),
referee_code		varchar2(1),
person_id		number		not null,
log_date		date		not null,
comments		varchar2(4000),
editor_notes		varchar2(4000),
transparency_code	varchar2(1) )
tablespace &PAC_Data;

create table log_errors (
log_id			number,
error_code		varchar2(4) )
tablespace &PAC_Data;

create table JN_log_errors (
log_id			number,
error_code		varchar2(4) )
tablespace &PAC_Data;

create table error_codes (
error_code		varchar2(4),
error_descr		varchar2(400)	not null,
editor			varchar2(1)	not null,
poster			varchar2(1)	not null,
referee			varchar2(1)	not null )
tablespace &pac_data;

create table log_codes (
log_code		varchar2(4),
log_descr		varchar2(400)	not null,
do_not_delete		varchar2(1),
srtf_function		varchar2(1),
publish			varchar2(1),
activity_log		varchar2(1),
chart_flag		varchar2(1),
status_code		varchar2(1) )
tablespace &pac_data;

create table files (
file_id			number,
abstract_id		number		not null,
file_name		varchar2(64)	not null,
file_type_code		varchar2(4)	not null,
platform_code		varchar2(4)	not null,
uploaded_date		date		not null,
deleted			varchar2(1),
paper_id		varchar2(13)	not null,
comments		varchar2(4000) )
tablespace &PAC_Data;

create table abstract_keywords (
abstract_id		number		not null,
keyword_code		number	 	not null)
tablespace &PAC_Data;

-- ********  Supporting (lookup) tables

create table classification_codes (
classification_code	varchar2(8),
classification_descr	varchar2(100)	not null )
tablespace &pac_data;

create table keyword_codes (
keyword_code		number,
keyword_descr		varchar2(80)	not null,
regular_expression	varchar2(40),
conference_code		varchar2(10)	not null )
tablespace &pac_data;

create table country_codes (
country_code		varchar2(4),
country_abbrev		varchar2(4)	not null,
country_descr		varchar2(80)	not null,
update_date		date		not null,
region_code		varchar2(4),
state_req_for_CC	varchar2(1) )
tablespace &pac_data;

create table presentation_codes (
presentation_code		varchar2(2),
presentation_descr		varchar2(80)	not null,
presentation_type_code		varchar2(1)	not null,
max_pages			number		not null,
editor_only			varchar2(1)	not null,
reclassify			varchar2(1),
sort_order			number,
include_in_paper_ID		varchar2(1),
propose_oral			varchar2(1) )
tablespace &pac_data;

create table presentation_option_codes (
presentation_option_code	varchar2(4),
presentation_option_descr	varchar2(80)	not null,
presentation_type_code		varchar2(1)	not null )
tablespace &pac_data;

create table file_type_codes (
file_type_code		varchar2(4),
file_type_descr		varchar2(80)	not null,
reg_exp			varchar2(100),
error_msg		varchar2(100),
required		varchar2(1)	not null,
transparency_flag	varchar2(1),
upload_2nd_codes	varchar2(1) )
tablespace &pac_data;

create table platform_codes (
platform_code	varchar2(4),
platform_descr	varchar2(80)	not null )
tablespace &pac_data;

create table presentation_type_codes (
presentation_type_code	varchar2(1),
presentation_type_descr	varchar2(40)	not null)
tablespace &pac_data;

create table byte_codes (
byte_code	number,
html_code	varchar2(20),
user_code	varchar2(20),
gif_file	varchar2(40),
spires_code	varchar2 (15) )
tablespace &pac_data;

create table sub_class_codes (
sub_class_code		varchar2(4),
sub_class_descr		varchar2(100)	not null )
tablespace &pac_data;

create table param_categories (
category_code	varchar2(4),
sort_order	number,
description	varchar2(80) )
tablespace &pac_data;

create table parameters (
ID		number,
category_code	varchar2(4),
description	varchar2(200),
value		varchar2(2000),
comments	varchar2(4000),
dtype		varchar2(1)	not null,
long_text	varchar2(1)	not null,
sort_order	number )
tablespace &pac_data;

create table mail_blats (
mail_id		number,
from_addr	varchar2(1024),
recipient	varchar2(1024),
subject		varchar2(1024),
message		clob,
cc		varchar2(1024),
bcc		varchar2(1024),
flag		varchar2(1),
create_date	date,
person_id	number,
abstract_id	number)
tablespace &pac_data;

create table mail_sent_blats (
mail_id		number,
from_addr	varchar2(1024),
recipient	varchar2(1024),
subject		varchar2(1024),
message		clob,
cc		varchar2(1024),
bcc		varchar2(1024),
flag		varchar2(1),
create_date	date,
person_id	number,
abstract_id	number)
tablespace &PAC_Data;

create table mail_blats_errors (
mail_id		number,
from_addr	varchar2(1024),
recipient	varchar2(1024),
subject		varchar2(1024),
message		clob,
cc		varchar2(1024),
bcc		varchar2(1024),
flag		varchar2(1),
create_date	date,
error_code	number,
error_message	varchar2(1000),
person_id	number,
abstract_id	number)
tablespace &pac_data;

create table affil_type_codes (
affil_type_code		varchar2(4),
affil_type_descr	varchar2(100)	not null )
tablespace &pac_data;

create table status_codes (
status_code		varchar2(1),
status_descr		varchar2(40)	not null,
sort_order		number,
email_msg		varchar2(4000),
image_URL		varchar2(200)	not null,
OK_to_upload		varchar2(1)	not null,
send_email_notice	varchar2(1)	not null,
publishable		varchar2(1)	not null,
edot_board_text 	varchar2(100),
px_width		integer,
px_height		integer,
edot_fg_color		varchar2(7),
edot_bg_color		varchar2(7),
OK_to_edit		varchar2(1)	not null,
user_validate		varchar2(1),
user_validate_status	varchar2(1),
pdf_required		varchar2(1) )
tablespace &pac_data;

create table referee_codes (
referee_code		varchar2(1),
referee_descr		varchar2(40)	not null,
sort_order		number,
email_msg		varchar2(4000),
image_URL		varchar2(200)	not null,
OK_to_upload		varchar2(1)	not null,
send_email_notice	varchar2(1)	not null,
publishable		varchar2(1)	not null,
declined		varchar2(1)	not null,
revisions		varchar2(1)	not null,
edot_board_text 	varchar2(100),
px_width		integer,
px_height		integer,
edot_fg_color		varchar2(7),
edot_bg_color		varchar2(7) )
tablespace &pac_data;

create table membership_codes (
membership_code		varchar2(8),
membership_descr	varchar2(40)	not null)
tablespace &pac_data;

create table person_memberships (
person_id		number		not null,
membership_code		varchar2(8) 	not null,
membership_number	varchar2(80) )
tablespace &PAC_Data;

create table date_format_codes (
date_format_code	varchar2(30) )
tablespace &pac_data;

create table control (
last_sync_date		date,
conference_code		varchar2(10),
jacow_pwd		varchar2(100),
sync			varchar2(1),
email_running		varchar2(1),
version			varchar2(20),
withdrawn_count		number		not null,
conference_id		number,
last_sync_id		number )
tablespace &pac_data;

create table conference_codes (
conference_code		varchar2(10),
conference_descr	varchar2(160),
discontinued		varchar2(1) )
tablespace &pac_data;

create table region_codes (
region_code		varchar2(4),
region_descr		varchar2(40),
super_region_code	varchar2(4)	not null )
tablespace &pac_data;

create table mailing_lists (
person_id	number		not null,
conference_code	varchar2(10)	not null)
tablespace &pac_data;

create table activity_codes (
activity_code		varchar2(4),
activity_descr		varchar2(80)	not null)
tablespace &pac_data;

create table activities (
person_id		number		not null,
activity_code		varchar2(4)	not null,
activity_date		date		not null,
ip_address		varchar2(32),
updated_by		number		not null )
tablespace &PAC_Data;

create table eclass_codes (
eclass_code		number,
classification_code	varchar2(8)	not null,
sub_class_code		varchar2(4) )
tablespace &pac_data;

create table affil_requests (
affil_request_id	number,
requestor_id		number		not null,
request_date		date,
ip_address		varchar2(20),
address_id		number		not null)
tablespace &pac_data;

create table source_codes (
source_code	varchar2(6)	not null,
source_descr	varchar2(40)	not null,
reg_exp		varchar2(40)	not null )
tablespace &pac_data;

create table valid_referers (
URL_Node_Name	varchar2(100) )
tablespace &pac_data;

create table search_sort_codes (
search_sort_code	varchar2(4),
search_sort_descr	varchar2(40),
search_flag		char(1) not null )
tablespace &pac_data;

create table merge_logs (
old_person_id	number	not null,
new_person_id	number	not null,
merged_by	number	not null,
merged_repo	date	not null,
merged_conf	date)
tablespace &pac_data;

create table search_display_codes (
search_display_code	varchar2(4)	not null,
search_display_descr	varchar2(40)	not null,
sort_order		number		not null )
tablespace &pac_data;

create table poster_logs (
abstract_id	number,
manned		varchar2(1)	not null,
posted		varchar2(1)	not null,
satisfactory	varchar2(1)	not null,
picture		varchar2(1)	not null,
comments	varchar2(4000) )
tablespace &pac_data;

create table daily_events (
daily_event_id	number,
beg_time	number		not null,
end_time	number		not null,
event		varchar2(100)	not null )
tablespace &pac_data;

create table programs (
day		date,
beg_time	number,
end_time	number,
event_id	number,
abstract_id	number,
session_id	varchar2(10),
location_code	varchar2(4) )
tablespace &pac_data;

create table emails (
email_id		integer,
subject			varchar2(1024)	not null,
message			clob	not null,
timestamp		date	not null )
tablespace &pac_data;

create table email_logs (
person_id	integer		not null,
email_id	integer		not null,
mail_id		integer		not null )
tablespace &pac_data;

create table unavailable_times (
unavailable_time_id	number,
beg_date		date		not null,
end_date		date		not null,
reason			varchar2(200) 	not null)
tablespace &pac_data;

-- ********** Registration module

create table pages (
page_id			number,
page_name		varchar2(80)	not null,
available		varchar2(1)	not null,
show_on_profile		varchar2(1)	not null,
show_on_abstract	varchar2(1)	not null,
return_URL		varchar2(200),
admin_privs		varchar2(1)	not null,
login_req		varchar2(1)	not null,
max_registrants		number,
post_info		varchar2(4000),
admin_email		varchar2(100),
hide_invoice		varchar2(1),
include_participant_rpt	varchar2(1),
include_statistics	varchar2(1),
external_URL		varchar2(200),
bypass_URL		varchar2(200) )
tablespace &PAC_Data;

create table meta_data_codes (
meta_data_code		number,
meta_data_descr		varchar2(4000)	not null,
data_type_code		varchar2(4)	not null,
display_code		varchar2(4)	not null,
data_length		number		not null,
view_length		number		not null,
required		varchar2(1)	not null,
fixed_length		varchar2(1)	not null,
fee			number,
late_fee		number,
short_descr		varchar2(20)	not null,
encrypt			varchar2(1),
miscellaneous		varchar2(1),
freeze_updates		varchar2(1)	not null,
single_selection	varchar2(1)	not null,
cutoff_date		date,
reg_cat_code		varchar2(4)	not null,
checkbox_max_items	number,
dropdown_max_items	number )
tablespace &PAC_Data;

create table poplist_items (
poplist_item_id	number,
meta_data_code	number		not null,
item_value	varchar2(4000)	not null,
sort_order	number,
fee		number,
late_fee	number)
tablespace &PAC_Data;

create table page_data (
page_data_id		number,
page_id			number		not null,
meta_data_code		number,
sort_order		number		not null,
text			varchar2(4000) )
tablespace &PAC_Data;

create table data_type_codes (
data_type_code	varchar2(4),
data_type_descr	varchar2(40)	not null )
tablespace &PAC_Data;

create table display_codes (
display_code	varchar2(4),
display_descr	varchar2(40)	not null )
tablespace &PAC_Data;

create table registrations (
registration_id	number,
person_id	number		not null,
meta_data_code	number,
value		varchar2(4000),
poplist_item_id	number,
fee_matrix_id	number,
timestamp	date,
payment_id	number,
fee		number,
reversed	date,
paid		number,
page_id		number		not null )
tablespace &PAC_Data;

create table checkbox_items (
checkbox_item_id	number,
poplist_item_id		number	not null,
person_id		number	not null,
timestamp		date	not null,
payment_id		number,
fee			number,
reversed		date,
paid			number )
tablespace &pac_data;

create table menu_items (
item_id		number,
URL		varchar2(1000),
link_name	varchar2(100)	not null,
repo_only	varchar2(1),
parent_item_id	number,
sortorder	number )
tablespace &pac_data;

create table abstract_presentations (
abstract_id		number		not null,
presentation_code	varchar2(2)	not null,
timestamp		date		not null,
person_id		number		not null)
tablespace &pac_data;

create table abstract_classifications (
abstract_id		number		not null,
classification_code	varchar2(8)	not null,
timestamp		date		not null,
person_id		number		not null,
sub_class_code		varchar2(4) )
tablespace &pac_data;

create table fee_matrix (
fee_matrix_id		number,
poplist_item_id1	number not null,
poplist_item_id2	number not null,
fee			number,
late_fee		number)
tablespace &pac_data;

create table conditional_requirements (
yesno_meta_code		number not null,
meta_data_code		number not null)
tablespace &pac_data;

create table payments (
person_id		number		not null,
timestamp		date		not null,
amount			number		not null,
payment_code		varchar2(4)	not null,
credit_card_id		number,
reversed		date,
payment_id		number,
processed		date,
IPN_status		varchar2(200),
invoice			varchar2(200),
receipt			varchar2(200),
comments		varchar2(4000) )
tablespace &pac_data;

create table registrants (
page_id		number		not null,
person_id	number		not null,
last_update	date		not null,
email_sent	date,
create_date	date		not null,
attended	varchar2(4),
sponsored_by	number,
meta_data_code	number,
NOTES		varchar2(4000),
cancel		date default null )
tablespace &pac_data;

create table payment_codes (
payment_code	varchar2(4),
payment_descr	varchar2(40)	not null,
online_option	varchar2(1)	not null,
conf_option	varchar2(1)	not null,
credit_card	varchar2(1)	not null,
instructions	varchar2(4000),
email_delay	number,
email_msg	varchar2(4000),
percentage_cost	number,
operation_cost	number,
waived		varchar2(1)	DEFAULT 'N' not null )
tablespace &pac_data;

create table credit_cards (
credit_card_id	number,
person_id	number,
payment_code	varchar2(4),
card_number	varchar2(32),
month		number(2),
year		number(4),
Cvv2		varchar2(32),
name		varchar2(50),
street		varchar2(50),
city		varchar2(50),
state		varchar2(50),
zip_postal	varchar2(20),
country_code	varchar2(4) )
tablespace &pac_data;

create table SPMS_jobs (
command		varchar2(60),
no_repo		varchar2(1),
trunc_sysdate	varchar2(1),
offset		number,
interval	varchar2(50) )
tablespace &pac_data;

create table time_zone_codes (
time_zone_code	varchar2(64),
time_zone_descr	varchar2(64) )
tablespace &pac_data;

create table person_schedules (
person_id	number,
abstract_id	number )
tablespace &PAC_Data;

create table experts (
person_id		number		not null,
classification_code	varchar2(8)	not null,
propose_reclass		varchar2(1)	not null,
approve_reclass		varchar2(1)	not null,
propose_present		varchar2(1)	not null,
approve_present		varchar2(1)	not null,
referee			varchar2(1)	not null,
referee_approver	varchar2(1)	not null,
coordinator		varchar2(1)	not null )
tablespace &PAC_Data;

create table referee_abstracts (
person_id		number		not null,
abstract_id		number		not null )
tablespace &PAC_Data;

create table reg_cat_codes (
reg_cat_code	varchar2(4),
reg_cat_descr	varchar2(40) )
tablespace &PAC_Data;

-- **********

create table deleted_persons (
person_id	number	not null,
timestamp	date	not null)
tablespace	&pac_data;

create table deleted_profiles (
profile_id	number	not null,
timestamp	date	not null)
tablespace	&pac_data;

-- **********

create table presentation_file_codes (
presentation_code	varchar2(2)	not null,
file_type_code		varchar2(4)	not null,
editor_only		varchar2(1)	not null,
always_available	varchar2(1)	not null,
weight			number)
tablespace &pac_data;

-- **********

create table attribute_codes (
attribute_code	varchar2(4),
attribute_descr	varchar2(40),
edit_early	varchar2(1) )
tablespace &pac_data;

create table abs_attributes (
abstract_id	number		not null,
attribute_code	varchar2(4)	not null )
tablespace &pac_data;

-- **********

create table program_sort_fields (
field_name	varchar2(40),
sort_order	number )
tablespace &pac_data;

-- **********

create table class_sessions (
class_session_id	number,
classification_code	varchar2(8),
sub_class_code		varchar2(4),
eclass_code		number,
session_id		varchar2(10)	not null,
sort_order		number		not null )
tablespace &pac_data;

-- **********

create table person_attributes (
person_id	number		not null,
attribute_code	varchar2(4)	not null)
tablespace &pac_data;

-- **********

create table ical_chars (
non_printable	varchar2(2)	not null,
printable	varchar2(2) )
tablespace &pac_data;

-- **********

create table payment_vendor_codes (
payment_vendor_code	varchar2(4),
payment_vendor_descr	varchar2(80)	not null,
action_URL		varchar2(100)	not null,
payment_msg		varchar2(4000),
input_tag_text		varchar2(4000),
action_URL_override	varchar2(1),
IPN_displays_invoice	varchar2(1),
confirmation_URL	varchar2(100),
failure_URL		varchar2(100) )
tablespace &pac_data;

create table SPMS_var_codes (
SPMS_var_code		varchar2(4),
SPMS_var_descr		varchar2(40) )
tablespace &pac_data;

create table var_type_codes (
var_type_code		varchar2(1),
var_type_descr		varchar2(20)	not null )
tablespace &pac_data;

create table payment_vendor_vars (
payment_vendor_var_ID	number,
payment_vendor_code	varchar2(4)	not null,
var_name		varchar2(100)	not null,
SPMS_var_code		varchar2(4),
var_text		varchar2(100),
var_type_code		varchar2(1)	not null )
tablespace &pac_data;

create table payment_vendor_IPNs (
payment_id		number		not null,
var_name		varchar2(4000)	not null,
var_values		varchar2(4000),
timestamp		date		not null )
tablespace &pac_data;

-- **********

create table function_codes (
function_code		varchar2(4),
function_descr		varchar2(80)	not null,
vendor_flag		varchar2(1),
abstract_flag		varchar2(1) )
tablespace &PAC_Data;

create table privilege_codes (
privilege_code		varchar2(4),
privilege_descr		varchar2(80)	not null,
activity_log		varchar2(1),
validate_ip_address	varchar2(1) )
tablespace &PAC_Data;

create table function_privileges (
function_code		varchar2(4)	not null,
privilege_code		varchar2(4)	not null)
tablespace &PAC_Data;

create table user_functions (
person_id		number		not null,
function_code		varchar2(4)	not null)
tablespace &PAC_Data;

create table person_privs (
person_id		number		not null,
privilege_code		varchar2(4)	not null)
tablespace &PAC_Data;

create table vendor_delegates (
person_id	number		not null,
vendor_id	number		not null,
function_code	varchar2(4)	not null)
tablespace &pac_data;

-- **********

create table merged_addresses (
old_addr_id	integer,
merge_into_id	integer,
timestamp	date)
tablespace &pac_data;

create table no_login_URLs (
url	varchar2(50) )
tablespace &pac_data;

-- **********

create table priority_codes (
priority_code	varchar2(2),
priority_descr	varchar2(40) )
tablespace &PAC_Data;

create table proposal_status_codes (
proposal_status_code	number,
proposal_status_descr	varchar2(40) )
tablespace &PAC_Data;

-- **********

create table author_types (
author_type	varchar2(4),
author_descr	varchar2(40)	not null)
tablespace &pac_data;

create table author_codes (
author_code	varchar2(4),
author_descr	varchar2(40)	not null,
pc_mode_descr	varchar2(40)	not null,
author_type	varchar2(4)	not null,
sort_order	number		not null)
tablespace &pac_data;

-- **********

CREATE TABLE HOTEL_CATEGORIES (
HOTEL_CAT_NAME	VARCHAR2(100) NOT NULL ,
DESCRIPTION	VARCHAR2(4000),
HOTEL_CAT_ID	NUMBER,
CAT_SYMBOL	VARCHAR2(10) )
TABLESPACE &pac_data;

CREATE TABLE HOTEL_PAYMENTS (
METHOD_ID	NUMBER,
PAYMENT_CODE	VARCHAR2(4000) )
TABLESPACE &pac_data;

CREATE TABLE HOTEL_ROOMTYPE_FEE (
HOTEL_ID	NUMBER,
ROOMTYPE_ID	NUMBER,
FEE		NUMBER,
HRF_ID		NUMBER )
TABLESPACE &pac_data;

CREATE TABLE HOTELS (
CORPORATE_NAME		VARCHAR2(100),
ADDRESS			VARCHAR2(100),
ADDRESS_NUMBER		NUMBER,
TOWN			VARCHAR2(100),
PROVINCE		VARCHAR2(100),
STATE			VARCHAR2(100),
VATIN			VARCHAR2(20),
PHONE_NUMBER		VARCHAR2(30),
FAX_NUMBER		VARCHAR2(30),
EMAIL			VARCHAR2(200),
DIRECTOR		VARCHAR2(100),
NATIONAL_ID_NUMB	VARCHAR2(20),
WEBSITE			VARCHAR2(150),
DESCRIPTION		VARCHAR2(4000),
HOTEL_CAT_ID		NUMBER,
HOTEL_ID		NUMBER )
TABLESPACE &pac_data;

CREATE TABLE REGISTRANTS_CHOICES (
CHOICE_ID	NUMBER,
REGISTRANT_ID	NUMBER,
START_DATE	DATE,
END_DATE	DATE,
CONFIG		VARCHAR2(10),
HOTEL_ID	NUMBER,
CONFIRMED	VARCHAR2(1) DEFAULT 'N',
DEPOSIT		NUMBER,
ROOM_ID		NUMBER,
CHOICE_ORDER	VARCHAR2(10),
STATUS		VARCHAR2(10),
PAYMENT_CODE	VARCHAR2(10),
R_LOCKED	VARCHAR2(1) DEFAULT 'N',
DATE_RECORD	timestamp default systimestamp,
SEQ_ID		number,
NOTES		VARCHAR2(4000),
RECEIPT		VARCHAR2(100),
IPN_STATUS	VARCHAR2(100),
INVOICE		VARCHAR2(100),
BOOKING_DATE	DATE,
PAYMENT_DATE	DATE,
DELETED		VARCHAR2(1) DEFAULT 'N',
voucher_qs	varchar2(4000) )
TABLESPACE &pac_data;

CREATE TABLE ROOM_DEPOSIT (
DEPOSIT_ID	NUMBER,
HOTEL_CAT_ID	NUMBER,
ROOM_TYPE_ID	NUMBER,
DEPOSIT		NUMBER,
DEP_LOCKED	NUMBER DEFAULT NULL)
TABLESPACE &pac_data;

CREATE TABLE ROOM_TYPES (
DESCRIPTION VARCHAR2(4000),
ROOM_TYPE_ID	NUMBER,
ROOM_NAME VARCHAR2(200) )
TABLESPACE &pac_data;

CREATE TABLE ROOMS_HOTEL (
ROOM_ID		NUMBER,
HOTEL_ID	NUMBER,
DESCRIPTION 	VARCHAR2(4000),
START_DATE	DATE,
END_DATE	DATE,
CONFIG		VARCHAR2(4000) )
TABLESPACE &pac_data;

create table payment_codes_page (
page_id		number,
payment_code	varchar2(4) )
tablespace &pac_data;

CREATE TABLE TEMP_REGISTRANTS_CHOICES (
CHOICE_ID	NUMBER,
REGISTRANT_ID	NUMBER,
START_DATE	DATE,
END_DATE	DATE,
CONFIG		VARCHAR2(10),
HOTEL_ID	NUMBER,
CONFIRMED	VARCHAR2(1)	DEFAULT 'N',
DEPOSIT		NUMBER,
ROOM_ID		NUMBER,
CHOICE_ORDER	VARCHAR2(10),
STATUS		VARCHAR2(10),
PAYMENT_CODE	VARCHAR2(10),
R_LOCKED	VARCHAR2(1)	DEFAULT 'N',
DATE_RECORD	TIMESTAMP(6)	DEFAULT systimestamp, 
NOTES		VARCHAR2(4000),
SEQ_ID		NUMBER,
IPN_STATUS	VARCHAR2(4000),
INVOICE		VARCHAR2(4000),
RECEIPT		VARCHAR2(4000),
BOOKING_DATE	DATE,
PAYMENT_DATE	DATE,
DELETED		VARCHAR2(1)	DEFAULT 'N' )
TABLESPACE &PAC_Data;

CREATE TABLE MISC_DATA_PAGE (
META_DATA_CODE	NUMBER, 
PERSON_ID	NUMBER, 
PAGE_ID		NUMBER, 
MISC_ID		NUMBER )
TABLESPACE &PAC_Data;

CREATE TABLE EXPORT_TEMPLATES (
TEMPLATE_ID	NUMBER,
TEMPLATE_NAME	VARCHAR2(100),
CHECKED_IN	VARCHAR2(1) DEFAULT 'N',
AFFILIATION	VARCHAR2(1) DEFAULT 'N',
REG_PAGE	VARCHAR2(1) DEFAULT 'N',
REG_DATE	VARCHAR2(1) DEFAULT 'N',
SPONSORED_BY	VARCHAR2(1) DEFAULT 'N',
SPONSOR_TYPE	VARCHAR2(1) DEFAULT 'N',
FEE		VARCHAR2(1) DEFAULT 'N',
PAID		VARCHAR2(1) DEFAULT 'N',
DUE		VARCHAR2(1) DEFAULT 'N' )
TABLESPACE &PAC_Data ;

CREATE GLOBAL TEMPORARY TABLE FREE_ROOMS_TEMP (
PID		NUMBER,
HOTEL_ID	NUMBER,
CONFIG		VARCHAR2(50),
START_DATE	DATE,
END_DATE	DATE,
ROOM_ID		NUMBER)
ON COMMIT DELETE ROWS;

create table regist_bypass_vars (
bypass_id	number,
page_id		number		not null,
var_name	varchar2(20)	not null,
value		varchar2(100),
bypass_var_code	varchar2(8) )
tablespace &pac_data;

create table bypass_var_codes (
bypass_var_code		varchar2(8),
bypass_var_descr	varchar2(40) )
tablespace &pac_data;

create table SPMS_CTX_indexes (
index_name	varchar2(30)	not null,
table_name	varchar2(30)	not null,
storage_name	varchar2(30)	not null)
tablespace &pac_data;

create table CTX_reserved_words (
word	varchar2(25) )
tablespace &pac_data;

create table registrations_payments (
registration_id	number not null,
payment_id	number not null,
amount 		number default 0 )
tablespace &pac_data;

CREATE TABLE TYPE_DISPLAY_DATA (
DISPLAY_CODE	VARCHAR2(4),
DATA_TYPE_CODE	VARCHAR2(4) )
TABLESPACE &pac_Data;

create table applications (
application_id		number,
application_name	varchar2(100)	not null )
tablespace &pac_data;

create table application_privs (
application_id		number,
privilege_code		varchar2(4) )
tablespace &pac_data;

create table upload_status_codes (
editor_status_code	varchar2(1)	not null,
referee_status_code	varchar2(1)	not null,
uploadable		varchar2(1)	not null )
tablespace &pac_data;

create table editor_status_codes (
editor_status_code	varchar2(1),
editor_status_descr	varchar2(80)	not null )
tablespace &pac_data;

create table referee_status_codes (
referee_status_code	varchar2(1),
referee_status_descr	varchar2(80)	not null )
tablespace &pac_data;

create table menu_item_subs (
maint_tab_name		varchar2(30)	not null,
alternate_URL		varchar2(30)	not null)
tablespace &PAC_Data;

create table transparency_codes (
transparency_code	varchar2(1),
transparency_descr	varchar2(40)	not null,
sort_order		number,
email_msg		varchar2(4000),
image_URL		varchar2(200)	not null,
publishable		varchar2(1)	not null,
px_width		number,
px_height		number,
edot_fg_color		varchar2(7),
edot_bg_color		varchar2(7) )
tablespace &PAC_Data;

create table maint_yes_no_flags (
table_column_name	varchar2(65) )
tablespace &pac_data;

create table abstract_proposals (
abstract_id		number		not null,
priority_code		varchar2(2)	not null,
proposal_status_code	number,
proposal_status_date	date		not null,
person_id		number		not null)
tablespace &pac_data;

create table initial_parameters (
ID	number		not null,
region	varchar2(4)	not null,
value	varchar2(2000) )
tablespace &pac_data;

create table initial_status_codes (
status_code	varchar2(1)	not null,
region		varchar2(4)	not null,
image_URL	varchar2(200)	not null )
tablespace &PAC_Data;

create table initial_referee_codes (
referee_code	varchar2(1)	not null,
region		varchar2(4)	not null,
image_URL	varchar2(200)	not null )
tablespace &PAC_Data;

create table super_region_codes (
super_region_code	varchar2(4),
super_region_descr	varchar2(80) not null)
tablespace &&PAC_Data;

-- ********** Sync Tables

create table sync_persons
	tablespace &PAC_Data
	as select 0 sync_id, t.* from persons t		where 0 = 1;

create table sync_profiles
	tablespace &PAC_Data
	as select 0 sync_id, t.* from profiles t	where 0 = 1;

create table sync_addresses
	tablespace &PAC_Data
	as select 0 sync_id, t.* from addresses t	where 0 = 1;

create table sync_affiliations
	tablespace &PAC_Data
	as select 0 sync_id, t.* from affiliations t	where 0 = 1;

create table sync_person_memberships
	tablespace &PAC_Data
	as select 0 sync_id, t.* from person_memberships t	where 0 = 1;

create table sync_mailing_lists
	tablespace &PAC_Data
	as select 0 sync_id, t.* from mailing_lists t	where 0 = 1;

create table sync_merge_persons (
sync_id		number,
old_person_id	number not null,
new_person_id	number not null )
tablespace &PAC_Data;

create table sync_merge_profiles (
sync_id		number,
old_profile_id	number not null,
new_profile_id	number not null )
tablespace &PAC_Data;

create table sync_data (
sync_id		number,
table_name	varchar2(30)	not null,
action		varchar2(6)	not null,
timestamp	date		not null )
tablespace &PAC_Data;

alter table sync_persons	modify lname		null;
alter table sync_persons	modify update_date	null;
alter table sync_profiles	modify person_id	null;
alter table sync_profiles	modify address_id	null;
alter table sync_profiles	modify update_date	null;
alter table sync_addresses	modify affiliation_id	null;
alter table sync_addresses	modify update_date	null;
alter table sync_affiliations	modify name1		null;
alter table sync_affiliations	modify update_date	null;

-- ********** End Sync Tables

create table abstract_sessions (
abstract_id		number		not null,
presentation_code	varchar2(2)	not null,
session_id		varchar2(10)	not null,
session_seq		number		not null,
paper_id		varchar2(13)	not null,
primary_flag		char(1)		not null,
start_time		number,
duration		number,
streaming_video_url	varchar2(200),
abstract_session_id	number )
tablespace &pac_data;

create global temporary table ID_list (
ID		NUMBER)
ON COMMIT DELETE ROWS;

spool off
