-- JACoW Repository

drop table xml_data;

create table xml_data (
conference_id	number		not null,
table_name	varchar2(30)	not null,
xml_data	xmltype );

alter table xml_data
	add constraint xml_data_conf_conferences_FK
	foreign key (conference_id)
	references conf_conferences (conference_id);

create unique index xml_data_UQ
	on xml_data (conference_id, table_name)
	tablespace &pac_index;

grant select on xml_data to jacow_bridge;

-- JACoW Bridge

create or replace synonym xml_data	for jacow.xml_data;
create or replace synonym xml_pkg	for jacow.xml_pkg;

-- **********

create or replace package xml_pkg as

type xml_data_type is table of varchar2(5000) index by pls_integer;

procedure load_xml_data (conf_id number, tname varchar2, xml_data xml_pkg.xml_data_type);

end;
/
show error

create or replace package BODY xml_pkg as

procedure load_xml_data (conf_id number, tname varchar2, xml_data xml_pkg.xml_data_type) is

clob_data	clob;

begin

   for i in 1..xml_data.COUNT loop
      clob_data := clob_data || xml_data(i);
   end loop;

   if clob_data is not null then
      delete from xml_data where conference_id = conf_id and table_name = tname;
      insert into xml_data values (conf_id, tname, xmltype(clob_data));
   end if;

end load_xml_data;

end;
/
show error

grant execute on xml_pkg to jacow_bridge;

