spool Create_XML_Views.log

create or replace view XML_Classification_Codes as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		CLASSIFICATION_CODE	VARCHAR2(8)	PATH '/ROW/CLASSIFICATION_CODE',
		CLASSIFICATION_DESCR	VARCHAR2(100)	PATH '/ROW/CLASSIFICATION_DESCR'
	) T
where	repo_xml_data.table_name = 'CLASSIFICATION_CODES';

create or replace view XML_Sub_Class_Codes as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		SUB_CLASS_CODE		VARCHAR2(4)	PATH '/ROW/SUB_CLASS_CODE',
		SUB_CLASS_DESCR		VARCHAR2(100)	PATH '/ROW/SUB_CLASS_DESCR'
	) T
where	repo_xml_data.table_name = 'SUB_CLASS_CODES';

create or replace view XML_Eclass_Codes as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		CLASSIFICATION_CODE	VARCHAR2(8)	PATH '/ROW/CLASSIFICATION_CODE',
		SUB_CLASS_CODE		VARCHAR2(4)	PATH '/ROW/SUB_CLASS_CODE'
	) T
where	repo_xml_data.table_name = 'ECLASS_CODES';

-- **********

create or replace view XML_User_Functions as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		PERSON_ID		NUMBER		PATH '/ROW/PERSON_ID',
		FUNCTION_CODE		VARCHAR2(4)	PATH '/ROW/FUNCTION_CODE'
	) T
where	repo_xml_data.table_name = 'USER_FUNCTIONS';

create or replace view XML_Function_Privileges as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		FUNCTION_CODE		VARCHAR2(4)	PATH '/ROW/FUNCTION_CODE',
		PRIVILEGE_CODE		VARCHAR2(4)	PATH '/ROW/PRIVILEGE_CODE'
	) T
where	repo_xml_data.table_name = 'FUNCTION_PRIVILEGES';

create or replace view XML_Function_Codes as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		FUNCTION_CODE		VARCHAR2(4)	PATH '/ROW/FUNCTION_CODE',
		FUNCTION_DESCR		VARCHAR2(80)	PATH '/ROW/FUNCTION_DESCR',
		VENDOR_FLAG		VARCHAR2(1)	PATH '/ROW/VENDOR_FLAG',
		ABSTRACT_FLAG		VARCHAR2(1)	PATH '/ROW/ABSTRACT_FLAG'
	) T
where	repo_xml_data.table_name = 'FUNCTION_CODES';

-- **********

create or replace view XML_Pages as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		page_id			NUMBER		PATH '/ROW/PAGE_ID',
		page_name		varchar2(80)	PATH '/ROW/PAGE_NAME',
		AVAILABLE		VARCHAR2(1)	PATH '/ROW/AVAILABLE',
		SHOW_ON_PROFILE		VARCHAR2(1)	PATH '/ROW/SHOW_ON_PROFILE',
		SHOW_ON_ABSTRACT	VARCHAR2(1)	PATH '/ROW/SHOW_ON_ABSTRACT',
		RETURN_URL		VARCHAR2(200)	PATH '/ROW/RETURN_URL',
		ADMIN_PRIVS		VARCHAR2(1)	PATH '/ROW/ADMIN_PRIVS',
		LOGIN_REQ		VARCHAR2(1)	PATH '/ROW/LOGIN_REQ',
		MAX_REGISTRANTS		NUMBER		PATH '/ROW/MAX_REGISTRANTS',
		POST_INFO		VARCHAR2(4000)	PATH '/ROW/POST_INFO',
		ADMIN_EMAIL		VARCHAR2(100)	PATH '/ROW/ADMIN_EMAIL',
		HIDE_INVOICE		VARCHAR2(1)	PATH '/ROW/HIDE_INVOICE',
		INCLUDE_PARTICIPANT_RPT	VARCHAR2(1)	PATH '/ROW/INCLUDE_PARTICIPANT_RPT',
		INCLUDE_STATISTICS	VARCHAR2(1)	PATH '/ROW/INCLUDE_STATISTICS',
		EXTERNAL_URL		VARCHAR2(200)	PATH '/ROW/EXTERNAL_URL',
		BYPASS_URL		VARCHAR2(200)	PATH '/ROW/BYPASS_URL'
	) T
where	repo_xml_data.table_name = 'PAGES';

create or replace view XML_Meta_Data_Codes as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		META_DATA_CODE		NUMBER		PATH '/ROW/META_DATA_CODE',
		META_DATA_DESCR		VARCHAR2(4000)	PATH '/ROW/META_DATA_DESCR',
		DATA_TYPE_CODE		VARCHAR2(4)	PATH '/ROW/DATA_TYPE_CODE',
		DISPLAY_CODE		VARCHAR2(4)	PATH '/ROW/DISPLAY_CODE',
		DATA_LENGTH		NUMBER		PATH '/ROW/DATA_LENGTH',
		VIEW_LENGTH		NUMBER		PATH '/ROW/VIEW_LENGTH',
		REQUIRED		VARCHAR2(1)	PATH '/ROW/REQUIRED',
		FIXED_LENGTH		VARCHAR2(1)	PATH '/ROW/FIXED_LENGTH',
		FEE			NUMBER		PATH '/ROW/FEE',
		LATE_FEE		NUMBER		PATH '/ROW/LATE_FEE',
		SHORT_DESCR		VARCHAR2(20)	PATH '/ROW/SHORT_DESCR',
		ENCRYPT			VARCHAR2(1)	PATH '/ROW/ENCRYPT',
		MISCELLANEOUS		VARCHAR2(1)	PATH '/ROW/MISCELLANEOUS',
		FREEZE_UPDATES		VARCHAR2(1)	PATH '/ROW/FREEZE_UPDATES',
		SINGLE_SELECTION	VARCHAR2(1)	PATH '/ROW/SINGLE_SELECTION',
		CUTOFF_DATE		DATE		PATH '/ROW/CUTOFF_DATE',
		REG_CAT_CODE		VARCHAR2(4)	PATH '/ROW/REG_CAT_CODE',
		CHECKBOX_MAX_ITEMS	NUMBER		PATH '/ROW/CHECKBOX_MAX_ITEMS',
		DROPDOWN_MAX_ITEMS	NUMBER		PATH '/ROW/DROPDOWN_MAX_ITEMS'
	) T
where	repo_xml_data.table_name = 'META_DATA_CODES';

create or replace view XML_Var_Type_Codes as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		VAR_TYPE_CODE	VARCHAR2(1)	PATH '/ROW/VAR_TYPE_CODE',
		VAR_TYPE_DESCR	VARCHAR2(20)	PATH '/ROW/VAR_TYPE_DESCR'
	) T
where	repo_xml_data.table_name = 'VAR_TYPE_CODES';

create or replace view XML_SPMS_VAR_CODES as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		SPMS_VAR_CODE	VARCHAR2(4)	PATH '/ROW/SPMS_VAR_CODE',
		SPMS_VAR_DESCR	VARCHAR2(40)	PATH '/ROW/SPMS_VAR_DESCR'
	) T
where	repo_xml_data.table_name = 'SPMS_VAR_CODES';

create or replace view XML_PAYMENT_VENDOR_CODES as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		PAYMENT_VENDOR_CODE	VARCHAR2(4)	PATH '/ROW/PAYMENT_VENDOR_CODE',
		PAYMENT_VENDOR_DESCR	VARCHAR2(80)	PATH '/ROW/PAYMENT_VENDOR_DESCR',
		ACTION_URL		VARCHAR2(100)	PATH '/ROW/ACTION_URL',
		PAYMENT_MSG		VARCHAR2(4000)	PATH '/ROW/PAYMENT_MSG',
		INPUT_TAG_TEXT		VARCHAR2(4000)	PATH '/ROW/INPUT_TAG_TEXT',
		ACTION_URL_OVERRIDE	VARCHAR2(1)	PATH '/ROW/ACTION_URL_OVERRIDE',
		IPN_DISPLAYS_INVOICE	VARCHAR2(1)	PATH '/ROW/IPN_DISPLAYS_INVOICE',
		CONFIRMATION_URL	VARCHAR2(100)	PATH '/ROW/CONFIRMATION_URL',
		FAILURE_URL		VARCHAR2(100)	PATH '/ROW/FAILURE_URL'
	) T
where	repo_xml_data.table_name = 'PAYMENT_VENDOR_CODES';

create or replace view XML_PAYMENT_VENDOR_VARS as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		PAYMENT_VENDOR_VAR_ID	NUMBER		PATH '/ROW/PAYMENT_VENDOR_VAR_ID',
		PAYMENT_VENDOR_CODE	VARCHAR2(4)	PATH '/ROW/PAYMENT_VENDOR_CODE',
		VAR_NAME		VARCHAR2(40)	PATH '/ROW/VAR_NAME',
		SPMS_VAR_CODE		VARCHAR2(4)	PATH '/ROW/SPMS_VAR_CODE',
		VAR_TEXT		VARCHAR2(100)	PATH '/ROW/VAR_TEXT',
		VAR_TYPE_CODE		VARCHAR2(1)	PATH '/ROW/VAR_TYPE_CODE'
	) T
where	repo_xml_data.table_name = 'PAYMENT_VENDOR_VARS';

create or replace view XML_DISPLAY_CODES as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		DISPLAY_CODE	VARCHAR2(4)	PATH '/ROW/DISPLAY_CODE',
		DISPLAY_DESCR	VARCHAR2(40)	PATH '/ROW/DISPLAY_DESCR'
	) T
where	repo_xml_data.table_name = 'DISPLAY_CODES';

create or replace view XML_DATA_TYPE_CODES as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		DATA_TYPE_CODE	VARCHAR2(4)	PATH '/ROW/DATA_TYPE_CODE',
		DATA_TYPE_DESCR	VARCHAR2(40)	PATH '/ROW/DATA_TYPE_DESCR'
	) T
where	repo_xml_data.table_name = 'DATA_TYPE_CODES';

create or replace view XML_REG_CAT_CODES as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		REG_CAT_CODE	VARCHAR2(4)	PATH '/ROW/REG_CAT_CODE',
		REG_CAT_DESCR	VARCHAR2(40)	PATH '/ROW/REG_CAT_DESCR'
	) T
where	repo_xml_data.table_name = 'REG_CAT_CODES';

create or replace view XML_POPLIST_ITEMS as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		POPLIST_ITEM_ID	NUMBER		PATH '/ROW/POPLIST_ITEM_ID',
		META_DATA_CODE	NUMBER		PATH '/ROW/META_DATA_CODE',
		ITEM_VALUE	VARCHAR2(4000)	PATH '/ROW/ITEM_VALUE',
		SORT_ORDER	NUMBER		PATH '/ROW/SORT_ORDER',
		FEE		NUMBER		PATH '/ROW/FEE',
		LATE_FEE	NUMBER		PATH '/ROW/LATE_FEE'
	) T
where	repo_xml_data.table_name = 'POPLIST_ITEMS';

create or replace view XML_CONDITIONAL_REQUIREMENTS as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		YESNO_META_CODE	NUMBER	PATH '/ROW/YESNO_META_CODE',
		META_DATA_CODE	NUMBER	PATH '/ROW/META_DATA_CODE'
	) T
where	repo_xml_data.table_name = 'CONDITIONAL_REQUIREMENTS';

create or replace view XML_FEE_MATRIX as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		FEE_MATRIX_ID		NUMBER	PATH '/ROW/FEE_MATRIX_ID',
		POPLIST_ITEM_ID1	NUMBER	PATH '/ROW/POPLIST_ITEM_ID1',
		POPLIST_ITEM_ID2	NUMBER	PATH '/ROW/POPLIST_ITEM_ID2',
		FEE			NUMBER	PATH '/ROW/FEE',
		LATE_FEE		NUMBER	PATH '/ROW/LATE_FEE'
	) T
where	repo_xml_data.table_name = 'FEE_MATRIX';

create or replace view XML_PAGE_DATA as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		PAGE_DATA_ID	NUMBER	PATH '/ROW/PAGE_DATA_ID',
		PAGE_ID	NUMBER	PATH '/ROW/PAGE_ID',
		META_DATA_CODE	NUMBER	PATH '/ROW/META_DATA_CODE',
		SORT_ORDER	NUMBER	PATH '/ROW/SORT_ORDER',
		TEXT		VARCHAR2(4000)	PATH '/ROW/TEXT'
	) T
where	repo_xml_data.table_name = 'PAGE_DATA';

create or replace view XML_PAYMENT_CODES as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		PAYMENT_CODE		VARCHAR2(4)	PATH '/ROW/PAYMENT_CODE',
		PAYMENT_DESCR		VARCHAR2(40)	PATH '/ROW/PAYMENT_DESCR',
		ONLINE_OPTION		VARCHAR2(1)	PATH '/ROW/ONLINE_OPTION',
		CONF_OPTION		VARCHAR2(1)	PATH '/ROW/CONF_OPTION',
		CREDIT_CARD		VARCHAR2(1)	PATH '/ROW/CREDIT_CARD',
		INSTRUCTIONS		VARCHAR2(4000)	PATH '/ROW/INSTRUCTIONS',
		EMAIL_DELAY		NUMBER		PATH '/ROW/EMAIL_DELAY',
		EMAIL_MSG		VARCHAR2(4000)	PATH '/ROW/EMAIL_MSG',
		PERCENTAGE_COST		NUMBER		PATH '/ROW/PERCENTAGE_COST',
		OPERATION_COST		NUMBER		PATH '/ROW/OPERATION_COST',
		WAIVED			VARCHAR2(1)	PATH '/ROW/WAIVED'
	) T
where	repo_xml_data.table_name = 'PAYMENT_CODES';

create or replace view XML_REGIST_BYPASS_VARS as
select	repo_xml_data.conference_id, T.*
from	repo_xml_data,
	XMLTable ('/ROWSET/ROW'
	PASSING xml_data
	COLUMNS
		BYPASS_ID	NUMBER		PATH '/ROW/BYPASS_ID',
		PAGE_ID		NUMBER		PATH '/ROW/PAGE_ID',
		VAR_NAME	VARCHAR2(40)	PATH '/ROW/VAR_NAME',
		VALUE		VARCHAR2(100)	PATH '/ROW/VALUE',
		BYPASS_VAR_CODE	VARCHAR2(8)	PATH '/ROW/BYPASS_VAR_CODE'
	) T
where	repo_xml_data.table_name = 'REGIST_BYPASS_VARS';

spool off
