set define off

Create or Replace package body editor as

rpt_title$		constant varchar2 (30)	:= 'Paper Editors'' Page';
qa_rpt_title$		constant varchar2 (30)	:= 'Paper QA';

edit_complete$		constant varchar2(1)	:= 'E';

platform_cookie$	constant varchar2(15)	:= 'JACoW_Platform';
source_cookie$		constant varchar2(15)	:= 'JACoW_Source';

QA_paper_ok$		constant varchar2(50) := 'QA Complete - Paper OK';
QA_reassign$		constant varchar2(50) := 'QA Failed - Reassign Paper To Me';
QA_back2editor$		constant varchar2(50) := 'QA Failed - Send back to the Editor';

-- ********************************************************************************************
-- ********************************************************************************************

function js$ return varchar2 is

begin

   return '<SCRIPT TYPE="text/javascript" language="JavaScript" src="' || common.server ||
		common.vdir$ || 'editor.js"></SCRIPT>';

end js$;

-- *********************************************************************************************

procedure js is

begin

   htp.p ('
function toggle_visibility (div_id, anchor_id) {

var DIV = document.getElementById (div_id);
var ANCHOR = document.getElementById (anchor_id);

   if (ANCHOR != null)
      if (DIV.style.display == ''none'')
	 ANCHOR.innerHTML = ''Hide Log'';
      else
	 ANCHOR.innerHTML = ''Show Log'';

   if (DIV.style.display == ''none'')
      DIV.style.display = ''block'';
   else
      DIV.style.display = ''none'';

}

String.prototype.toTitleCase = function() {
    return this.replace(/([\w&`''".@:\/\{\(\[<>_]+-? *)/g, function(match, p1, index, title) {
        if (index > 0 && title.charAt(index - 2) !== ":" &&
        	match.search(/^(a(nd?|s|t)?|b(ut|y)|en|for|i[fn]|o[fnr]|t(he|o)|vs?\.?|via)[ \-]/i) > -1)
            return match.toLowerCase();
        if (title.substring(index - 1, index + 1).search(/[''"_{(\[]/) > -1)
            return match.charAt(0) + match.charAt(1).toUpperCase() + match.substr(2);
        if (match.substr(1).search(/[A-Z]+|&|[\w]+[._][\w]+/) > -1 || 
        	title.substring(index - 1, index + 1).search(/[\])}]/) > -1)
            return match;
        return match.charAt(0).toUpperCase() + match.substr(1);
    });
};


');

end js;

-- ********************************************************************************************
-- ********************************************************************************************

procedure set_page_count (up_passphrase varchar2, abs_id integer, pcount integer) is

begin

   if nvl(up_passphrase,'~') = nvl(common.pass_phrase_paper_upload$,'#') then
      update	abstracts
      set	total_pages	= pcount
      where	abstract_id	= abs_id;
   end if;

end set_page_count;

-- ********************************************************************************************
-- ********************************************************************************************

function early_edit_profile (prof_id integer) return varchar2 is

cursor	driver is
select	'Y'
from	attribute_codes		ac,
	person_attributes	pa,
	profiles		prof
where	prof.profile_id		= prof_id
and	pa.person_id		= prof.person_id
and	ac.attribute_code	= pa.attribute_code
and	ac.edit_early		= 'Y';

dummy		varchar2(1)	:= null;

begin

   open driver;
   fetch driver into dummy;
   close driver;

   return dummy;

end early_edit_profile;

-- ********************************************************************************************

function early_edit_authors (abs_id integer) return boolean is

cursor	driver is
select	1
from	authors
where	abstract_id	= abs_id
and	'Y'		= editor.early_edit_profile (profile_id);

dummy		integer;
rec_found	boolean;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end early_edit_authors;

-- ********************************************************************************************

function early_edit (abs_id integer) return varchar2 is

cursor	driver is
select	common.get_author_profile_id (a.abstract_id, common.speaker$) spk_profile_id,
	common.get_author_profile_id (a.abstract_id, common.primary_author$) primary_profile_id
from	attribute_codes		ac,
	abs_attributes		aa,
	abstracts		a
where	a.abstract_id		= abs_id
and	aa.abstract_id		= a.abstract_id
and	ac.attribute_code	= aa.attribute_code
and	ac.edit_early		= 'Y';

driver_rec	driver%ROWTYPE;
rec_found	boolean;

begin

   open driver;
   fetch driver into driver_rec;
   rec_found := driver%FOUND;
   close driver;

   if rec_found then
      return '1';
   end if;

   if early_edit_profile (driver_rec.spk_profile_id) = 'Y' then
      return '1';
   end if;

   if early_edit_profile (driver_rec.primary_profile_id) = 'Y' then
      return '1';
   end if;

   if early_edit_authors (abs_id) then
      return '1';
   end if;

   return '9';

end early_edit;

-- ********************************************************************************************
-- ********************************************************************************************

procedure set_toc_page_numbers as

cursor	driver is
select	a.rowid, total_pages
from	presentation_option_codes	p,
	sessions			s,
	abstract_sessions		sa,
	abstracts			a
where	common.paper_OK_to_publish(a.ABSTRACT_ID) ='Yes'
and	a.total_pages			is not null
and	sa.abstract_id			= a.abstract_id
and	sa.primary_flag			= 'Y'
and	s.session_id			= sa.session_id
and	p.presentation_option_code	= s.presentation_option_code
order by
	decode (common.toc_by_present$, 'Y', p.presentation_type_code, ' '),
	s.sort_order nulls last, s.session_date, s.beg_time, sa.session_seq;

page_number	integer := 1;

begin

   update abstracts set toc_page_num = null;

   for driver_rec in driver LOOP
      update	abstracts
      set	toc_page_num	= page_number
      where	rowid		= driver_rec.rowid;

      page_number := page_number + driver_rec.total_pages;
   end loop;

end set_toc_page_numbers;

-- **************************************************************************************
-- **************************************************************************************

procedure restore_abstract3 (aid integer, this_payment_code varchar2 default null) is

begin

   common.get_gbl_pid;
   insert into abstracts
   select	ABSTRACT_ID, PERSON_ID, TITLE, DESCRIPTION, CLASSIFICATION_CODE,
		SUB_CLASS_CODE, ECLASS_CODE,
		NVL(this_payment_code, PRESENTATION_CODE), AGENCY, PAPER_URL,
		STATUS_CODE, EDITOR_ID,  ASSIGNABLE, TOTAL_PAGES, TOC_PAGE_NUM,
		SEARCH_TEXT, FOOTNOTE, POSTER_STATUS, REFEREE_CODE,
		TRANSPARENCY_CODE, TRANS_EDITOR_ID
   from		JN_abstracts
   where	abstract_id = aid;

   insert into authors
   select	*
   from		JN_authors
   where	abstract_id = aid;

   insert into logs
   select	*
   from		JN_logs
   where	abstract_id = aid;

   insert into log_errors
   select	*
   from		JN_log_errors
   where	log_id in
	(	select log_id from logs where abstract_id = aid);

   delete from JN_authors	where abstract_id = aid;
   delete from JN_logs		where abstract_id = aid;
   delete from JN_abstracts	where abstract_id = aid;

   common.redirect_URL ('editor.restore_abstract');

end restore_abstract3;

-- **************************************************************************************
-- **************************************************************************************

procedure restore_abstract2 (aid integer) is

cursor	driver is
select	a.title, pc.presentation_descr
from	presentation_codes	pc,
	jn_abstracts		a
where	a.abstract_id		= aid
and	pc.presentation_code(+)	= a.presentation_code;

rec_found	boolean;
rec		driver%ROWTYPE;

begin

   open driver;
   fetch driver into rec;
   rec_found := driver%FOUND;
   close driver;

   if rec.presentation_descr is not null then
      restore_abstract3(aid);

   else
      common.get_gbl_pid;

      if common.header ('Restore A Withdrawn Abstract') then
         htp.header (3, 'Restore: ' || aid || common.mdash$ || rec.title);
         htp.header (3, 'Please select the presentation type for this abstract');

         htp.formOpen ('editor.restore_abstract3', 'POST');
         htp.formHidden ('aid', aid);
         htp.tableOpen;
         common.show_popup_table_row ('presentation_code', 'presentation_descr',
					'presentation_codes', 'Presentation Type' || common.space2$);
         common.show_data_row (null, htf.formSubmit);
         htp.tableClose;
         htp.formClose;

         common.footer;
      end if;

   end if;

end restore_abstract2;

-- ********************************************************************************************
-- ********************************************************************************************

procedure restore_abstract is

cursor	driver is
select	jabs.*,
	common.get_author_profile_id (jabs.abstract_id, common.primary_author$) primary_profile_id
from	jn_abstracts	jabs
order by
	abstract_id;

begin

   if common.header ('Restore A Withdrawn Abstract') then
      htp.bold ('Click the ID to restore.');
      htp.tableOpen ('BORDER');
      htp.tableRowOpen ('LEFT', 'BOTTOM');
      htp.tableHeader ('ID');
      htp.tableHeader ('Paper ID');
      htp.tableHeader ('Title');
      htp.tableHeader ('Speaker/Presenter');
      htp.tableHeader ('Withdrawn');
      htp.tableRowClose;

      for driver_rec in driver LOOP
	 htp.tableRowOpen ('LEFT', 'TOP');
	 htp.tableData (htf.anchor ('editor.restore_abstract2?aid=' || driver_rec.abstract_id, driver_rec.abstract_id));
	 htp.tableData (driver_rec.title);
	 htp.tableData (common.get_user_name_affiliation (driver_rec.primary_profile_id) );
	 htp.tableData (common.local_time (driver_rec.withdraw_date)	|| htf.br ||
			common.get_user_name (driver_rec.withdrawn_by) );
	 htp.tableRowClose;
      end loop;

      htp.tableClose;
      common.footer;
   end if;

end restore_abstract;

-- ********************************************************************************************
-- ********************************************************************************************

function find_id (abs_id common.ident_arr) return integer is

begin

   for i in 1..abs_id.count LOOP
      if abs_id(i) is not null then
	 return abs_id(i);
      end if;
   end loop;

   return null;

end find_id;

-- ********************************************************************************************

procedure show_toc_page_numbers is

cursor	driver is
select	sa.paper_id, a.toc_page_num
from	sessions		s,
	abstract_sessions	sa,
	abstracts		a
where	s.session_id		= sa.session_id
and	a.abstract_id		= sa.abstract_id
order by
	a.toc_page_num;

begin

   htp.header (3, 'TOC Numbers Generated');
   htp.tableOpen;
   htp.tableRowOpen ('LEFT', 'BOTTOM');
   htp.tableHeader ('Paper ID');
   htp.tableHeader ('TOC #');
   htp.tableRowClose;

   for driver_rec in driver LOOP
      common.show_data_row (driver_rec.paper_id, driver_rec.toc_page_num);
   end loop;

   htp.tableClose;

end show_toc_page_numbers;

-- ********************************************************************************************

function validate_toc return boolean is

cursor	c1 is
select	sa.paper_id,
	upper (nvl (
		common.decode_value (	'status_descr', 'status_codes',
					'status_code', a.status_code),
			 'missing'))	status
from	sessions		s,
	abstract_sessions	sa,
	abstracts		a
where (	a.status_code		is null OR
	a.status_code		in
	(	select	status_code
		from	status_codes
		where	publishable(+)	= 'N'
      )	)
and	sa.abstract_id		= a.abstract_id
and	s.session_id		= sa.session_id
order by
	s.sort_order, s.session_date, s.beg_time;

cursor	c2 is
select	sa.paper_id
from	sessions		s,
	abstract_sessions	sa,
	status_codes		sc,
	abstracts		a
where	a.total_pages		is null
and	sa.abstract_id		= a.abstract_id
and	sa.primary_flag		= 'Y'
and	s.session_id		= sa.session_id
and	sc.status_code		= a.status_code
and	sc.publishable		= 'Y'
order by
	s.sort_order, s.session_date, s.beg_time;

icount		integer;
valid_data	boolean := true;

begin

   for driver_rec in c1 LOOP
      htp.p (driver_rec.paper_id || ' has a ' || driver_rec.status || ' dot.');
      htp.br;
   end loop;

   for driver_rec in c2 LOOP
      htp.p (driver_rec.paper_id || ' is missing its total page count.');
      htp.br;
      valid_data := false;
   end loop;

   return valid_data;

end validate_toc;

-- ********************************************************************************************

procedure toc is

begin

   if common.header (rpt_title$) then
      if validate_toc then
	 set_toc_page_numbers;
	 show_toc_page_numbers;
      else
	 htp.header (3, 'Unable to generate TOC numbers');
	 htp.bold ('Please correct the errors listed above.');
      end if;
      common.footer;
   end if;

end toc;

-- ********************************************************************************************
-- ********************************************************************************************

procedure show_link_backs is

begin

   htp.anchor ('editor.html', 'Back to Editors'' Page');
   htp.p (common.space2$);
   htp.anchor ('editor.list_all', 'List All Papers');
   htp.p (common.space2$);
   htp.anchor ('reports.html', 'Reports &amp; Statistics');
   htp.para;

end show_link_backs;

-- *****************************************************************************
-- *****************************************************************************

function get_max_pages (abs_id integer) return integer is

presentation_code	presentation_codes.presentation_code%TYPE;
max_pages		integer;

begin

   presentation_code	:= common.decode_value ('presentation_code', 'abstracts', 'abstract_id', abs_id);
   max_pages		:= common.decode_value ('max_pages', 'presentation_codes', 'presentation_code', presentation_code);

   return max_pages;

end get_max_pages;

-- *****************************************************************************

procedure QA_post (abs_id integer, abs_title varchar2, action varchar2,
				pcount varchar2, this_comment varchar2) is

begin

   if common.header (rpt_title$) then
      if action = QA_paper_ok$ then

         if pcount is null then
            htp.header (3, 'Missing Page Count');

         elsif NOT common.validate_number (pcount) then
            htp.header (3, 'Invalid Page Count ' || pcount);

         elsif pcount > get_max_pages (abs_id) then
            htp.header (3, 'Page Count ' || pcount || ' Exceeds Maximum Pages: ' || get_max_pages (abs_id));

         elsif pcount < 0 then
            htp.header (3, 'Page Count Is Negative' || pcount);

         else
            update	abstracts
	    set		total_pages	= pcount,
			title		= abs_title
	    where	abstract_id	= abs_id;

         insert into logs (abstract_id, log_code, comments)
         values (abs_id, common.final_QA_passed$, trim (this_comment) );
         htp.header (3, 'QA Complete');
         end if;

      else
         update	abstracts
         set	status_code	= null,
		title		= abs_title
         where	abstract_id	= abs_id;

         insert into logs (abstract_id, log_code, comments)
         values (abs_id, common.final_QA_failed$, trim (this_comment) );

         if action = QA_reassign$ then
            if common.gbl_priv_pid <> common.decode_value ('editor_id', 'abstracts',
							'abstract_id', abs_id) then
               insert into logs (abstract_id, log_code)
               values (abs_id, common.paper_reassigned$);

               update	abstracts
               set	editor_id	= common.gbl_priv_pid,
			title		= abs_title
               where	abstract_id	= abs_id;
            end if;

            htp.header (3, 'Paper Reassigned To You');

         elsif action = QA_back2editor$ then
            htp.header (3, 'Paper Assiged Back to the Original Editor');
         end if;

      end if;

      htp.anchor ('editor.qa', 'QA Next Paper');
      htp.p (common.space2$);
      show_link_backs;

      htp.para;
      common.footer;
   end if;

end QA_post;

-- *****************************************************************************
-- *****************************************************************************

procedure QA_paper (abs_id common.ident_arr) is

cursor	driver (aid integer) is
select	a.*, common.get_paper_id (a.abstract_id) paper_id
from	abstracts	a
where	abstract_id	= aid;

driver_rec	driver%ROWTYPE;
rec_found	boolean;
buffer		varchar2(1000) := 'No PDF File';

ID		constant integer := find_id (abs_id);
URL		varchar2(100);

begin

   if common.header (rpt_title$) then
      open driver (ID);
      fetch driver into driver_rec;
      rec_found := driver%FOUND;
      close driver;

      htp.p (profile.js$);
      htp.p (editor.js$);
      htp.anchor ('editor.qa', 'Get Another Paper to QA');
      htp.br;
      htp.header (3, driver_rec.paper_id || ' (' ||
			common.decode_value ('presentation_descr', 'presentation_codes',
						'presentation_code', driver_rec.presentation_code) ||
			') ' || driver_rec.title);
      htp.tableOpen;

      if NOT rec_found then
	 htp.header (3, 'No Such Paper.' || driver_rec.paper_id);

      elsif NOT common.publishable_status_code (driver_rec.status_code) AND
		common.publishable_referee_code (driver_rec.referee_code) then
	 htp.header (3, 'Unable to QA Paper ' || driver_rec.paper_id);
	 htp.p ('The paper does not have a publishable status.');
	 htp.para;

      else
	 htp.formOpen ('editor.qa_post', 'POST', cattributes=>'NAME="SPMS"');
	 htp.formHidden ('abs_id', ID);

	 htp.tableOpen (cattributes=>'CELLSPACING="5"');

	 URL := 'javascript:newWindow (''JACoW.abs_authors?abs_id=' || ID || ''')';
	 common.show_data_row (htf.anchor2 (URL, 'Authors'), common.get_author_list2 (ID) );

	 URL := 'javascript:newWindow (''email.one_email?abs_id=' || ID || ''')';
	 common.show_data_row (htf.anchor2 (URL, 'Send Email'), '' );

	 common.show_data_row ('Editor',  common.get_user_name (driver_rec.editor_id));
	 common.show_data_row ('Title', htf.formText ('abs_title', 75, 200, htf.escape_sc (driver_rec.title) )	||
		common.space2$ ||
		'<input type="button" name="Title Case" value="TitleCase" '	||
		'onClick="document.SPMS.abs_title.value=document.SPMS.abs_title.value.toLowerCase();'	||
			 'document.SPMS.abs_title.value=document.SPMS.abs_title.value.toTitleCase();"' );
	 htp.tableRowOpen ('LEFT', 'TOP');
	 htp.tableHeader ('Select an Action', 'RIGHT');
	 htp.p ('<TD>');
	 htp.formSelectOpen ('action');
	 htp.formSelectOption (QA_paper_ok$, 'SELECTED');
	 htp.formSelectOption (QA_reassign$);
	 htp.formSelectOption (QA_back2editor$);
	 htp.formSelectClose;
	 htp.p ('</TD>');
	 htp.tableRowClose;

	 if common.PDF_uploaded (ID) then
	    buffer := htf.anchor2 (common.get_paper_PDF (ID), 'View PDF', ctarget=>'_new');
	 end if;

	 common.show_data_row ('Total Pages',		htf.formText ('pcount', 3, 3, nvl (driver_rec.total_pages, get_max_pages (ID)) ) );
	 common.show_data_row ('Comments (Optional)',	htf.formTextArea ('this_comment', 5, 40) );
	 common.show_data_row (buffer, htf.formSubmit || common.space2$ ||
		htf.anchor2 ('JACoW.file_info'	||
					'?abs_id=' || ID ||
					'&paper_id=' || common.get_paper_id(ID),
				'File Upload', ctarget=>'upload') );
	 htp.tableClose;
	 htp.formClose;

	 htp.hr;
	 common.show_abstract_log (driver_rec.abstract_id, show_notes=>true, toggle_view=>true);

      end if;

      common.footer;
   end if;

end QA_paper;

-- ********************************************************************************************
-- ********************************************************************************************

procedure QA is

begin

   common.get_gbl_pid;

   if common.has_privs_to_page (common.QA_page$) then
      maint.header (QA_rpt_title$);
      htp.formOpen ('editor.qa_paper', 'POST');

      htp.tableOpen (cattributes=>'WIDTH=100%"');
      htp.tableRowOpen ('LEFT', 'TOP');
      htp.p ('<TD>');
	 htp.tableOpen;
	 htp.header (3, 'Select a Paper to QA');
	 show_paper_id_popup (true);
	 common.show_data_row (null, htf.formSubmit);
	 htp.tableClose;

	 htp.para;
	 htp.formClose;
      htp.p ('</TD>');

      htp.tableData (common.space2$ || common.space2$ || common.space2$);

      htp.p ('<TD>');
	 maint.menu;
      htp.p ('<TD>');

      htp.tableRowClose;
      htp.tableClose;

      show_link_backs;
      common.footer;
   end if;

end QA;

-- *****************************************************************************
-- *****************************************************************************

procedure download (paper_id varchar2) is

begin

   if common.header (rpt_title$) then
      htp.header (3, 'This Page is a Placeholder For the Editors'' Download Utility.');
      htp.p ('Set the value for the parameter');
      htp.bold ('"Editor Download Script"');
      htp.p ('on the');
      htp.anchor (common.server || common.vdir$ || 'params.html', 'Systems Parameters Page.');
      htp.bold ('Note:');
      htp.p ('You must log into this page as the schema owner (JACoW is the default owner).');
      htp.para;

      htp.p ('The script may have any valid name but must accept the parameter "PAPER_ID."');
      htp.para;
      common.footer;
   end if;

end download;

-- ********************************************************************************************
-- ********************************************************************************************

function get_abs_owner_email (abs_id integer) return varchar2 is

cursor	driver is
select	distinct email_address
from	profiles		pro,
	abstracts		abs
where	abs.abstract_id		= abs_id
and	pro.person_id		= abs.person_id
and	pro.email_address	is not null;

buffer	varchar2(200);

begin

   for driver_rec in driver LOOP
      buffer := buffer || ',' || driver_rec.email_address;
   end loop;

   return substr (buffer, 2);

end get_abs_owner_email;

-- ********************************************************************************************

procedure save_status (abs_id integer, code varchar2, error_list common.ident_arr,
			this_comment varchar2, this_note varchar2) is

paper_id	constant varchar2(20)	:= common.get_paper_id (abs_id);
status_code	constant status_codes.status_code%TYPE := common.decode_value ('status_code', 'abstracts', 'abstract_id', abs_id);

next_log_id	integer;

begin

   if common.header (rpt_title$, test_only=>true) then
      if code is not null AND NOT common.publishable_status_code (code) AND error_list.count = 1 then
	 common.public_header (rpt_title$);
	 htp.header (3, 'You must check at least one check box when assigning a non-publishable dot status.');
	 htp.p (common.click_back$);
	 htp.para;
	 common.footer;

      else
	 select log_id_seq.nextval into next_log_id from dual;

	 update abstracts
	 set	status_code	= code
	 where	abstract_id	= abs_id;

	 insert into logs (log_id, abstract_id, log_code, status_code, comments, editor_notes)
	 values (next_log_id, abs_id, common.edit_complete$, code, this_comment, this_note);

	 for i in 2..error_list.count LOOP
	    insert into log_errors (log_id, error_code)
	    values (next_log_id, error_list(i));
	 end loop;

	 common.redirect_URL ('editor.process_paper?abs_id=' || abs_id);

      end if;

   end if;

end save_status;

-- ********************************************************************************************
-- ********************************************************************************************

procedure set_status (abs_id integer, code varchar2, flag integer) is

cursor	driver is
select	*
from	error_codes
where	editor		like decode (flag, editor_only$, 'Y', '%')
and	poster		like decode (flag, poster_only$, 'Y', '%')
and	referee		like decode (flag, referee_only$, 'Y', '%')
order by
	error_descr;

status_code	constant status_codes.status_code%TYPE :=
		common.decode_value ('status_code', 'abstracts', 'abstract_id', abs_id);
status_descr	constant status_codes.status_descr%TYPE :=
		common.decode_value ('status_descr', 'status_codes', 'status_code', code);
OK_to_save	boolean := true;

begin

   if common.header (rpt_title$) then
      htp.header (3, common.get_paper_id (abs_id) );

      htp.formOpen ('editor.save_status', 'POST', cattributes=>'NAME="SPMS"');
      htp.formHidden ('abs_id', abs_id);
      htp.formHidden ('code', code);
      htp.formHidden ('error_list', 'dummy');

      if code is not null AND NOT common.publishable_status_code (code) then
         htp.header (3, 'Check all reasons for assigning a ' || status_descr || ' Dot to this paper');
         for driver_rec in driver LOOP
	    htp.formCheckBox ('error_list', driver_rec.error_code);
            htp.p (driver_rec.error_descr);
            htp.br;
         end loop;
      end if;

      htp.para;
      htp.tableOpen;

      htp.tableRowOpen ('LEFT', 'BOTTOM');
      htp.tableHeader ('Comments to Author');
      htp.tableHeader ('Editor''s Notes');
      htp.tableRowClose;

      htp.tableRowOpen ('LEFT', 'BOTTOM');
      htp.tableHeader (htf.formTextArea ('this_comment', 5, 40) );
      htp.tableHeader (htf.formTextArea ('this_note',    5, 40) );
      htp.tableRowClose;

      htp.tableClose;
      htp.para;

      if NOT common.PDF_uploaded (abs_id) AND common.pdf_required_code (code) then
         htp.bold ('Warning: You are assigning a dot status that requires a PDF but there is no PDF file uploaded.',
			cattributes=>common.red$);
         htp.br;
         OK_to_save := false;
      end if;

      if nvl (code, '~') = nvl (status_code, '~') then
         htp.bold ('Note: You have not changed the papers'' status',
		cattributes=>common.red$);
         htp.p ('You may continue if you simply wish to add additional comments.');
         htp.br;
         OK_to_save := true;
      end if;

      if OK_to_save then
         htp.formSubmit (null, 'Save');
      end if;
      htp.formClose;
      common.form_focus ('SPMS', 'this_comment');

      common.footer;
   end if;

end set_status;

-- ********************************************************************************************
-- ********************************************************************************************

procedure process_paper_hdr is

begin

   htp.tableOpen ('BORDER');

   htp.tableRowOpen ('LEFT', 'BOTTOM');
   htp.tableHeader ('Paper ID');
   htp.tableHeader ('Function');
   htp.tableHeader ('Change Status');
   htp.tableHeader ('Files Uploaded');
   htp.tableRowClose;

end process_paper_hdr;

-- ********************************************************************************************

function new_files (abs_id integer) return varchar2 is

cursor	C1 is
select	max (log_date)
from	logs
where	abstract_id	= abs_id
and	log_code	in (common.edit_complete$, common.dot_reassignment$);

cursor	C2 is
select	max (uploaded_date)
from	files
where	abstract_id	= abs_id
and	file_type_code	IN
(
	select	file_type_code
	from	presentation_file_codes
	where	always_available 	= 'N'
	and	editor_only	 	= 'N'
	and	presentation_code	in
	(	select	presentation_code
		from	abstracts
		where	abstract_id	= abs_id
)	);

last_edit	date;
last_upload	date;

begin

   open C1;
   fetch C1 into last_edit;
   close C1;

   open C2;
   fetch C2 into last_upload;
   close C2;

   if last_upload > last_edit then
      return 'YES';
   else
      return 'NO';
   end if;

end new_files;

-- ********************************************************************************************

function files_uploaded (abs_id integer) return boolean is

cursor	driver is
select	1
from	files
where	abstract_id	= abs_id
and	deleted		is null;

dummy		integer;
rec_found	boolean;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end files_uploaded;

-- ********************************************************************************************

procedure show_file_list (abs_id integer) is

cursor	driver is
select	*
from	files
where	abstract_id = abs_id
order by
	uploaded_date desc;

first	boolean	:= true;
platform_descr	platform_codes.platform_descr%TYPE;

begin

   htp.p ('<TD>');
   for driver_rec in driver loop
      if first then
	 htp.ulistOpen;
	 first := false;
      end if;

      platform_descr := common.decode_value ('platform_descr', 'platform_codes', 'platform_code', driver_rec.platform_code);
      htp.listItem (platform_descr || common.space$ || driver_rec.file_name, cattributes=>'CLASS="BULLET"');
   end loop;

   if first then
      htp.p (common.space$);
   else
      htp.ulistClose;
   end if;

   htp.p ('</TD>');

end show_file_list;

-- ********************************************************************************************

procedure show_registered (abs_id integer) is

cursor	driver is
select	aa.ctype, common.get_user_name (aa.person_id) name
from	persons			p,
	abstract_authors	aa
where	aa.abstract_id	= abs_id
and	p.person_id	= aa.person_id
and	regist_maint.is_registered (aa.person_id)	= 'Y'
order by aa.ctype, p.sort_lname, p.sort_fname, p.sort_mname;

begin

   common.blank_header ('Registered Persons');
   htp.header (3, 'Registered Individuals');
   common.show_abstract_title (abs_id);

   htp.tableOpen;
   htp.tableRowOpen ('LEFT', 'BOTTOM');
   htp.tableHeader ('Type');
   htp.tableHeader ('Name');
   htp.tableRowClose;

   for driver_rec in driver LOOP
      htp.tableRowOpen ('LEFT', 'BOTTOM');
      htp.tableData (driver_rec.ctype);
      htp.tableData (driver_rec.name);
      htp.tableRowClose;
   end loop;

   htp.tableClose;
   common.blank_footer;

end show_registered;

-- ********************************************************************************************

procedure anyone_registered (abs_id integer) is

cursor	driver is
select	ctype, count(1) icount
from	abstract_authors	aa
where	abstract_id 		= abs_id
and	regist_maint.is_registered (aa.person_id)	= 'Y'
group by ctype;

first	boolean := true;
buffer	varchar2(100);

style$	varchar2(30)	:= 'STYLE="margin-left: -15pt"';
style	varchar2(30);
URL	varchar2(100);

begin

   for driver_rec in driver LOOP
      if first then
	 URL := 'editor.show_registered?abs_id=' || abs_id;
	 htp.para;
	 htp.anchor ('javascript:popUp(''' || URL || ''')', 'Registered');
	 htp.br;
	 first := false;

	 style := 'STYLE="margin-top: 0pt"';
	 if lower (owa_util.get_cgi_env('HTTP_USER_AGENT')) like '%firefox%' then
	    style := 'STYLE="margin-top: -6pt"';
	 end if;
	 htp.ulistOpen (cattributes=>style);

      end if;

      buffer := driver_rec.ctype;
      if driver_rec.icount > 1 then
	 buffer := buffer || ' (' || driver_rec.icount || ')';
      end if;
      htp.listItem (buffer, cattributes=>style$);
   end loop;

   if not first then
      htp.ulistClose;
   end if;

end anyone_registered;

-- ********************************************************************************************

procedure process_paper_data (abs_id integer) is

status_code	status_codes.status_code%TYPE :=
			common.decode_value ('status_code', 'abstracts', 'abstract_id', abs_id);
paper_id	varchar2(50) := common.get_paper_id (abs_id);
IDs		common.ident_arr := common.get_paper_ID_list(abs_id);

begin

   htp.tableRowOpen ('LEFT', 'TOP');
   htp.p ('<TD NOWRAP>');

      htp.p (paper_id);
      if status_code is not null then
	 htp.p (common.get_dot_image (status_code, common.editor_dot$));
      end if;

      if common.uploadable_dot_status (status_code) and new_files (abs_id) = 'YES' then
	 htp.br;
	 htp.bold ('NEW FILES', cattributes=>common.red$);
      end if;

      anyone_registered (abs_id);

   htp.p ('</TD>');

   htp.p ('<TD NOWRAP>');
      htp.anchor2 ('jacow.view_abstract?abs_id=' || abs_id, 'View Abstract', ctarget=>'_new');
      htp.br;
      htp.anchor2 ('jacow.edit_abstract_editor?abs_id=' || abs_id, 'Edit Abstract', ctarget=>'_new');
      htp.br;
      htp.anchor2 ('JACoW.abs_log?abs_id=' || abs_id, 'Full Log', ctarget=>'_new');

      if common.has_privs_to_page (common.email_page$, false) then
         htp.br;
	 htp.anchor ('email.one_email?abs_id=' || abs_id, 'Email');
      end if;

      htp.br;

      if IDs.COUNT = 1 then
         htp.anchor2 ('jacow.file_info' || '?abs_id=' || abs_id ||
					'&paper_id=' || paper_id, 'Upload Files', ctarget=>'_new');
         htp.br;
         htp.p (common.paper_anchor_tag (paper_id) );
      else
         htp.p ('Upload Files');
         for i in 1..IDs.COUNT loop
            htp.br;
            htp.listItem (htf.anchor2 ('jacow.file_info' || '?abs_id=' || abs_id ||
					'&paper_id=' || IDs(i), IDs(i), ctarget=>'_new'));
         end loop;

         htp.br;
         htp.p ('Download Files');
         for i in 1..IDs.COUNT loop
            htp.br;
            htp.listItem (common.paper_anchor_tag (IDs(i), IDs(i)) );
         end loop;
      end if;

   htp.p ('</TD>');

   htp.p ('<TD ALIGN="CENTER">');
      htp.formOpen ('editor.set_status', 'POST');
      htp.formHidden ('abs_id', abs_id);
      htp.formHidden ('flag', editor_only$);

      common.status_code_popup (status_code, 'Y', '%', show_null_opt=>false);

      htp.br;
      htp.formSubmit (null, 'Set Status');
      htp.formClose;
   htp.p ('</TD>');

   show_file_list (abs_id);
   htp.tableRowClose;

end process_paper_data;

-- ********************************************************************************************

procedure process_paper (abs_id integer) is

platform	platform_codes.platform_code%TYPE;
source		source_codes.source_code%TYPE;
URL		varchar2(100);

begin

   platform	:= nvl (common.get_cookie (platform_cookie$), '%');
   source	:= nvl (common.get_cookie (source_cookie$), 'Any');
   common.get_gbl_pid;

   if common.header (rpt_title$) then
      common.js$;
      htp.p (editor.js$);

      URL := 'editor.assign_next_paper'		||
			'?abs_id='		||
			'&ppid='		||
			'&this_platform='	|| platform ||
			'&this_source='		|| source;

      htp.anchor (htf.escape_URL (URL), 'Get Next Paper');
      htp.p (common.space2$);
      show_link_backs;

      process_paper_hdr;
      process_paper_data (abs_id);
      htp.tableClose;
      common.footer;
   end if;

end process_paper;

-- ********************************************************************************************
-- ********************************************************************************************

procedure assign_paper (abs_id integer, this_code varchar2) is

cursor	driver is
select	status_code
from	log_codes
where	log_code = this_code;

rec	driver%ROWTYPE;

begin

   common.get_gbl_pid;

   open driver;
   fetch driver into rec;
   close driver;

   update	abstracts
   set		editor_id	= common.gbl_priv_pid,
		status_code	= nvl (status_code, rec.status_code)
   where	abstract_id	= abs_id;

   insert into logs (abstract_id, log_code, person_id, status_code)
   values (abs_id, this_code, common.gbl_priv_pid, rec.status_code);

   common.redirect_URL ('editor.process_paper?abs_id=' || abs_id);

end assign_paper;

-- ********************************************************************************************
-- ********************************************************************************************

function select_next_paper (this_platform varchar2, this_source varchar2) return boolean is

cursor	driver (expression$ varchar2) is
select	/* INDEX(s) */
	a.abstract_id, sa.paper_id
from	sessions					s,
	abstract_sessions				sa,
	abstracts					a
where	a.editor_id					is null
and	a.assignable					>= common.file_weight_threshold$
and	common.get_abs_platform (a.abstract_id)		like this_platform
and	sa.abstract_id					= a.abstract_id
and	sa.primary_flag					= 'Y'
and	s.session_id					= sa.session_id
and	exists
(
	select	/*+ INDEX(f) */ 1
	from	files			f
	where	f.abstract_id		= a.abstract_id
	and	uploaded_date		< common.get_UTC_time - (30/1440)
	and	REGEXP_LIKE (file_name, expression$, 'i')
)
order by
	editor.early_edit (a.abstract_id),
	s.sort_order	nulls last,
	s.session_date,
	s.beg_time,
	a.assignable,
	sa.session_seq
for update of editor_id;

assignable	boolean := false;
expression	source_codes.reg_exp%TYPE;

begin

   expression := common.decode_value ('reg_exp', 'source_codes', 'source_code', this_source);

   for driver_rec in driver(expression) LOOP
      if common.referee_conf$ = 'Y' then
	 if referee.assigned (driver_rec.abstract_id) = 'N' then
	    assignable := true;
	 end if;
      else
	 assignable := true;
      end if;

      if assignable then
	 assign_paper (driver_rec.abstract_id, common.paper_assigned$);
      end if;

      exit when assignable;
   end loop;

   if assignable then
      return true;
   end if;

   common.public_header (rpt_title$);
   htp.header (3, 'No More Papers to Assign');
   return false;

end select_next_paper;

-- ********************************************************************************************

function assign_1_paper (abs_id integer) return boolean is

cursor	driver is
select	a.*, common.get_paper_id (a.abstract_id) paper_id
from	abstracts	a
where	abstract_id	= abs_id;

rec_found	boolean;
driver_rec	driver%ROWTYPE;

begin

   open driver;
   fetch driver into driver_rec;
   rec_found := driver%FOUND;
   close driver;

   if rec_found then

      if driver_rec.editor_id is null then

	 if driver_rec.assignable < common.file_weight_threshold$ then

	    common.public_header (rpt_title$);
	    htp.header (3, driver_rec.paper_id || ' Is Not Ready Yet.');
	    htp.p ('Not all files are uploaded.');

	    htp.formOpen ('editor.assign_paper', 'POST');
	    htp.formHidden ('abs_id', abs_id);
	    htp.formHidden ('this_code', common.paper_assigned$);
	    htp.formSubmit (null, 'Assign ' || driver_rec.paper_id || ' to me anyway.');
	    htp.formClose;

	 else
	    assign_paper (abs_id, common.paper_assigned$);
	    return true;

	 end if;

      elsif driver_rec.editor_id = common.gbl_priv_pid then
	 common.redirect_URL ('editor.process_paper?abs_id=' || abs_id);
	 return true;

      else

	 common.public_header (rpt_title$);
	 htp.header (3, driver_rec.paper_id || ' is currently assigned to ' || common.get_user_name (driver_rec.editor_id) );
	 htp.formOpen ('editor.assign_paper', 'POST');
	 htp.formHidden ('abs_id', abs_id);
	 htp.formHidden ('this_code', common.paper_reassigned$);
	 htp.formSubmit (null, 'Reassign ' || driver_rec.paper_id || ' to me.');
	 htp.formClose;

      end if;

   else
      common.public_header (rpt_title$);
      htp.header (1, 'SYSTEM ERROR: No Paper Found.');
      htp.header (3, 'Contact the Database Administrator');

   end if;

   return false;

end assign_1_paper;

-- ********************************************************************************************

procedure assign_next_paper (abs_id common.ident_arr, ppid varchar2, this_platform varchar2, this_source varchar2) is

cookies		common.ident_arr;
cvalues		common.ident_arr;
paper_assigned	boolean;

ID		integer;

begin

   common.get_gbl_pid;

   if common.has_privs_to_page (common.editor_page$) then

-- Record the Editor's last selection
      cookies(1)	:= platform_cookie$;
      cookies(2)	:= source_cookie$;
      cvalues(1)	:= this_platform;
      cvalues(2)	:= this_source;
      common.write_cookies (cookies, cvalues, sysdate+365);

      if ppid is not null then
	 ID := NVL (common.decode_value ('abstract_id', 'abstract_sessions', 'paper_id', ppid),
		    common.decode_value ('abstract_id', 'abstract_sessions', 'paper_id', upper(ppid))
		   );
      else
	 ID := find_id (abs_id);
      end if;

      if ID is null then
	 paper_assigned := select_next_paper (this_platform, this_source);
      else
	 paper_assigned := assign_1_paper (ID);
      end if;

-- **********

      if NOT paper_assigned then
	 show_link_backs;
	 common.footer;
      end if;

   end if;

end assign_next_paper;

-- ********************************************************************************************
-- ********************************************************************************************

procedure list (code varchar2) is

cursor	driver is
select	a.abstract_id, a.status_code, a.referee_code
from	sessions			s,
	abstract_sessions		sa,
	abstracts			a
where	a.editor_id			= common.gbl_priv_pid
and	nvl (a.status_code, '?')	= code
and	sa.abstract_id			= a.abstract_id
and	sa.primary_flag			= 'Y'
and	s.session_id			= sa.session_id
order by
	s.sort_order nulls last,
	sa.session_id,
	sa.session_seq;

show_paper	boolean;

begin

   for driver_rec in driver LOOP

      show_paper := true;

      if common.referee_conf$ = 'Y' then
	 if common.referee_declined (driver_rec.referee_code) then
	    show_paper := false;
	 elsif common.referee_accepted (driver_rec.referee_code) then
	    show_paper := true;
	 elsif driver_rec.status_code is null and common.pdf_uploaded (driver_rec.abstract_id) then
	    show_paper := false;
	 end if;

      end if;

      if show_paper then
	 process_paper_data (driver_rec.abstract_id);
      end if;
   end loop;

end list;

-- ********************************************************************************************
-- ********************************************************************************************

procedure list_new_files is

cursor	driver is
select	a.abstract_id
from	sessions		s,
	abstract_sessions	sa,
	abstracts		a
where	a.editor_id		= common.gbl_priv_pid
and	a.status_code		in (select status_code from status_codes where ok_to_upload = 'Y')
and	'YES'			= new_files (a.abstract_id)
and	sa.abstract_id		= a.abstract_id
and	sa.primary_flag		= 'Y'
and	s.session_id		= sa.session_id
order by
	s.sort_order nulls last,
	sa.session_id,
	sa.session_seq;

begin

   for driver_rec in driver LOOP
      process_paper_data (driver_rec.abstract_id);
   end loop;

end list_new_files;

-- ********************************************************************************************
-- ********************************************************************************************

procedure list_all is

cursor	driver is
select	 /*+ INDEX(a) INDEX(s) */
	a.abstract_id
from	status_codes		c,
	abstracts		a,
	abstract_sessions	sa,
	sessions		s
where	a.editor_id		= common.gbl_priv_pid
and	sa.abstract_id		= a.abstract_id
and	sa.primary_flag		= 'Y'
and	s.session_id		= sa.session_id
and	c.status_code(+)	= a.status_code
order by
	c.sort_order,
	s.sort_order nulls last,
	s.session_date, s.beg_time, s.session_id, sa.session_seq;

begin

   if common.header (rpt_title$) then
      common.js$;
      htp.p (profile.js$);
      htp.p (editor.js$);
      show_link_backs;
      process_paper_hdr;

      for driver_rec in driver LOOP
         process_paper_data (driver_rec.abstract_id);
      end loop;

      htp.tableClose;
      common.footer;
   end if;

end list_all;

-- ********************************************************************************************
-- ********************************************************************************************

procedure display_option (prompt varchar2, code varchar2, last_option varchar2) is

selected	varchar2(8) := null;

begin

   if code = last_option then
      selected := 'SELECTED';
   end if;

   htp.formSelectOption (prompt, selected, cattributes=>'VALUE="' || code || '"');

end display_option;

-- ***********************************************************************************************

procedure show_platform_options (platform varchar2) is

cursor	driver is
select	*
from	platform_codes
order by platform_descr;

begin

   htp.tableRowOpen ('LEFT', 'TOP');
   htp.tableHeader ('Platform', 'RIGHT');
   htp.p ('<TD>');

   htp.formSelectOpen ('this_platform');
   display_option ('*No Preference*', '%', platform);
   htp.p (common.space2$);

   for driver_rec in driver LOOP
      display_option (driver_rec.platform_descr, driver_rec.platform_code, platform);
   end loop;

   htp.formSelectClose;
   htp.p ('</TD>');
   htp.tableRowClose;

end show_platform_options;

-- ***********************************************************************************************

function qa_person_is_editor (abs_id integer) return boolean is

cursor	driver is
select	1
from	abstracts
where	abstract_id	= abs_id
and	editor_id	= common.gbl_pid;

dummy		integer;
rec_found	boolean;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end qa_person_is_editor;

-- ***********************************************************************************************

function ready_for_qa (abs_id integer, editor_code varchar2, referee_code varchar2) return boolean is

cursor	driver is
select	/*+ INDEX(l) */
	log_code
from	logs		l
where	abstract_id	= abs_id
and	log_code	in (common.final_QA_passed$, common.final_QA_failed$)
order by log_date desc;

driver_rec	driver%ROWTYPE;
rec_found	boolean;

begin

   if NOT common.publishable_status_code (editor_code) then
      return false;
   end if;

   if common.referee_conf$ = 'Y' then
      if NOT common.publishable_referee_code (referee_code) then
	 return false;
      end if;
   end if;

   if common.same_editor_and_qa_allowed$ = 'N' then
      if qa_person_is_editor (abs_id) then
	 return false;
      end if;
   end if;

   open driver;
   fetch driver into driver_rec;
   rec_found := driver%FOUND;
   close driver;

   if NOT rec_found then
      return true;
   end if;

   if driver_rec.log_code = common.final_QA_passed$ then
      return false;
   end if;

   return true;

end ready_for_qa;

-- ***********************************************************************************************

procedure show_paper_id_popup (QA_only boolean) is

cursor	driver (dte date) is
select	/*+ INDEX(a) INDEX(s) */
	sa.paper_id, a.abstract_id, a.editor_id, a.assignable, a.status_code, a.referee_code
from	abstracts		a,
	abstract_sessions	sa,
	sessions		s
where	s.session_date		= dte
and	sa.session_id		= s.session_id
and	sa.primary_flag		= 'Y'
and	a.abstract_id		= sa.abstract_id
and	sa.paper_id		is NOT null
order by
	s.sort_order nulls last, s.session_id, sa.session_seq;

buffer		varchar2(100);
load_array	boolean;
load_count	integer := 0;

begin

   if QA_only AND common.same_editor_and_qa_allowed$ = 'N' then
      htp.cite ('Note: You cannot QA a paper if you are the editor.');
      htp.br;
      htp.p ('To disable this feature go to the SPMS Configuration section');
      htp.br;
      htp.p ('on the System Parameters page and change the parameter "Allow');
      htp.br;
      htp.p ('editor to QA a paper they edited" to Yes');
      htp.para;
   end if;

   for i in 1..common.conf_len_days$ LOOP
      htp.tableRowOpen ('LEFT', 'TOP');
      htp.tableHeader (to_char (common.conf_start_monday$+i-1, 'Day'), 'RIGHT');

      htp.p ('<TD>');
      htp.formSelectOpen ('abs_id');
      htp.formSelectOption ('', 'SELECTED');

      for driver_rec in driver (common.conf_start_monday$+i-1) LOOP
	 buffer		:= null;
	 load_array	:= true;

	 if QA_only then
	    buffer	:= null;
	    load_array	:= ready_for_qa (driver_rec.abstract_id,
					 driver_rec.status_code,
					 driver_rec.referee_code);

	 elsif driver_rec.editor_id is NOT null then
	    buffer := ' Assigned to: ' || common.get_user_name (driver_rec.editor_id);

	 elsif driver_rec.assignable >= common.file_weight_threshold$ then
	    buffer := ' Assignable';

	 end if;

	 if load_array then
	    htp.formSelectOption (driver_rec.paper_id || buffer,
			cattributes=>'VALUE="' || driver_rec.abstract_id || '"');

	    load_count := load_count + 1;
	 end if;

      end loop;

      htp.p ('</TD>');
      htp.tableRowClose;
   end loop;

   if QA_only and load_count = 0 then
      common.show_data_row (null, 'There are no more papers to QA');
   end if;

end show_paper_id_popup;

-- ***********************************************************************************************

procedure show_get_next_paper_options (platform varchar2, source varchar2) is

begin

   htp.formOpen ('editor.assign_next_paper', 'POST');
   htp.tableOpen;

   show_paper_id_popup (false);
   common.show_data_sep (2);

   show_platform_options (platform);
   common.show_lookup_table ('source', 'Source Type', source, show_null=>false);
   common.show_data_row ('Paper ID', htf.formText ('ppid', 10, 20));
   common.show_data_row (null, htf.formSubmit (null, 'Get Next Paper'));

   htp.tableClose;
   htp.formClose;

end show_get_next_paper_options;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure html is

platform	platform_codes.platform_code%TYPE;
source		varchar2(20);
authorized	boolean;

begin

   common.get_gbl_pid;
   authorized := common.has_privs_to_page (common.editor_page$, false) OR
		    common.has_privs_to_page (common.sort_file_page$, false);

   if authorized then
      platform	:= common.get_cookie (platform_cookie$);
      source	:= common.get_cookie (source_cookie$);
      maint.header (rpt_title$);
      htp.p (profile.js$);
      htp.p (editor.js$);
      common.js$;
      htp.tableOpen (cattributes=>'WIDTH="100%"');
      htp.tableRowOpen ('LEFT', 'TOP');

      if common.has_privs_to_page (common.editor_page$, false) AND
         common.gbl_priv_pid <> common.admin_pid$ then
         htp.p ('<TD>');
         show_get_next_paper_options (platform, source);
         htp.p ('</TD>');
      end if;

      htp.p ('<TD>');
      maint.menu;
      htp.p ('</TD>');

      htp.tableRowClose;
      htp.tableClose;

      if common.has_privs_to_page (common.editor_page$, false) AND
         common.gbl_priv_pid <> common.admin_pid$ then
         htp.header (3, 'Active Papers');
         process_paper_hdr;
         list (common.paper_assigned$);
         list_new_files;
         htp.tableClose;
      end if;

      common.footer;

   else -- call has_privs_to_page again to show the error message
      authorized := common.has_privs_to_page (common.editor_page$, true);

   end if;

end html;

-- ********************************************************************************************

procedure latin is

max_bytes$	constant integer := 255;
max_cols$	constant integer := 15;
col_count	integer := 0;

begin

   common.public_header ('LATIN Characters');
   htp.tableOpen ('BORDER');

   for i in 1..max_bytes$ LOOP
      col_count := col_count + 1;
      if col_count = 1 then
	 htp.tableRowOpen;
      end if;

      htp.tableData (i, cattributes=>'STYLE="background-color: #D2FF00"');
      htp.tableData (chr(i));
      htp.tableData ('&#' || to_char(i) || ';');

      if col_count = max_cols$ then
	 htp.tableRowClose;
	 col_count := 0;
      end if;
   end loop;

   htp.tableClose;

end latin;

-- ********************************************************************************************

end editor;

/
show error

set define on

--	Copyright (C) 2004-2008 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
