--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace package editor as

   procedure assign_next_paper (abs_id common.ident_arr, ppid varchar2, this_platform varchar2, this_source varchar2);
   procedure assign_paper (abs_id integer, this_code varchar2);
   procedure download (paper_id varchar2);

   procedure html;
   procedure js;
   procedure list_all;
   procedure process_paper (abs_id integer);
   procedure QA;
   procedure QA_paper (abs_id common.ident_arr);
   procedure QA_post (abs_id integer, abs_title varchar2, action varchar2, pcount varchar2, this_comment varchar2);
   procedure save_status (abs_id integer, code varchar2, error_list common.ident_arr,
			this_comment varchar2, this_note varchar2);
   procedure set_status (abs_id integer, code varchar2, flag integer);

   procedure show_paper_id_popup (QA_only boolean);
   procedure toc;
   procedure restore_abstract;
   procedure restore_abstract2 (aid integer);
   procedure restore_abstract3 (aid integer, this_payment_code varchar2 default null);
   procedure show_registered (abs_id integer);

   procedure set_page_count (up_passphrase varchar2, abs_id integer, pcount integer);

   function js$ return varchar2;
   function early_edit (abs_id integer) return varchar2;
   function early_edit_profile (prof_id integer) return varchar2;
   function files_uploaded (abs_id integer) return boolean;
   function new_files (abs_id integer) return varchar2;

   PRAGMA RESTRICT_REFERENCES (new_files, WNDS, WNPS);

   procedure latin;

editor_only$	constant integer := 1;
poster_only$	constant integer := 2;
referee_only$	constant integer := 3;

end editor;
/
show error
