set define off

Create or Replace package body hotel_handling as

 record_per_page$  			constant integer := 10;
 record_per_page_list$ 		constant integer := 20;
 not_authorized$			constant varchar2(100) 	:= 	'You are not authorized to access this page.';
 association_error$			constant varchar2(1000) := 	'A deposit is associated with this item; please delete it before trying to delete the room type';
 created$					constant varchar2(100) 	:= 	'Deposit list created';
 error$ 					constant varchar2(100) 	:= 	'An error occurred.';
 choice$					constant varchar2(100) 	:= 	'Your Hotel preferencies have been saved';
 rec_not_found$ 			constant varchar2(100) 	:= 	'No results';
 pid_error$					constant varchar2(100) 	:= 	'Unknown id';
 payment_recorded_text$ 	constant varchar2(1000) := 	'Dear <lname> your hotel booking procedure was successful.'|| common.eol$ ||
 														'Once your payment is processed you will receive an e-mail confirmation.';
 payment_recorded_subject$ 	constant varchar2(100) 	:= 	'Hotel booking recorded';
 processed_payment_text$ 	constant varchar2(1000) := 	'Dear <lname> your hotel booking procedure was processed. Follow the link to get your hotel voucher:' || common.eol$ ||'  <link>'|| common.eol$;
 processed_payment_subject$ constant varchar2(100) 	:= 	'Hotel booking processed';
 failed_payment_text$ 		constant varchar2(1000) := 	'Dear <lname> your hotel booking  procedure has failed.' || common.eol$ ||
 														'We shall check and contact you as soon as possible.';
 failed_payment_subject$ 	constant varchar2(100) 	:= 	'Hotel booking failed';
 reversed_payment_text$ 	constant varchar2(1000) := 	'Dear <lname> your hotel booking procedure has been reversed.' || common.eol$ ||' If you received an hotel voucher prior to this e-mail it will not be available anymore .';
 reversed_payment_subject$ 	constant varchar2(100) 	:= 	'Hotel booking reversed';
 cc_payment_subject$ 		constant varchar2(100) 	:= 	'Credid Card Deposit Payment';
 rpt_title$					constant varchar2(30)	:= 	'Hotel Confirmation ';
 rpt_title2$				constant varchar2(30)	:= 	rpt_title$ || 'Payments';
 type						pmt_type is table of payment_codes.instructions%TYPE index by varchar2(4);
 pmt_instr					pmt_type;

-- *******************************************************************************************
-- *******************************************************************************************

  function getFreeRooms(startDate date default null, endDate date default null) return number_arr is

    cursor driver is
    select max(end_date) from
    rooms_hotel;

    cursor driver2 is
    select min(start_date) from
    rooms_hotel;

    cursor driver3 is
		select	hotels.hotel_id, hotels.corporate_name, rrh.room_id, rrh.config, rb.booked_from , rb.booked_to,
			rrh.start_date as available_from, rrh.end_date as available_to from
		   rooms_hotel rrh left outer join
			(Select rooms_hotel.room_id ,r.start_date as booked_from, r.end_date as booked_to, rooms_hotel.start_date as available_from, rooms_hotel.END_DATE as available_to
				from (select distinct rs.choice_id, rs.registrant_id, rs.SEQ_ID , rs.config , rs.room_id, rs.start_date, rs.end_date, rs.hotel_id
					from (
							(Select  rc.*
							from registrants_choices rc
							where rc.confirmed='Y' and rc.deleted='N'
							and rc.date_record in (select max(rrc.date_record) from registrants_choices rrc where rrc.seq_id= rc.seq_id and rrc.choice_order=rc.choice_order and rrc.DELETED='N'))
						UNION
							(Select  rc.*
							from registrants_choices rc
							where rc.choice_order='fc' and rc.deleted='N'
							and rc.seq_id not in
							(select rcc.seq_id from registrants_choices rcc
							where rcc.seq_id= rc.seq_id and rcc.choice_order<>'fc' and  rcc.confirmed='Y' and rcc.deleted='N'
							and rcc.date_record in (select max(rccc.date_record) from registrants_choices rccc where rccc.seq_id= rcc.seq_id and rccc.choice_order=rcc.choice_order and rccc.DELETED='N'))
							and rc.date_record in (select max(rrcc.date_record) from registrants_choices rrcc where rrcc.seq_id= rc.seq_id and rrcc.choice_order=rc.choice_order and rrcc.DELETED='N')))
					 	rs ) r,
					 	rooms_hotel
				where r.room_id=rooms_hotel.room_id) rb on rrh.room_id=rb.room_id,
			hotels
		where rrh.hotel_id=hotels.hotel_id
		order by hotels.hotel_id, rrh.room_id;

	cursor driver4 (p integer, diff integer) is
	    Select *
	    from free_rooms_temp fr
	    where (startdate>=fr.START_DATE and endDate<=fr.END_DATE) and pid=p
	    and (fr.end_Date-fr.start_date + 1 - diff) in
				(Select min(fr1.end_date-fr1.start_date + 1 -diff)
	    						from free_rooms_temp fr1
	    						where (startdate>=fr1.START_DATE and endDate<=fr1.END_DATE) and pid=p
						       and fr1.hotel_id=fr.hotel_id and fr1.config=fr.config);


	bad_month exception;
  	pragma EXCEPTION_INIT(bad_month, -1843);

  	driver_rec driver3%ROWTYPE;
	driver4_rec driver4%ROWTYPE;

    min_date date := null;
    max_date date := null;
    start_date date;
    end_date date;
    rid integer := -1;
    available_day integer :=0;
    booked_day integer :=0;
    room_descr varchar2(50):='';
    description varchar2(50):='';
    diff integer := 0;
    lower_bound integer :=0;
    upper_bound integer :=0;
    hotid integer :=-1;

    found boolean:=true;
    same_room boolean:=true;
    i integer;
    status common.int_arr;

    r number_arr;

begin

    open driver;
    fetch driver into max_date;
    close driver;

    open driver2;
    fetch driver2 into min_date;
    close driver2;

    diff := max_date - min_date;
    for i in 1..(diff+1) loop
    	status(i):=0;
    end loop;

	open driver3;
	fetch driver3 into driver_rec;
	found:=driver3%FOUND;
    common.GET_GBL_PID;
    while found=true loop
		if (hotid!=driver_rec.hotel_id) then
		    hotid:=driver_rec.hotel_id;
		end if;
		for i in 1..(diff+1) loop
			status(i):=0;
	    end loop;
	    upper_bound:=driver_rec.available_from - min_date;
		for i in 1..upper_bound loop
	    	status(i):=1;
	    end loop;
	    lower_bound:=driver_rec.available_to-min_date;
	    for i in (lower_bound+1)..(diff+1) loop
	    	status(i):=1;
	    end loop;
	    rid:=driver_rec.room_id;
	    room_descr:=driver_rec.config;
		available_day:=driver_rec.available_to-driver_rec.available_from+1;
		booked_day:=0;
		same_room:=true;
		while same_room=true and found=true loop
		    if (driver_rec.booked_to is not null and driver_rec.booked_from is not null) then
			    lower_bound:=driver_rec.booked_from-min_date;
			    upper_bound:=driver_rec.booked_to-min_date;
			    for i in (lower_bound+1)..(upper_bound) loop
				    status(i):=1;
			    end loop;
			    booked_day:=booked_day+driver_rec.booked_to-driver_rec.booked_from;
		    end if;
		    fetch driver3 into driver_rec;
		    found:=driver3%FOUND;
		    if found=true then
				if rid!=driver_rec.room_id then
					same_room:=false;
				end if;
		    end if;
		end loop;
		start_date:=min_date;
		end_date:=min_date;
		if (booked_day<available_day)then
		    for i in 1..diff+1 loop
				if status(i)=0 then
				    end_date:=end_date+1;
				else
				    if start_date!=end_date then
						insert into free_rooms_temp(pid,hotel_id,config,start_date,end_date,room_id)
						    values (common.gbl_pid,hotid, room_descr, start_date, end_date,rid);
				    end if;
				    end_date:=end_date+1;
				    start_date:=end_date;
				end if;
		    end loop;
		    if start_date!=end_date then
				insert into free_rooms_temp(pid,hotel_id,config,start_date,end_date,room_id)
				    values (common.gbl_pid,hotid, room_descr, start_date, end_date, rid);
		    end if;
		end if;
	end loop;
    close driver3;

  	i:=1;
	for driver4_rec in driver4(common.gbl_pid,enddate-startdate+1) loop
		r(i):=driver4_rec.room_id;
		i:=i+1;
	end  loop;

  	return r;

  exception
	when bad_month then
	     htp.header(3,'Month must be in capital letters in the form MON');
	     htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
end getFreeRooms;


-- *******************************************************************************************
-- *******************************************************************************************

-- Procedure to display the legen about rooms type
	procedure show_room_types_legend is

		cursor legend is
		Select * from room_types;

	begin
		htp.p('<br>');
		htp.tableopen();
		htp.tablerowopen();
		htp.tabledata('&nbsp');
		htp.p('<td>');
		htp.tableOpen(cattributes=>'border="1px"');
		htp.tablerowopen();
		htp.tableheader('LEGEND',cattributes=>'colspan="2"');
		htp.tableRowClose();
		for legend_rec in legend loop
			htp.tablerowopen();
			htp.tabledata('<b>'||legend_rec.room_name||'</b>');
			htp.tabledata(legend_rec.description);
			htp.tableRowClose();
		end loop;
		htp.tableclose();
		htp.p('</td>');
		htp.tablerowclose();
		htp.tableclose();
	end show_room_types_legend;

-- *******************************************************************************************
-- *******************************************************************************************

	procedure search_free_rooms(action varchar2 default null, startDate date default null, endDate date default null,
				      fc varchar2 default null, sc varchar2 default null, tc varchar2 default null) is


	   	null_startDate exception;
	   	bad_month exception;
	   	pragma EXCEPTION_INIT(bad_month, -1843);

		rooms_id number_arr := empty_room_arr;
		r	   number :=0;

	begin
		common.get_gbl_pid;
		if(action = 'search_rooms' and (startDate is null or endDate is null)) then
			raise null_startDate;
		end if;

		maint.header('Hotel choice');
		regist_maint.jsFunctions;

		htp.tableOpen();
		htp.tableRowOpen();
		htp.p('<td width="25%">');
		htp.p('&nbsp;');
		htp.p('</td>');
		htp.p('<td>');
		htp.tableOpen();
		htp.tableRowOpen();
		htp.p('<td colspan="4">');
		if hasBookedRooms(common.ENCRYPT(common.gbl_pid)) then
			show_booked_rooms(common.gbl_pid);
		end if;
		htp.p('</td>');
		htp.tablerowclose();
		htp.tableRowOpen();
		htp.p('<td colspan="4">');
		htp.p(common.space$);
		htp.p('</td>');
		htp.tableRowClose();
		htp.tableRowOpen();
		htp.formOpen(curl=>'hotel_handling.search_free_rooms', cmethod=>'post',cattributes=>'name="searchRoom"');
		htp.formHidden(cname=>'action', cvalue=>'search_rooms');
		htp.tableData('Select the period you need',cattributes=>'colspan="4"');
		htp.tableRowClose();
		htp.tableRowOpen();
		htp.tableData('From (dd-MON-yy)');
		htp.tableData(htf.formText(cname=>'startDate',csize=>'9',cvalue=>startDate));
		htp.tableData('To (dd-MON-yy)');
		htp.tableData(htf.formText(cname=>'endDate',csize=>'9',cvalue=>endDate));
		htp.tableRowClose();
		htp.tableRowOpen();
		htp.tableData(htf.formSubmit(cvalue=>'Search'), cattributes=>'colspan="4"');
		htp.tableRowClose();
		htp.formClose();
		if(action = 'search_rooms' and (startDate is not null and endDate is not null)) then
			rooms_id := getFreeRooms(startDate,endDate);
			r:=rooms_id.count;
	    	if(r>0) then
				htp.formOpen(curl=>'hotel_handling.save_choices', cmethod=>'post',cattributes=>'name="choices"');
				htp.formHidden(cname=>'startDate', cvalue=>startDate);
				htp.formHidden(cname=>'endDate', cvalue=>endDate);

				create_room_jsarray(rooms_id);

				htp.p('<script type="text/javascript" language="javascript">
						var firstIndex = 0;
						var chValue = new Array('|| showVal.count ||');
						var chText = new Array('|| showVal.count ||');');

				for f in 1..showVal.count loop
					htp.p(' chValue[' || f || '] = "' || optionVal(f) || '"');
					htp.p(' chText[' || f ||'] = "'  || showVal(f) || '"');
				end loop;

				create_room_onChangef;
				htp.tableRowOpen();
				htp.p('<td colspan="4">');
				htp.tableOpen();
				htp.tableRowOpen();
				htp.tableData('Hotel first choice', cattributes=>'align = "right"');
			 	htp.p('<td>');
			 	htp.formSelectOpen(cname=>'fc', cattributes=>'onChange="comboB(fc.options[this.selectedIndex].value);firstIndex = this.selectedIndex"');
			   	htp.p('<option></option>');

				for f in 1..showVal.count loop
					htp.p('<option value="'|| optionVal(f) || '">');
					htp.p(showVal(f));
					htp.p('</option>');
				end loop;

			  	htp.formSelectClose();
				htp.p('</td>');
				htp.tableRowClose();
				htp.tableRowOpen();
				htp.tableData('Hotel second choice', cattributes=>'align = "right"');
				htp.p('<td>');
				htp.formSelectOpen(cname=>'sc', cattributes=>'onChange="comboC(fc.options[firstIndex].value,sc.options[this.selectedIndex].value);"');
				htp.formSelectClose();
				htp.p('</td>');
				htp.tableRowClose();
				htp.tableRowOpen();
				htp.tableData('Hotel third choice', cattributes=>'align = "right"');
				htp.p('<td>');
			  	htp.formSelectOpen(cname=>'tc');
			  	htp.formSelectClose();
				htp.p('</td>');
				htp.tableRowClose();
				htp.tableRowOpen();
				htp.tableData('Payment methods :',cattributes=>'align="right"');
				htp.p('<td>');
			  	show_available_pay_methods();
				htp.p('</td>');
				htp.tableRowClose();
				htp.tableClose();
				htp.p('</td>');
				htp.tableRowClose();
				htp.tableRowOpen();
				htp.tableData(htf.formSubmit(cvalue=>'Save choices'), cattributes=>'colspan="4"');
				htp.tableRowClose();
				htp.formClose();
		    else
		   		htp.tablerowOpen();
				htp.tabledata('<br><h3><b>We are sorry, but there is no rooms available in the system for the selected period.</b></h3>','center',null,null,null,4);
		   		htp.tablerowOpen();
			    htp.tablerowclose();
				htp.tabledata('Here follow a table of rooms availability.' ||
					       '<br> Please try again selecting a time interval highligthed by any green blocks.' ||
					       ' This table shows available <b>nigths</b>.<br><br>',null,null,null,null,4);
		   		htp.tablerowOpen();
			    htp.tablerowclose();
			    htp.tablerowOpen();
			    htp.p('<td colspan="4">');
			    htp.tableopen();
				htp.tabledata('i.e. for',cattributes=>'style="vertical-align:middle"');
				htp.p('<td>');
					htp.tableOpen('border="1px"');
					htp.tablerowopen();
					htp.tableheader('1');
					htp.tableheader('2');
					htp.tableheader('3');
					htp.tableheader('4');
					htp.tableheader('5');
					htp.tableheader('6');
			   		htp.tablerowOpen();
				    htp.tablerowclose();
					htp.tabledata('&nbsp',cattributes=>'align="center" bgcolor="#00ff66"');
					htp.tabledata('&nbsp',cattributes=>'align="center" bgcolor="#00ff66"');
					htp.tabledata('&nbsp',cattributes=>'align="center" bgcolor="#00ff66"');
					htp.tabledata('&nbsp',cattributes=>'align="center" bgcolor="#00ff66"');
					htp.tabledata('-',cattributes=>'align="center" ');
					htp.tabledata('-',cattributes=>'align="center" ');
					htp.tablerowclose();
					htp.tableclose();
			    htp.p('</td>');
			    htp.tabledata('you can search for an intervall less or equal',cattributes=>'align="center" style="vertical-align:middle"');
			    htp.tabledata('from',cattributes=>'style="vertical-align:middle"');
			    htp.tabledata('<table border="1px"><TR><td align="center" style="vertical-align:middle"> 1-MON-08 </td></tr></table>',cattributes=>'style="vertical-align:middle"');
			    htp.tabledata('to',cattributes=>'style="vertical-align:middle"');
			    htp.tabledata('<table border="1px"><TR><td align="center" style="vertical-align:middle"> 5-MON-08 </td></tr></table>',cattributes=>'style="vertical-align:middle"');
			    htp.tabledata('&nbsp',cattributes=>'style="vertical-align:middle"');
			    htp.tableRowOpen();
			    htp.p('<td colspan="4">');
			    htp.p(common.space$);
			    htp.p('</td>');
			    htp.tableRowClose();
			    htp.tableclose();
			    htp.p('</td>');
			    htp.tablerowclose();
			    htp.tablerowOpen();
				htp.p('<td colspan="4">');
			    show_hotel_notches_user;
			    htp.p('</td>');
			    htp.tablerowclose();
		    end if;
		end if;
		htp.tableClose();
		htp.p('</td>');
		htp.p('<td>');
		htp.tableopen();
		show_room_types_legend;
		htp.tableclose();
		htp.p('</td>');
		htp.tableRowClose();
		htp.tableClose();
	exception
		when null_startDate then
		    htp.header(3,'Both dates must be set');
		    htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
		when bad_month then
		     htp.header(3,'Month must be in capital letters in the form MON');
		     htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
	end search_free_rooms;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure create_room_jsarray(rooms_id number_arr default empty_room_arr) is

  cursor room(rid number) is
	  select * from rooms_hotel
	  where room_id = rid;

  cursor hotel(hid number) is
	  select h.corporate_name,h.hotel_cat_id,hc.cat_symbol
	  from hotels h, hotel_categories hc
	  where h.hotel_id = hid
	  and	hc.hotel_cat_id = h.hotel_cat_id
	  order by hc.cat_symbol;

  cursor roomtype(rt varchar2) is
	  select room_type_id,room_name from room_types
	  where lower(room_name) = lower(rt);

  cursor deposit(rtid varchar2, hcid number) is
	  select deposit from room_deposit
	  where hotel_cat_id = hcid and room_type_id = rtid;

  room_rec room%ROWTYPE;
  roomtype_rec roomtype%ROWTYPE;
  hotel_rec hotel%ROWTYPE;
  deposit_rec deposit%ROWTYPE;
  y	    pls_integer;
  token   varchar2(100);
  show_arr	  common.ident_arr;
  options common.ident_arr;
  k	    number;
  z	    number;
  exist boolean := false;
  dummy varchar2(1000);

  begin
     z:=1;
     for i in 1..rooms_id.count loop
		 -- search for rooms characteristics ---
		 open room(rooms_id(i));
		 fetch room into room_rec;
		 close room;
		  -- search the hotel ---
		 open hotel(room_rec.hotel_id);
		 fetch hotel into hotel_rec;
		 close hotel;
		 y :=1;
		 loop
			token := common.stringTokenizer(room_rec.config, y , '|') ;
			exit when token is  null;
			-- search roomtype ----
			open roomtype(token );
			fetch roomtype into roomtype_rec;
			close roomtype;

			open deposit(roomtype_rec.room_type_id,hotel_rec.hotel_cat_id);
			fetch deposit into deposit_rec;
			close deposit;

			show_arr(z) := hotel_rec.cat_symbol || ' ' || hotel_rec.corporate_name || ' ' || roomtype_rec.room_name || ' ' || deposit_rec.deposit;
			options(z) := room_rec.hotel_id || '|' || roomtype_rec.room_name || '|' || rooms_id(i) || '|' || deposit_rec.deposit;



			y := y+1;
			z := z+1;
		 end loop;
    end loop;


	for i in 1..show_arr.count loop
		exist := false;
		z:=1;
		while exist=false and z<=showVal.count loop
			if(showVal(z) = show_arr(i)) then
				exist := true;
			end if;
			z:=z+1;
	 	end loop;
		if(exist = false) then
			showVal(z) := show_arr(i);
			optionVal(z) := options(i);
		end if;
	end loop;


  end create_room_jsarray;

-- *******************************************************************************************
-- *******************************************************************************************

   procedure create_room_onChangef is
   begin
      htp.p('
	    function comboB(firstChoice){
     		    for(y=document.choices.sc.options.length;y>=0;y--){
			  document.choices.sc.options[y] = null;
		    }
		    for(y=document.choices.tc.options.length;y>=0;y--){
			  document.choices.tc.options[y] = null;
		    }
		    k = 0;
		    for(i=0;i<chValue.length;i++){
		if(chValue[i] != firstChoice){
		    if(chText[i] == null || chValue[i] == null){
				document.choices.sc.options[k] = new Option("","");
			  }else{
			  	document.choices.sc.options[k] = new Option(chText[i] ,chValue[i]);
		    }
			  k++;
			}
		}
	     }

	      function comboC(firstChoice,secondChoice){
     		    for(y=document.choices.tc.options.length;y>=0;y--){
			  document.choices.tc.options[y] = null;
		    }
		    k = 0;
		    for(i=0;i<chValue.length;i++){
		if((chValue[i] != firstChoice) && (chValue[i] != secondChoice) ){
			  if(chText[i] == null || chValue[i] == null){
				document.choices.tc.options[k] = new Option("","");
			  }else{
			  	document.choices.tc.options[k] = new Option(chText[i] ,chValue[i]);
		    }

			  k++;
			}
		}
	     }

	    </script>');
   end create_room_onChangef;

-- *******************************************************************************************
-- *******************************************************************************************

procedure payment (this_page integer, crypt_pid varchar2, reg_id common.ident_arr,
			chkb_id common.ident_arr, this_payment_code varchar2,
			amt varchar2, text varchar2 default null, deposit varchar2, sqid number) is

credit_card$	constant payment_codes.credit_card%TYPE := common.decode_value ('credit_card',
				'payment_codes', 'payment_code', this_payment_code);
pid$		constant integer := common.decrypt (crypt_pid);

msg		long := null;
total		number := 0;
calc_amt	number := 0;
new_reg_id	common.ident_arr	:= reg_id;
new_chkb_id	common.ident_arr	:= chkb_id;
dummy 		varchar2(1);
seq		number := sqid;
admin		boolean;

begin

   common.get_gbl_pid;
   common.gbl_pid := common.decrypt (crypt_pid);

-- **********

   if this_payment_code is null then
      msg := htf.header (3, 'You must select a payment type.');
   end if;

-- **********

   if trim (amt) is null then
       msg := msg || htf.header (3, 'The payment amount you entered is null.  Please enter a value.');
   else
      if common.validate_number (amt) then
	 	admin := common.has_privs_to_page (common.reg_admin_page$, false);
		if (amt <= 0.0) then
	    	msg := msg || htf.header (3, 'You must enter a valid payment amount.');
		end if;
		if(to_number(amt) < to_number(deposit)) then
	    	msg := msg || htf.header (3, 'You must exactly deposit ' || deposit || ' ' || common.currency_symbol$);
		end if;
      else
	 	msg := msg || htf.header (3, 'The payment amount you entered is non-numeric.  Please enter a valid number.');
      end if;

   end if;

-- **********

  if msg is null then

      if credit_card$ = 'Y' then
		if common.cc_vendor$ is NOT null then
	  		cc_vendor.forwarder (pid$, amt, new_reg_id, new_chkb_id,dummy,true);
		 end if;
      else
		 save_payment(crypt_pid ,this_payment_code, seq );
		 htp.header(3,'Your deposit has been recorded');
		 htp.p(htf.anchor ('jacow.html',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')));
      end if;
   else
       htp.p (msg);
       htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
   end if;
   exception
      when others then
      htp.header (3,error$);
      htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));

end payment;

-- *******************************************************************************************
-- *******************************************************************************************

procedure save_choices(fc varchar2 default null, sc varchar2 default null, tc varchar2 default null,startDate date default null, endDate date default null, this_payment_code varchar2 default null) is

    fc_null exception;
    sc_null exception;
    tc_null exception;
    stDate_null exception;
    edDate_null exception;
    pid_null exception;
    pay_null exception;
    no_fc_room exception;
    no_sc_room exception;
    no_tc_room exception;



    pid number;
    crypt_pid varchar2(32767);
    stDate date;
    enDate date;
    conf varchar2(10);
    hid number;
    dep number;
    rid number;

    dummy1 common.ident_arr;
    dummy2 common.ident_arr;
    credit_card$	constant payment_codes.credit_card%TYPE := common.decode_value ('credit_card',
				'payment_codes', 'payment_code', this_payment_code);
    tms registrants_choices.DATE_RECORD%TYPE;
    tm	registrants_choices.BOOKING_DATE%TYPE;
	seq_value registrants_choices.SEQ_ID%TYPE;

    begin
    if(this_payment_code is null) then
		raise pay_null;
    else
		if(fc is null) then
		    raise fc_null;
		elsif (startDate is null) then
		    raise stDate_null;
		elsif (endDate is null) then
		    raise edDate_null;
		else
			SELECT SYSTIMESTAMP into tms FROM DUAL;
			SELECT SYSDATE into tm FROM DUAL;
			common.get_gbl_pid();
			pid := common.gbl_pid;
			crypt_pid:=common.ENCRYPT(pid);
			if (pid is not null) then
				stDate := startDate;
				enDate := endDate;
				hid := common.stringTokenizer(fc,1,'|');
				conf := common.stringTokenizer(fc,2,'|');
				rid := common.stringTokenizer(fc,3,'|');
				dep := common.stringTokenizer(fc,4,'|');
				if(isBooked(crypt_pid,rid, stDate, enDate,false) = true) then
					 -- raise no_fc_room;
					 rid := searchAlternativeRoom(hid, conf, stDate, enDate);
					 if(rid = -1) then
						raise no_fc_room;
					 end if;
				end if;
				if(credit_card$ != 'Y') then
					select choice_sequence_seq.nextval into seq_value from dual;
					insert into registrants_choices (registrant_id,start_date,end_date,config,hotel_id,confirmed,deposit,room_id,choice_order,
						    date_record,booking_date,deleted,seq_id)
							      values (pid,to_date(stDate,'DD-MON-YY'),to_date(enDate,'DD-MON-YY'),conf,hid,'N',dep,rid,'fc',
							      tms,tm,'N',seq_value);
				else
					cc_vendor.set_ipn_hh_data(pid,stDate,enDate,conf,hid,'N',dep,rid,'fc',tms,this_payment_code,'processing');
				end if;
				 if(sc is not null) then
				     hid := common.stringTokenizer(sc,1,'|');
				     conf := common.stringTokenizer(sc,2,'|');
				     rid := common.stringTokenizer(sc,3,'|');
				     if(isBooked(crypt_pid,rid, stDate, enDate,false) = true) then
					 rid := searchAlternativeRoom(hid, conf, stDate, enDate);
						 if(rid = -1) then
						    raise no_sc_room;
						 end if;
				     end if;
				     if(credit_card$ != 'Y') then
						insert into registrants_choices (registrant_id,start_date,end_date,config,hotel_id,confirmed,deposit,room_id,choice_order,
							    date_record,booking_date,deleted,seq_id)
								      values (pid,to_date(stDate,'DD-MON-YY'),to_date(enDate,'DD-MON-YY'),conf,hid,'N',dep,rid,'sc',
								      tms,tm,'N',seq_value);
				      else
						cc_vendor.set_ipn_hh_data(pid,stDate,enDate,conf,hid,'N',dep,rid,'sc',tms,this_payment_code,'processing');

				      end if;
				 end if;
				 if(tc is not null) then
				     hid := common.stringTokenizer(tc,1,'|');
				     conf := common.stringTokenizer(tc,2,'|');
				     rid := common.stringTokenizer(tc,3,'|');
				     if(isBooked(crypt_pid,rid, stDate, enDate,false) = true) then
						 rid := searchAlternativeRoom(hid, conf, stDate, enDate);
						 if(rid = -1) then
						    raise no_tc_room;
						 end if;
				     end if;
				      if(credit_card$ != 'Y') then
						insert into registrants_choices (registrant_id,start_date,end_date,config,hotel_id,confirmed,deposit,room_id,choice_order,
							    date_record,booking_date,deleted,seq_id)
								      values (pid,to_date(stDate,'DD-MON-YY'),to_date(enDate,'DD-MON-YY'),conf,hid,'N',dep,rid,'tc',
								      tms,tm,'N',seq_value);
				      else
						cc_vendor.set_ipn_hh_data(pid,stDate,enDate,conf,hid,'N',dep,rid,'tc',tms,this_payment_code,'processing');
				      end if;
				 end if;
				 payment(-1,common.encrypt(pid),dummy1,dummy2,this_payment_code,dep,deposit=>dep,sqid=>seq_value);
			else
			     raise pid_null;
			end if;
		end if;
    end if;
    exception
       when pay_null then
	    htp.header(3,'A payment method must be set');
	    htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
       when pid_null then
	    htp.header(3,'Unknown user');
	    htp.p(htf.anchor ('jacow.html',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')));
       when fc_null then
	    htp.header(3,'First choice must be set');
	    htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
       when sc_null then
	    htp.header(3,'Second choice must be set');
	    htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
       when tc_null then
	    htp.header(3,'Third choice must be set');
	    htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
      when stDate_null then
	    htp.header(3,'Both dates must be set');
	    htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
      when edDate_null then
	    htp.header(3,'Both dates must be set');
	    htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
      when no_fc_room then
	     htp.header(3,'No choice available for the first hotel selected, please make a new choice');
	    htp.p(htf.anchor ('hotel_handling.search_free_rooms',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')));
      when no_sc_room then
	     htp.header(3,'No choice available for the second hotel selected, please make a new choice');
	    htp.p(htf.anchor ('hotel_handling.search_free_rooms',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')));
      when no_tc_room then
	     htp.header(3,'No choice available for the third hotel selected, please make a new choice');
	    htp.p(htf.anchor ('hotel_handling.search_free_rooms',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')));
      when others then
	    htp.header(3,'A generic error occurred');
	    htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
end save_choices;

-- *******************************************************************************************
-- *******************************************************************************************

procedure show_available_pay_methods is

cursor driver is
select hp.*,pc.payment_descr from hotel_payments hp
inner join payment_codes pc on
pc.payment_code = hp.payment_code;

driver_rec driver%ROWTYPE;

begin

htp.formSelectOpen(cname=>'this_payment_code');
htp.formSelectOption(cvalue=>'');
for driver_rec in driver loop
    htp.formSelectOption(cvalue=>driver_rec.payment_descr,cattributes=>'value="' ||driver_rec.payment_code || '"');
end loop;
htp.formSelectClose();
end show_available_pay_methods;

-- *******************************************************************************************
-- *******************************************************************************************

procedure save_payment(crypt_pid varchar2 default null, paycode varchar2 default null, sqid number default null) is

	cursor driver is
	select	c.payment_code, c.payment_descr, c.instructions
	from	payment_codes	c
	where	c.payment_code	= paycode;

	pid_null exception;
	paycode_null exception;
	pmt_code	payment_codes.payment_code%TYPE;
	pmt_msg varchar2(10000) := common.eol$;
begin
  if (crypt_pid is null) then
      raise pid_null;
  elsif (paycode is null) then
      raise paycode_null;
  else
      for driver_rec in driver LOOP
		 if driver_rec.instructions is not null then
		    pmt_instr(driver_rec.payment_code) := driver_rec.instructions;
	 	end if;
      end loop;
      update registrants_choices set status = 'processing', payment_code = paycode where registrant_id = common.DECRYPT(crypt_pid) and seq_id = sqid;
      htp.bold ('Please print this page for your records.');
      htp.para;
      if pmt_instr.count > 0 then
		  htp.header (3, 'Payment Instructions');
		  htp.tableOpen;
		  htp.tableRowOpen ('LEFT', 'TOP');
	      pmt_code := pmt_instr.FIRST;


		  LOOP
		    exit when pmt_code is null;
		    htp.tableData (htf.bold (
				common.decode_value ('payment_descr', 'payment_codes',
						'payment_code', pmt_code) ) || htf.br ||
				replace (pmt_instr(pmt_code), chr(10), htf.br)
				  );
		    pmt_instr(pmt_code):= replace (pmt_instr(pmt_code), '<b>', '');
		    pmt_instr(pmt_code):= replace (pmt_instr(pmt_code), '</b>', '');
		    pmt_msg := pmt_msg || common.decode_value ('payment_descr', 'payment_codes',
						'payment_code', pmt_code)  || common.eol$ ||
			replace (pmt_instr(pmt_code), chr(10), common.eol$);
		    exit when pmt_code = pmt_instr.LAST;
		    pmt_code := pmt_instr.next(pmt_code);
		  end loop;

		  htp.tableRowClose;
		  htp.tableClose;
      end if;
   hotel_handling_maint.send_payment_recorded_mail(crypt_pid, 'processing', sqid,pmt_msg);

  end if;
  exception
      when pid_null then
	  htp.header (3,'Unknown user');
	  htp.p(htf.anchor ('jacow.html',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')));

      when paycode_null then
	  htp.header (3,'Unknow payment method');
	  htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));

      when others then
	  htp.header (3,error$);
	  htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));

end save_payment;

-- *******************************************************************************************
-- *******************************************************************************************

function  hasBookedRooms(crypt_pid varchar2 default null) return boolean is

cursor room is
select * from registrants_choices
where  date_record in
(select max(date_record)
from registrants_choices
where registrant_id = common.DECRYPT(crypt_pid) and deleted='N' )
order by seq_id, choice_order;

room_rec room%ROWTYPE;
found boolean default false;
begin
    open room;
    fetch room into room_rec;
      found := room%FOUND;
    close room;

return found;
end hasBookedRooms;

-- *******************************************************************************************
-- *******************************************************************************************

procedure show_booked_rooms(crypt_pid varchar2 default null) is


	pid integer := common.DECRYPT(crypt_pid);
	
	cursor room is
		select rc.*,h.corporate_name,h.hotel_cat_id,hc.hotel_cat_name,rt.description
		from registrants_choices rc
			inner join hotels h on h.hotel_id = rc.hotel_id
			inner join hotel_categories hc on hc.hotel_cat_id = h.hotel_cat_id
			inner join room_types rt on lower(rt.room_name) = lower(rc.config)
		where rc.registrant_id = pid
			and h.hotel_id = rc.hotel_id
			and rc.r_locked = 'N'
			and rc.deleted='N'
			and (rc.date_record in
					(select (date_record) from registrants_choices
					 where registrant_id = rc.registrant_id and confirmed = 'N' )
				or rc.date_record in
					(select max(date_record) from registrants_choices
					 where registrant_id = rc.registrant_id and confirmed = 'Y' group by room_id))
		order by rc.booking_date,rc.seq_id, rc.choice_order;

	room_rec room%ROWTYPE;
	pid_error exception;

begin
    common.get_gbl_pid;
    if(common.gbl_pid != pid) then
		raise pid_error;
    else
		htp.p('<br/>');
		htp.tableOpen(cattributes=>'border="1px"');
		htp.tableRowOpen();

		htp.tableHeader('Rooms already booked  by ' || common.get_user_name(pid,'N','N'),cattributes=>'colspan="6"');
		htp.tableRowClose();
		htp.tableRowOpen();
		htp.tableHeader('Hotel');
		htp.tableHeader('Category');
		htp.tableHeader('Room type');
		htp.tableHeader('Booking date');
		htp.tableHeader('Confirmed');
		htp.tableHeader('Choice order');
		htp.tableRowClose();
		open room;
		loop
		fetch room into room_rec;
		exit when room%NOTFOUND;
		  htp.tableRowOpen();
		    htp.tableData(room_rec.corporate_name);
		    htp.tableData(room_rec.hotel_cat_name);
		    htp.tableData(room_rec.description);
		    htp.tableData(to_char(room_rec.booking_date,'dd/mm/yyyy'));
		    htp.tableData(room_rec.confirmed);
		    if(room_rec.choice_order = 'fc') then
		      htp.tableData('First');
		    elsif(room_rec.choice_order = 'sc') then
		      htp.tableData('Second');
		    else
		      htp.tableData('Third');
		    end if;
		  htp.tableRowClose();
		end loop;
		close room;
		htp.tableClose();
    end if;
exception
    when pid_error then
	htp.header (3,not_authorized$);
	htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
    when NO_DATA_FOUND then
	htp.header(3,rec_not_found$);
	htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
end show_booked_rooms;

-- *******************************************************************************************
-- *******************************************************************************************

--Print the header of the tables of hotels notches
procedure hotel_header_notches (startDate date, enddate date, hotelName varchar2) is
	dummy_date date :=null;
	num_months integer := 0;
	num_columns integer := 0;
	diff integer := 0;

begin
    diff:=enddate-startdate;
    htp.tableRowOpen();
    htp.tableHeader(hotelname,cattributes=>'colspan="' || to_char(diff+2) || '"');
    htp.tableRowClose();
    htp.tableRowOpen();
    htp.tableHeader('&nbsp');
    dummy_date := last_day(startdate);
    num_months:=trunc(months_between(enddate,startdate));
    num_columns:=last_day(startdate)-startdate+1;
    htp.tableHeader(to_char(dummy_date,'MONTH/yyyy'),cattributes=>'colspan="' || to_char(num_columns) || '"');
    if (num_months>0) then
		for i in 1..num_months-1 loop
			dummy_date :=add_months(dummy_date,1);
			num_columns:= extract(DAY from dummy_date);
			htp.tableHeader(to_char(dummy_date,'MONTH/yyyy'),cattributes=>'colspan="' || to_char(num_columns) || '"');
		end loop;
		num_columns:=extract(DAY from enddate);
		htp.tableHeader(to_char(enddate,'MONTH/yyyy'),cattributes=>'colspan="' || to_char(num_columns) || '"');
	end if;
    htp.tableRowClose();
    htp.tableRowOpen();
    htp.tableHeader('Room/day');
    for i in 0..diff loop
		htp.tableHeader(to_char(startdate + i,'dd'));
    end loop;
    htp.tableRowClose();

end hotel_header_notches;

-- *******************************************************************************************
-- *******************************************************************************************

procedure room_row_notches(min_date date, max_date date, startDate date, endDate date, room_descr varchar2) is

    diff integer:=0;
    date_temp date;

begin
    htp.tableRowOpen();
    htp.tableData(room_descr,cattributes=>'align="center"');
    date_temp:=min_date;
    while date_temp<=max_date loop
	if date_temp>=startdate and date_temp<=enddate then
	    htp.tableData('&nbsp',cattributes=>'align="center" bgcolor="#00ff66"');
	else
	    htp.tableData('-',cattributes=>'align="center"');
	end if;
	date_temp:=date_temp+1;
    end loop;
    htp.tableRowClose();
end room_row_notches;

-- *******************************************************************************************
-- *******************************************************************************************

procedure show_hotel_notches_user  is

    cursor driver is
    select max(end_date) from
    rooms_hotel;

    cursor driver2 is
    select min(start_date) from
    rooms_hotel;

    cursor driver3 is
		select	hotels.hotel_id, hotels.corporate_name, rrh.room_id, rrh.config, rb.booked_from , rb.booked_to,
			rrh.start_date as available_from, rrh.end_date as available_to from
		   rooms_hotel rrh left outer join
			(Select rooms_hotel.room_id ,r.start_date as booked_from, r.end_date as booked_to, rooms_hotel.start_date as available_from, rooms_hotel.END_DATE as available_to
				from (select distinct rs.choice_id, rs.registrant_id, rs.SEQ_ID , rs.config , rs.room_id, rs.start_date, rs.end_date, rs.hotel_id
					from (
							(Select  rc.*
							from registrants_choices rc
							where rc.confirmed='Y' and rc.deleted='N'
							and rc.date_record in (select max(rrc.date_record) from registrants_choices rrc where rrc.seq_id= rc.seq_id and rrc.choice_order=rc.choice_order and rrc.DELETED='N'))
						UNION
							(Select  rc.*
							from registrants_choices rc
							where rc.choice_order='fc' and rc.deleted='N'
							and rc.seq_id not in
							(select rcc.seq_id from registrants_choices rcc
							where rcc.seq_id= rc.seq_id and rcc.choice_order<>'fc' and  rcc.confirmed='Y' and rcc.deleted='N'
							and rcc.date_record in (select max(rccc.date_record) from registrants_choices rccc where rccc.seq_id= rcc.seq_id and rccc.choice_order=rcc.choice_order and rccc.DELETED='N'))
							and rc.date_record in (select max(rrcc.date_record) from registrants_choices rrcc where rrcc.seq_id= rc.seq_id and rrcc.choice_order=rc.choice_order and rrcc.DELETED='N')))
					 	rs ) r,
					 	rooms_hotel
				where r.room_id=rooms_hotel.room_id) rb on rrh.room_id=rb.room_id,
	hotels
	where rrh.hotel_id=hotels.hotel_id
	order by hotels.hotel_id, rrh.room_id;

    cursor driver4 (p integer) is
	Select fr.hotel_id,fr.config,fr.start_date,fr.end_date,fr.t, hotels.CORPORATE_NAME, hotels.website, hotels.HOTEL_CAT_ID
	from
	    (Select hotel_id,config,start_date,end_date, count(*) as t
	    from free_rooms_temp where pid=p
	    group by hotel_id,config,start_date,end_date
	    order by hotel_id) fr,
	    hotels
	where hotels.hotel_id=fr.hotel_id;

    driver_rec driver3%ROWTYPE;
    driver4_rec driver4%ROWTYPE;

    min_date date := null;
    max_date date := null;
    start_date date;
    end_date date;
    rid integer := -1;
    available_day integer :=0;
    booked_day integer :=0;
    room_descr varchar2(50):='';
    description varchar2(50):='';
    diff integer := 0;
    lower_bound integer :=0;
    upper_bound integer :=0;
    hotid integer :=-1;
    hotel_descr varchar2(400) default null;
	hotel_cat hotel_categories.HOTEL_CAT_NAME%type;

    found boolean:=true;
    same_room boolean:=true;
    i integer;
    status common.int_arr;
    query varchar(4000);

begin

    open driver;
    fetch driver into max_date;
    close driver;

    open driver2;
    fetch driver2 into min_date;
    close driver2;

    diff := max_date - min_date;
    for i in 1..(diff+2) loop
    	status(i):=0;
    end loop;

	open driver3;
	fetch driver3 into driver_rec;
	found:=driver3%FOUND;
    common.GET_GBL_PID;
    while found=true loop
	if (hotid!=driver_rec.hotel_id) then
	    hotid:=driver_rec.hotel_id;
	end if;
	for i in 1..(diff+1) loop
		status(i):=0;
	    end loop;
	    upper_bound:=driver_rec.available_from - min_date;
		for i in 1..upper_bound loop
	    	status(i):=1;
	    end loop;
	    lower_bound:=driver_rec.available_to-min_date;
	    for i in (lower_bound+1)..(diff+1) loop
	    	status(i):=1;
	    end loop;
	    rid:=driver_rec.room_id;
	    room_descr:=driver_rec.config;
	available_day:=driver_rec.available_to-driver_rec.available_from;
	booked_day:=0;
	same_room:=true;
	while same_room=true and found=true loop
	    if (driver_rec.booked_to is not null and driver_rec.booked_from is not null) then
		    lower_bound:=driver_rec.booked_from-min_date;
		    upper_bound:=driver_rec.booked_to-min_date;
		    for i in (lower_bound+1)..(upper_bound) loop
			    status(i):=1;
		    end loop;
		    booked_day:=booked_day+driver_rec.booked_to-driver_rec.booked_from;
	    end if;
	    fetch driver3 into driver_rec;
	    found:=driver3%FOUND;
	    if found=true then
		if rid!=driver_rec.room_id then
			same_room:=false;
		end if;
	    end if;
	end loop;
	start_date:=min_date;
	end_date:=min_date;
	if (booked_day<available_day)then
	    for i in 1..diff+1 loop
		if status(i)=0 then
		    end_date:=end_date+1;
		else
		    if start_date!=end_date then
			insert into free_rooms_temp(pid,hotel_id,config,start_date,end_date,room_id)
			    values (common.gbl_pid,hotid, room_descr, start_date, end_date-1,rid);
		    end if;
		    end_date:=end_date+1;
		    start_date:=end_date;
		end if;
	    end loop;
	    if start_date!=end_date then
		insert into free_rooms_temp(pid,hotel_id,config,start_date,end_date,room_id)
		    values (common.gbl_pid,hotid, room_descr, start_date, end_date, rid);
	    end if;
	end if;
	end loop;
    close driver3;

    select min(start_date) into min_date from free_rooms_temp where pid=common.gbl_pid;
    select max(end_date) into max_date from free_rooms_temp where pid=common.gbl_pid;

   	htp.tableOpen();
-- show legend

	htp.tableRowOpen();
	htp.p('<TD colspan="' || to_char(diff+2) || '">');
	htp.tableOpen();
	htp.tableRowOpen();
	htp.tabledata('<b>Legend:</b>');
	htp.tabledata('&nbsp');
	htp.tableData(htf.tableopen('border="1px"')||htf.tablerowopen()||
					htf.tabledata('&nbsp',cattributes=>'align="center" bgcolor="#00ff66"')||
				  	htf.tabledata('Free room')|| '</tr></table>');
	htp.tabledata('&nbsp');
	htp.tableData(htf.tableopen('border="1px"')||htf.tablerowopen()||
					htf.tableData('-',cattributes=>'align="center"')||
				  	htf.tabledata('Room not available')|| '</tr></table>');
	htp.TableRowClose();
	htp.tableClose();
	htp.p('</TD>');
	htp.tableRowClose();

 -- Show Free Roos Notches
	htp.tableRowOpen();
	htp.p('<TD colspan="' || to_char(diff+2) || '">');
	htp.tableOpen('BORDER');

	open driver4(common.gbl_pid);
	fetch driver4 into driver4_rec;
	found:=driver4%FOUND;
    hotid:=-1;
	while found=true loop
	if (hotid!=driver4_rec.hotel_id) then
		hotel_cat:=common.DECODE_VALUE('hotel_cat_name','hotel_categories','hotel_cat_id',driver4_rec.hotel_cat_id);
		if hotel_cat is not null then
			hotel_descr:=driver4_rec.corporate_name || ' (' || hotel_cat || ')';
		else
			 hotel_descr:=driver4_rec.corporate_name;
		end if;
		if driver4_rec.website is not null then
			hotel_descr:=htf.anchor('http://'||driver4_rec.website,hotel_descr,cattributes=>'target="_blank"');
		end if;
	    hotel_header_notches (min_date, max_date, hotel_descr);
	    hotid:=driver4_rec.hotel_id;
	end if;
	description:=driver4_rec.t || ' rooms of type ' || driver4_rec.config ;
	room_row_notches(min_date, max_date, driver4_rec.start_date, driver4_rec.end_date, description);
	fetch driver4 into driver4_rec;
	found:=driver4%FOUND;
	end loop;
	commit;
	htp.tableClose();
	htp.p('</TD>');
	htp.tableRowClose();
	htp.tableClose();

end show_hotel_notches_user;

-- *******************************************************************************************
-- *******************************************************************************************

procedure ipn_hotel_redirected_receipt(seq number) is

cursor driver is
select * from registrants_choices
where seq_id = seq
and deleted='N'
order by date_record desc;

driver_rec driver%ROWTYPE;

begin

	if common.header (rpt_title$) then
	   open driver;
	   fetch driver into driver_rec;
	   close driver;

	   htp.header (3, 'Positive Deposit Payment Transaction ', cattributes=>common.red$);
	   htp.tableOpen;
	   common.show_data_row ('Order nr.',	driver_rec.invoice);
	   common.show_data_row ('Receipt',	driver_rec.receipt);
	   common.show_data_row ('Status',	driver_rec.ipn_status);
	   common.show_data_row ('Amount',	driver_rec.deposit);
	   common.show_data_row ('Notes', 'Please print this page for your records');
	   htp.tableClose;

	   common.footer;
	end if;

end ipn_hotel_redirected_receipt;

-- *******************************************************************************************
-- *******************************************************************************************

 function isBooked(crypt_pid varchar2 default null ,rid integer default -1,startDate date default null, endDate date default null, without_pid boolean default false) return boolean is

    cursor driver (room number) is
		Select rooms_hotel.room_id ,r.start_date as booked_from, r.end_date as booked_to, rooms_hotel.start_date as available_from, rooms_hotel.END_DATE as available_to
		from 	(Select  rc.*
				from registrants_choices rc
				where rc.confirmed='Y' and rc.deleted='N'
				and rc.date_record in (select max(rrc.date_record)
						       from registrants_choices rrc
						       where rrc.seq_id= rc.seq_id and rrc.choice_order=rc.choice_order and rrc.DELETED='N')
				) r,
			 	rooms_hotel
		where r.room_id=rooms_hotel.room_id and r.room_id=room;

  	driver_rec driver%ROWTYPE;

    cursor driver2 (room number, registrant number) is
		Select rooms_hotel.room_id ,r.start_date as booked_from, r.end_date as booked_to, rooms_hotel.start_date as available_from, rooms_hotel.END_DATE as available_to
		from 	(Select  rc.*
				from registrants_choices rc
				where rc.confirmed='Y' and rc.deleted='N'
				and rc.date_record in (select max(rrc.date_record)
						       from registrants_choices rrc
						       where rrc.seq_id= rc.seq_id and rrc.choice_order=rc.choice_order and rrc.DELETED='N')
				) r,
			 	rooms_hotel
		where r.room_id=rooms_hotel.room_id and r.room_id=room and r.registrant_id<>registrant;

  	driver2_rec driver%ROWTYPE;

    found boolean:=true;

begin
	found:=false;
	if without_pid=false then
		for driver_rec in driver(rid) loop
			if (driver_rec.available_from<=startDate and  enddate<=driver_rec.available_to) then
				if (driver_rec.available_from>startdate or enddate>driver_rec.booked_from)
				   and (driver_rec.booked_to>startdate or enddate>driver_rec.available_to) then
				   found:=true;
				end if;
			else
				found:=true;
			end if;
		end loop;
	else
		for driver2_rec in driver2(rid,common.DECRYPT(crypt_pid)) loop
			if (driver_rec.available_from<=startDate and  enddate<=driver_rec.available_to) then
				if (driver_rec.available_from>startdate or enddate>driver_rec.booked_from)
				   and (driver_rec.booked_to>startdate or enddate>driver_rec.available_to) then
				   found:=true;
				end if;
			else
				found:=true;
			end if;
		end loop;
	end if;

	return found;

end isBooked;

-- *******************************************************************************************
-- *******************************************************************************************

function searchAlternativeRoom(hid integer default -1, config varchar2 default null, stDate date default null, enDate date default null) return integer is

	query varchar2(4000);
  	r	  number_arr;
	room number;
	i number;
	type	cursor_type is REF CURSOR;
	driver	cursor_type;

begin
	r:=getFreeRooms(stDate,enDate);
	if r.count>0 then
		query:='Select rh.room_id
				from rooms_hotel rh
				where rh.HOTEL_ID='|| hid ||' and config like ''%' || config || '%'' and rh.ROOM_ID in (';
		for i in 1..(r.count-1) loop
			query:=query || r(i) || ',';
		end loop;
		query:=query || r(r.count) || ')';
		open driver for query;
		fetch driver into room;
		if driver%found=false then
			return -1;
		else
			return room;
		end if;
	else
		return -1;
	end if;

 end searchAlternativeRoom;

-- *******************************************************************************************
-- *******************************************************************************************

procedure show_free_rooms(startDate date default null, endDate date default null, sqid integer default -1,chid integer default -1,
  							stPage number default 1, last_name varchar2 default null, cfmed varchar2 default null,
						ch_order varchar2 default null, hid number default -1, action varchar2 default null) is

	null_startDate exception;
	bad_month exception;
	pragma EXCEPTION_INIT(bad_month, -1843);

	rooms_id number_arr := empty_room_arr;
	r	   number :=0;

	cursor driver is
		select p.lname,p.fname
		from persons p,
			registrants_choices rc
		where  rc.choice_id = chid	and  p.person_id = rc.registrant_id ;

	driver_rec driver%ROWTYPE;

begin

   if common.header ('Move registrants',js_src=>regist_maint.JS$) then
	regist_maint.jsFunctions;

	htp.tableOpen();
	htp.tableRowOpen();
	if(action != 'Move') then
	 	htp.tabledata('<b>No alternative room found, please move the registrant to another hotel</b><br /><br />',cattributes=>'align="center" colspan="3"');
	end if;
	htp.tableRowClose();
	htp.p('<td width=25%>');
	htp.p('&nbsp;');
	htp.p('</td>');
	htp.p('<br/>');
	htp.p('<td>');
	htp.tableOpen();
	htp.tableRowOpen();
	htp.p('<td colspan="3">');
	htp.p('</td>');
	htp.tableRowClose();
	htp.tableRowOpen();
	htp.p('<td colspan="3">');
  	htp.tableOpen();
  	htp.tableRowOpen();
	htp.tableHeader('Registrant');
	htp.tableHeader('From');
	htp.tableHeader('To');
    htp.tableRowClose();
    open driver;
	fetch driver into driver_rec;
    close driver;
    htp.tableRowOpen(cattributes=>'align="center"');
	htp.tableData(driver_rec.fname || '&nbsp;' || driver_rec.lname);
	htp.tableData(to_char(startDate,'dd-mm-yyyy'));
	htp.tableData(to_char(endDate,'dd-mm-yyyy'));
    htp.tableRowClose();
    htp.tableRowOpen();
    htp.tableData(common.space$,cattributes=>'colspan="3"');
    htp.tableRowClose();
  	htp.tableClose();
  	htp.p('</td>');
  	htp.tableRowClose();
 	if((startDate is not null and endDate is not null)) then
	  	rooms_id := getFreeRooms(startDate,endDate);
	  	r:=rooms_id.count;
		if (r>0) then
			htp.formOpen(curl=>'hotel_handling.save_alt_choice', cmethod=>'post',cattributes=>'name="choices"');
			htp.formHidden(cname=>'action', cvalue=>action);
			htp.formHidden(cname=>'startDate', cvalue=>startDate);
			htp.formHidden(cname=>'endDate', cvalue=>endDate);
			htp.formHidden(cname=>'sqid', cvalue=>sqid);
			htp.formHidden(cname=>'chid', cvalue=>chid);
			htp.formHidden(cname=>'stPage' , cvalue=>stPage);
			htp.formHidden(cname=>'last_name', cvalue=> replace(last_name,'%','%25') );
			htp.formHidden(cname=>'cfmed' , cvalue=>cfmed );
			htp.formHidden(cname=>'ch_order', cvalue=>ch_order );
			htp.formHidden(cname=>'hid', cvalue=> hid);
			htp.tableRowOpen();
			htp.p('<td colspan="4">');
			htp.tableOpen();
			htp.tableRowOpen();
			htp.tableData('Choose the new room', cattributes=>'align = "right"');
			htp.p('<td>');
			htp.formSelectOpen(cname=>'new_choice');

			create_room_jsarray(rooms_id);

			htp.p('<option></option>');
			for f in 1..showVal.count loop
				htp.p('<option value="'|| optionVal(f) || '">');
				htp.p(showVal(f));
				htp.p('</option>');
			end loop;

			htp.formSelectClose();
			htp.p('</td>');
			htp.tableRowClose();
			htp.tableClose();
			htp.p('</td>');
			htp.tableRowClose();
			htp.tableRowOpen();
			htp.tableData(htf.formSubmit(cvalue=>'Save choices'), cattributes=>'colspan="4"');
			htp.tableRowClose();
			htp.formClose();
		else
			htp.p('No rooms available in the system for the selected period.<br/> Please contact <a href="mailto:'||common.ht_manager$ ||'" >
			'|| common.ht_manager$ || '</a> directly <br/>');
    	        end if;
       end if;

	htp.tableClose();
	htp.p('</td>');
	htp.tableData('&nbsp;', cattributes=>'width="25%"');
	htp.tableRowClose();
	htp.tableClose();
   end if;

exception
	when null_startDate then
	    htp.header(3,'Both dates must be set');
	    htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
	when bad_month then
	     htp.header(3,'Month must be in capital letters in the form MON');
	     htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
end show_free_rooms;

-- *******************************************************************************************
-- *******************************************************************************************

procedure save_alt_choice(startDate date default null, endDate date default null, sqid integer default -1,chid integer default -1,
 							stPage number default 1, last_name varchar2 default null, cfmed varchar2 default null,
						ch_order varchar2 default null, hid number default -1, new_choice varchar2 default null,
						action varchar2 default null) is

	 cursor choice is
		 select * from registrants_choices
		 where choice_id = chid;

	 choice_rec choice%ROWTYPE;
	 found boolean := false;
	 confirmed varchar2(2);
	 conf varchar2(10);
	 new_hid number;
	 dep number;
	 rid number;
	 no_fc_room exception;
	 no_new_choice exception;
	 dummy integer;

begin
	 open choice;
	    fetch choice into choice_rec;
	    found := choice%FOUND;
	 close choice;
	 if(action = 'Move') then
	    confirmed := choice_rec.confirmed;
	 else
	    confirmed := 'Y';
	 end if;
	 if(found) then
	    if new_choice is null then
	    	raise no_new_choice;
	    end if;
	    new_hid := common.stringTokenizer(new_choice,1,'|');
	    conf := common.stringTokenizer(new_choice,2,'|');
	    rid := common.stringTokenizer(new_choice,3,'|');
	    dep := common.stringTokenizer(new_choice,4,'|');
	    if(isBooked(common.ENCRYPT(choice_rec.registrant_id),rid, startDate, endDate,false) = true) then
			rid := searchAlternativeRoom(new_hid, conf, startDate, endDate);
			if(rid = -1) then
				raise no_fc_room;
			end if;
		end if;

		insert into registrants_choices (registrant_id,start_date,end_date,config,
						 hotel_id,confirmed,deposit,room_id,choice_order,status,
						 payment_code,r_locked,date_record,notes,seq_id,ipn_status,
						 invoice,receipt,booking_date,payment_date,deleted)
		values(
		       choice_rec.registrant_id,
		       choice_rec.start_date,
		       choice_rec.end_date,
		       conf,
		       new_hid,
		       confirmed,
		       choice_rec.deposit,
		       rid,
		       choice_rec.choice_order,
		       choice_rec.status,
		       choice_rec.payment_code,
		       choice_rec.r_locked,
		       systimestamp,
		       choice_rec.notes,
		       choice_rec.seq_id,
		       choice_rec.ipn_status,
		       choice_rec.invoice,
		       choice_rec.receipt,
		       choice_rec.booking_date,
		       choice_rec.payment_date,
		       choice_rec.deleted);
 	end if;
 	common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.show_all_registrants_bookings?'||
									 						'stPage=' || stPage ||
															'&last_name=' || replace(last_name,'%','%25') ||
															'&cfmed=' || cfmed ||
															'&ch_order=' || ch_order ||
															'&hid=' || hid);

 exception
	 when no_fc_room then
	    htp.header(3,'No choice available for the selected hotel, please make a new choice');
		htp.p(htf.anchor('hotel_handling.show_free_rooms?action=' || action ||
									 '&startDate='|| to_char(startDate,'dd-MON-yyyy') ||
					     '&endDate=' || to_char(endDate,'dd-MON-yyyy') ||
					     '&sqid=' || sqid ||
					     '&chid='||chid ||
									 '&stPage=' || stPage ||
									 '&last_name=' || replace(last_name,'%','%25') ||
									 '&cfmed=' || cfmed ||
									 '&ch_order=' || ch_order ||
									 '&hid=' || hid,
									 htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')));
	 when no_new_choice then
	      htp.header(3,'No choice made. Please make a new choice');
		  htp.p(htf.anchor('hotel_handling.show_free_rooms?action=' || action ||
									 '&startDate='|| to_char(startDate,'dd-MON-yyyy') ||
					     '&endDate=' || to_char(endDate,'dd-MON-yyyy') ||
					     '&sqid=' || sqid ||
					     '&chid='||chid ||
									 '&stPage=' || stPage ||
									 '&last_name=' || replace(last_name,'%','%25') ||
									 '&cfmed=' || cfmed ||
									 '&ch_order=' || ch_order ||
									 '&hid=' || hid,
									 htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')));

end save_alt_choice;

-- *******************************************************************************************
-- *******************************************************************************************

END HOTEL_HANDLING;

/
show error

set define on

--	Copyright (C) 2004-2008 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
