set define off

Create or Replace package hotel_handling as

  type number_arr 	is table of integer index by binary_integer;
  ignore_admin$		boolean default true;
  validate_IP$		boolean default true;
  empty_room_arr 	number_arr;
  empty_arr			owa_util.ident_arr;

  optionVal 			common.ident_arr;
  showVal   			common.ident_arr;

-- Procedure and function intended for end user

  procedure search_free_rooms(action varchar2 default null, startDate date default null,
			      endDate date default null,fc varchar2 default null,
			      sc varchar2 default null, tc varchar2 default null);
  procedure save_alt_choice(startDate date default null, endDate date default null, sqid integer default -1,
			    chid integer default -1,stPage number default 1, last_name varchar2 default null,
			    cfmed varchar2 default null, ch_order varchar2 default null, hid number default -1,
			    new_choice varchar2 default null, action varchar2 default null);
  procedure show_free_rooms(startDate date default null, endDate date default null, sqid integer default -1,
			    chid integer default -1,stPage number default 1, last_name varchar2 default null,
			    cfmed varchar2 default null, ch_order varchar2 default null, hid number default -1,
			    action varchar2 default null );
  procedure save_choices(fc varchar2 default null, sc varchar2 default null, tc varchar2 default null,
			 startDate date default null, endDate date default null,
			 this_payment_code varchar2 default null);
  procedure create_room_jsarray(rooms_id number_arr default empty_room_arr);
  procedure create_room_onChangef;
  procedure payment (this_page integer, crypt_pid varchar2, reg_id common.ident_arr,
			chkb_id common.ident_arr, this_payment_code varchar2,
			amt varchar2, text varchar2 default null, deposit varchar2, sqid number);
  procedure save_payment(crypt_pid varchar2 default null, paycode varchar2 default null, sqid number default null);
  procedure show_hotel_notches_user ;
  procedure ipn_hotel_redirected_receipt(seq number);
  procedure show_available_pay_methods;
  procedure show_booked_rooms(crypt_pid varchar2 default null);


  function searchAlternativeRoom(hid integer default -1, config varchar2 default null, stDate date default null,
				 enDate date default null) return integer;
  function getFreeRooms(startDate date default null, endDate date default null) return number_arr;
  function hasBookedRooms(crypt_pid varchar2 default null) return boolean;
  function isBooked(crypt_pid varchar2 default null,rid integer default -1,startDate date default null,
		    endDate date default null, without_pid boolean default false) return boolean;


END HOTEL_HANDLING;

/
show error

set define on

--	Copyright (C) 2004-2008 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
