set define off

Create or Replace package body hotel_handling_maint as

 record_per_page$  			constant integer := 10;
 record_per_page_list$ 		constant integer := 20;
 not_authorized$			constant varchar2(100) 	:= 	'You are not authorized to access this page.';
 association_error$			constant varchar2(1000) := 	'A deposit is associated with this item; please delete it before trying to delete the room type';
 created$					constant varchar2(100) 	:= 	'Deposit list created';
 error$ 					constant varchar2(100) 	:= 	'An error occurred.';
 choice$					constant varchar2(100) 	:= 	'Your Hotel preferencies have been saved';
 rec_not_found$ 			constant varchar2(100) 	:= 	'No results';
 pid_error$					constant varchar2(100) 	:= 	'Unknown id';
 payment_recorded_text$ 	constant varchar2(1000) := 	'Dear <lname> your hotel booking procedure was successful.'|| common.eol$ ||
 														'Once your payment is processed you will receive an e-mail confirmation.';
 payment_recorded_subject$ 	constant varchar2(100) 	:= 	'Hotel booking recorded';
 processed_payment_text$ 	constant varchar2(1000) := 	'Dear <lname> your hotel booking procedure was processed. Follow the link to get your hotel voucher:' || common.eol$ ||'  <link>'|| common.eol$;
 processed_payment_subject$ constant varchar2(100) 	:= 	'Hotel booking processed';
 failed_payment_text$ 		constant varchar2(1000) := 	'Dear <lname> your hotel booking  procedure has failed.' || common.eol$ ||
 														'We shall check and contact you as soon as possible.';
 failed_payment_subject$ 	constant varchar2(100) 	:= 	'Hotel booking failed';
 reversed_payment_text$ 	constant varchar2(1000) := 	'Dear <lname> your hotel booking procedure has been reversed.' || common.eol$ ||' If you received an hotel voucher prior to this e-mail it will not be available anymore .';
 reversed_payment_subject$ 	constant varchar2(100) 	:= 	'Hotel booking reversed';
 cc_payment_subject$ 		constant varchar2(100) 	:= 	'Credid Card Deposit Payment';
 rpt_title$					constant varchar2(30)	:= 	'Hotel Confirmation ';
 rpt_title2$				constant varchar2(30)	:= 	rpt_title$ || 'Payments';
 type						pmt_type is table of payment_codes.instructions%TYPE index by varchar2(4);
 pmt_instr					pmt_type;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure create_hotel_entry(hid number default -1) is

cursor driver is
select * from hotel_categories
order by hotel_cat_name;

cursor hdriver is
select * from hotels
where hotel_id = hid;

hdriver_rec	hdriver%ROWTYPE;
rec_found	boolean := false;

BEGIN

    common.get_gbl_pid;
    if common.header ('Add/Modify Hotel') then
       if(hid != -1) then
	   open hdriver;
	   fetch hdriver into hdriver_rec;
	   rec_found := hdriver%FOUND;
	   close hdriver;
       end if;

       htp.p (common.space2$);
       htp.tableOpen();
       htp.tableRowOpen();
       htp.tableData('&nbsp;', cattributes=>'width="25%"');
       htp.p('<td>');
       if(hid !=-1 ) then
	  htp.formOpen(curl=>'hotel_handling_maint.update_hotel', cmethod=>'post');
	  htp.formHidden(cname=>'hid', cvalue=>hid);
       else
	  htp.formOpen(curl=>'hotel_handling_maint.insert_hotel', cmethod=>'post');
       end if;
       htp.tableOpen();
       htp.tableRowopen();
       htp.tableData('Hotel name');
       htp.tableData(htf.formText(cname=>'corporateName',csize=>'60',cvalue=>hdriver_rec.corporate_name));
       htp.tableRowClose();
       htp.tableRowOpen();
       htp.tableData('Select hotel category');
       htp.p('<td>');
	htp.formSelectOpen(cname=>'h_cat');
	htp.p('<option VALUE="">');
	htp.p('</option>');
	for driver_rec in driver loop
	if(driver_rec.hotel_cat_id = hdriver_rec.hotel_cat_id) then
	   htp.formSelectOption(driver_rec.hotel_cat_name, cattributes=>'VALUE="' || driver_rec.hotel_cat_id || '", selected');
	else
	    htp.formSelectOption(driver_rec.hotel_cat_name, cattributes=>'VALUE="' || driver_rec.hotel_cat_id || '"');
	end if;
	   htp.p('</option>');
	end loop;
	htp.formSelectClose();
	htp.p('</td>');
	htp.tableRowClose();
	htp.tableRowopen();
       htp.tableData('Hotel director');
       htp.tableData(htf.formText(cname=>'director',csize=>'30',cvalue=>hdriver_rec.director));
       htp.tableRowClose();
       htp.tableRowopen();
       htp.tableData('National id Number');
       htp.tableData(htf.formText(cname=>'nationalIdNumber',csize=>'15',cvalue=>hdriver_rec.national_id_numb));
       htp.tableRowClose();
	   htp.tableRowopen();
       htp.tableData('Address');
       htp.tableData(htf.formText(cname=>'address',csize=>'60',cvalue=>hdriver_rec.address));
       htp.tableRowClose();
       htp.tableRowopen();
       htp.tableData('Add. Number');
       htp.tableData(htf.formText(cname=>'addressNumber',csize=>'3',cvalue=>hdriver_rec.address_number));
       htp.tableRowClose();
       htp.tableRowopen();
       htp.tableData('Town');
       htp.tableData(htf.formText(cname=>'town',csize=>'30',cvalue=>hdriver_rec.town));
       htp.tableRowClose();
       htp.tableRowopen();
       htp.tableData('Province');
       htp.tableData(htf.formText(cname=>'province',csize=>'30',cvalue=>hdriver_rec.province));
       htp.tableRowClose();
       htp.tableRowopen();
       htp.tableData('Country');
       htp.tableData(htf.formText(cname=>'state',csize=>'30',cvalue=>hdriver_rec.state));
       htp.tableRowClose();
       htp.tableRowopen();
       htp.tableData('VAT id number');
       htp.tableData(htf.formText(cname=>'vatin',csize=>'15',cvalue=>hdriver_rec.vatin));
       htp.tableRowClose();
       htp.tableRowopen();
       htp.tableData('Phone');
       htp.tableData(htf.formText(cname=>'phoneNumber',csize=>'15',cvalue=>hdriver_rec.phone_number));
       htp.tableRowClose();
       htp.tableRowopen();
       htp.tableData('Fax');
       htp.tableData(htf.formText(cname=>'faxNumber',csize=>'15',cvalue=>hdriver_rec.fax_number));
       htp.tableRowClose();
       htp.tableRowopen();
       htp.tableData('E-mail');
       htp.tableData(htf.formText(cname=>'email',csize=>'60',cvalue=>hdriver_rec.email));
       htp.tableRowClose();
       htp.tableRowopen();
       htp.tableData('Website');
       htp.tableData(htf.formText(cname=>'website',csize=>'60',cvalue=>hdriver_rec.website));
       htp.tableRowClose();
       htp.tableRowopen();
       htp.tableData('Description');
       htp.tableData(htf.formTextarea(cname=>'rdescription',ncolumns=>'60',nrows=>'10',cattributes=>'value="' || hdriver_rec.website || '"'));
       htp.tableRowClose();
       htp.tableRowOpen();
       htp.tableData(htf.formSubmit(cvalue=>'Save'), cattributes=>'colspan="2"');
       htp.tableRowClose();
       htp.tableClose();
       htp.formClose();
       htp.tableData('&nbsp;', cattributes=>'width="25%"');
       htp.tableRowClose();
       htp.tableClose();
    end if;
    NULL;
  END create_hotel_entry;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure list_available_hotels is

  cursor driver is
  select h.*,hc.hotel_cat_name from hotels h
  left join hotel_categories hc on h.hotel_cat_id = hc.hotel_cat_id
  order by h.corporate_name asc;


  driver_rec	driver%ROWTYPE;

  cursor dr (hid number) is
  select hf.fee,rt.room_name from hotel_roomtype_fee hf
  left join room_types rt on rt.room_type_id = hf.roomtype_id
  where hf.hotel_id = hid
  order by rt.room_name;

  dr_rec dr%ROWTYPE;

  cursor num (hid number) is
  select count(room_id) as num_rooms from rooms_hotel
  where hotel_id = hid;

  num_rec num%ROWTYPE;

  begin
  common.get_gbl_pid;
      if common.has_privs_to_page then
        maint.header('Available Hotels');
	regist_maint.jsFunctions;
	htp.tableOpen();
	htp.tableRowOpen();
	htp.p('<td width=25%>');
	maint.menu(0);
	htp.p('</td>');
	htp.p('<td>');
	htp.tableOpen(cattributes=>'border = 1px');
	htp.tableRowOpen();
	htp.tableHeader(common.space$);
	htp.tableHeader('Hotel Name');
	htp.tableHeader('Category');
	htp.tableHeader('Phone Numb.');
	htp.tableHeader('Services');
	htp.tableHeader('Rooms');
	htp.tableHeader('Hotel Notches');
	htp.tableHeader(common.space$);
	htp.tableRowClose();
	for driver_rec in driver loop
	  htp.tableRowOpen();
	  htp.tableData(htf.anchor ('hotel_handling_maint.create_hotel_entry?hid=' || driver_rec.hotel_id, htf.IMG(common.editImg$,cattributes=>'border=0 alt=Edit title=Edit')));
	  htp.tableData(driver_rec.corporate_name);
	  htp.tableData(driver_rec.hotel_cat_name);
	  htp.tableData(driver_rec.phone_number);
	  htp.p('<td>');
	  for dr_rec in dr (driver_rec.hotel_id) loop
	    htp.p(dr_rec.room_name || '<br />');
	  end loop;
	  htp.anchor ('hotel_handling_maint.show_room_types_hotel?hid=' || driver_rec.hotel_id,'Associate/Modify' );
	  htp.p('</td>');
	  open num (driver_rec.hotel_id);
	  fetch num into num_rec;
	  close num;
	  htp.p('<td align="center">');
	  htp.p(num_rec.num_rooms || '<br/>');
	  if(num_rec.num_rooms = 0) then
	     htp.anchor ('hotel_handling_maint.add_rooms_hotels?hid=' || driver_rec.hotel_id,'Add' );
	  else
	     htp.anchor ('hotel_handling_maint.remove_modify_rooms_hotel?hid=' || driver_rec.hotel_id ,'Modify/Remove' );
	  end if;
	  htp.p('</td>');
	  htp.tableData(htf.anchor ('hotel_handling_maint.show_hotel_notches?hid=' || driver_rec.hotel_id ,'Show' ));
	  htp.tableData(htf.anchor ('hotel_handling_maint.remove_hotel?hid=' || driver_rec.hotel_id ,htf.IMG(common.deleteImg$,cattributes=>'border=0 alt="Remove Hotel" title="Remove Hotel"'),cattributes=>'onclick=''return hotelDeleteConfirm()'''));
	  htp.tableRowClose();
	end loop;
	htp.tableRowOpen();
	htp.tableData(htf.anchor ('hotel_handling_maint.create_hotel_entry',htf.IMG(common.newImg$,cattributes=>'border=0 alt="New hotel" title="New hotel"')),cattributes=>'colspan="7"');
	htp.tableRowClose();
	htp.tableClose();
	htp.p('</td>');
	htp.tableRowClose();
	htp.tableClose();
    end if;
  end list_available_hotels;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure show_hotel_list is

  cursor driver is
  select h.* from hotels h
  order by h.corporate_name asc;


  driver_rec	driver%ROWTYPE;

  begin
   common.get_gbl_pid;
   if common.has_privs_to_page then
     maint.header('Show hotel bookings');
     regist_maint.jsFunctions;
     htp.tableOpen();
	htp.tableRowOpen();
	htp.p('<td width=25%>');
	maint.menu(0);
	htp.p('</td>');
	htp.p('<td>');
	htp.tableOpen();
	  htp.tableRowOpen();
	      htp.tableData('Select a hotel from the list below to view all bookings:');
	  htp.tableRowClose();
	  htp.formOpen(curl=>'hotel_handling_maint.show_hotel_notches',cmethod=>'get');
	  htp.tableRowOpen();
	  htp.p('<td>');
	      htp.formSelectOpen(cname=>'hid');
		htp.p('<option VALUE="">');
		htp.p('</option>');
		for driver_rec in driver loop
		  exit when driver%NOTFOUND;
		  htp.formSelectOption(driver_rec.corporate_name, cattributes=>'VALUE="' || driver_rec.hotel_id || '"');
		  htp.p('</option>');
		end loop;
	      htp.formSelectClose();
	  htp.p('</td>');
	  htp.tableRowClose();
	  htp.tableRowOpen();
	      htp.tableData(htf.formSubmit(cvalue=>'Search'),cattributes=>'align="left"');
	  htp.tableRowClose();
	  htp.formClose();
	htp.tableClose();
	htp.p('</td>');
	htp.tableRowClose();
      htp.tableClose();
      end if;
  end show_hotel_list;

-- *******************************************************************************************
-- *******************************************************************************************

procedure insert_hotel(corporateName varchar2,address varchar2, addressNumber number,
			 town varchar2, province varchar2,state varchar2, vatin varchar2,
			 phoneNumber varchar2, faxNumber varchar2,email varchar2,director varchar2,
			 nationalIdNumber varchar2,website varchar2,rdescription varchar2, h_cat number) is


  begin
     common.get_gbl_pid;
      if common.has_privs_to_page then
	    insert into hotels (corporate_name,address,address_number,town,province,state,
	    vatin, phone_number, fax_number, email, director, national_id_numb, website, description, hotel_cat_id) values (corporateName, address, addressNumber, town, province, state, vatin, phoneNumber, faxNumber, email, director, nationalIdNumber, website, rdescription, h_cat);
      end if;
      common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.list_available_hotels');
  end insert_hotel;

-- *******************************************************************************************
-- *******************************************************************************************

procedure update_hotel(corporateName varchar2,address varchar2, addressNumber number,
			 town varchar2, province varchar2,state varchar2, vatin varchar2,
			 phoneNumber varchar2, faxNumber varchar2,email varchar2,director varchar2,
			 nationalIdNumber varchar2,website varchar2,rdescription varchar2, h_cat number, hid number) is


cpname varchar2(4000) := corporateName;
adr varchar2(4000) := address;
adrnr varchar2(4000) := addressNumber;
twn varchar2(4000) := town;
pvn varchar2(4000) := province;
sts varchar2(4000) := state;
vtn varchar2(4000) := vatin;
pnr varchar2(4000) := phoneNumber;
fxnr varchar2(4000) := faxNumber;
eml varchar2(4000) := email;
dkr varchar2(4000) := director;
nid varchar2(4000) := nationalIdNumber;
wbs varchar2(4000) := website;
dsn varchar2(4000) := rdescription;

  begin
     common.get_gbl_pid;
      if common.has_privs_to_page then
	    update  hotels h
	    set
		h.corporate_name = cpname,
		h.address = adr,
		h.address_number = adrnr,
		h.town = twn,
		h.province = pvn,
		h.state = sts,
		h.vatin = vtn,
		h.phone_number = pnr,
		h.fax_number = fxnr,
		h.email = eml,
		h.director = dkr,
		h.national_id_numb = nid,
		h.website = wbs,
		h.description = dsn,
		h.hotel_cat_id =  h_cat
	    where
		h.hotel_id = hid;

      end if;
    common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.list_available_hotels');
  end update_hotel;

-- *******************************************************************************************
-- *******************************************************************************************

   procedure list_available_room_types(action varchar2 default null, rid number default -1) is

  cursor driver is
  select * from room_types h
  order by room_name asc;

  driver_rec	driver%ROWTYPE;

  begin
  common.get_gbl_pid;
      if common.has_privs_to_page then
   maint.header('Available Room Types');
    regist_maint.jsFunctions;
	if(action = 'delete') then
	   delete_room_type(rid);
	end if;
	htp.tableOpen();
	htp.tableRowOpen();
	htp.p('<td width=25%>');
	maint.menu(0);
	htp.p('</td>');
	htp.p('<td>');
	htp.tableOpen(cattributes=>'border = 1px');
	htp.tableRowOpen();
	htp.tableHeader(common.space$);
	htp.tableHeader('Room name');
	htp.tableHeader('Description');
	htp.tableHeader(common.space$);
	htp.tableRowClose();
	for driver_rec in driver loop
	  htp.tableRowOpen();
	  htp.tableData(htf.anchor ('hotel_handling_maint.create_room_type_entry?rid=' || driver_rec.room_type_id, htf.IMG(common.editImg$,cattributes=>'border=0 alt=Edit title=Edit')));
	  htp.tableData(driver_rec.room_name);
	  htp.tableData(driver_rec.description);
	   htp.tableData(htf.anchor ('hotel_handling_maint.list_available_room_types?action=delete&rid=' || driver_rec.room_type_id ,htf.IMG(common.deleteImg$,cattributes=>'border=0 alt="Remove Room Type" title="Remove Room Type"'),cattributes=>'onclick=''return deleteConfirm()'''));
	  htp.tableRowClose();
	end loop;
	htp.tableRowOpen();
	htp.tableData(htf.anchor ('hotel_handling_maint.create_room_type_entry',htf.IMG(common.newImg$,cattributes=>'border=0 alt="New hotel" title="New hotel"')),cattributes=>'colspan="3"');
	htp.tableRowClose();
	htp.tableClose();
	htp.p('</td>');
	htp.tableRowClose();
	htp.tableClose();
    end if;
  end list_available_room_types;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure delete_room_type(rid number default -1) is

  rid_null exception;
  association exception;
  begin
  if(rid = -1 or rid is null) then
      raise rid_null;
  else
      if(hasDepositAssociated(rid) = true) then
	raise association;
      else
	delete from room_types where room_type_id = rid;
      end if;
  end if;
  exception
  when rid_null then
	htp.header (3,pid_error$);
  when association then
	htp.header (3,association_error$);
  when others then
	htp.header (3,error$);
  end delete_room_type;

-- *******************************************************************************************
-- *******************************************************************************************

   procedure create_room_type_entry(rid number default -1) is

cursor driver is
select * from room_types
where room_type_id = rid;

driver_rec	driver%ROWTYPE;
rec_found	boolean := false;

BEGIN
    if common.header ('Add/Modify Room Types') then
       if(rid != -1) then
	   open driver;
	   fetch driver into driver_rec;
	   rec_found := driver%FOUND;
	   close driver;
       end if;

       htp.p (common.space2$);
       htp.tableOpen();
       htp.tableRowOpen();
       htp.tableData('&nbsp;', cattributes=>'width="25%"');
       htp.p('<td>');
       htp.formOpen(curl=>'hotel_handling_maint.insert_room_type', cmethod=>'post');
       htp.formHidden(cname=>'rid',cvalue=>rid);
       htp.tableOpen();
       htp.tableRowopen();
       htp.tableData('Room type name');
       htp.tableData(htf.formText(cname=>'roomName',csize=>'60',cvalue=>driver_rec.room_name));
       htp.tableRowClose();
       htp.tableRowopen();
       htp.tableData('Description');
       htp.tableData(htf.formTextarea(cname=>'rdescription',ncolumns=>'60',nrows=>'5',cattributes=>'value="' || driver_rec.description || '"'));
       htp.tableRowClose();
       htp.tableRowOpen();
       htp.tableData(htf.formSubmit(cvalue=>'Save'), cattributes=>'colspan="2"');
       htp.tableRowClose();
       htp.tableClose();
       htp.formClose();
       htp.tableData('&nbsp;', cattributes=>'width="25%"');
       htp.tableRowClose();
       htp.tableClose();
    end if;
    NULL;
  END create_room_type_entry;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure insert_room_type(rid number,roomName varchar2, rdescription varchar2) is
  begin
      common.get_gbl_pid;
      if common.has_privs_to_page then
	  if(rid != -1) then
	      update room_types set room_name = roomName, description = rdescription where room_type_id = rid;
	  else
	      insert into room_types (room_name,description) values(roomName,rdescription);
	  end if;
      end if;
      common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.list_available_room_types');
  end insert_room_type;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure add_rooms_hotels(hid number default -1,selected owa_util.ident_arr default empty_arr, rnum number default 0,
			     startDate date default null, endDate date default null, description varchar2 default null) is

  cursor driver is
  select * from rooms_hotel
  where hotel_id = hid;

  cursor rtype is
  select hc.roomtype_id, rt.room_name,rt.description from hotel_roomtype_fee hc
  inner join room_types rt on rt.room_type_id = hc.roomtype_id
  where hc.hotel_id = hid order by rt.room_name;


  rtype_rec	rtype%ROWTYPE;
  driver_rec	driver%ROWTYPE;
  rec_found	boolean := false;
  token 	varchar2(1000);
  counter	number := 0;
  i		number :=0;

begin

      if common.header ('Add Rooms') then
	if(rnum = 0 or rnum is	null) then
	    htp.p (common.space2$);
	    htp.tableOpen();
	    htp.tableRowOpen();
	    htp.tableData(htf.anchor ('hotel_handling_maint.list_available_hotels',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')),cattributes=>'colspan="3"');
	    htp.tableRowClose();
	    htp.tableRowOpen();
	    htp.tableData('&nbsp;', cattributes=>'width="25%"');
	    htp.p('<td>');
	    htp.formOpen(curl=>'hotel_handling_maint.add_rooms_hotels', cmethod=>'post');
	    htp.formHidden(cname=>'hid',cvalue=>hid);
	    htp.tableOpen();
	    htp.tableRowOpen();
	    htp.tableData('How many rooms at this hotel?',cattributes=>'colspan="2"');
	    htp.tableData(htf.formText(cname=>'rnum',csize=>'4'),cattributes=>'colspan="2"');
	    htp.tableRowClose();
	    htp.tableRowOpen();
	    htp.tableData('Description',cattributes=>'colspan="2"');
	    htp.tableData(htf.formText(cname=>'description',csize=>'30'),cattributes=>'colspan="2"');
	    htp.tableRowClose();
	    htp.tableRowOpen();
	    htp.tableData('Available from:', cattributes=>'colspan="4"');
	    htp.tableRowClose();
	    htp.tableRowOpen();
	    htp.tableData('Start date (dd-MON-yy):');
	    htp.tableData(htf.formText(cname=>'startDate',csize=>'9',cattributes=>'maxlength="9"'));
	    htp.tableData('End date (dd-MON-yy):');
	    htp.tableData(htf.formText(cname=>'endDate',csize=>'9',cattributes=>'maxlength="9"'));
	    htp.tableRowClose();
	    -- insert default configuration --
	    htp.tableRowOpen();
	    htp.tableRowOpen();
	    htp.tableData('<b>Select default room possible configurations</b>', cattributes=>'colspan="4"');
	    htp.tableRowClose();
	    htp.p('<td colspan="4">');
	    htp.tableOpen(cattributes=>'border="0px"');
	    htp.tableRowOpen();
	    htp.tableHeader('Room name');
	    htp.tableHeader('Description');
	    htp.tableHeader(common.space$);
	    htp.tableRowClose();
	    for rtype_rec in rtype loop
	      htp.tableRowOpen();
	      htp.tableData(rtype_rec.room_name);
	      htp.tableData(rtype_rec.description);
	      htp.p('<td>');
	      htp.formCheckbox('selected',rtype_rec.room_name);
	      htp.p('</td>');
	      htp.tableRowClose();
	    end loop;
	    htp.tableClose();
	    htp.p('</td>');
	    htp.tableRowClose();
	    htp.tableRowOpen();
	    htp.tableData(htf.formSubmit(cvalue=>'Insert'), cattributes=>'colspan="4"');
	    htp.tableRowClose();
	    htp.tableClose();
	    htp.formClose();
	    htp.p('</td>');
	    htp.tableData('&nbsp;', cattributes=>'width="50%"');
	    htp.tableRowClose();
	    htp.tableClose();
	else
	    if(hid != -1 or hid is not null) then
	      open driver;
	      fetch driver into driver_rec;
		rec_found := driver%FOUND;
	       close driver;
	    end if;
	    if(rec_found = false and rnum is not null) then
		if(selected is not null) then
		    counter := selected.count;
		    for i in 1..(counter-1) loop
		      token := token || selected(i) || '|';
		    end loop;
		    token := token || selected(counter);
	       end if;
	       for i in 1..rnum
	       loop
		  insert into rooms_hotel (hotel_id,description,start_date,end_date,config) values (hid, description, startDate, endDate,token);
	       end loop;
		htp.tableOpen();
		htp.tableRowOpen();
		htp.tableData(htf.anchor ('hotel_handling_maint.list_available_hotels',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')),cattributes=>'colspan="3"');
		htp.tableData('Rooms added');
		htp.tableRowClose();
		htp.tableClose();
	    end if;
	end if;
      end if;
  end add_rooms_hotels;

-- *******************************************************************************************
-- *******************************************************************************************

procedure remove_modify_rooms_hotel(action varchar2 default null, hid number default -1,str number default 1, roomid number default null,
				      rid owa_util.ident_arr default empty_arr, description owa_util.ident_arr default empty_arr,
				      startDate owa_util.ident_arr default empty_arr, endDate owa_util.ident_arr default empty_arr) is

   cursor counter is
	   select count(room_id) as total from rooms_hotel
	   where hotel_id = hid;

	cursor room (str number) is
    	select * from
   			(select rh.*,rownum rnum
   		 		from (select * from rooms_hotel where rooms_hotel.hotel_id = hid) rh
   		 	where ROWNUM<=(str+record_per_page$-1)
   		     )
   		 where rnum >=str;

   cursor checkroom(hid integer) is
   select room_id from rooms_hotel
   where hotel_id = hid;

   	cursor choices(rid integer) is
		Select r.registrant_id, r.start_date, r.end_date, r.confirmed, r.choice_order, persons.lname, persons.fname
		from persons,
			(select distinct rs.choice_id, rs.confirmed, rs.choice_order, rs.registrant_id, rs.SEQ_ID , rs.config , rs.room_id, rs.start_date, rs.end_date, rs.hotel_id
			from (
					(Select  rc.*
					from registrants_choices rc
					where rc.room_id=rid and rc.confirmed='Y' and rc.deleted='N'
					and rc.date_record in (select max(rrc.date_record) from registrants_choices rrc where rrc.seq_id= rc.seq_id and rrc.choice_order=rc.choice_order and rrc.deleted='N'))
				UNION
					(Select  rc.*
					from registrants_choices rc
					where rc.room_id=rid and rc.choice_order='fc' and rc.deleted='N'
					and rc.seq_id not in
					(select rcc.seq_id from registrants_choices rcc
					where rcc.seq_id= rc.seq_id and rcc.choice_order<>'fc' and  rcc.confirmed='Y' and rcc.deleted='N'
					and rcc.date_record in (select max(rccc.date_record) from registrants_choices rccc where rccc.seq_id= rcc.seq_id and rccc.choice_order=rcc.choice_order and rccc.deleted='N'))
					and rc.date_record in (select max(rrcc.date_record) from registrants_choices rrcc where rrcc.seq_id= rc.seq_id and rrcc.choice_order=rc.choice_order and  rrcc.deleted='N')))
			 	rs ) r
		where persons.person_id=r.registrant_id
		order by r.start_date;


   room_rec   room%ROWTYPE;
   counter_rec counter%ROWTYPE;
   checkroom_rec checkroom%ROWTYPE;
   page_number number := 0;
   remder      number := 0;
   rec_found   boolean := false;
   st_date  varchar2(100);
   end_date varchar2(100);
   lname varchar2(100);
   fname varchar2(100);
   conf varchar2(10);
   ch_order varchar2(100);
   reg_id integer;
   book_status varchar2(1000) := '';
   persons varchar2(10000):= '';
   stDates varchar2(1000):= '';
   enDates varchar2(1000):= '';
   i integer := 0;
   found boolean := false;

begin
    if common.header ('Modify/Remove rooms') then
	regist_maint.jsFunctions;
      	if (action = 'Save changes') then
			for i in 1..rid.count loop
				if(rid(i) != -1) then
				  	update rooms_hotel set description = description(i), start_date = startDate(i), end_date = endDate(i) where room_id = rid(i) and hotel_id = hid;
				else
				  	insert into rooms_hotel (hotel_id,description,start_date,end_date) values(hid,description(i),startDate(i),endDate(i));
				end if;
			end loop;
		end if;
	    if(action = 'Remove all') then
			open checkroom(hid);
			loop
				fetch checkroom into checkroom_rec;
				exit when checkroom%NOTFOUND;
				open choices(checkroom_rec.room_id);
				fetch choices into reg_id,st_date,end_date,conf,ch_order,lname,fname;
				close choices;
				if(reg_id is null) then
					delete from rooms_hotel where hotel_id = hid and room_id = checkroom_rec.room_id;
				end if;
			end loop;
			close checkroom;
	    end if;

		if(action = 'remove') then
			open choices(roomid);
			fetch choices into reg_id,st_date,end_date,conf,ch_order,lname,fname;
			close choices;
			if(reg_id is null) then
				delete from rooms_hotel where hotel_id = hid and room_id = roomid;
			end if;
		end if;

	    open counter;
	    fetch counter into counter_rec;
	    rec_found := counter%FOUND;
	    close counter;

	    if(rec_found) then
			remder:= counter_rec.total mod record_per_page$;
			page_number := (counter_rec.total - remder) / record_per_page$;
			if (remder >0) then
				page_number:=page_number+1;
			end if;
	    end if;
	    htp.p (common.space2$);
	    htp.tableOpen();
	    htp.tableRowOpen();
	    htp.tableData(htf.anchor ('hotel_handling_maint.list_available_hotels',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')),cattributes=>'colspan="3"');
	    htp.tableRowClose();
	    htp.tableRowOpen();
	    htp.tableData('&nbsp;', cattributes=>'width="5%"');
	    htp.p('<td>');
	    htp.formOpen(curl=>'hotel_handling_maint.remove_modify_rooms_hotel', cmethod=>'post');
	    htp.formHidden(cname=>'hid',cvalue=>hid);
	    htp.tableOpen('border=1px');
	    htp.tableHeader('Room id');
	    htp.tableHeader('Booking status');
	    htp.tableHeader('From');
	    htp.tableHeader('To');
	    htp.tableHeader('Registrant');
	    htp.tableHeader('Description');
	    htp.tableHeader('Start Date');
	    htp.tableHeader('End date');
	    htp.tableHeader('Configurations');
	    htp.tableHeader(common.space$);
	    for room_rec in room (str) loop
	    	htp.tableRowOpen();
	    	htp.tableData(room_rec.room_id);
	    	open choices(room_rec.room_id);
	    	i:=0;
		    book_status := '';
		    stDates := '';
		    enDates := '';
		    persons := '';
		    found := false;
		    loop
				fetch choices into reg_id,st_date,end_date,conf,ch_order,lname,fname;
				exit when choices%NOTFOUND;
				found := choices%FOUND;
				if(ch_order = 'fc') then
			    	ch_order := 'First choice';
				elsif(ch_order = 'sc') then
			    	ch_order := 'Second choice';
				elsif(ch_order = 'tc') then
				    ch_order := 'Third choice';
				end if;
				if(ch_order is not null) then
				  if(i>0) then
				    book_status := book_status || '<br>' || 'Conf:' || conf || '&nbsp;--&nbsp;' || ch_order;
				  else
				    book_status := book_status || 'Conf:' || conf || '&nbsp;--&nbsp;' || ch_order;
				  end if;
			    end if;
				if (st_date is not null) then
				  	if(i>0) then
				     	stDates := stDates || '<br/>' || st_date ;
				     	enDates := enDates || '<br/>' || end_date ;
				  	else
				     	stDates := stDates || st_date ;
				     	enDates := enDates || end_date ;
				  	end if;
				end if;
				if (lname is not null) then
				  	if(i>0) then
				     	persons := persons || '<br/>' || lname || '&nbsp;' ||fname ;
				  	else
				     	persons := persons || lname || '&nbsp;' || fname;
				  	end if;
				end if;
				i := i+1;
		    end loop;
		    close choices;
		    htp.tableData(book_status);
		    htp.tableData(stDates);
		    htp.tableData(enDates);
		    htp.tableData(persons);
		    htp.formHidden(cname=>'rid',cvalue=>room_rec.room_id);
		    htp.tableData(htf.formText(cname=>'description',csize=>'30',cvalue=>room_rec.description));
		    htp.tableData(htf.formText(cname=>'startDate',csize=>'9',cvalue=>room_rec.start_date));
		    htp.tableData(htf.formText(cname=>'endDate',csize=>'9',cvalue=>room_rec.end_date));
		    htp.p('<td>' || room_rec.config || '<br>');
		    if(found = false) then
		      htp.anchor('hotel_handling_maint.room_config_edit?roomid='|| room_rec.room_id || '&hid=' || hid ,'Modify/Remove');
		    end if;
		    htp.p('</td>');
		    if(found = false) then
			 	htp.tableData(htf.anchor ('hotel_handling_maint.remove_modify_rooms_hotel?action=remove&hid=' || hid || '&str=' || str || '&roomid=' || room_rec.room_id,htf.IMG(common.deleteImg$,cattributes=>'border=0 alt="Remove Room" title="Remove Room"'),cattributes=>'onclick=''return deleteConfirm()'''));
		    else
			 	htp.tableData (htf.IMG(common.usedImg$,cattributes=>'border=0 alt=Booked title=Booked'));
		    end if;
		    htp.tableRowClose();
	    end loop;
	    if(action = 'add') then
			htp.tableRowOpen();
			htp.tableData(common.space$);
			htp.formHidden(cname=>'rid',cvalue=>'-1');
			htp.tableData(htf.formText(cname=>'description',csize=>'30'));
			htp.tableData(htf.formText(cname=>'startDate',csize=>'9'));
			htp.tableData(htf.formText(cname=>'endDate',csize=>'9'));
			htp.tableRowClose();
	    end if;
	    htp.tableClose();
	    htp.p('<BR>');
	    htp.anchor ('hotel_handling_maint.remove_modify_rooms_hotel?action=add&hid=' || hid || '&str=' || str,htf.IMG(common.newImg$,cattributes=>'align="top" border=0 alt="New Room" title="New Room"'));
	    htp.p('&nbsp;');
		htp.formSubmit(cname=>'action',cvalue=>'Save changes');
		htp.p('&nbsp;');
		htp.formSubmit(cname=>'action',cvalue=>'Remove all',cattributes=>'onclick=''return deleteConfirm()''');
	    htp.p('<BR>');
	    for i in 1..page_number loop
			htp.p(htf.anchor ('hotel_handling_maint.remove_modify_rooms_hotel?action=&hid=' || hid || '&str=' || ((i-1)*record_per_page$+1),i));
	    end loop;
	    htp.formClose();
      end if;
    end remove_modify_rooms_hotel;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure show_room_types_hotel(hid number) is

  cursor driver is
  select rt.*,hrf.roomtype_id,hrf.fee,hrf.hrf_id from room_types rt
  left join hotel_roomtype_fee hrf
  on rt.room_type_id = hrf.roomtype_id
  and hrf.hotel_id = hid order by rt.room_name;


  driver_rec	driver%ROWTYPE;
  rec_found	boolean := false;
  i		number :=1;

  begin
     common.get_gbl_pid;
      if common.has_privs_to_page then
	  open	driver;
	  fetch driver into  driver_rec;
		rec_found := driver%FOUND;
	  close driver;
	  maint.header('Add Services');
	  regist_maint.jsFunctions;
	  htp.tableOpen();
	  htp.tableRowOpen();
	  htp.p('<td width=25%>');
	  maint.menu(0);
	  htp.p('</td>');
	  htp.p('<td>');
	  htp.tableOpen(cattributes=>'border="1px"');
	  htp.formOpen(curl=>'hotel_handling_maint.add_selected_room_types_hotel', cmethod=>'post');
	  htp.tableRowOpen();
	  htp.tableHeader('Room name');
	  htp.tableHeader('Description');
	  htp.tableHeader('Hotel fee');
	  htp.tableHeader();
	  htp.tableRowClose();
	  for driver_rec in driver loop
	  htp.tableRowOpen();
	  htp.tableData(driver_rec.room_name);
	  htp.tableData(driver_rec.description);
	  htp.tableData(htf.formText(cname=>'fee',cvalue=>driver_rec.fee));
	  htp.p('<td>');
	  if(driver_rec.roomtype_id is not null) then
	     htp.formHidden(cname=>'rtid',cvalue=>driver_rec.roomtype_id);
	     htp.formCheckbox('selected',i,'1');
	  else
	     htp.formHidden(cname=>'rtid',cvalue=>driver_rec.room_type_id);
	     htp.formCheckbox('selected',i);
	  end if;
	   htp.p('</td>');
	  htp.tableRowClose();
	  i := i+1;
	  end loop;
	  htp.tableRowOpen();
	  htp.p('<td colspan="4">');
	  htp.formHidden(cname=>'hid',cvalue=>hid);
	  htp.formSubmit(cvalue=>'Associate/Modify services',cattributes=>'align="left"');
	  htp.p('</td>');
	  htp.tableRowClose();
	  htp.formClose();
	  htp.tableClose();
	  htp.p('</td>');
	  htp.tableData('&nbsp;', cattributes=>'width="25%"');
	  htp.tableRowClose();
	  htp.tableClose();
      end if;
  end show_room_types_hotel;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure add_selected_room_types_hotel(hid number,fee owa_util.ident_arr default empty_arr,
					  selected owa_util.ident_arr default empty_arr, rtid owa_util.ident_arr default empty_arr) is

  f number := 0;
  r number :=0;
  begin
  common.get_gbl_pid;
  if common.has_privs_to_page then
    if(selected is not null ) then
     delete from hotel_roomtype_fee where hotel_id = hid;
      for i in 1..selected.count loop
	  f := fee(selected(i));
	  r := rtid(selected(i));
	insert into hotel_roomtype_fee (hotel_id,roomtype_id,fee) values (hid,r,f);
      end loop;
     else
      delete from hotel_roomtype_fee where hotel_id = hid;
     end if;
      common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.list_available_hotels');
  end if;
  end add_selected_room_types_hotel;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure list_available_deposit is

  cursor driver is
  select rd.*, hc.hotel_cat_name,rt.room_name from room_deposit rd
  inner join hotel_categories hc on rd.hotel_cat_id = hc.hotel_cat_id
  inner join room_types rt on rd.room_type_id = rt.room_type_id
  order by hc.hotel_cat_name;

  driver_rec	driver%ROWTYPE;

  begin
    common.get_gbl_pid;
      if common.has_privs_to_page then
      automated_deposit_filling;
   maint.header('Deposit list ');
    regist_maint.jsFunctions;
	htp.tableOpen();
	htp.tableRowOpen();
	htp.p('<td width=25%>');
	maint.menu(0);
	htp.p('</td>');
	htp.p('<td>');
	htp.tableOpen(cattributes=>'border = 1px');
	htp.tableRowOpen();
	htp.tableHeader(common.space$);
	htp.tableHeader('Category');
	htp.tableHeader('Room Type');
	htp.tableHeader('Deposit');
	htp.tableHeader('Data Update');
	htp.tableRowClose();
	for driver_rec in driver loop
	  htp.tableRowOpen();
	  htp.tableData(htf.anchor ('hotel_handling_maint.add_modify_deposit?did=' || driver_rec.deposit_id, htf.IMG(common.editImg$,cattributes=>'border=0 alt=Edit title=Edit')));
	  htp.tableData(driver_rec.hotel_cat_name);
	  htp.tableData(driver_rec.room_name);
	  htp.tableData(driver_rec.deposit);
	  if(driver_rec.dep_locked = 1) then
	     htp.tableData(htf.anchor ('hotel_handling_maint.change_deposit_status?dip=' || driver_rec.deposit_id || '&val=0','Manual'));
	  else
	     htp.tableData(htf.anchor ('hotel_handling_maint.change_deposit_status?dip=' || driver_rec.deposit_id || '&val=1','Auto'));
	  end if;
	  htp.tableRowClose();
	end loop;
	htp.tableRowOpen();
	htp.tableData(htf.anchor ('hotel_handling_maint.add_modify_deposit?',htf.IMG(common.newImg$,cattributes=>'border=0 alt="New deposit" title="New deposit"')),cattributes=>'colspan="5"');
	htp.tableRowClose();
	htp.tableClose();
	htp.p('</td>');
	htp.tableData(common.space$,cattributes=>'width="25%"');
	htp.tableRowClose();
	htp.tableClose();
    end if;
  end list_available_deposit;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure automated_deposit_filling is

   cursor driver is
   select ht.hotel_cat_id,tab.fee,tab.roomtype_id from hotels ht,
  (select hrf.hotel_id,hrf.fee,hrf.roomtype_id from hotel_roomtype_fee hrf,
  (select max(fee) as deposit,roomtype_id from
   hotel_roomtype_fee
   group by roomtype_id) maxresults
   where hrf.fee = maxresults.deposit) tab
   where ht.hotel_id = tab.hotel_id;

   cursor finder (rt_id number,cat_id number) is
   select deposit_id,dep_locked from room_deposit
   where room_type_id = rt_id
   and hotel_cat_id = cat_id;

  driver_rec driver%ROWTYPE;
  finder_rec finder%ROWTYPE;
  rec_found	boolean := false;

  begin
      common.get_gbl_pid;
      if common.has_privs_to_page then
       for driver_rec in driver loop
	      open finder(driver_rec.roomtype_id, driver_rec.hotel_cat_id);
	      fetch finder into  finder_rec;
		  rec_found := finder%FOUND;
	      close finder;
	      if(rec_found and finder_rec.dep_locked != 1) then
		  update room_deposit set deposit = driver_rec.fee where room_type_id = driver_rec.roomtype_id and hotel_cat_id = driver_rec.hotel_cat_id;
	      else
		if(rec_found = false) then
		  insert into room_deposit(room_type_id,hotel_cat_id,deposit,dep_locked) values(driver_rec.roomtype_id,driver_rec.hotel_cat_id,driver_rec.fee,1);
		end if;
	      end if;
       end loop;
      end if;
  exception
      when others then
      htp.header (3,error$);
      htp.p(htf.anchor ('hotel_handling_maint.list_available_deposit',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')));
  end automated_deposit_filling;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure change_deposit_status(dip number default -1, val number default 0) is
  begin
       common.get_gbl_pid;
      if common.has_privs_to_page then
	  if(dip != -1) then
	      update room_deposit set dep_locked = val where deposit_id = dip;
	  end if;
      else
      htp.header (3,not_authorized$);
      htp.p(htf.anchor ('hotel_handling_maint.list_available_deposit',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')));
      end if;
      common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.list_available_deposit');
  end change_deposit_status;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure add_modify_deposit(did number default -1) is

  cursor deposit is
  select * from room_deposit
  where deposit_id = did;

  cursor hotelcat is
  select * from hotel_categories
  order by hotel_cat_name;

  cursor roomtype is
  select * from room_types
  order by room_name;

  deposit_rec	deposit%ROWTYPE;
  hotelcat_rec	hotelcat%ROWTYPE;
  roomtype_rec	roomtype%ROWTYPE;

  begin
  common.get_gbl_pid;
  if common.has_privs_to_page then
	if(did != -1) then
	     maint.header('Modify Deposit');
	     open deposit;
	     fetch deposit into deposit_rec;
	     close deposit;
	else
	     maint.header('Add new deposit');
	end if;
	  regist_maint.jsFunctions;
	  htp.tableOpen();
	  htp.tableRowOpen();
	  htp.p('<td width=25%>');
	  maint.menu(0);
	  htp.p('</td>');
	  htp.p('<td>');
	  htp.tableOpen(cattributes=>'border="0px"');
	  htp.formOpen(curl=>'hotel_handling_maint.save_deposit', cmethod=>'post');
	  htp.formHidden(cname=>'did',cvalue=>deposit_rec.deposit_id);
	  htp.tableRowOpen();
	  htp.tableData('Hotel category',cattributes=>'align="right"');
	  htp.p('<td>');
	      htp.formSelectOpen(cname=>'hotelCatId');
	      htp.p('<option VALUE="-1">');
	      htp.p('</option>');
	      for hotelcat_rec in hotelcat loop
		if(hotelcat_rec.hotel_cat_id = deposit_rec.hotel_cat_id) then
		   htp.formSelectOption(hotelcat_rec.hotel_cat_name, cattributes=>'VALUE="' || hotelcat_rec.hotel_cat_id || '", selected');
		else
		   htp.formSelectOption(hotelcat_rec.hotel_cat_name, cattributes=>'VALUE="' || hotelcat_rec.hotel_cat_id || '"');
		end if;
	      htp.p('</option>');
	      end loop;
	      htp.formSelectClose();
	  htp.p('</td>');
	  htp.tableRowClose();
	  htp.tableRowOpen();
	  htp.tableData('Service type',cattributes=>'align="right"');
	  htp.p('<td>');
	      htp.formSelectOpen(cname=>'roomTypeId');
	      htp.p('<option VALUE="-1">');
	      htp.p('</option>');
	      for roomtype_cat in roomtype loop
		if(roomtype_cat.room_type_id = deposit_rec.room_type_id) then
		   htp.formSelectOption(roomtype_cat.room_name, cattributes=>'VALUE="' ||roomtype_cat.room_type_id || '", selected');
		else
		   htp.formSelectOption(roomtype_cat.room_name, cattributes=>'VALUE="' || roomtype_cat.room_type_id || '"');
		end if;
	      htp.p('</option>');
	      end loop;
	      htp.formSelectClose();
	  htp.p('</td>');
	  htp.tableRowClose();
	  htp.tableRowOpen();
	  htp.tableData('Deposit',cattributes=>'align="right"');
	  htp.tableData(htf.formText(cname=>'dep',cvalue=>deposit_rec.deposit,csize=>'10'));
	  htp.tableRowClose();
	  htp.tableRowOpen();
	  htp.tableData('Disable auto update',cattributes=>'align="right"');
	  htp.p('<td>');
	  if(deposit_rec.dep_locked =1) then
	     htp.formCheckbox('depLocked',deposit_rec.dep_locked,'1');
	  else
	     htp.formCheckbox('depLocked',0);
	  end if;
	   htp.p('</td>');
	  htp.tableRowClose();
	  htp.tableRowOpen();
	  htp.tableData(htf.formSubmit(cvalue=>'Save'), cattributes=>'colspan="2" align="middle"');
	  htp.tableRowClose();
	  htp.formClose();
	  htp.tableClose();
	  htp.p('</td>');
	  htp.tableData('&nbsp;', cattributes=>'width="25%"');
	  htp.tableRowClose();
	  htp.tableClose();
	else
      htp.header (3,not_authorized$);
      htp.p(htf.anchor ('hotel_handling_maint.list_available_deposit',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')));
      end if;

  end add_modify_deposit;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure save_deposit(did number default -1, hotelCatId number default -1,
			 roomTypeId number default -1, dep number default -1, depLocked number default 1 ) is


      null_values exception;
      null_hotel exception;
      null_room exception;
      dl number :=1;

  begin
    common.get_gbl_pid;
      if common.has_privs_to_page then
	  if(hotelCatId = -1) then
	      raise null_hotel;
	  elsif (roomTypeId = -1) then
	      raise null_room;
	  elsif (dep = -1 or dep is null) then
	      raise null_values;
	    else
	     if(did != -1) then
		 if (depLocked is not null) then
		      dl := depLocked;
		 end if;
		update room_deposit set hotel_cat_id = hotelCatId, room_type_id = roomTypeId,
		       deposit = dep, dep_locked = dl where deposit_id = did;
	     else
		insert into room_deposit(hotel_cat_id,room_type_id,deposit,dep_locked) values (hotelCatId,roomTypeId,dep,dl);
	     end if;
	     common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.list_available_deposit');
	  end if;
      else
	  htp.header (3,not_authorized$);
	  htp.p(htf.anchor ('hotel_handling_maint.list_available_deposit',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')));
      end if;
  exception
      when null_values then
	  htp.header(3,'Deposit must have a value');
	  htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
      when null_hotel then
	  htp.header(3,'Hotel category must be set');
	  htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
      when null_room then
	  htp.header(3,'Room type must be set');
	  htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
      when others then
	  htp.header(3,error$);
	  htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
  end save_deposit;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure room_config_edit(roomid number default -1, hid number default -1) is

  cursor rtype is
  select hc.roomtype_id, rt.room_name,rt.description from hotel_roomtype_fee hc
  inner join room_types rt on rt.room_type_id = hc.roomtype_id
  where hc.hotel_id = hid order by rt.room_name;

  cursor service  is
  select room_id,config from rooms_hotel
  where hotel_id = hid and room_id = roomid;

  rtype_rec   rtype%ROWTYPE;
  service_rec service%ROWTYPE;
  i	      PLS_INTEGER := 1;
  token       varchar2(100);
  isOk	      boolean := false;
  selected    varchar2(1) := null;
  tokenValue	    varchar2(100);

  begin
  common.get_gbl_pid;
      if common.has_privs_to_page then
       maint.header('Room services configuration');
	  regist_maint.jsFunctions;
	  htp.tableOpen();
	  htp.tableRowOpen();
	  htp.p('<td width=25%>');
	  maint.menu(0);
	  htp.p('</td>');
	  htp.p('<td>');
	  htp.tableOpen(cattributes=>'border="0px"');
	  htp.formOpen(curl=>'hotel_handling_maint.room_config_save', cmethod=>'post');
	  htp.formHidden(cname=>'roomid',cvalue=>roomid);
	  htp.formHidden(cname=>'hid',cvalue=>hid);
	  htp.tableRowOpen();
	  htp.tableHeader('Room name');
	  htp.tableHeader('Description');
	  htp.tableHeader(common.space$);
	  htp.tableRowClose();
	  for rtype_rec in rtype loop
	  htp.tableRowOpen();
	  htp.tableData(rtype_rec.room_name);
	  htp.tableData(rtype_rec.description);
	  htp.p('<td>');
	  open service;
	     fetch service into service_rec;
	  close service;
	  i :=1;
	  tokenValue := rtype_rec.room_name;
	  loop
	     token := common.stringTokenizer( service_rec.config, i , '|') ;
	     exit when token is  null ;
	     if(token is not null) then
		 if(lower(token) = lower(rtype_rec.room_name)) then
		    selected := '1';
		    tokenValue := token;
		 end if;
	     end if;
	     i := i + 1 ;
	  end loop ;
	  htp.formCheckbox('selected',tokenValue,selected);
	  selected := null;
	  htp.p('</td>');
	  htp.tableRowClose();
	  end loop;
	  htp.tableRowOpen();
	  htp.tableData(htf.formSubmit(cvalue=>'Save changes'), cattributes=>'colspan="3" align="middle"');
	  htp.tableRowClose();
	  htp.formClose();
	  htp.tableClose();
	  htp.p('</td>');
	  htp.tableData('&nbsp;', cattributes=>'width="25%"');
	  htp.tableRowClose();
	  htp.tableClose();
      else
	  htp.header (3,not_authorized$);
	  htp.p(htf.anchor ('hotel_handling_maint.list_available_hotels',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')));
      end if;
  end room_config_edit;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure room_config_save (roomid number default -1, selected owa_util.ident_arr default empty_arr, hid number default -1) is

  token varchar2(1000);
  counter number := 0;

  begin
  common.get_gbl_pid;
      if common.has_privs_to_page then
      if(roomid != -1 and selected is not null) then
	counter := selected.count;
	for i in 1..(counter-1) loop
	   token := token || selected(i) || '|';
	end loop;
	   token := token || selected(counter);
      end if;
	  update rooms_hotel set config = token where room_id = roomid;
	  common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.remove_modify_rooms_hotel?hid=' || hid);
      else
	  htp.header (3,not_authorized$);
	  htp.p(htf.anchor ('hotel_handling_maint.list_available_hotels',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')));
      end if;
  end room_config_save;

-- *******************************************************************************************
-- *******************************************************************************************

 procedure remove_hotel(hid number default -1) is

 null_hotel exception;

 begin
    common.get_gbl_pid;
      if common.has_privs_to_page then
      if(hid != -1) then
	  delete from registrants_choices where hotel_id = hid;
	  delete from hotel_roomtype_fee where hotel_id = hid;
	  delete from rooms_hotel where hotel_id = hid;
	  delete from hotels where hotel_id = hid;
	  common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.list_available_hotels');
      else
	  raise null_hotel;
      end if;
      else
	  htp.header (3,not_authorized$);
	  htp.p(htf.anchor ('hotel_handling_maint.list_available_hotels',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')));
      end if;
      exception
      when null_hotel then
	  htp.header(3,'Nothing to delete');
	  htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
 end remove_hotel;

-- *******************************************************************************************
-- *******************************************************************************************

 procedure enable_payments(action varchar2 default null) is

    cursor code is
    select * from payment_codes;

    cursor added is
    select * from hotel_payments;


checked$ varchar2(1) :=null;
begin
 common.get_gbl_pid;
      if common.has_privs_to_page then
   maint.header('Available Payments');
	htp.tableOpen();
	htp.tableRowOpen();
	htp.p('<td width=25%>');
	maint.menu(0);
	htp.p('</td>');
    htp.p('<td>');
     htp.formOpen(curl=>'hotel_handling_maint.add_selected_payments', cmethod=>'post');
     htp.formHidden(cname=>'action',cvalue=>action);
       htp.tableOpen(cattributes=>'border="1px"');
       htp.tableRowOpen();
       htp.tableHeader('Payment method');
       htp.tableHeader('Available online');
       htp.tableHeader('Available to conf.');
       htp.tableHeader();
       htp.tableRowClose();
       for code_rec in code loop
	 htp.tableRowOpen();
	 htp.tableData(code_rec.payment_descr);
	 for added_rec in added loop
	    if(code_rec.payment_code = added_rec.payment_code) then
		checked$ :=1;
	    end if;
	 end loop;
	 htp.tableData(code_rec.online_option);
	 htp.tableData(code_rec.conf_option);
	 htp.tableData(htf.formCheckbox('selected',code_rec.payment_code,checked$));
      	 checked$:=null;
	 htp.tableRowClose();
       end loop;
       htp.tableRowOpen();
       htp.tableData(htf.formSubmit(cvalue=>'Add'),cattributes=>'align="left" colspan="4"');
       htp.tableRowClose();
       htp.tableClose();
     htp.formClose();
    htp.p('</td>');
    htp.tableData('&nbsp;', cattributes=>'width="25%"');
    htp.tableRowClose();
    htp.tableClose();
  end if;
    end enable_payments;

-- *******************************************************************************************
-- *******************************************************************************************

procedure add_selected_payments(selected owa_util.ident_arr default empty_arr, action varchar2) is
begin
  common.get_gbl_pid;
  if common.has_privs_to_page then
 if(selected is not null ) then
     delete from hotel_payments;
     for i in 1..selected.count loop
	insert into hotel_payments (payment_code) values (selected(i));
     end loop;
      common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.enable_payments?action=' || action);
    else
      common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.enable_payments?action=' || action);
    end if;
  end if;
end add_selected_payments;

-- *******************************************************************************************
-- *******************************************************************************************

procedure show_all_registrants_bookings(stPage number default 1,action varchar2 default null, cid number default -1,
					  crypt_pid varchar2  default null, last_name varchar2 default null, cfmed varchar2 default null,
					  ch_order varchar2 default null, cat_id number default null, hid number default -1,sqid number default -1) is

	query varchar2(10000);
	query_where varchar2(10000);
	dummy_query varchar2(10000);
	type	cursor_type is REF CURSOR;
	driver	cursor_type;
	counter cursor_type;
	hotel_id number;
	room_id number;
	rid 	number;
	seq_id number;
	sequence_id number;
	registrant_id number;
	lname varchar2(1000);
	fname varchar2(1000);
	corporate_name varchar2(1000);
	hotel_cat_name varchar2(1000);
	hotel_cat_id number;
	description varchar2(1000);
	confirmed varchar2(10);
	status varchar2(20);
	notes varchar2(4000);
	r_locked varchar2(1);
	choice_order varchar2(2);
	choice_id number;
	deposit number;
	title varchar2(1000);
	stDate date;
	enDate date;
	bookDate date;
	payDate date;
	payCode varchar2(100);
	config varchar2(1000);
	voucherqs varchar2(1000);
	page_number number := 0;
	remder	    number := 0;
	rec_found   boolean := false;
	rnum number;
	str number :=0;
	y number;
	token$ varchar2(1000);
	total number := 0;
	color varchar2(100);
	cc_payment varchar2(100);
	systime timestamp;
	no_alt_room exception;

begin


    if common.header ('Confirmation list', test_only=>true) then
     str := stPage;
     query := 	'Select * from
					(Select rc.choice_id, rc.registrant_id, rc.room_id, rc.choice_order, rc.hotel_id,
							rc.confirmed, rc.r_locked,rc.config,
	    			h.corporate_name, h.hotel_cat_id, hc.hotel_cat_name, h.description,
	    			p.fname, p.lname, p.title, rc.seq_id, rc.start_date, rc.end_date,
	    			rc.status, rc.notes, rc.booking_date, rc.payment_date, rc.payment_code, rc.voucher_qs
					 from registrants_choices rc
						inner join persons p on rc.registrant_id= p.person_id
						inner join hotels h on rc.hotel_id= h.hotel_id
						inner join hotel_categories hc on hc.hotel_cat_id=h.hotel_cat_id
						inner join room_types rp on rc.config=rp.room_name
						inner join payment_codes pc on rc.payment_code= pc.payment_code
					 where rc.deleted=''N'' and
					       rc.date_record= ( select max(rc1.date_record) from registrants_choices rc1
									  where rc1.seq_id=rc.seq_id and rc1.choice_order=rc.choice_order and rc1.deleted=''N'')
					 ) rc3
				where not exists ( select ''found'' from
									(Select rc.*
										from registrants_choices rc
											inner join persons p on rc.registrant_id= p.person_id
											inner join hotels h on rc.hotel_id= h.hotel_id
											inner join room_types rp on rc.config=rp.room_name
											inner join payment_codes pc on rc.payment_code= pc.payment_code
										where rc.deleted=''N'' and
											rc.date_record= ( select max(rc1.date_record) from registrants_choices rc1
															where rc1.seq_id=rc.seq_id and rc1.choice_order=rc.choice_order and rc1.deleted=''N'')
									 ) rc4
									where rc4.seq_id=rc3.seq_id and rc3.choice_id<>rc4.choice_id and rc4.confirmed=''Y'')';
		query_where:=null;
	    if(last_name is not null) then
	    	y:=1;
	    	token$ := common.stringTokenizer(last_name, y , '%');
	    	query_where:= query_where || '((lower(lname) like lower(''%'|| token$ ||'%'')';
			while token$ is not null and token$!='' loop
				y:=y+1;
				token$ := common.stringTokenizer(last_name, y , '%');
		    	query_where:= query_where || ') or (lower(lname) like lower(''%'|| token$ ||'%'')';
			end loop;
			query_where := query_where || '))';
	    end if;


	    if(cat_id is not null) then
	    	if query_where is null then
				query_where := query_where || '(hc.hotel_cat_id = ' || cat_id || ')';
			else
				query_where := query_where || ' and (hc.hotel_cat_id = ' || cat_id || ')';
			end if;
	    end if;
	    if(hid != -1) then
	    	if query_where is null then
	    		query_where := query_where || '(hotel_id = ' || hid ||')' ;
	    	else
	    		query_where := query_where || ' and (hotel_id = ' || hid ||')' ;
	    	end if;
	    end if;
	    if(ch_order is not null) then
	    	if query_where is null then
	    		query_where := query_where || '(choice_order = ''' || ch_order || ''')';
	    	else
	    		query_where := query_where || ' AND (choice_order = ''' || ch_order || ''')';
			end if;
	    end if;

	    if(cfmed ='Y' or cfmed='N') then
			 if query_where is null then
			 	query_where := query_where || '(confirmed = ''' || cfmed || ''')';
			 else
			 	query_where := query_where || ' and (confirmed = ''' || cfmed || ''')';
			 end if;
	    end if;


      	common.public_header ('Confirmation list',js_src=>regist_maint.JS$);
		regist_maint.jsFunctions;



      	if query_where is not null  then
      		query:=query || ' and ' || query_where;
      	end if;

		query:=query || '  order by rc3.lname, rc3.fname, rc3.seq_id, rc3.choice_order';

	  	dummy_query:= 'select count(*) as total from (' || query || ')';



	  	open counter for dummy_query;
	    fetch counter into total;
	    rec_found := counter%FOUND;
	    close counter;
	    if(rec_found) then
			remder:= total mod record_per_page_list$;
			page_number := (total - remder) / record_per_page_list$;
			if (remder >0) then
				page_number:=page_number+1;
			end if;
	    end if;

	    if(action = 'cfm' ) then
	      select rc.registrant_id, rc.room_id,rc.start_date,rc.end_date,rc.config,rc.HOTEL_ID, rc.SEQ_ID into registrant_id,rid,stDate,enDate,config,hotel_id,sequence_id  from registrants_choices rc where rc.choice_id = cid;
	      if(hotel_handling.isBooked(common.ENCRYPT(registrant_id),rid,stdate,endate,false)) then
			  rid := hotel_handling.searchAlternativeRoom(hotel_id, config, stDate, enDate);
			  if(rid = -1) then
				raise no_alt_room;
			  end if;
		  end if;
	   	  systime := systimestamp;
		  update registrants_choices set confirmed = 'Y', date_record = systime, room_id=rid where choice_id = cid;
		  update registrants_choices set r_locked = 'Y' where confirmed != 'Y' and seq_id = sequence_id;
		  common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.show_all_registrants_bookings?cfmed=' || cfmed || '&last_name=' || replace(last_name,'%','%25') || '&ch_order=' || ch_order || '&cid=' || choice_id || '&stPage=' || stPage || '&hid=' || hid);
	    end if;
	    if(action = 'ucfm') then
	      systime := systimestamp;
	      update registrants_choices set confirmed = 'N', date_record = systime where choice_id = cid;
	      update registrants_choices set r_locked = 'N', date_record = systime where   r_locked = 'Y' and seq_id = sqid;
		  common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.show_all_registrants_bookings?cfmed=' || cfmed || '&last_name=' || replace(last_name,'%','%25') || '&ch_order=' || ch_order || '&cid=' || choice_id || '&stPage=' || stPage || '&hid=' || hid);
	    end if;
	    if(action = 'reversed' or action = 'failed') then
			deposit_due(action,crypt_pid,cid,sqid,stPage,last_name,cfmed,ch_order,cat_id,hid);
		    common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.show_all_registrants_bookings?cfmed=' || cfmed || '&last_name=' || replace(last_name,'%','%25') || '&ch_order=' || ch_order || '&cid=' || choice_id || '&stPage=' || stPage || '&hid=' || hid);
	    end if;

		htp.p (common.space2$);
		htp.tableOpen();
		htp.tableRowOpen();
		htp.tableData(htf.anchor ('hotel_handling_maint.search_registrants_bookings',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')),cattributes=>'colspan="3"');
		htp.tableRowClose();
		htp.tableRowOpen();
		htp.tableData('&nbsp;', cattributes=>'width="5%"');
		htp.p('<td>');
		htp.tableOpen(cattributes=>'border="1px"');
		htp.tableRowOpen();
		htp.tableHeader('');
		htp.tableHeader('');
		htp.tableHeader('Registrant');
		htp.tableHeader('');
		htp.tableHeader('Hotel');
		htp.tableHeader('Category');
		htp.tableHeader('Room <br> type');
		htp.tableHeader('Confirmed');
		htp.tableHeader('Start date');
		htp.tableHeader('End date');
		htp.tableHeader('Booking date');
		htp.tableHeader('Payment date');
		htp.tableHeader('Payment');
		htp.tableHeader('Voucher');
		htp.tableHeader('Notes');
		htp.tableHeader(common.space$);
		htp.tableRowClose();
		dummy_query:='select q1.choice_id, q1.registrant_id, q1.room_id, q1.choice_order, q1.hotel_id,
								q1.confirmed, q1.r_locked,q1.config, q1.corporate_name, q1.hotel_cat_id, q1.hotel_cat_name,
								q1.description, q1.fname, q1.lname, q1.title, q1.seq_id, q1.start_date, q1.end_date,
		    			q1.status, q1.notes, q1.booking_date, q1.payment_date, q1.payment_code, q1.voucher_qs, q1.seq_id
		 			  from (select q.*,rownum rnum from (' || query ||
			     ') q where ROWNUM<=' || (str+record_per_page_list$-1) ||
			     ') q1 where rnum >=' ||str;


		open driver for dummy_query;
	    loop
		    fetch driver into choice_id, registrant_id, room_id, choice_order, hotel_id, confirmed, r_locked, config,
				      corporate_name, hotel_cat_id, hotel_cat_name, description, fname, lname, title, seq_id, stDate, enDate, status,
				      notes,bookDate,payDate,payCode,voucherqs,sequence_id;
		    exit when driver%NOTFOUND;
		    htp.tableRowOpen();
			if(lower(confirmed) = 'y') then
				if(status = 'processed') then
					color := '#00ff66';
				elsif(status = 'failed') then
					color := '#ff0066';
				elsif (status = 'reversed') then
					color := '#ffff66';
				end if;
			 	if(lower(status) != 'processed') then
					htp.tableData (htf.anchor ('javascript:popUp(''hotel_handling_maint.process_booking?action=modify&cid=' || choice_id ||'&cfmed=' || cfmed ||'&last_name='|| replace(last_name,'%','%25') ||'&ch_order='|| ch_order ||'&hid=' || hid || '&stPage=' || stPage || ''')', 'Process',cattributes=>'bgcolor="'|| color ||'"'));
			    else
				 	htp.tableData (htf.anchor ('hotel_handling_maint.deposit_due?action=reversed&cid=' || choice_id ||'&cfmed=' || cfmed ||'&last_name='|| replace(last_name,'%','%25') ||'&ch_order='|| ch_order ||'&hid=' || hid || '&stPage=' || stPage || '&crypt_pid=' || common.ENCRYPT(registrant_id) || '&sqid=' || sequence_id , 'Reverse',cattributes=>'onclick=''return generalConfirm()'''),cattributes=>'bgcolor="'|| color ||'"');
			    end if;
			else
				htp.tableData(common.space$);
			end if;
			color := null;
			if(status != 'processed') then
			    htp.p('<td>');
				htp.p(htf.anchor('hotel_handling.show_free_rooms?action=Move&startDate='|| to_char(stDate,'dd-MON-yyyy') ||
							     '&endDate=' || to_char(enDate,'dd-MON-yyyy') ||
							     '&sqid=' || sequence_id ||
							     '&chid='||choice_id ||
											 '&stPage=' || stPage ||
											 '&last_name=' || replace(last_name,'%','%25') ||
											 '&cfmed=' || cfmed ||
											 '&ch_order=' || ch_order ||
											 '&hid=' || hid, 'Move'));
			    htp.p('</td>');
			else
			    htp.tableData(common.space$);
			end if;
			htp.tableData(lname || ' ' || fname );
			if(choice_order = 'fc') then
			    htp.tableData('1');
			elsif(choice_order = 'sc') then
			    htp.tableData('2');
			else
			    htp.tableData('3');
			end if;
			htp.tableData(corporate_name);
			htp.tableData(hotel_cat_name);
			htp.tableData(room_id|| '<br />' ||config  );
			if lower(confirmed) = lower('N') then
			    htp.tableData(htf.anchor('hotel_handling_maint.show_all_registrants_bookings?action=cfm&cfmed=' || cfmed ||'&last_name='|| replace(last_name,'%','%25') ||'&ch_order='|| ch_order ||'&cid=' || choice_id || '&stPage=' || stPage || '&hid=' || hid || '&sqid=' || sequence_id, confirmed, cattributes=>'onClick="return roomConfirmation()"'));
			elsif lower(status) != lower('processed') then
			   htp.tableData(htf.anchor('hotel_handling_maint.show_all_registrants_bookings?action=ucfm&cfmed=' || cfmed ||'&last_name='|| replace(last_name,'%','%25') ||'&ch_order='|| ch_order ||'&cid=' || choice_id || '&stPage=' || stPage || '&hid=' || hid || '&sqid=' || sequence_id, confirmed, cattributes=>'onClick="return roomUnConfirmation()"'));
			else
			   htp.tableData(confirmed);
			end if;
			if confirmed='Y' then
				htp.tableData (htf.anchor ('javascript:popUp(''hotel_handling_maint.modify_booking_period?action=modify&cid=' || choice_id ||'&cfmed=' || cfmed ||'&last_name='|| replace(last_name,'%','%25') ||'&ch_order='|| ch_order ||'&hid=' || hid || '&stPage=' || stPage || ''')',to_char(stDate,'dd-mm-yyyy')));
				htp.tableData (htf.anchor ('javascript:popUp(''hotel_handling_maint.modify_booking_period?action=modify&cid=' || choice_id ||'&cfmed=' || cfmed ||'&last_name='|| replace(last_name,'%','%25') ||'&ch_order='|| ch_order ||'&hid=' || hid || '&stPage=' || stPage || ''')',to_char(enDate,'dd-mm-yyyy')));
			else
				htp.tableData(to_char(stDate,'dd-mm-yyyy'));
				htp.tableData(to_char(enDate,'dd-mm-yyyy'));
			end if;
			htp.tableData(to_char(bookDate,'dd-mm-yyyy'));
			if(payDate is null) then
			    htp.tableData(htf.anchor('javascript:popUp(''hotel_handling_maint.show_payment_date?action=add&sqid=' || seq_id ||'&cfmed=' || cfmed ||'&cat_id='|| cat_id ||'&last_name='|| replace(last_name,'%','%25') ||'&ch_order='|| ch_order || '&hid=' || hid || '&cid=' || choice_id || '&stPage=' || stPage || '&crypt_pid=' || common.ENCRYPT(registrant_id) || ''')', 'Add'));
			else
			    htp.p('<td>');
			    htp.p(htf.anchor('javascript:popUp(''hotel_handling_maint.show_payment_date?action=show&sqid=' || seq_id ||'&cfmed=' || cfmed ||'&cat_id='|| cat_id ||'&last_name='|| replace(last_name,'%','%25') ||'&ch_order='|| ch_order ||'&hid=' || hid || '&cid=' || choice_id || '&stPage=' || stPage || '&crypt_pid=' || common.ENCRYPT(registrant_id) || ''')', to_char(payDate,'dd-mm-yyyy')));
			    htp.p('</td>');
			end if;
			cc_payment := common.decode_value ('credit_card','payment_codes', 'payment_code', payCode);
			if(cc_payment = 'Y') then
			    htp.p('<td>');
				htp.p(common.decode_value ('payment_descr', 'payment_codes','payment_code', payCode));
				htp.p('<br/>');
				htp.p(htf.anchor('javascript:popUp(''hotel_handling_maint.show_ipn_values?action=show&sqid=' || seq_id ||'&cfmed=' || cfmed ||'&cat_id='|| cat_id ||'&last_name='|| replace(last_name,'%','%25') ||'&ch_order='|| ch_order ||'&hid=' || hid || '&cid=' || choice_id || '&stPage=' || stPage || '&crypt_pid=' || common.ENCRYPT(registrant_id) || ''')', 'Details'));
			    htp.p('</td>');
			else
			    htp.tableData(common.decode_value ('payment_descr', 'payment_codes','payment_code', payCode));
			end if;
			if(voucherqs is not null) then
			    voucherqs := replace(voucherqs,'''','');
			    htp.tableData(htf.anchor('hotel_handling_maint.createVoucher?' || voucherqs, 'Show',cattributes=>'target="_blank"'));
			else
			    htp.tableData(common.space$);
			end if;
			if(trim(notes) is not null or trim(notes) != '') then
			    htp.tableData(htf.anchor('javascript:popUp(''hotel_handling_maint.add_hotel_delegates_notes?cid=' || choice_id || '&action=show'')', 'Show'));
			else
			    htp.tableData(htf.anchor('javascript:popUp(''hotel_handling_maint.add_hotel_delegates_notes?cid=' || choice_id || '&action=add'')', 'Add'));
			end if;
			if(status != 'processed' and confirmed!='Y' ) then
			    htp.tableData(htf.anchor ('hotel_handling_maint.cancel_hotel_entry?' ||
										    'action='||action ||
										    '&sqid=' || sequence_id ||
										    '&cfmed=' || cfmed ||
										    '&cat_id='|| cat_id ||
										    '&last_name='|| replace(last_name,'%','%25') ||
										    '&ch_order='|| choice_order ||
										    '&hid=' || hid ||
										    '&cid=' || choice_id ||
										    '&stPage=' || stPage ||
										    '&crypt_pid=' || common.ENCRYPT(registrant_id),
					  htf.IMG(common.deleteImg$,cattributes=>'border=0 alt="Delete entry" title="Delete entry"')),cattributes=>'onclick=''return deleteConfirm()''');
			else
			    htp.tableData (htf.IMG(common.usedImg$,cattributes=>'border=0 alt=processed title=Processed'));
			end if;
			htp.tableRowClose();
		end loop;
	   	close driver;
	    htp.tableRowOpen();
	    htp.p('<td colspan="16">');
	    lname := replace(last_name,'%','%25');
	    for i in 1..page_number loop
			htp.p(htf.anchor ('hotel_handling_maint.show_all_registrants_bookings?stPage=' || ((i-1)*record_per_page_list$+1) || '&last_name=' || lname || '&cfmed=' || cfmed || '&hid=' || hid || '&ch_order=' ||ch_order,i));
	    end loop;
	    htp.p('</td>');
	    htp.tableRowClose();
	    htp.tableClose();
	    htp.formClose();
	    htp.p('</td>');
	    htp.tableData('&nbsp;', cattributes=>'width="5%"');
	    htp.tableRowClose();
	    htp.tableClose();
	    common.FOOTER;

	end if;
exception
    when no_alt_room then
	    common.redirect_URL (common.sserver || common.vdir$ ||
				 'hotel_handling.show_free_rooms?startDate='|| stDate ||
								 '&endDate=' || enDate ||
								 '&sqid=' || sequence_id ||
								 '&chid=' || cid ||
								 '&action=change&cfmed=' || cfmed ||
								     '&last_name=' || replace(last_name,'%','%25') ||
								     '&ch_order=' || ch_order ||
								     '&stPage=' || stPage ||
								     '&hid=' || hid);

end show_all_registrants_bookings;

-- *******************************************************************************************
-- *******************************************************************************************

procedure search_registrants_bookings is

cursor driver is
select * from hotels
order by corporate_name;

driver_rec driver%ROWTYPE;

begin
common.get_gbl_pid;
      if common.has_privs_to_page then
      maint.header ('Search the confirmation list');
      htp.tableOpen();
	htp.tableRowOpen();
	htp.p('<td width=25%>');
	maint.menu(0);
	htp.p('</td>');
	htp.p('<td>');
	htp.tableOpen(cattributes=>'class="filter"');
	htp.p('<td colspan="2">');
	htp.p('You can search multiple attendees. Use % as a separator between two last names. If you want all the attendees just leave every field blank an click on the search button.');
	htp.p('</td>');
	htp.formOpen(curl=>'hotel_handling_maint.show_all_registrants_bookings',cmethod=>'post');
	htp.tableRowOpen();
	htp.tableData('Last name', cattributes=>'align="right"');
	htp.tableData(htf.formText(cname=>'last_name', csize=>'30'), cattributes=>'align="left"');
	htp.tableRowClose();
	htp.tableRowOpen();
	htp.tableData('Hotel name',  cattributes=>'align=''right''');
	htp.p('<td>');
	htp.formSelectOpen(cname=>'hid');
	htp.p('<option VALUE="">');
	htp.p('</option>');
	for driver_rec in driver loop
	    htp.formSelectOption(driver_rec.corporate_name, cattributes=>'VALUE="' || driver_rec.hotel_id || '"');
	    htp.p('</option>');
	end loop;
	htp.formSelectClose();
	htp.p('</td>');
	htp.tableRowClose();
	htp.tableRowOpen();
	htp.tableData('Confirmed',  cattributes=>'align=''right''');
	htp.p('<td>');
	htp.formSelectOpen(cname=>'cfmed');
	htp.p('<option VALUE="">');
	htp.p('</option>');
	htp.formSelectOption('yes', cattributes=>'VALUE="Y"');
	htp.p('</option>');
	htp.formSelectOption('no', cattributes=>'VALUE="N"');
	htp.p('</option>');
	htp.formSelectClose();
	htp.p('</td>');
	htp.tableRowClose();
	htp.tableData('Choice order',  cattributes=>'align=''right''');
	htp.p('<td>');
	htp.formSelectOpen(cname=>'ch_order');
	htp.p('<option VALUE="">');
	htp.p('</option>');
	htp.formSelectOption('First choice', cattributes=>'VALUE="fc"');
	htp.p('</option>');
	htp.formSelectOption('Second choice', cattributes=>'VALUE="sc"');
	htp.p('</option>');
	 htp.formSelectOption('Third choice', cattributes=>'VALUE="tc"');
	htp.p('</option>');
	htp.formSelectClose();
	htp.p('</td>');
	htp.tableRowClose();
	htp.tableRowOpen();
	htp.tableData(htf.formSubmit(cvalue=>'Search'),cattributes=>'align="left" colspan="2"');
	htp.tableRowClose();
	htp.formClose();
	htp.tableClose();
	htp.p('</td>');
	htp.tableRowClose();
	htp.tableClose();
	common.footer;
      end if;
end search_registrants_bookings;

-- *******************************************************************************************
-- *******************************************************************************************

procedure send_payment_recorded_mail(crypt_pid varchar2 default null,status varchar2 default null, sqid number, message varchar2 default null) is

cursor driver is
select p.lname,p.fname from persons p
where p.person_id = common.DECRYPT(crypt_pid);


email varchar2(200);
recipient varchar2(200);
msg varchar2(32000);
signature varchar2(300);
voucher_link varchar2(1000);
voucherqs varchar2(1000);
driver_rec driver%ROWTYPE;
found boolean default false;
pid_not_found exception;
n positive;
fib integer;
code varchar2(1000) := '-1';
stat varchar2(15) := status;
subject varchar2(1000);
begin

  open driver;
  fetch driver into driver_rec;
  found := driver%FOUND;
  close driver;
  signature := replace(common.hh_mail_signature$,'<cr>',common.eol$);
  if(found = true) then
      email := common.ht_manager$;
      recipient := common.get_user_email (common.DECRYPT(crypt_pid));
	  if (stat = 'ccpay') then
	       msg := msg|| message|| signature;
	       subject := cc_payment_subject$;
	  elsif(stat = 'processing') then
	      msg := replace(payment_recorded_text$,'<lname>',driver_rec.fname || ' ' || driver_rec.lname);
	      msg := msg|| message|| signature;
	      subject := payment_recorded_subject$;
	  elsif(stat = 'processed') then
	      msg :=  replace(processed_payment_text$,'<lname>',driver_rec.fname || ' ' || driver_rec.lname);
	      n := round(dbms_random.value(1,20));
	      fib := generate_fib(n);
	      if(n<10) then
		  code := fib ||'0'||n;
	      else
		  code := fib ||'+'||n;
	      end if;
	      voucherqs := 'crypt_pid=' || crypt_pid|| '&sqid=' || sqid || '&code=' || code;
	      update  registrants_choices set voucher_qs = voucherqs
	      where seq_id=sqid and deleted='N' and status=stat and confirmed='Y'
		    and date_record = (select max(date_record)
								 	from registrants_choices
								 	where seq_id=sqid and deleted='N' and status=stat and confirmed='Y');


      -- ******************************************************************************

	      voucher_link := common.sserver || common.vdir$ || 'hotel_handling_maint.createVoucher?' || voucherqs;
	      msg := replace(msg,'<link>',voucher_link);
	      msg := msg|| message|| signature;
	      subject := processed_payment_subject$;
	  elsif(stat = 'reversed') then
	       msg := replace(reversed_payment_text$,'<lname>',driver_rec.fname || ' ' || driver_rec.lname);
	       msg := msg|| message|| signature;
	      subject := reversed_payment_subject$;
	  elsif(stat = 'failed') then
	       msg := replace(failed_payment_text$,'<lname>',driver_rec.fname || ' ' || driver_rec.lname);
	       msg := msg|| message|| signature;
	       subject := failed_payment_subject$;
	  end if;
	  send_mail(recipient, subject, msg, email, email, null,common.DECRYPT(crypt_pid));
	  stat := null;
  else
      raise pid_not_found;
  end if;
  exception
     when pid_not_found then
	htp.header (3,rec_not_found$);
	htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
    when NO_DATA_FOUND then
	htp.header(3,rec_not_found$);
	htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
    when others then
	htp.header(3,'An error occured sending an e-mail');
	htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));

end send_payment_recorded_mail;

-- *******************************************************************************************
-- *******************************************************************************************

procedure createVoucher(crypt_pid varchar2 default null,  sqid number, code varchar2) is

	cursor driver is
		select * from registrants_choices
		where date_record =
			(select max(date_record)
			 from registrants_choices
			 where seq_id = sqid and
			 confirmed = 'Y'
			 and registrant_id = common.DECRYPT(crypt_pid));

	cursor driver2(hid number) is
		select * from hotels
		where hotel_id = hid;

	cursor driver3(cfg varchar2) is
		select * from room_types
		where lower(room_name) = lower(cfg);

	cursor driver4 is
		select * from persons
		where person_id = common.DECRYPT(crypt_pid);

	cursor driver5(hid integer,rt integer) is
		select * from hotel_roomtype_fee
		where hotel_id = hid
		and roomtype_id = rt;

	driver_rec  driver%ROWTYPE;
	driver_rec2 driver2%ROWTYPE;
	driver_rec3 driver3%ROWTYPE;
	driver_rec4 driver4%ROWTYPE;
	driver_rec5 driver5%ROWTYPE;

	string_voucher 		varchar2(32000);
	string_body   varchar2(10000);
	n integer := 0;
	fn integer := 0;
	diff number := 0;
	fee number := 0;
begin

    n := substr(code,-2,2);
    fn := substr(code,0,length(code)-2);
    if(substr(n,1,1) = 0) then
	n := substr(n,-1,1);
    end if;
    if(n != 0 and fn !=0)then
     	if(isFib(n,fn)) then
     		open driver4;
	 		fetch driver4 into driver_rec4;
      		close driver4;
      		if common.CSS_URL$ is not null then
	 			htp.p ('<link rel=stylesheet type="text/css" href="' || common.CSS_URL$ || '">');
      		else
	 			htp.p ('<link rel=stylesheet type="text/css" href="' || common.sserver || common.vdir$ || 'common.css">');
      		end if;
		    open driver;
			fetch driver into driver_rec;
		    close driver;
			if(driver_rec.status != 'reversed' and driver_rec.status != 'failed' and driver_rec.status != 'processing') then
				htp.tableopen;
				htp.tablerowopen;
				htp.tabledata(htf.img(common.logo_url$,cattributes=>'border="0"'),ccolspan=>'3');
				htp.tablerowclose;
				htp.tablerowopen;
				htp.tabledata(common.string_header$,'LEFT',ccolspan=>'3');
				htp.tablerowclose;
				htp.tablerowopen;
				htp.tabledata(common.space$,'LEFT',ccolspan=>'3');
				htp.tablerowclose;
				htp.tablerowopen;
				htp.tabledata(driver_rec4.title || common.space$ || driver_rec4.lname || common.space$ || driver_rec4.fname,
							  'RIGHT',ccolspan=>'3' );
				htp.tablerowclose;
				htp.tablerowopen;
				htp.tabledata(common.space$,'LEFT',ccolspan=>'3');
				htp.tablerowclose;
				htp.tablerowopen;
				htp.tabledata('We have booked the following room(s)','LEFT',ccolspan=>'3');
				htp.tablerowclose;
				htp.tablerowopen;
				htp.tabledata(common.space$,'LEFT',ccolspan=>'3');
				htp.tablerowclose;
				htp.tablerowopen;
				htp.p('<td align="center" colspan="3">');
					htp.tableopen('border');
					htp.tablerowopen;
					htp.tableheader('Nr.');
					htp.tableheader('Room');
					htp.tableheader('From');
					htp.tableheader('To');
					htp.tableheader('Nr.of nights');
					htp.tableheader('Price of the room per night');
					htp.tableheader('Deposit for booking confirmation');
					htp.tablerowclose;
					htp.tablerowopen;
					htp.tabledata('<br>1<br><br>','CENTER');
					open driver3(driver_rec.config);
					fetch driver3 into driver_rec3;
					close driver3;
					open driver5(driver_rec.hotel_id,driver_rec3.room_type_id);
					fetch driver5 into driver_rec5;
					close driver5;
					diff := driver_rec.end_date - driver_rec.start_date ;
					htp.tabledata('<br>' ||  driver_rec3.description ||'<br>' ||  '<br>'   ,'CENTER');
					htp.tabledata('<br>' ||  to_char(driver_rec.start_date,'dd-mm-yyyy')||'<br>' ||  '<br>','CENTER');
					htp.tabledata('<br>' ||  to_char(driver_rec.end_date,'dd-mm-yyyy')||'<br>' ||  '<br>','CENTER');
					htp.tabledata('<br>' ||  diff ||'<br>' ||  '<br>','CENTER');
					htp.tabledata('<br>' ||  driver_rec5.fee||'<br>' ||  '<br>','CENTER');
					htp.tabledata('<br>' ||  driver_rec.deposit||'<br>' ||	'<br>','CENTER');
					htp.tablerowclose;
					htp.tablerowopen;
					open driver2(driver_rec.hotel_id);
					fetch driver2 into driver_rec2;
					close driver2;
					htp.tabledata('<br>At '|| driver_rec2.corporate_name  || common.space$ ||
								  driver_rec2.address || common.space$ || driver_rec2.address_number || common.space$ || driver_rec2.town ||
								  '<br>Telephone: ' || driver_rec2.phone_number
						      ,'LEFT',ccolspan=>'7');
					htp.tablerowclose;
					htp.tableclose;
				htp.p('</td>');
				htp.tablerowclose;
				htp.tablerowopen;
				htp.tabledata(common.space$,'LEFT',ccolspan=>'3');
				htp.tablerowclose;
				htp.tablerowopen;
				htp.tabledata(common.string_instruction$,'CENTER',ccolspan=>'3');
				htp.tablerowclose;
				htp.tablerowopen;
				htp.tabledata(common.space$,'LEFT',ccolspan=>'3');
				htp.tablerowclose;
				htp.tablerowopen;
				htp.tabledata(common.string_contacts$,'LEFT',ccolspan=>'3');
				htp.tablerowclose;
				htp.tablerowopen;
				htp.tabledata(common.space$,'LEFT',ccolspan=>'3');
				htp.tablerowclose;
				htp.tablerowopen;
				htp.tabledata(common.space$);
				htp.tabledata(common.space$);
				htp.tabledata(common.string_footer$,'CENTER');
				htp.tablerowclose;
				htp.tableclose;
			else
			     string_body := '<h3>This voucher is no longer available</h3><br/><br/>';
			     string_voucher := common.string_header$ || string_body;
			end if;
		else
		   htp.header (3, not_authorized$);
		end if;
	else
	   htp.header (3, not_authorized$);
	end if;


end createVoucher;

-- *******************************************************************************************
-- *******************************************************************************************

function hasDepositAssociated(rid number default -1) return boolean is

cursor driver is
select deposit_id from room_deposit
where room_type_id = rid;

found boolean default false;
driver_rec driver%ROWTYPE;

begin
  open driver;
  fetch driver into driver_rec;
  found := driver%FOUND;
  close driver;

  return found;
end hasDepositAssociated;

-- *******************************************************************************************
-- *******************************************************************************************

 procedure list_available_categories is

  cursor driver is
  select * from hotel_categories
  order by hotel_cat_name asc;


  driver_rec	driver%ROWTYPE;

  begin
  common.get_gbl_pid;
      if common.has_privs_to_page then
   maint.header('Available Hotels');
	regist_maint.jsFunctions;
	htp.tableOpen();
	htp.tableRowOpen();
	htp.p('<td width=25%>');
	maint.menu(0);
	htp.p('</td>');
	htp.p('<td>');
	htp.tableOpen(cattributes=>'border = 1px');
	htp.tableRowOpen();
	htp.tableHeader(common.space$);
	htp.tableHeader('Category');
	htp.tableHeader('Description');
	htp.tableHeader(common.space$);
	htp.tableRowClose();
	for driver_rec in driver loop
	  htp.tableRowOpen();
	  htp.tableData(htf.anchor ('hotel_handling_maint.create_cat_entry?cid=' || driver_rec.hotel_cat_id, htf.IMG(common.editImg$,cattributes=>'border=0 alt=Edit title=Edit')));
	  htp.tableData(driver_rec.hotel_cat_name);
	  htp.tableData(driver_rec.description);
	  htp.tableData(htf.anchor ('hotel_handling_maint.delete_category?cid='|| driver_rec.hotel_cat_id,htf.IMG(common.deleteImg$,cattributes=>'border=0 alt="Delete category" title="Delete category"')),cattributes=>'onclick=''return deleteConfirm()''');
	  htp.tableRowClose();
	end loop;
	htp.tableRowOpen();
	htp.tableData(htf.anchor ('hotel_handling_maint.create_cat_entry',htf.IMG(common.newImg$,cattributes=>'border=0 alt="New category" title="New category"')),cattributes=>'colspan="3"');
	htp.tableRowClose();
	htp.tableClose();
	htp.p('</td>');
	htp.tableRowClose();
	htp.tableClose();
    end if;
  end list_available_categories;

-- *******************************************************************************************
-- *******************************************************************************************

procedure create_cat_entry(cid number default -1) is

cursor driver is
select * from hotel_categories
where hotel_cat_id = cid
order by hotel_cat_name;



driver_rec	driver%ROWTYPE;
rec_found	boolean := false;

BEGIN

    if common.header ('Add/Modify Category') then
       if(cid != -1) then
	   open driver;
	   fetch driver into driver_rec;
	   rec_found := driver%FOUND;
	   close driver;
       end if;

       regist_maint.jsFunctions;
       htp.p (common.space2$);
       htp.tableOpen();
       htp.tableRowOpen();
       htp.tableData('&nbsp;', cattributes=>'width="25%"');
       htp.p('<td>');
       if(cid !=-1 ) then
	  htp.formOpen(curl=>'hotel_handling_maint.update_category', cmethod=>'post');
	  htp.formHidden(cname=>'cid', cvalue=>cid);
       else
	  htp.formOpen(curl=>'hotel_handling_maint.insert_category', cmethod=>'post');
       end if;
       htp.tableOpen();
       htp.tableRowopen();
       htp.tableData('Category name');
       htp.tableData(htf.formText(cname=>'catName',csize=>'30',cvalue=>driver_rec.hotel_cat_name));
       htp.tableRowClose();
       htp.tableRowopen();
       htp.tableData('Category symbol');
       htp.tableData(htf.formText(cname=>'catSym',csize=>'10',cvalue=>driver_rec.cat_symbol,cattributes=>'maxlength="10"'));
       htp.tableRowClose();
       htp.tableRowopen();
       htp.tableData('Description');
       htp.p('<td>');
       htp.p('<textarea name="rdescription" rows="10" cols="60">');
       htp.p(driver_rec.description);
       htp.p('</textarea>');
       htp.p('</td>');
       htp.tableRowClose();
       htp.tableRowOpen();
       htp.tableData(htf.formSubmit(cvalue=>'Save'), cattributes=>'colspan="2"');
       htp.tableRowClose();
       htp.tableClose();
       htp.formClose();
       htp.tableData('&nbsp;', cattributes=>'width="25%"');
       htp.tableRowClose();
       htp.tableClose();
    end if;
   END create_cat_entry;

-- *******************************************************************************************
-- *******************************************************************************************

  procedure delete_category(cid number default -1) is

  cid_null exception;
  cid_associated exception;
  begin
    if(cid != -1 and cid is not null) then
      if(hasHotelAssociated(cid) != true) then
	  delete from hotel_categories where hotel_cat_id = cid;
      else
	raise cid_associated;
      end if;
    else
      raise cid_null;
    end if;
    exception
     when cid_null then
	htp.header (3,'No category selected');
	htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
     when cid_associated then
	htp.header (3,'The selected category has been already associated to a hotel. Change this association before deleting the category');
	htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
     when others then
	htp.header (3,error$);
	htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
  end delete_category;

-- *******************************************************************************************
-- *******************************************************************************************

  function hasHotelAssociated(cid number default -1) return boolean is

  cursor driver is
  select hotel_id from hotels
  where hotel_cat_id = cid;

  driver_rec driver%ROWTYPE;
  found boolean default false;
  cid_null exception;
  begin
  if(cid != -1 and cid is not null ) then
      open driver;
      fetch driver into driver_rec;
      found := driver%FOUND;
      close driver;
  else
    raise cid_null;
  end if;
  return found;
  exception
    when cid_null then
	htp.header (3,'No category selected');
	htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
     when others then
	htp.header (3,error$);
	htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
   end hasHotelAssociated;

-- *******************************************************************************************
-- *******************************************************************************************

   procedure insert_category(catName varchar2 default null, rdescription varchar2 default null, catSym varchar2 default null) is

   no_name exception;
   begin
   if(catName is null) then
      raise no_name;
   else
      insert into hotel_categories (hotel_cat_name,description,cat_symbol) values (catName,rdescription,catSym);
      common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.list_available_categories');
   end if;
   exception
     when no_name then
	htp.header (3,'Category name must be set');
	htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
     when others then
	htp.header (3,error$);
	htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
   end insert_category;

-- *******************************************************************************************
-- *******************************************************************************************

   procedure update_category(cid number default -1, catName varchar2 default null, rdescription varchar2 default null, catSym varchar2 default null) is
   no_name exception;
   begin
   if(catName is null) then
      raise no_name;
   else
      update  hotel_categories
      set hotel_cat_name = catName,
	  description = rdescription,
	  cat_symbol = catSym
      where
	  hotel_cat_id = cid;

      common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.list_available_categories');
   end if;
   exception
     when no_name then
	htp.header (3,'Category name must be set');
	htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
     when others then
	htp.header (3,error$);
	htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
   end update_category;


-- *******************************************************************************************
-- *******************************************************************************************

procedure deposit_due(action varchar2 default null, crypt_pid varchar2 default null, cid integer, sqid integer,
			 stPage number default 1,last_name varchar2 default null, cfmed varchar2 default null,
			 ch_order varchar2 default null ,cat_id number default null,hid number default -1) is


   cursor driver is
	   select * from registrants_choices
	   where choice_id = cid;

   pid_null exception;
   cid_null exception;
   driver_rec driver%ROWTYPE;
   found boolean := false;
   dummy1 integer := common.DECRYPT(crypt_pid);
   dummy2 varchar2(100) := action;
   dummy3 integer :=sqid;

begin
	if(crypt_pid is null) then
		raise pid_null;
	elsif (cid is null) then
		raise cid_null;
	else
       	open driver;
	 	fetch driver into driver_rec;
	 	found := driver%FOUND;
      	close driver;
      	if(found = true) then
			insert into registrants_choices (registrant_id,status,start_date,end_date,config,hotel_id,confirmed,deposit,room_id,
							 payment_code,r_locked,choice_order,notes,date_record,seq_id,ipn_status,invoice,receipt,booking_date,payment_date,deleted)
			values (driver_rec.registrant_id,action,driver_rec.start_date,driver_rec.end_date,driver_rec.config,driver_rec.hotel_id,driver_rec.confirmed,
				driver_rec.deposit,driver_rec.room_id,driver_rec.payment_code,driver_rec.r_locked,driver_rec.choice_order,
				driver_rec.notes,systimestamp,driver_rec.seq_id,driver_rec.ipn_status,driver_rec.invoice,driver_rec.receipt,driver_rec.booking_date,driver_rec.payment_date,
				driver_rec.deleted);
			found := false;
			send_payment_recorded_mail(dummy1 ,dummy2, dummy3);
			common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.show_all_registrants_bookings?action=' ||
						     '&stPage=' || stPage || '&cid='|| cid || '&crypt_pid='|| crypt_pid || '&last_name=' || last_name ||
						     '&cfmed=' || cfmed || '&ch_order=' || ch_order || '&cat_id=' || cat_id || '&hid=' || hid ||
						     '&sqid=' || sqid);
      	end if;
    end if;
exception
	when pid_null then
		htp.header (3,'No person selected');
		htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
	when cid_null then
		htp.header (3,'No choice selected');
		htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
end deposit_due;

-- *******************************************************************************************
-- *******************************************************************************************

procedure show_hotel_notches(hid integer default -1) is

    cursor driver is
    select max(end_date) from
    rooms_hotel
    where hotel_id = hid;

    cursor driver2 is
    select min(start_date) from
    rooms_hotel
    where hotel_id = hid;

    cursor driver3(hotid integer) is
		Select r.*, persons.lname, persons.fname, rooms_hotel.start_date as r_start_date, rooms_hotel.END_DATE as r_end_date
		from persons ,
			(select distinct rs.choice_id, rs.registrant_id, rs.SEQ_ID , rs.config , rs.room_id, rs.start_date, rs.end_date, rs.hotel_id, rs.confirmed
			from (
					(Select  rc.*
					from registrants_choices rc
					where rc.confirmed='Y' and rc.deleted='N'
					and rc.date_record in (select max(rrc.date_record) from registrants_choices rrc where rrc.seq_id= rc.seq_id and rrc.choice_order=rc.choice_order and rrc.DELETED='N'))
				UNION
					(Select  rc.*
					from registrants_choices rc
					where rc.choice_order='fc' and rc.deleted='N'
					and rc.seq_id not in
					(select rcc.seq_id from registrants_choices rcc
					where rcc.seq_id= rc.seq_id and rcc.choice_order<>'fc' and  rcc.confirmed='Y' and rcc.deleted='N'
					and rcc.date_record in (select max(rccc.date_record) from registrants_choices rccc where rccc.seq_id= rcc.seq_id and rccc.choice_order=rcc.choice_order and rccc.DELETED='N'))
					and rc.date_record in (select max(rrcc.date_record) from registrants_choices rrcc where rrcc.seq_id= rc.seq_id and rrcc.choice_order=rc.choice_order and rrcc.DELETED='N')))
			 	rs ) r,
			 	rooms_hotel
		where persons.person_id=r.registrant_id and r.room_id=rooms_hotel.room_id and r.hotel_id=hotid
		order by rooms_hotel.config,r.room_id, persons.lname, persons.fname ;

   	cursor driver4 is
   	select corporate_name from hotels
   	where hotel_id = hid;

    min_date date := null;
    max_date date := null;
    hotel_name varchar2(1000) := null;
    diff integer := 0;
    curr_conf varchar2(10) := 'pip';
    dummy_date date := null;
    hid_null exception;

    num_months integer;
    num_columns integer;
    i integer;

    begin

    if(hid = -1 or hid is null) then
      raise hid_null;
    else
	    open driver;
	    fetch driver into max_date;
	    close driver;

	    open driver2;
	    fetch driver2 into min_date;
	    close driver2;

	    open driver4;
	    fetch driver4 into hotel_name;
	    close driver4;

	    common.get_gbl_pid;
	 	if common.has_privs_to_page then
		    maint.header('Hotel Notches');
		    regist_maint.jsFunctions;
		    htp.tableOpen();
		    htp.tableRowOpen();
		    htp.p('<td width=25%>');
		    maint.menu(0);
		    htp.p('</td>');
		    htp.p('<td>');
		    diff := max_date - min_date;
		    htp.tableOpen('BORDER');
		    htp.tableRowOpen();
		    htp.tableHeader(hotel_name,cattributes=>'colspan="' || to_char(diff+2) || '"');
		    htp.tableRowClose();
		    htp.tableRowOpen();
		    htp.tableHeader(common.space$);
		    dummy_date := last_day(min_date);
		    num_months:=trunc(months_between(max_date,min_date));
		    num_columns:=last_day(min_date)-min_date+1;
		    htp.tableHeader(to_char(dummy_date,'MONTH/yyyy'),cattributes=>'colspan="' || to_char(num_columns) || '"');
		    if (num_months>0) then
				for i in 1..num_months-1 loop
					dummy_date :=add_months(dummy_date,1);
					htp.p(dummy_date || '<br>');
					num_columns:= extract(DAY from dummy_date);
					htp.tableHeader(to_char(dummy_date,'MONTH/yyyy'),cattributes=>'colspan="' || to_char(num_columns) || '"');
				end loop;
				num_columns:=extract(DAY from max_date);
				htp.tableHeader(to_char(max_date,'MONTH/yyyy'),cattributes=>'colspan="' || to_char(num_columns) || '"');
			end if;
		    htp.tableRowClose();
		    htp.tableRowOpen();
		    htp.tableHeader('Person/day');
		    for i in 0..diff loop
				htp.tableHeader(to_char(min_date + i,'dd'));
		    end loop;
		    htp.tableRowClose();

	      	for driver_rec in driver3(hid) loop
				exit when driver3%NOTFOUND;
			    if(curr_conf != driver_rec.config) then
					curr_conf := driver_rec.config;
					htp.tableRowOpen();
					htp.tableHeader(curr_conf,cattributes=>'colspan="' || to_char(diff+2) || '"');
					htp.tableRowClose();
			    end if;
			    htp.tableRowOpen();
			    if driver_rec.confirmed='Y' then
			    	htp.tableData(driver_rec.room_id || ' - ' || driver_rec.lname || '&nbsp;' || driver_rec.fname );
			    else
			    	htp.tableData('<I>' || driver_rec.room_id || ' - ' || driver_rec.lname || '&nbsp;' || driver_rec.fname	|| '</I>');
			    end if;
			    for i in 0..diff loop
				  	if((min_date+i)>=driver_rec.start_date and (min_date+i)<driver_rec.end_date) then
				      	htp.tableData('X',cattributes=>'align="center" bgcolor="#ffff66"');
				  	elsif ((min_date+i)>=driver_rec.r_start_date and (min_date+i)<driver_rec.r_end_date) then
				  		htp.tableData('&nbsp',cattributes=>'align="center" bgcolor="#00ff66"');
				  	else
				      	htp.tableData('-',cattributes=>'align="center"');
				  	end if;
			    end loop;
			    htp.tableRowClose();
		    end loop;
		    htp.tableClose();
			htp.p('<br>');
			htp.tableOpen();
			htp.tableRowOpen();
			htp.tabledata('<b>Legend:</b>');
			htp.tabledata('&nbsp');
			htp.tableData(htf.tableopen('border="1px"')||htf.tablerowopen()||
							htf.tabledata('Italic text',cattributes=>'align="center"')||
						  	htf.tabledata('First choice not confirmed')|| '</tr></table>');
			htp.tabledata('&nbsp');
			htp.tableData(htf.tableopen('border="1px"')||htf.tablerowopen()||
							htf.tabledata('&nbsp',cattributes=>'align="center" bgcolor="#00ff66"')||
						  	htf.tabledata('Free room')|| '</tr></table>');
			htp.tabledata('&nbsp');
			htp.tableData(htf.tableopen('border="1px"')||htf.tablerowopen()||
							htf.tableData('X',cattributes=>'align="center" bgcolor="#ffff66"')||
						  	htf.tabledata('Booked room')|| '</tr></table>');
			htp.tabledata('&nbsp');
			htp.tableData(htf.tableopen('border="1px"')||htf.tablerowopen()||
							htf.tableData('-',cattributes=>'align="center"')||
						  	htf.tabledata('Room not available')|| '</tr></table>');
			htp.TableRowClose();
			htp.tableClose();
		    htp.tableRowClose();
		    htp.p('</td>');
		    htp.tableClose();
			common.footer;
		 end if;
	end if;
 exception
    when hid_null then
	htp.header (3,'No Hotel selected');
	htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));
    when others then
	htp.header (3,error$);
	htp.p(htf.anchor ('#',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"'),cattributes=>'onclick="history.back(-1);return false;"'));

end show_hotel_notches;

-- *******************************************************************************************
-- *******************************************************************************************

procedure add_hotel_delegates_notes(cid number, action varchar2, del_notes varchar2 default null) is

cursor driver is
select notes from registrants_choices
where choice_id = cid;

dummy varchar2(4000);
begin
 common.get_gbl_pid;
 if common.has_privs_to_page then
	if common.CSS_URL$ is not null then
	    htp.p ('<link rel=stylesheet type="text/css" href="' || common.CSS_URL$ || '">');
	else
	    htp.p ('<link rel=stylesheet type="text/css" href="' || common.sserver || common.vdir$ || 'common.css">');
	end if;
	htp.tableOpen();
	htp.tableRowOpen();
	htp.p('<td width=25%>');
	htp.p(common.space$);
	htp.p('</td>');
	htp.p('<td>');
	if (action = 'add') then
	    htp.formOpen(curl=>'hotel_handling_maint.add_hotel_delegates_notes', cmethod=>'post');
	    htp.formHidden(cname=>'cid', cvalue=>cid);
	    htp.formHidden(cname=>'action',cvalue=>'save');
	    htp.tableOpen();
	    htp.tableRowOpen();
	    htp.tableData('Notes:',cattributes=>'class=boldtext');
	    htp.p('<td>');
		htp.p('<textarea name="del_notes" cols="60" rows="10">');
		htp.p(del_notes);
		htp.p('</textarea>');
	    htp.p('</td>');
	    htp.tableRowClose();
	    htp.tableRowOpen();
	    htp.p('<td colspan="2" align="center">');
	      htp.formSubmit(cvalue=>'Save', cattributes=>'colspan="2"');
	      htp.p(common.space$);
	      htp.formReset(cvalue=>'Reset');
	    htp.p('<td>');
	    htp.tableRowClose();
	    htp.tableClose();
	    htp.formClose();
	elsif(action = 'show') then
	    open driver;
	      fetch driver into dummy;
	    close driver;
	    htp.formOpen(curl=>'hotel_handling_maint.add_hotel_delegates_notes', cmethod=>'post');
	    htp.formHidden(cname=>'cid', cvalue=>cid);
	    htp.formHidden(cname=>'action',cvalue=>'save');
	    htp.tableOpen();
	    htp.tableRowOpen();
	    htp.tableData('Notes:',cattributes=>'class=boldtext');
	    htp.p('<td>');
		htp.p('<textarea name="del_notes" cols="60" rows="10">');
		htp.p(dummy);
		htp.p('</textarea>');
	    htp.p('</td>');
	    htp.tableRowClose();
	    htp.tableRowOpen();
	    htp.p('<td colspan="2" align="center">');
	      htp.formSubmit(cvalue=>'Save', cattributes=>'colspan="2"');
	      htp.p(common.space$);
	      htp.formReset(cvalue=>'Reset');
	    htp.p('<td>');
	    htp.tableRowClose();
	    htp.tableClose();
	    htp.formClose();
	elsif(action = 'save') then
	    update registrants_choices set notes = del_notes, date_record= systimestamp where choice_id = cid;
	    htp.formOpen(curl=>'hotel_handling_maint.add_hotel_delegates_notes', cmethod=>'post');
	    htp.formHidden(cname=>'cid', cvalue=>cid);
	    htp.formHidden(cname=>'action',cvalue=>'save');
	    htp.tableOpen();
	    htp.tableRowOpen();
	    htp.tableData('Notes:',cattributes=>'class=boldtext');
	    htp.p('<td>');
		htp.p('<textarea name="del_notes" cols="60" rows="10">');
		htp.p(del_notes);
		htp.p('</textarea>');
	    htp.p('</td>');
	    htp.tableRowClose();
	    htp.tableRowOpen();
	    htp.p('<td colspan="2" align="center">');
	      htp.formSubmit(cvalue=>'Save');
	      htp.p(common.space$);
	      htp.formReset(cvalue=>'Reset');
	    htp.p('</td>');
	    htp.tableRowClose();
	    htp.tableClose();
	    htp.formClose();
	end if;
	htp.p('</td>');
	htp.tableRowClose();
	htp.tableClose();
	htp.para;
	common.footer;
      else
	htp.header (3,not_authorized$);
      end if;
end add_hotel_delegates_notes;

-- *******************************************************************************************
-- *******************************************************************************************

function generate_fib (n positive) return  integer is
   pos1 integer := 1;
   pos2 integer := 0;
   accumulator	integer;
begin
   if (n = 1) or (n = 2) then
      return 1;
   else
      accumulator := pos1 + pos2;
      for i in 3..n loop
	 pos2 := pos1;
	 pos1 := accumulator;
	 accumulator := pos1 + pos2;
      end loop;
      return accumulator;
   end if;
end generate_fib;

-- *******************************************************************************************
-- *******************************************************************************************

function isFib (n positive, fn integer) return boolean is

isOk boolean :=false;
fidia number := (1+sqrt(5))/2;
dummy number := 0;
dummy2 number := 0;

begin
    dummy := round((power(fidia,n) -power((-fidia),(-1*n)))/(sqrt(5)));
    dummy2 := generate_fib(n);
    if(dummy != dummy2) then
	dummy := dummy2;
    end if;
    if(fn = dummy) then
	isOk := true;
    else
	isOk := false;
    end if;
    return isOk;
end isFib;

-- *******************************************************************************************
-- *******************************************************************************************

procedure cancel_hotel_entry(stPage number default 0,action varchar2 default null, cid number default -1,
					  crypt_pid varchar2, last_name varchar2 default null, cfmed varchar2 default null,
					  ch_order varchar2 default null, cat_id number default null, hid number default -1, sqid number default -1) is
begin

update registrants_choices set deleted = 'Y' where choice_id = cid;
update registrants_choices set deleted = 'Y' where seq_id =sqid and choice_order=ch_order ;

common.redirect_URL (common.sserver || common.vdir$ || 'hotel_handling_maint.show_all_registrants_bookings?action='|| action ||'&sqid='|| sqid ||'&cfmed='|| cfmed ||'&hid='|| hid ||
		     '&last_name='|| last_name ||'&ch_order='|| ch_order ||'&cid='|| cid ||'&stPage='|| stPage ||'&crypt_pid='|| crypt_pid ||'');
end cancel_hotel_entry;

-- *******************************************************************************************
-- *******************************************************************************************

procedure show_payment_date(stPage number default 0,action varchar2 default null, cid number default -1,
					  crypt_pid varchar2 default null, last_name varchar2 default null, cfmed varchar2 default null,
					  ch_order varchar2 default null, cat_id number default null, hid number default -1, sqid number default -1, payDate date default null) is

cursor driver is
select payment_date from registrants_choices
where choice_id = cid;

dummy date;
location varchar2(4000);
begin
 common.get_gbl_pid;
      if common.has_privs_to_page then
	if common.CSS_URL$ is not null then
	    htp.p ('<link rel=stylesheet type="text/css" href="' || common.CSS_URL$ || '">');
	else
	    htp.p ('<link rel=stylesheet type="text/css" href="' || common.sserver || common.vdir$ || 'common.css">');
	end if;
	location := common.sserver || common.vdir$ || 'hotel_handling_maint.show_all_registrants_bookings?action='|| action ||
		 '&sqid='|| sqid ||'&cfmed='|| cfmed ||'&hid='|| hid ||
		     '&last_name='|| last_name ||'&ch_order='|| ch_order ||'&cid='|| cid ||'&stPage='|| stPage ||'&crypt_pid='|| crypt_pid;
	htp.tableOpen();
	htp.tableRowOpen();
	htp.p('<td width=25%>');
	htp.p(common.space$);
	htp.p('</td>');
	htp.p('<td>');
	if (action = 'add') then
	    htp.formOpen(curl=>'hotel_handling_maint.show_payment_date', cmethod=>'post');
	    htp.formHidden(cname=>'cid', cvalue=>cid);
	    htp.formHidden(cname=>'action',cvalue=>'save');
	    htp.tableOpen();
	    htp.tableRowOpen();
	    htp.tableData('Payment Date (dd-MON-yyyy):', cattributes=>'class=boldtext align="right"');
	    htp.p('<td align="left">');
	    htp.formText(cname=>'payDate');
	    htp.p('</td>');
	    htp.tableRowClose();
	    htp.tableRowOpen();
	    htp.p('<td colspan="2" align="center">');
	      htp.formSubmit(cvalue=>'Save', cattributes=>'colspan="2" onClick="window.close();"');
	      htp.p(common.space$);
	      htp.formReset(cvalue=>'Reset');

	    htp.tableRowClose();
	    htp.tableClose();
	    htp.formClose();
	 elsif(action = 'show') then
	    open driver;
	      fetch driver into dummy;
	    close driver;
	    htp.formOpen(curl=>'hotel_handling_maint.show_payment_date', cmethod=>'post');
	    htp.formHidden(cname=>'cid', cvalue=>cid);
	    htp.formHidden(cname=>'action',cvalue=>'save');
	    htp.tableOpen();
	    htp.tableRowOpen();
	    htp.tableData('Payment Date (dd-MON-yyyy):',cattributes=>'class=boldtext align="right"');
	    htp.p('<td align="left">');
	    htp.formText(cname=>'payDate',cvalue=>dummy);
	    htp.p('</td>');
	    htp.tableRowClose();
	    htp.tableRowOpen();
	    htp.p('<td colspan="2" align="center">');
	    htp.formSubmit(cvalue=>'Save', cattributes=>'colspan="2" onClick="window.close();"');
	    htp.p(common.space$);
	    htp.formReset(cvalue=>'Reset');
	    htp.p('<td>');
	    htp.tableRowClose();
	    htp.tableClose();
	    htp.formClose();
	elsif(action = 'save') then
	    update registrants_choices set payment_date = payDate, date_record= systimestamp where choice_id = cid;
	end if;
	htp.p('</td>');
	htp.tableRowClose();
	htp.tableClose();
	htp.para;
	common.footer;
      else
	htp.header (3,not_authorized$);
      end if;
end show_payment_date;

-- *******************************************************************************************
-- *******************************************************************************************

procedure show_ipn_values(stPage number default 0,action varchar2 default null, cid number default -1,
					  crypt_pid varchar2 default null, last_name varchar2 default null, cfmed varchar2 default null,
					  ch_order varchar2 default null, cat_id number default null, hid number default -1, sqid number default -1, payDate date default null) is
cursor driver is
select * from registrants_choices
where seq_id = sqid
and choice_id = cid;

driver_rec driver%ROWTYPE;
begin
common.get_gbl_pid;
      if common.has_privs_to_page then
	if common.CSS_URL$ is not null then
	    htp.p ('<link rel=stylesheet type="text/css" href="' || common.CSS_URL$ || '">');
	else
	    htp.p ('<link rel=stylesheet type="text/css" href="' || common.sserver || common.vdir$ || 'common.css">');
	end if;

	open driver;
	    fetch driver into driver_rec;
	close driver;
	htp.tableOpen();
	htp.tableRowOpen();
	htp.p('<td width=25%>');
	htp.p(common.space$);
	htp.p('</td>');
	htp.p('<td>');
	htp.tableOpen();
	htp.tableRowOpen();
	    htp.tableData('Order nr.:',cattributes=>'class="boldtext"');
	    htp.tableData(driver_rec.invoice);
	htp.tableRowClose();
	htp.tableRowOpen();
	    htp.tableData('Receipt:',cattributes=>'class="boldtext"');
	    htp.tableData(driver_rec.receipt);
	htp.tableRowClose();
	htp.tableRowOpen();
	    htp.tableData('Status:',cattributes=>'class="boldtext"');
	    htp.tableData(driver_rec.ipn_status);
	htp.tableRowClose();
	htp.tableRowOpen();
	    htp.tableData('Amount:',cattributes=>'class="boldtext"');
	    htp.tableData(driver_rec.deposit);
	htp.tableRowClose();
	htp.tableClose();
	htp.p('</td>');
	htp.tableRowClose();
	htp.tableRowOpen();
	    htp.tableData(htf.anchor ('#', 'close window',cattributes=>'onClick="window.close();"'),cattributes=>'colspan="2" align="middle"');
	htp.tableRowClose();
	htp.tableClose();
	htp.para;
	common.footer;
      else
	htp.header (3,not_authorized$);
      end if;
end show_ipn_values;

-- *******************************************************************************************
-- *******************************************************************************************

procedure room_export_filter is

	cursor hotel is
		Select *
		from hotels
		order by corporate_name;

begin
	common.get_gbl_pid;
    if common.has_privs_to_page then
	    maint.header ('Room Data Export');

		htp.p('<script type="text/javascript" language="javascript">
		       <!--
				function disable_free_filter()
				{
					document.type.confirmed[0].disabled=true;
					document.type.confirmed[1].disabled=true;
					document.type.confirmed[2].disabled=true;
					document.type.processed[0].disabled=true;
					document.type.processed[1].disabled=true;
					document.type.processed[2].disabled=true;
					document.type.reversed[0].disabled=true;
					document.type.reversed[1].disabled=true;
					document.type.reversed[2].disabled=true;
					document.type.choice_order[1].disabled=true;
					document.type.choice_order[2].disabled=true;
					document.type.choice_order[3].disabled=true;
					document.type.preselection[0].disabled=false;
					document.type.preselection[1].disabled=false;
					document.type.preselection[0].checked=true;
					document.type.hid.disabled=false;
					document.type.deleted.disabled=true;
				    return true;
				}

				function enable_free_filter()
				{
					document.type.confirmed[0].disabled=false;
					document.type.confirmed[1].disabled=false;
					document.type.confirmed[2].disabled=false;
					document.type.processed[0].disabled=false;
					document.type.processed[1].disabled=false;
					document.type.processed[2].disabled=false;
					document.type.reversed[0].disabled=false;
					document.type.reversed[1].disabled=false;
					document.type.reversed[2].disabled=false;
					document.type.choice_order[1].disabled=false;
					document.type.choice_order[2].disabled=false;
					document.type.choice_order[3].disabled=false;
					document.type.preselection[0].disabled=true;
					document.type.preselection[1].disabled=true;
					document.type.hid.disabled=true;
					document.type.deleted.disabled=true;
					return true;
				}

				//--></script>');

	    htp.tableOpen();
		htp.tableRowOpen();
		htp.p('<td width=25%>');
		maint.menu(0);
		htp.p('</td>');
		htp.p('<td>');
		htp.formOpen('hotel_handling_maint.room_export','post',cattributes=>'name="type"');
		htp.tableOpen;
		htp.tablerowopen;
-- begin Pre selection input form
		htp.p('<td>');
		htp.tableopen(cattributes=>'border="1px"');
		htp.tablerowopen;
		htp.p('<td colspan="7" bgcolor=#eeeeee>');
		htp.p('<h3>');
		htp.formradio('filter_type','pre_selection','CHECKED','onclick="disable_free_filter()" onfocus="disable_free_filter()"');
		htp.p('<b>Pre Selection</b>');
		htp.p('</h3></td>');
		htp.tablerowclose;
		htp.tablerowopen;
		htp.p('<td>');
		htp.tableopen;
		htp.tablerowopen;
		htp.p('<td>');
		htp.formradio('preselection','RL','CHECKED','onclick="document.type.hid.disabled=false;document.type.deleted.disabled=true;return true;" onfocus="document.type.hid.disabled=false;document.type.deleted.disabled=true;return true;"');
		htp.p('</td>');
		htp.tableData('<b>Rooming List</b> (confirmed choices or first choice if there are no confirmed choice)','Left',ccolspan=>'6');
		htp.tablerowclose;
		htp.tablerowopen;
		htp.tabledata('&nbsp');
		htp.p('<td>');
		HTP.FORMSELECTOPEN('hid','Hotel Filter ');
		HTP.FORMSELECTOPTION('All','SELECTED','value=-1');
		for h in hotel loop
			HTP.FORMSELECTOPTION(h.corporate_name,null,'value='|| h.hotel_id );
		end loop;
		HTP.FORMSELECTCLOSE;
		htp.p('</td>');
		htp.tablerowclose;
		htp.tablerowopen;
		htp.p('<td>');
		htp.formradio('preselection','FC',null,'onclick="document.type.hid.disabled=true;document.type.deleted.disabled=false;return true;"');
		htp.p('</td>');
		htp.tableData('<b>Financial Check</b> (all processed or reversed record)','Left',ccolspan=>'6');
		htp.tablerowclose;
		htp.tablerowopen;
		htp.tabledata('&nbsp');
		htp.p('<td>');
		htp.formcheckbox('deleted','true');
		htp.p(' Consider deleted reversed records');
		htp.p('</td>');
		htp.tablerowclose;
		htp.tableclose;
		htp.p('</td>');
		htp.tablerowclose;
		htp.tableclose;
		htp.p('</td>');
-- end Pre selection input form
		htp.tablerowclose;
		htp.tablerowopen;
	htp.tabledata('&nbsp');
	htp.tablerowclose();
-- Begin Free filtering input form
		htp.tablerowopen();
		htp.p('<td>');
		htp.tableopen(cattributes=>'border="1px"');
		htp.tablerowopen;
		htp.p('<td colspan="7" bgcolor=#eeeeee>');
		htp.p('<h3>');
		htp.formradio('filter_type','free_filter',null,'onclick="enable_free_filter()"');
		htp.p('<b>Filter choices</b>');
		htp.p('</h3></td>');
		htp.tablerowclose;
		htp.tableRowOpen();
		htp.p('<td>');
		htp.tableopen;
		htp.tabledata('Confirmed');
		htp.p('<td>');
		htp.formradio('confirmed','Y');
		htp.p('</td>');
		htp.tabledata('Yes');
		htp.p('<td>');
		htp.formradio('confirmed','N');
		htp.p('</td>');
		htp.tabledata('No');
		htp.p('<td>');
		htp.formradio('confirmed','B','CHECKED');
		htp.p('</td>');
		htp.tabledata('Both');
		htp.tablerowclose();
		htp.tableRowOpen();
		htp.tabledata('Processed');
		htp.p('<td>');
		htp.formradio('processed','Y');
		htp.p('</td>');
		htp.tabledata('Yes');
		htp.p('<td>');
		htp.formradio('processed','N');
		htp.p('</td>');
		htp.tabledata('No');
		htp.p('<td>');
		htp.formradio('processed','B','CHECKED');
		htp.p('</td>');
		htp.tabledata('Both');
		htp.tablerowclose();
		htp.tableRowOpen();
		htp.tabledata('Reversed');
		htp.p('<td>');
		htp.formradio('reversed','Y');
		htp.p('</td>');
		htp.tabledata('Yes');
		htp.p('<td>');
		htp.formradio('reversed','N');
		htp.p('</td>');
		htp.tabledata('No');
		htp.p('<td>');
		htp.formradio('reversed','B','CHECKED');
		htp.p('</td>');
		htp.tabledata('Both');
		htp.tablerowclose();
		htp.tableRowOpen();
		htp.tabledata('Choice Order');
		htp.p('<td>');
		htp.formHidden ('choice_order', 'dummy');
		htp.formcheckbox('choice_order','1');
		htp.p('</td>');
		htp.tabledata('First Choice');
		htp.p('<td>');
		htp.formcheckbox('choice_order','2');
		htp.p('</td>');
		htp.tabledata('Second Choice');
		htp.p('<td>');
		htp.formcheckbox('choice_order','3');
		htp.p('</td>');
		htp.tabledata('Third Choice');
		htp.tablerowclose();
		htp.tableclose;
		htp.p('</td>');
		htp.tablerowclose;
		htp.tableclose;
-- end	Free filtering input form
		htp.tablerowclose();
		htp.tablerowopen();
		htp.p('<td colspan="7"');
		htp.p('<br>');
		htp.formsubmit('Export','export');
		htp.p('</td>');
		htp.tablerowclose();
		htp.tableclose();
		htp.formclose;
		htp.p('</td>');
		htp.p('<td width=25%>');
		htp.tabledata('&nbsp');
		htp.p('</td>');
		htp.tablerowclose();
		htp.tableclose();
		htp.p('<script type="text/javascript" language="javascript"> disable_free_filter();</script>');
		common.footer;
	end if;
end room_export_filter;

-- *******************************************************************************************
-- *******************************************************************************************

procedure room_export(filter_type varchar, hid number default -1, deleted boolean default false, confirmed varchar default null, processed varchar  default null, reversed varchar  default null, preselection varchar default null, choice_order common.ident_arr, export varchar ) is

	query varchar(4000);
	query_where varchar(4000);
	dummy varchar(400);
	filename varchar(30);
	type	cursor_type is REF CURSOR;
	driver	cursor_type;
	credit_card	payment_codes.credit_card%TYPE;
	choiceord registrants_choices.choice_order%type;
	confirmation registrants_choices.confirmed%TYPE;
	config registrants_choices.CONFIG%TYPE;
	corporate_name hotels.CORPORATE_NAME%TYPE;
	fname persons.LNAME%TYPE;
	lname persons.FNAME%TYPE;
	start_date registrants_choices.START_DATE%TYPE;
	end_date registrants_choices.END_DATE%TYPE;
	status registrants_choices.STATUS%TYPE;
	notes registrants_choices.NOTES%TYPE;
	booking_date registrants_choices.BOOKING_DATE%TYPE;
	payment_date registrants_choices.PAYMENT_DATE%TYPE;
	payment_code registrants_choices.PAYMENT_CODE%TYPE;
	voucher_qs registrants_choices.VOUCHER_QS%TYPE;
	deposit registrants_choices.DEPOSIT%TYPE;
	choice_id registrants_choices.CHOICE_ID%TYPE;
	seq_id registrants_choices.SEQ_ID%TYPE;
	ipn_status registrants_choices.IPN_STATUS%TYPE;
	hotel hotels.HOTEL_ID%TYPE;

begin

	common.get_gbl_pid;
	if common.has_privs_to_page then

		query := 	'Select * from
					(Select rc.choice_order, rc.confirmed, rc.config,h.corporate_name,
						p.fname, p.lname, rc.start_date, rc.end_date,
						rc.status, rc.notes, rc.booking_date, rc.payment_date, rc.payment_code, rc.voucher_qs,
						rc.deposit, rc.choice_id, rc.SEQ_ID, rc.IPN_STATUS, h.HOTEL_ID
					 from registrants_choices rc
						inner join persons p on rc.registrant_id= p.person_id
						inner join hotels h on rc.hotel_id= h.hotel_id
						inner join hotel_categories hc on hc.hotel_cat_id=h.hotel_cat_id
						inner join room_types rp on rc.config=rp.room_name
						inner join payment_codes pc on rc.payment_code= pc.payment_code
					 where rc.deleted=''N'' and
					       rc.date_record= ( select max(rc1.date_record) from registrants_choices rc1
									  where rc1.seq_id=rc.seq_id and rc1.choice_order=rc.choice_order and rc1.deleted=''N'')
					 ) rc3
				where not exists ( select ''found'' from
									(Select rc.*
										from registrants_choices rc
											inner join persons p on rc.registrant_id= p.person_id
											inner join hotels h on rc.hotel_id= h.hotel_id
											inner join room_types rp on rc.config=rp.room_name
											inner join payment_codes pc on rc.payment_code= pc.payment_code
										where rc.deleted=''N'' and
											rc.date_record= ( select max(rc1.date_record) from registrants_choices rc1
															where rc1.seq_id=rc.seq_id and rc1.choice_order=rc.choice_order and rc1.deleted=''N'')
									 ) rc4
									where rc4.seq_id=rc3.seq_id and rc3.choice_id<>rc4.choice_id and rc4.confirmed=''Y'')';

		query_where:=null;
		if filter_type='free_filter' then
			filename:='export_free_filter';
			if confirmed='Y' then
				query_where:='rc3.confirmed=''Y''';
			elsif confirmed='N' then
				query_where:='rc3.confirmed=''N''';
			end if;
			if processed='Y' then
				if query_where is null then
					query_where:=query_where || 'rc3.status=''processed''';
				else
					query_where:=query_where || ' and rc3.status=''processed''';
				end if;
			elsif processed='N' then
				if query_where is null then
					query_where:=query_where || 'rc3.status<>''processed''';
				else
					query_where:=query_where || ' and rc3.status<>''processed''';
				end if;
			end if;

			if reversed='Y' then
				if query_where is null then
					query_where:=query_where || 'rc3.status=''reversed''';
				else
					query_where:=query_where || ' and rc3.status=''reversed''';
				end if;
			elsif reversed='N' then
				if query_where is null then
					query_where:=query_where || 'rc3.status<>''reversed''';
				else
					query_where:=query_where || ' and  rc3.status<>''reversed''';
			    end if;
			end if;

			dummy:=null;
			for i in 1..choice_order.count loop
				if choice_order(i)='1' then
					if dummy is null then
						dummy:=dummy || 'rc3.choice_order=''fc''';
					else
						dummy:=dummy || ' or rc3.choice_order=''fc''';
					end if;
				elsif choice_order(i)='2' then
					if dummy is null then
						dummy:=dummy || 'rc3.choice_order=''sc''';
					else
						dummy:=dummy || ' or  rc3.choice_order=''sc''';
				    end if;
				elsif choice_order(i)='3' then
					if dummy is null then
						dummy:=dummy || 'rc3.choice_order=''tc''';
					else
						dummy:=dummy || ' or  rc3.choice_order=''tc''';
				    end if;
				end if;
			end loop;
		else
			if preselection='RL' then
				filename:='export_rooming_list';
				query_where:=' (rc3.confirmed=''Y'' or rc3.choice_order=''fc'')';
				if hid!=-1 then
					query_where:=query_where || ' and rc3.hotel_id=' || hid;
				end if;
			else
				filename:='export_financial_check';
				if deleted=false then
					query_where:=' (rc3.status=''processed'' or rc3.status=''reversed'')';
				else
					query:='Select * from (' || query ||
					'union
						Select	rc.choice_order, rc.confirmed, rc.config,h.corporate_name,
										p.fname, p.lname, rc.start_date, rc.end_date,
										rc.status, rc.notes, rc.booking_date, rc.payment_date, rc.payment_code, rc.voucher_qs,
										rc.deposit, rc.choice_id, rc.SEQ_ID, rc.IPN_STATUS, h.HOTEL_ID, rc.DELETED
						from registrants_choices rc
							inner join persons p on rc.registrant_id= p.person_id
							inner join hotels h on rc.hotel_id= h.hotel_id
							inner join hotel_categories hc on hc.hotel_cat_id=h.hotel_cat_id
							inner join room_types rp on rc.config=rp.room_name
							inner join payment_codes pc on rc.payment_code= pc.payment_code
						where rc.STATUS=''reversed'' and deleted=''Y''
						      and not exists (Select ''found''	from registrants_choices rcc
						      			     where rc.seq_id=rcc.SEQ_ID and rc.choice_order=rcc.CHOICE_ORDER and rcc.DATE_RECORD>rc.date_record)
					   ) rc3';
				end if;
			end if;
		end if;

		if query_where is not null then
			query:=query || ' and  ' || query_where;
		end if;

		if dummy is not null then
			query:=query || ' and  (' || dummy || ')';
		end if;


		query:=query || '  order by rc3.lname, rc3.fname, rc3.seq_id, rc3.choice_order';

		owa_util.mime_header('text/csv',false, common.charset$);
		htp.p('Content-Disposition: filename="' || filename ||'.csv"');
		owa_util.http_header_close;

		htp.prn('Registrant' || ',');
		htp.prn('Hotel' || ',');
		htp.prn('Config' || ',');
		htp.prn('In_date' || ',');
		htp.prn('Out_date' || ',');
		htp.prn('Nights' || ',');
		htp.prn('Actual_paid' || ',');
		htp.prn('Payment_date' || ',');
		htp.prn('Paymennt_method' || ',');
		htp.prn('notes' || ',');
		htp.prn('status' || ',');
		htp.prn('confirmed' || ',');
		htp.prn('choice_order');

		open driver for query;
		loop
			fetch driver into choiceord,	confirmation, config,corporate_name,
						fname, lname, start_date, end_date,
						status, notes, booking_date, payment_date, payment_code, voucher_qs,
						deposit,choice_id, seq_id, ipn_status, hotel;
		    exit when driver%NOTFOUND;
			htp.prn (common.crlf$);
			htp.prn('"' || lname || ' ' || fname || '" ,');
			htp.prn('"' || corporate_name|| '" ,');
			htp.prn('"' || config || '" ,');
			htp.prn('"' || to_char(start_date) || '" ,');
			htp.prn('"' || to_char(end_date) || '" ,');
			htp.prn('"' || to_char(end_date-start_date) || '" ,');
			credit_card:= common.decode_value ('credit_card','payment_codes', 'payment_code', payment_code);
			if(credit_card != 'Y') then
				if status='processed' then
					htp.prn('"' || to_char(deposit) || '",');
				else
					htp.prn('"0",');
				end if;
			else
				if ipn_status='PAID' then
					htp.prn('"' || to_char(deposit) || '",');
				else
					htp.prn('"0",');
				end if;
			end if;
			htp.prn('"' || to_char(payment_date) || '",');
			htp.prn('"' || payment_code || '",');
			htp.prn('"' || notes || '",');
			htp.prn('"' || status || '",');
			htp.prn('"' || confirmation || '",');
			htp.prn('"' || choiceord || '"');
		end loop;
	end if;

end room_export;

-- *******************************************************************************************
-- *******************************************************************************************

procedure process_booking (action varchar, stPage integer default 1, last_name varchar2 default null,cfmed varchar2 default null,
										ch_order varchar2 default null, hid number default -1, cid integer default -1,
										actual_paid number default null, payment_date date default null) is

	cursor driver is
		select *
		from registrants_choices
		where choice_id=cid;

	driver_rec driver%ROWTYPE;
	tsp registrants_choices.DATE_RECORD%TYPE;
	conf rooms_hotel.CONFIG%TYPE;
	room_not_available exception;


begin

	if common.header ('', test_only=>true) then
		open driver;
		fetch driver into driver_rec;
		if action='modify' then
			common.public_header('');
			htp.formopen('hotel_handling_maint.process_booking','POST');
			htp.formhidden('stPage',stPage);
			htp.formhidden('last_name',last_name);
			htp.formhidden('cfmed',cfmed);
			htp.formhidden('ch_order',ch_order);
			htp.formhidden('hid',hid);
			htp.formhidden('action','processed');
			htp.formhidden('cid',cid);
			htp.tableopen;
			htp.tablerowopen;
			htp.p('<td width="25%">&nbsp</td>');
			htp.p('<td>');
			htp.Tableopen;
			htp.tablerowopen;
			htp.tabledata('<b>Total due:</b>','right');
			htp.tabledata(driver_rec.deposit || '<br>');
			htp.tablerowclose;
			htp.tablerowopen;
			htp.tabledata('<b>Payment method:</b>','right');
			htp.p('<td>');
			htp.p(common.decode_value('payment_descr','payment_codes','payment_code',driver_rec.payment_code)|| '<br>');
			htp.p('</td>');
			htp.tablerowclose;
			htp.tablerowopen;
			htp.tabledata('<b>Actual paid:</b>','right');
			htp.p('<td>');
			htp.formtext('actual_paid',10,10,driver_rec.deposit);
			htp.p('<br>');
			htp.p('</td>');
			htp.tablerowclose;
			htp.tablerowopen;
			htp.tabledata('<b>Date of payment:</b>','right');
			htp.p('<td>');
			htp.formtext('payment_date',10,10,driver_rec.payment_date);
			htp.p('<br>');
			htp.p('</td>');
			htp.tablerowclose;
			htp.tablerowopen;
			htp.tabledata('After submitting an automatic mail will be sent to the bookker<br />','center',ccolspan=>'2');
			htp.tablerowclose;
			htp.tablerowopen;
			htp.p('<td align="right">');
			htp.formreset(cattributes=>'onClick="javascript:window.close();"');
			htp.p('<br>');
			htp.p('</td>');
			htp.p('<td>');
			htp.formsubmit();
			htp.p('<br>');
			htp.p('</td>');
			htp.tablerowclose;
			htp.tableclose;
			htp.p('</td>');
			htp.p('<td width="25%">&nbsp</td>');
			htp.tablerowclose;
			htp.tableclose;
			htp.formclose;
			common.footer;
		else
			SELECT SYSTIMESTAMP into tsp FROM DUAL;
			insert into registrants_choices (registrant_id,start_date,end_date,config,
						hotel_id,confirmed,deposit,room_id,choice_order,status,payment_code,
						r_locked,date_record,notes,seq_id,
						ipn_status,invoice,receipt,booking_date,payment_date,
						deleted,voucher_qs)
			values (driver_rec.registrant_id,driver_rec.start_date,driver_rec.end_date,driver_rec.config,
					driver_rec.hotel_id,driver_rec.confirmed,actual_paid,driver_rec.room_id,driver_rec.choice_order,'processed',
					driver_rec.payment_code,driver_rec.r_locked, tsp,driver_rec.notes,driver_rec.seq_id,
					driver_rec.ipn_status,driver_rec.invoice,driver_rec.receipt,driver_rec.booking_date,payment_date,
				    driver_rec.deleted,driver_rec.voucher_qs);
			send_payment_recorded_mail(common.ENCRYPT(driver_rec.registrant_id) ,'processed', driver_rec.seq_id);
			htp.htmlOpen;
			htp.headOpen;
			htp.headClose;
			htp.BODYOPEN;
			htp.p('<SCRIPT TYPE="text/javascript">window.opener.location.reload() ; window.close();</SCRIPT>');
			htp.BODYCLOSE;
			htp.htmlClose;
		end if;
   	end if;

exception
      when room_not_available then
	    htp.header(3,'No choice available for the first hotel selected, please make a new choice');
	    htp.p(htf.anchor ('hotel_handling.search_free_rooms',htf.IMG(common.prevImg$,cattributes=>'border=0 alt="Back" title="Back"')));

end process_booking;

-- *******************************************************************************************
-- *******************************************************************************************

procedure modify_booking_period (action varchar, stPage integer default 1, last_name varchar2 default null,cfmed varchar2 default null,
										ch_order varchar2 default null, hid number default -1, cid integer default -1,
										stdate date default null, endate date default null) is

	cursor driver is
		select *
		from registrants_choices
		where choice_id=cid;

	driver_rec driver%ROWTYPE;
	date_record timestamp;
	available_from rooms_hotel.START_DATE%TYPE;
	available_to rooms_hotel.END_DATE%TYPE;

begin

	if common.header('', test_only=>true) then
		open driver;
		fetch driver into driver_rec;
		if action='modify' then
			common.public_header ('');
			htp.formopen('hotel_handling_maint.modify_booking_period','POST');
			htp.formhidden('stPage',stPage);
			htp.formhidden('last_name',last_name);
			htp.formhidden('cfmed',cfmed);
			htp.formhidden('ch_order',ch_order);
			htp.formhidden('hid',hid);
			htp.formhidden('action','update');
			htp.formhidden('cid',cid);
			htp.tableopen;
			htp.tablerowopen;
			htp.p('<td width="30%">&nbsp</td>');
			htp.p('<td>');
			htp.Tableopen;
			htp.tablerowopen;
			htp.Tableheader('Start Date');
			htp.tableheader('End Date');
			htp.tablerowclose;
			htp.tablerowopen;
			htp.p('<td align="center">');
			htp.formtext('stdate',10,10,driver_rec.start_date);
			htp.p('</td>');
			htp.p('<td align="center">');
			htp.formtext('endate',10,10,driver_rec.end_date);
			htp.p('<br><br>');
			htp.p('</td>');
			htp.tablerowclose;
			htp.tablerowopen;
			htp.p('<td align="right">');
			htp.formreset(cattributes=>'onClick="javascript:window.close();"');
			htp.p('</td>');
			htp.p('<td align="left">');
			htp.formsubmit();
			htp.p('<br>');
			htp.p('<br>');
			htp.p('</td>');
			htp.tablerowclose;
			htp.tableclose;
			htp.p('</td>');
			htp.p('<td width="30%">&nbsp</td>');
			htp.tablerowclose;
			htp.tableclose;
			htp.formclose;
			common.footer;
		elsif action='update' then
			available_from:=common.DECODE_VALUE('start_date','rooms_hotel','room_id',driver_rec.room_id);
			available_to:=common.DECODE_VALUE('end_date','rooms_hotel','room_id',driver_rec.room_id);
			if (available_from<=stDate and	endate<=available_to) then
				if hotel_handling.isbooked(common.ENCRYPT(driver_rec.registrant_id),driver_rec.room_id,stdate,endate,true)=false then
					date_record:=systimestamp;
					insert into registrants_choices (registrant_id,start_date,end_date,config,
								hotel_id,confirmed,deposit,room_id,choice_order,status,payment_code,
								r_locked,date_record,notes,seq_id,
								ipn_status,invoice,receipt,booking_date,payment_date,
								deleted,voucher_qs)
					values (driver_rec.registrant_id,stdate,endate,driver_rec.config,
							driver_rec.hotel_id,driver_rec.confirmed,driver_rec.deposit,driver_rec.room_id,driver_rec.choice_order,
							driver_rec.status,driver_rec.payment_code,driver_rec.r_locked,date_record, driver_rec.notes,driver_rec.seq_id,
							driver_rec.ipn_status,driver_rec.invoice,driver_rec.receipt,driver_rec.booking_date,driver_rec.payment_date,
						    driver_rec.deleted,driver_rec.voucher_qs);
					htp.htmlOpen;
					htp.headOpen;
					htp.headClose;
					htp.BODYOPEN;
					htp.p('<SCRIPT TYPE="text/javascript">window.opener.location.reload() ; window.close();</SCRIPT>');
					htp.BODYCLOSE;
					htp.htmlClose;
				else
					common.public_header('');
					htp.Tableopen;
					htp.tablerowopen;
					htp.tabledata('<br />It is not possible to change the booking period to the new (Start_date: ' || stdate || ' End date: ' || endate || ')<br>'
								|| ' The system detected an overlapping.<br />' ||
								  'Before to continue you have to check the reservation about ' ||
								  common.decode_value('corporate_name','hotels','hotel_id',driver_rec.hotel_id) ||
								  ' (room '|| driver_rec.room_id || ')');
					htp.tablerowclose;
					htp.tablerowopen;
					htp.tabledata('&nbsp');
					htp.tablerowclose;
					htp.tablerowopen;
					htp.p('<td align="center">');
					htp.formreset(cattributes=>'onClick="javascript:window.close();"');
					htp.p('</td>');
					htp.tablerowclose;
					htp.tableclose;
					htp.formclose;
					common.footer;
				end if;
			else
					common.public_header('');
					htp.formopen('hotel_handling_maint.modify_booking_period','POST');
					htp.formhidden('stPage',stPage);
					htp.formhidden('last_name',last_name);
					htp.formhidden('cfmed',cfmed);
					htp.formhidden('ch_order',ch_order);
					htp.formhidden('hid',hid);
					htp.formhidden('action','processed');
					htp.formhidden('cid',cid);
					htp.formhidden('action','updateroom');
					htp.formhidden('stdate',stdate);
					htp.formhidden('endate',endate);
					htp.Tableopen;
					htp.tablerowopen;
					htp.tabledata('<br />The new booking period (Start_date: ' || stdate || ' End date: ' || endate
								|| ') exceeded the room availability, the system can update it automaticaly.<br>'
								|| ' Would you modify the room settings?<br />');
					htp.tablerowclose;
					htp.tablerowopen;
					htp.tabledata('&nbsp');
					htp.tablerowclose;
					htp.tablerowopen;
					htp.p('<td align="center">');
					htp.formreset('No','onClick="javascript:window.close();"');
					htp.p('&nbsp');
					htp.formsubmit(cvalue=>'Yes');
					htp.p('<br>');
					htp.p('<br>');
					htp.p('</td>');
					htp.tablerowclose;
					htp.tableclose;
					htp.formclose;
					common.footer;
			end if;
		else
			update rooms_hotel set start_date=to_date(stdate,'dd-mon-yy'), end_date=to_date(endate,'dd-mon-yy') where room_id=driver_rec.room_id;
			date_record:=systimestamp;
			insert into registrants_choices (registrant_id,start_date,end_date,config,
						hotel_id,confirmed,deposit,room_id,choice_order,status,payment_code,
						r_locked,date_record,notes,seq_id,
						ipn_status,invoice,receipt,booking_date,payment_date,
						deleted,voucher_qs)
			values (driver_rec.registrant_id,to_date(stdate,'dd-mon-yy'),to_date(endate,'dd-mon-yy'),driver_rec.config,
					driver_rec.hotel_id,driver_rec.confirmed,driver_rec.deposit,driver_rec.room_id,driver_rec.choice_order,
					driver_rec.status,driver_rec.payment_code,driver_rec.r_locked,date_record, driver_rec.notes,driver_rec.seq_id,
					driver_rec.ipn_status,driver_rec.invoice,driver_rec.receipt,driver_rec.booking_date,driver_rec.payment_date,
				    driver_rec.deleted,driver_rec.voucher_qs);
			htp.htmlOpen;
			htp.headOpen;
			htp.headClose;
			htp.BODYOPEN;
			htp.p('<SCRIPT TYPE="text/javascript">window.opener.location.reload() ; window.close();</SCRIPT>');
			htp.BODYCLOSE;
			htp.htmlClose;
		end if;
   	end if;
end modify_booking_period;

-- *******************************************************************************************
-- *******************************************************************************************

procedure summary_statistic is

	valid_rc varchar2(5000);
	rooms varchar2(5000);
	booked varchar2(5000);
	processed varchar2(5000);
	only_confirmed varchar2(5000);
	to_be_confirmed varchar2(5000);
	summary varchar2(10000);

	category hotel_categories.HOTEL_CAT_NAME%TYPE;
	r_total number;
	r_booked number;
	free number;
	r_processed number;
	r_only_confirmed number;
	r_to_be_confirmed number;


	type	cursor_type is REF CURSOR;
	driver	cursor_type;

	cursor deposit is
		select pc.PAYMENT_DESCR, d.due, dp.processed, d.due-dp.processed pending, dr.reversed, drd.reversed_with_deleted
		from
		    (Select distinct rc.payment_code, p.PAYMENT_DESCR
		    from registrants_choices rc
		    inner join payment_codes p on rc.PAYMENT_CODE=p.PAYMENT_CODE) pc
			left outer join
				(select payment_code,sum(deposit) due
				       from (
							Select * from
									(Select *
									 from registrants_choices rc
									 where rc.deleted='N' and
									       rc.date_record= ( select max(rc1.date_record) from registrants_choices rc1
													  where rc1.seq_id=rc.seq_id and rc1.choice_order=rc.choice_order and rc1.deleted='N')
									 ) rc3
								where not exists ( select 'found' from
													(Select rc.*
														from registrants_choices rc
														where rc.deleted='N' and
															rc.date_record= ( select max(rc1.date_record) from registrants_choices rc1
																			where rc1.seq_id=rc.seq_id and rc1.choice_order=rc.choice_order and rc1.deleted='N')
													 ) rc4
													where rc4.seq_id=rc3.seq_id and rc3.choice_id<>rc4.choice_id and rc4.confirmed='Y')
									 and confirmed='Y'

							UNION

								Select * from
										(Select *
										 from registrants_choices rc
										 where rc.deleted='N' and
										       rc.date_record= ( select max(rc1.date_record) from registrants_choices rc1
														  where rc1.seq_id=rc.seq_id and rc1.choice_order=rc.choice_order and rc1.deleted='N')
										 ) rc3
									where not exists ( select 'found' from
														(Select rc.*
															from registrants_choices rc
															where rc.deleted='N' and
																rc.date_record= ( select max(rc1.date_record) from registrants_choices rc1
																				where rc1.seq_id=rc.seq_id and rc1.choice_order=rc.choice_order and rc1.deleted='N')
														 ) rc4
														where rc4.seq_id=rc3.seq_id and rc3.choice_id<>rc4.choice_id and rc4.confirmed='Y')
										 and confirmed='N' and choice_order='fc'						    )
				group by payment_code) d on pc.payment_code=d.payment_code
			left outer join
				(select payment_code,sum(deposit) processed
			       from (Select  *
							from registrants_choices rc
							where rc.confirmed='Y' and rc.deleted='N'
							and rc.date_record in (select max(rrc.date_record) from registrants_choices rrc where rrc.seq_id= rc.seq_id and rrc.choice_order=rc.choice_order and rrc.deleted='N'))
				  where status='processed'
			      group by payment_code) dp on pc.payment_code=dp.payment_code
			left outer join
				(select payment_code,sum(deposit) reversed
			       from (Select  *
							from registrants_choices rc
							where rc.confirmed='Y' and rc.deleted='N'
							and rc.date_record in (select max(rrc.date_record) from registrants_choices rrc where rrc.seq_id= rc.seq_id and rrc.choice_order=rc.choice_order and rrc.deleted='N'))
				  where status='reversed'
			      group by payment_code) dr on pc.payment_code=dr.payment_code
			left outer join
				(select payment_code,sum(deposit) reversed_with_deleted
			       from (Select  *
							from registrants_choices rc
							where rc.confirmed='Y'
							and rc.date_record in (select max(rrc.date_record) from registrants_choices rrc where rrc.seq_id= rc.seq_id and rrc.choice_order=rc.choice_order))
				  where status='reversed'
			      group by payment_code) drd on pc.payment_code=drd.payment_code;


	deposit_rec deposit%ROWTYPE;

begin

-- list registrant choices (in the case that are one confirmed only that)
	valid_rc:='select distinct room_id, HOTEL_ID, status, confirmed, choice_order
		       from (
						(Select  *
						from registrants_choices rc
						where rc.confirmed=''Y'' and rc.deleted=''N''
						and rc.date_record in (select max(rrc.date_record) from registrants_choices rrc where rrc.seq_id= rc.seq_id and rrc.choice_order=rc.choice_order and rrc.deleted=''N''))
				   UNION
						(Select   *
						from registrants_choices rc
						where rc.choice_order=''fc''and rc.deleted=''N''
						and rc.seq_id not in
						(select rcc.seq_id from registrants_choices rcc
						where rcc.seq_id= rc.seq_id and rcc.choice_order<>''fc'' and  rcc.confirmed=''Y'' and rcc.deleted=''N''
						and rcc.date_record in (select max(rccc.date_record) from registrants_choices rccc where rccc.seq_id= rcc.seq_id and rccc.choice_order=rcc.choice_order and rCcc.deleted=''N''))
						and rc.date_record in (select max(rrcc.date_record) from registrants_choices rrcc where rrcc.seq_id= rc.seq_id and rrcc.choice_order=rc.choice_order and rrcc.deleted=''N'')))';

-- number of rooms for each categorie hotel
	rooms:='select hcc.HOTEL_CAT_ID, hcc.HOTEL_CAT_NAME , q.total
			from
				(Select h.HOTEL_CAT_ID, count(*) total
				from
				hotels h inner join hotel_categories hc on h.HOTEL_CAT_ID=hc.HOTEL_CAT_ID
				inner join rooms_hotel r on h.HOTEL_ID=r.HOTEL_ID
				group by h.HOTEL_CAT_ID) q
			inner join hotel_categories hcc on hcc.HOTEL_CAT_ID=q.hotel_cat_id
			order by hcc.hotel_cat_id';

-- number of rooms involved at least one choice
	booked:='select hcc.HOTEL_CAT_ID, hcc.HOTEL_CAT_NAME , q.booked
			 from
				(select hc.HOTEL_CAT_ID, count(*) as booked
				from
					(' ||
					valid_rc ||
					') rc
				inner join hotels h on rc.HOTEL_ID=h.HOTEL_ID
				inner join hotel_categories hc on h.HOTEL_CAT_ID=hc.HOTEL_CAT_ID
				group by hc.HOTEL_CAT_ID) q
			 inner join hotel_categories hcc on hcc.HOTEL_CAT_ID=q.hotel_cat_id
			 order by hcc.hotel_cat_id';

	processed:='select hcc.HOTEL_CAT_ID, hcc.HOTEL_CAT_NAME , q.processed
				 from
					(select hc.HOTEL_CAT_ID, count(*) as processed
					from
						(' ||
						valid_rc ||
						') rc
					inner join hotels h on rc.HOTEL_ID=h.HOTEL_ID
					inner join hotel_categories hc on h.HOTEL_CAT_ID=hc.HOTEL_CAT_ID
					where rc.confirmed=''Y'' and rc.status=''processed''
					group by hc.HOTEL_CAT_ID) q
				 inner join hotel_categories hcc on hcc.HOTEL_CAT_ID=q.hotel_cat_id
				 order by hcc.hotel_cat_id';

	only_confirmed:='select hcc.HOTEL_CAT_ID, hcc.HOTEL_CAT_NAME , q.only_confirmed
					 from
						(select hc.HOTEL_CAT_ID, count(*) as only_confirmed
						from
							(' ||
							valid_rc ||
							') rc
						inner join hotels h on rc.HOTEL_ID=h.HOTEL_ID
						inner join hotel_categories hc on h.HOTEL_CAT_ID=hc.HOTEL_CAT_ID
						where rc.confirmed=''Y'' and rc.status!=''processed''
						group by hc.HOTEL_CAT_ID) q
					 inner join hotel_categories hcc on hcc.HOTEL_CAT_ID=q.hotel_cat_id
					 order by hcc.hotel_cat_id';

	to_be_confirmed:='select hcc.HOTEL_CAT_ID, hcc.HOTEL_CAT_NAME , q.to_be_confirmed
					 from
						(select hc.HOTEL_CAT_ID, count(*) as to_be_confirmed
						from
							(' ||
							valid_rc ||
							') rc
						inner join hotels h on rc.HOTEL_ID=h.HOTEL_ID
						inner join hotel_categories hc on h.HOTEL_CAT_ID=hc.HOTEL_CAT_ID
						where rc.confirmed=''N'' and rc.status!=''processed'' and rc.choice_order=''fc''
						group by hc.HOTEL_CAT_ID) q
					 inner join hotel_categories hcc on hcc.HOTEL_CAT_ID=q.hotel_cat_id
					 order by hcc.hotel_cat_id';

	summary:='select q1.hotel_cat_name, nvl(q1.total,0), nvl(q2.booked,0), nvl(q1.total,0)-nvl(q2.booked,0) free,
			 nvl(q3.processed,0), nvl(q4.only_confirmed,0), nvl(q5.to_be_confirmed,0)
		  from ('|| rooms ||
		  ') q1 left outer join (' ||
			  booked ||
			  ') q2 on q1.hotel_cat_id=q2.hotel_cat_id' ||
			  ' left outer join (' ||
			  processed ||
			  ') q3 on q1.hotel_cat_id=q3.hotel_cat_id'  ||
			  ' left outer join (' ||
			  only_confirmed ||
			  ') q4 on q1.hotel_cat_id=q4.hotel_cat_id'  ||
			  ' left outer join (' ||
			  to_be_confirmed ||
			  ') q5 on q1.hotel_cat_id=q5.hotel_cat_id'
			  ;

	common.get_gbl_pid;
	if common.has_privs_to_page then
	    maint.header ('Summary Statistics');

	    htp.tableOpen();
		htp.tableRowOpen();
		htp.p('<td width=25%>');
		maint.menu(0);
		htp.p('</td>');
		htp.p('<td>');
		htp.p('<br />');
		htp.tableopen(cattributes=>'border="1px"');
		htp.tablerowopen;
		htp.tabledata('<b>Rooms</b>',ccolspan=>'4',cattributes=>'align=center bgcolor=#eeeeee');
		htp.tabledata('&nbsp');
		htp.tabledata('<b>Booking process</b>',ccolspan=>'4',cattributes=>'align=center bgcolor=#eeeeee');
		htp.tablerowclose;
		htp.tablerowopen;
		htp.tabledata('<b>Hotel Categories</b>',cattributes=>'align=center bgcolor=#eeeeee');
		htp.tabledata('<b>Booked rooms</b>',cattributes=>'align=center bgcolor=#eeeeee');
		htp.tabledata('<b>Free rooms</b>',cattributes=>'align=center bgcolor=#eeeeee');
		htp.tabledata('<b>Total rooms</b>',cattributes=>'align=center bgcolor=#eeeeee');
		htp.tabledata('&nbsp');
		htp.tabledata('<b>Processed</b>',cattributes=>'align=center bgcolor=#eeeeee');
		htp.tabledata('<b>Only Confirmed</b>',cattributes=>'align=center bgcolor=#eeeeee');
		htp.tabledata('<b>To be confirmed</b>',cattributes=>'align=center bgcolor=#eeeeee');
		htp.tabledata('<b>Total booking</b>',cattributes=>'align=center bgcolor=#eeeeee');
		htp.tablerowclose;

		open driver for summary;
		loop
			fetch driver into category, r_total, r_booked, free, r_processed, r_only_confirmed, r_to_be_confirmed;
	 		exit when driver%found=false;
			htp.tablerowopen;
			htp.tabledata(category);
			htp.tabledata(r_booked,cattributes=>'align=center');
			htp.tabledata(free,cattributes=>'align=center');
			htp.tabledata(r_total,cattributes=>'align=center');
			htp.tabledata('&nbsp');
			htp.tabledata(r_processed,cattributes=>'align=center');
			htp.tabledata(r_only_confirmed,cattributes=>'align=center');
			htp.tabledata(r_to_be_confirmed,cattributes=>'align=center');
			htp.tabledata(To_char(r_processed+r_only_confirmed+r_to_be_confirmed),cattributes=>'align=center');
			htp.tablerowclose;
		end loop;
		htp.tableclose;
		htp.p('<br />');

		htp.tableopen(cattributes=>'border="1px"');
		htp.tablerowopen;
		htp.tabledata('<b>Methods of payment</b>',cattributes=>'align=center bgcolor=#eeeeee');
		htp.tabledata('<b>Due</b>',cattributes=>'align=center bgcolor=#eeeeee');
		htp.tabledata('<b>Processed</b>',cattributes=>'align=center bgcolor=#eeeeee');
		htp.tabledata('<b>Pending</b>',cattributes=>'align=center bgcolor=#eeeeee');
		htp.tabledata('&nbsp');
		htp.tabledata('<b>Reversed</b>',cattributes=>'align=center bgcolor=#eeeeee');
		htp.tabledata('<b>Reversed<br /> (with reversed deleted record)</b>',cattributes=>'align=center bgcolor=#eeeeee');
		htp.tablerowclose;

		For deposit_rec in deposit loop
			htp.tablerowopen;
			htp.tabledata(deposit_rec.payment_descr);
			htp.tabledata(deposit_rec.due,cattributes=>'align=center');
			htp.tabledata(deposit_rec.processed,cattributes=>'align=center');
			htp.tabledata(deposit_rec.pending,cattributes=>'align=center');
			htp.tabledata('&nbsp');
			htp.tabledata(deposit_rec.reversed,cattributes=>'align=center');
			htp.tabledata(deposit_rec.reversed_with_deleted,cattributes=>'align=center');
			htp.tablerowclose;
		end loop;
		htp.tableclose;

		htp.p('</td>');
		htp.tablerowclose;
		htp.tableclose;
		common.footer;
	end if;
end summary_statistic;

-- *******************************************************************************************
-- *******************************************************************************************

END hotel_handling_maint;

/
show error

set define on

--	Copyright (C) 2004-2008 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
