set define off

Create or Replace package hotel_handling_maint as

  type number_arr 	is table of integer index by binary_integer;
  ignore_admin$		boolean default true;
  validate_IP$		boolean default true;
  empty_room_arr 	number_arr;
  empty_arr			owa_util.ident_arr;

  optionVal 			common.ident_arr;
  showVal   			common.ident_arr;

-- Procedure and Function intended for administrative manage

  procedure add_hotel_delegates_notes(cid number,action varchar2, del_notes varchar2 default null);
  procedure add_modify_deposit(did number default -1);
  procedure add_rooms_hotels(hid number default -1,selected owa_util.ident_arr default empty_arr,
			     rnum number default 0, startDate date default null,
			     endDate date default null, description varchar2 default null);
  procedure add_selected_payments(selected owa_util.ident_arr default empty_arr, action varchar2);
  procedure add_selected_room_types_hotel(hid number,fee owa_util.ident_arr default empty_arr,
					  selected owa_util.ident_arr default empty_arr,
					  rtid owa_util.ident_arr default empty_arr);
  procedure automated_deposit_filling;
  procedure cancel_hotel_entry(stPage number default 0,action varchar2 default null, cid number default -1,
					  crypt_pid varchar2, last_name varchar2 default null, cfmed varchar2 default null,
					  ch_order varchar2 default null, cat_id number default null, hid number default -1, sqid number default -1);
  procedure change_deposit_status(dip number default -1,val number default 0);
  procedure create_cat_entry(cid number default -1);
  procedure create_hotel_entry(hid number default -1);
  procedure create_room_type_entry(rid number default -1);
  procedure delete_category(cid number default -1);
  procedure delete_room_type(rid number default -1);
  procedure enable_payments(action varchar2 default null);
  procedure insert_category(catName varchar2 default null,
			    rdescription varchar2 default null, catSym varchar2 default null);
  procedure insert_hotel(corporateName varchar2,address varchar2, addressNumber number,
			 town varchar2, province varchar2,state varchar2, vatin varchar2,
			 phoneNumber varchar2, faxNumber varchar2,email varchar2,director varchar2,
			 nationalIdNumber varchar2,website varchar2, rdescription varchar2, h_cat number);
  procedure insert_room_type(rid number,roomName varchar2, rdescription varchar2);
  procedure list_available_categories;
  procedure list_available_deposit;
  procedure list_available_hotels;
  procedure list_available_room_types(action varchar2 default null, rid number default -1);
  procedure modify_booking_period (action varchar, stPage integer default 1, last_name varchar2 default null,cfmed varchar2 default null,
										ch_order varchar2 default null, hid number default -1, cid integer default -1,
										stdate date default null, endate date default null);
  procedure process_booking (action varchar, stPage integer default 1, last_name varchar2 default null,cfmed varchar2 default null,
										ch_order varchar2 default null, hid number default -1,cid integer default -1,
										actual_paid number default null, payment_date date default null);
  procedure deposit_due(action varchar2 default null, crypt_pid varchar2 default null, cid integer, sqid integer,
				     stPage number default 1,last_name varchar2 default null,cfmed varchar2 default null,
				     ch_order varchar2 default null ,cat_id number default null,hid number default -1);
  procedure remove_hotel(hid number default -1);
  procedure remove_modify_rooms_hotel(action varchar2 default null, hid number default -1,str number default 1, roomid number default null, rid owa_util.ident_arr default empty_arr,
						      description owa_util.ident_arr default empty_arr,
						      startDate owa_util.ident_arr default empty_arr,
						      endDate owa_util.ident_arr default empty_arr);
  procedure room_config_edit(roomid number default -1, hid number default -1);
  procedure room_config_save (roomid number default -1, selected owa_util.ident_arr default empty_arr,
			      hid number default -1);
  procedure room_export_filter;
  procedure room_export(filter_type varchar,hid number default -1, deleted boolean default false,
			confirmed varchar	default null, processed varchar  default null,
			reversed varchar  default null, preselection varchar default null,
			choice_order common.ident_arr, export varchar);
  procedure save_deposit(did number default -1, hotelCatId number default -1,
			 roomTypeId number default -1, dep number default -1, depLocked number default 1 );
  procedure search_registrants_bookings;
  procedure send_payment_recorded_mail(crypt_pid varchar2 default null,status varchar2 default null, sqid number,
				       message varchar2 default null);
  procedure show_all_registrants_bookings(stPage number default 1,action varchar2 default null, cid number default -1,
					  crypt_pid varchar2 default null, last_name varchar2 default null, cfmed varchar2 default null,
					  ch_order varchar2 default null, cat_id number default null, hid number default -1, sqid number default -1);
  procedure show_hotel_list;
  procedure show_hotel_notches(hid integer default -1);
  procedure show_ipn_values(stPage number default 0,action varchar2 default null, cid number default -1,
						crypt_pid varchar2 default null, last_name varchar2 default null, cfmed varchar2 default null,
						ch_order varchar2 default null, cat_id number default null, hid number default -1,
						sqid number default -1, payDate date default null);
  procedure show_payment_date(stPage number default 0,action varchar2 default null, cid number default -1,
						  crypt_pid varchar2 default null, last_name varchar2 default null, cfmed varchar2 default null,
						  ch_order varchar2 default null, cat_id number default null, hid number default -1,
						  sqid number default -1,payDate date default null);
  procedure show_room_types_hotel(hid number);
  procedure summary_statistic;
  procedure update_category(cid number default -1, catName varchar2 default null,
			    rdescription varchar2 default null, catSym varchar2 default null);
  procedure update_hotel(corporateName varchar2,address varchar2, addressNumber number,
				     town varchar2, province varchar2,state varchar2, vatin varchar2,
				     phoneNumber varchar2, faxNumber varchar2,email varchar2,director varchar2,
				     nationalIdNumber varchar2,website varchar2, rdescription varchar2,
				     h_cat number, hid number);
  procedure createVoucher(crypt_pid varchar2 default null, sqid number, code varchar2);



  function hasDepositAssociated(rid number default -1) return boolean;
  function hasHotelAssociated(cid number default -1) return boolean;
  function isFib (n positive, fn integer) return boolean;
  function generate_fib (n positive) return  integer;


END hotel_handling_maint;

/
show error

set define on

--	Copyright (C) 2004-2008 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
