set define off

create or replace package body JACoW as

new_abstract$		constant varchar2(100)	:= 'Submit A New Abstract';
propose_abstract$	constant varchar2(100)	:= 'Propose A New Invited Oral';
mod_profile$		constant varchar2(100)	:= 'Modify Your Profile';
user_script$		constant varchar2(30)	:= 'JACoW.save_abstract';
editor_script$		constant varchar2(30)	:= 'JACoW.save_abs_editor';
redX$			constant varchar2(50)	:= htf.bold(common.red('X'));
invite_msg$		constant varchar2(60)	:= 'Participation in this conference is by invitation only.';
verify_msg$		constant char(31)	:= 'Verify Abstract and Author List';
no_privs$		constant varchar2(50)	:= 'You do not have privileges to edit this abstract.';

speaker_rec_exists	boolean;
rec_found		boolean;
dummy			integer;
abs_edt_err_msg		long := null;
editor_saved_abs	boolean := false; -- used to control URL redirect after saving an abstract
label			varchar2(50);

cursor	abstract_cursor (abs_id varchar2) is
select	*
from	abstracts
where	abstract_id = abs_id;

abstract_rec	abstract_cursor%ROWTYPE;

-- ***********************************************************************************************
-- ***********************************************************************************************

function js$ return varchar2 is

begin

   return '<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript" src="' || common.server ||
					common.vdir$ || 'JACoW.js"></SCRIPT>';

end js$;

-- ***********************************************************************************************

procedure define_reg_exp is

cursor	driver is
select	*
from	file_type_codes
where	reg_exp is not null;

begin

   for driver_rec in driver LOOP
      htp.p ('');
      htp.prn ('var ');
      htp.prn (driver_rec.file_type_code);
      htp.prn (chr(9));

      htp.prn ('= new RegExp (document.FILE_UPLOAD.paper_id.value + "');
      htp.prn (driver_rec.reg_exp);
      htp.prn ('", "i");');
   end loop;

end define_reg_exp;

-- ***********************************************************************************************

procedure test_reg_exp is

cursor	driver is
select	*
from	file_type_codes
where	reg_exp is not null;

cursor	c2 is
select	error_msg
from	file_type_codes
where	reg_exp is null;

c2_rec	c2%ROWTYPE;

cmd		varchar2(7) := 'if';
paper_id$	constant varchar2(45) := '" + document.FILE_UPLOAD.paper_id.value + "';

begin

   open c2;
   fetch c2 into c2_rec;
   close c2;

   htp.p ('');
   htp.p ('var err_msg = "' || replace (c2_rec.error_msg, '*', paper_id$) || '";');
   htp.p ('');

   for driver_rec in driver LOOP
      htp.p ('');
      htp.p ('	 ' || cmd || ' (document.FILE_UPLOAD.this_file_type.value == "' || driver_rec.file_type_code || '") {');
      htp.p ('	    if (filename.match(' || driver_rec.file_type_code || ') == null) {');
      htp.p ('	       alert ("' || replace (driver_rec.error_msg, '*', paper_id$) || '");');
      htp.p ('	       return false;');
      htp.p ('	 }  }');
      cmd := 'else if';
   end loop;

   cmd := 'if';
   htp.p ('');
   htp.p ('   else {');

   for driver_rec in driver LOOP
      htp.p ('');
      htp.p ('	    ' || cmd || ' (filename.match(' || driver_rec.file_type_code || ') !== null) {');
      htp.p ('	       alert (err_msg);');
      htp.p ('	       return false;');
      htp.p ('	    }');
      cmd := 'else if';
   end loop;

   htp.p ('');
   htp.p ('   }');

end test_reg_exp;

-- ***********************************************************************************************

procedure js_load_sub_class (this_code varchar2) is

cursor	driver is
select	*
from	sub_class_codes
where	sub_class_code	in
(	select	sub_class_code
	from	eclass_codes
	where	classification_code = this_code)
OR	this_code	is null
order by
	sub_class_descr;

icount	integer := 1;

begin

   for driver_rec in driver LOOP
      driver_rec.sub_class_descr := replace (driver_rec.sub_class_descr, '"', chr(39)||chr(39));
      htp.print ('	document.ABSTRACT.THIS_SUB_CLASS.options[' || icount || '] = new Option ("' ||
		driver_rec.sub_class_descr  || '", "' || driver_rec.sub_class_code || '", false, false);');
      icount := icount + 1;
   end loop;

end js_load_sub_class;

-- ***********************************************************************************************

procedure js_template_guidelines is

cursor	driver is
select	*
from	file_type_codes
where	required = 'Y';

begin

   htp.p ('');
   htp.p ('');
   htp.p ('function template_guidelines() {');
   htp.p ('var resp;');

   for rec in driver LOOP
      htp.p ('	 if (document.FILE_UPLOAD.this_file_type.value == "' || rec.file_type_code || '") {');
      htp.p ('	   return (confirm ("I confirm that my manuscript conforms to the guidelines of the JACoW template, and I have checked the paper against the \"Common Oversights\" document, and implemented any necessary changes accordingly."));');
      htp.p ('	 }');
   end loop;

   htp.p ('}');

end js_template_guidelines;

-- ***********************************************************************************************

procedure JS is

cursor	driver is
select	classification_code
from	classification_codes
UNION
select	null
from	dual;

cmd	varchar2(10) := 'if';

begin

   htp.print ('function load_sub_class (class_code) {');

   htp.print ('');
   htp.print ('   document.ABSTRACT.THIS_SUB_CLASS.options.length = 0; // remove all options');
   htp.print ('   document.ABSTRACT.THIS_SUB_CLASS.options[0] = new Option ("", "", true, true);');

   for driver_rec in driver LOOP
      htp.print ('');
      htp.print ('   ' || cmd || ' (class_code == "' || driver_rec.classification_code || '") {');

      js_load_sub_class (driver_rec.classification_code);

      htp.print ('   }');

      cmd := 'else if';
   end loop;

   htp.print ('');
   htp.print ('   return true;');
   htp.print ('');
   htp.print ('}');

-- **********

   htp.prn (

'function validatedSource () {

   window.opener.document.FILE_UPLOAD.source_verified.value="Y";
   window.close();
   return true;

}
');

-- **********

   htp.prn (

'function validateJACoWForm (sub_required) {

   if (document.ABSTRACT.this_title.value == "") {
      alert ("You must enter a Title");
      return false;
   }

   if (document.ABSTRACT.this_PRESENTATION.options[document.ABSTRACT.this_PRESENTATION.selectedIndex].value == "") {
      alert ("You must select a Presentation");
      return false;
  }

   if (document.ABSTRACT.this_CLASSIFICATION.options.length <= 1) {
      if (sub_required == "N") {
	 load_classifiation (document.ABSTRACT.this_presentation.options[document.ABSTRACT.this_presentation.selectedIndex].value);
      }
  }

   if (document.ABSTRACT.this_CLASSIFICATION.options[document.ABSTRACT.this_CLASSIFICATION.selectedIndex].value == "") {
      alert ("You must select a Main Classification");
      return false;
   }

   if (sub_required == "Y") {
      if (document.ABSTRACT.THIS_SUB_CLASS.options.length != 1) {
	 if (document.ABSTRACT.THIS_SUB_CLASS.options[document.ABSTRACT.THIS_SUB_CLASS.selectedIndex].value == "") {
	    alert ("You must select a Sub Classification");
	    return false;
   }  }  }

   if (document.ABSTRACT.this_description.value == "") {
      alert ("You must enter an Abstract");
      return false;
   }

   if (document.ABSTRACT.this_description.value.length > ' || common.max_abstract_len$ || ') {
      alert ("Abstract exceeds the maximum length of ' || common.max_abstract_len$ || ' characters.  ' ||
		'Your abstract is " + document.ABSTRACT.this_description.value.length + " characters.");

      return false;
   }

   if (document.ABSTRACT.this_footnote.value.length > ' || common.max_footnote_len$ || ') {
      alert ("Footnote exceeds the maximum length of ' || common.max_footnote_len$ || ' characters.  ' ||
		'Your footnote is " + document.ABSTRACT.this_footnote.value.length + " characters.");

      return false;
   }

   if (document.ABSTRACT.this_agency.value.length > ' || common.max_funding_agency_len$ || ') {
      alert ("Agency exceeds the maximum length of ' || common.max_funding_agency_len$ || ' characters.  ' ||
		'Your agency is " + document.ABSTRACT.this_agency.value.length + " characters.");

      return false;
   }

   return true;

}
');

-- **********

   htp.print ('');
   htp.prn (
'function validateFileForm () {
');

   define_reg_exp;

htp.prn ('
var filename = document.FILE_UPLOAD.file_name.value.toUpperCase();


   document.FILE_UPLOAD.validated.value = "YES";

   if (document.FILE_UPLOAD.this_file_type.value == "") {
      alert ("You must specify a File Type");
      return false;
   }

   if (document.FILE_UPLOAD.this_platform.value == "") {
      alert ("You must specify a Platform");
      return false;
   }

   if (document.FILE_UPLOAD.file_name.value == "") {
      alert ("You must specify a File to Upload");
      return false;
   }

   if (document.FILE_UPLOAD.this_file_type.value == "PS") {
      if (filename.match(PS) == null) {
	 alert ("Postscript filename must be named " + document.FILE_UPLOAD.paper_id.value + ".PS");
	 return false;
   }  }

   if (document.FILE_UPLOAD.this_file_type.value == "SRC") {
      if (document.FILE_UPLOAD.source_verified.value == "N") {
	 alert ("You must verify the Abstract and Author List prior to uploading a source file.");
	 return false;
   }  }
');

   test_reg_exp;

htp.prn ('
   return true;

}');

   js_template_guidelines;

end JS;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure additional_sessions_pri (asid integer, aid integer) is

begin

   common.get_gbl_pid;
   if common.has_privs_to_page then
      update	abstract_sessions
      set	primary_flag	= 'N'
      where	abstract_id	= aid
      and	primary_flag	= 'Y';

      update	abstract_sessions
      set	primary_flag		= 'Y'
      where	abstract_session_id	= asid;

      common.redirect_URL (common.server || common.vdir$ || 'jacow.additional_sessions?aid=' || aid);
   end if;

end additional_sessions_pri;

-- ***********************************************************************************************

procedure additional_sessions_del (asid integer, aid integer) is

begin

   common.get_gbl_pid;
   if common.has_privs_to_page then
      delete from abstract_sessions where abstract_session_id = asid;
      common.redirect_URL (common.server || common.vdir$ || 'jacow.additional_sessions?aid=' || aid);
   end if;

end additional_sessions_del;

-- ***********************************************************************************************

function additional_sessions_validate (sid varchar2, seq varchar2, pcode varchar2,
					stime varchar2, dur varchar2,
					validate_session boolean) return long is

cursor	driver is
select	1
from	abstract_sessions
where	session_id	= sid
and	session_seq	= seq;

msg		long := null;
dummy		integer;
rec_found	boolean;

begin

   if validate_session then
      if sid is null then
         msg := msg || htf.header(3, 'You must select a Session.');
      end if;

      if seq is not null then
         if NOT common.validate_number(seq) then
            msg := msg || htf.header(3, 'Sequence# must be a number.');
         end if;
      end if;

      if msg is null then
         open driver;
         fetch driver into dummy;
         rec_found := driver%FOUND;
         close driver;

         if rec_found then
            msg := msg || htf.header(3, 'The Session/Sequence you selected is assinged to another paper.');
         end if;
      end if;
   end if;

   if pcode is null then
      msg := msg || htf.header(3, 'You must select a Presentation Type.');
   end if;

   if trim (dur) is not null then
      if NOT common.validate_number (dur) then
         msg := msg || htf.header(3, 'Duration must be a number.');
      end if;
   end if;

   if trim (stime) is not null then
      if NOT common.validate_number (stime) then
         msg := msg || htf.header(3, 'Start Time must be a number.');
      end if;
   end if;

   return msg;

end additional_sessions_validate;

-- ***********************************************************************************************

procedure additional_sessions_edt (aid integer,
					asid	common.ident_arr,
					pcode	common.ident_arr,
					stime	common.ident_arr,
					dur	common.ident_arr,
					sv_URL	common.ident_arr) is

errors_found	boolean := false;

begin

   for i in 1..pcode.COUNT loop
      if additional_sessions_validate(null, null, pcode(i), stime(i), dur(i), false) is null then
         update	abstract_sessions
         set	presentation_code	= pcode(i),
		start_time		= stime(i),
		duration		= dur(i),
		streaming_video_URL	= sv_URL(i)
         where	abstract_session_id	= asid(i);
      else
         errors_found := true;
      end if;
   end loop;

   if errors_found then
      if common.header ('Additional Sessions') then
         htp.header(3, 'Errors found while Saving.');
         htp.p('One or more errors were found while validating the data.');
         htp.p('Please reattempt to make your updates.');
         htp.formOpen(common.server || common.vdir$ || 'jacow.additional_sessions', 'POST');
         htp.formHidden('aid', aid);
         htp.formSubmit(null,'Continue');
         htp.formClose;
         common.footer;
      end if;
   else
      common.redirect_URL (common.server || common.vdir$ || 'jacow.additional_sessions?aid=' || aid);
   end if;

end additional_sessions_edt;

-- ***********************************************************************************************

procedure additional_sessions_save (aid integer, sid varchar2, seq varchar2,
				pcode varchar2, pflag varchar2, stime varchar2,
				dur varchar2, sv_URL varchar2) is

msg	long;

begin

   msg := additional_sessions_validate(sid, seq, pcode, stime, dur, true);

   if msg is null then
      common.add_abs_session (aid, sid, pcode, pflag, stime, dur, seq, sv_URL);
      common.redirect_URL (common.server || common.vdir$ || 'jacow.additional_sessions?aid=' || aid);
   elsif common.header ('Additional Sessions') then
      htp.p (msg);
      htp.p (common.click_back$);
      common.footer;
   end if;

end additional_sessions_save;

-- ***********************************************************************************************

procedure additional_sessions_prompts (aid integer) is

begin

   common.show_popup_table_row ('session_id', 'session_id || '' - '' || title', 'sessions', 'Session',
		where_claws=>'where session_id not in '	||
			'(select session_id from abstract_sessions where abstract_id = ' || aid || ')',
		order_by=>'order by sort_order nulls last, session_date, beg_time',
		var_name=>'sid');

   common.show_data_row('Sequence#', htf.formText('seq',5,5));

   common.show_popup_table_row ('presentation_code', 'presentation_descr',
					'presentation_codes', 'Presentation Type',
					var_name=>'pcode');

   htp.tableRowOpen;
   htp.tableHeader ('Program Code Type', 'RIGHT');
   htp.p ('<TD>');
      htp.formSelectOpen ('pflag');
      htp.formSelectOption ('Primary', cattributes=>'VALUE=Y');
      htp.formSelectOption ('Secondary', 'SELECTED', cattributes=>'VALUE=N');
      htp.formSelectClose;
   htp.p ('</TD>');
   htp.tableRowClose;

   common.show_data_row (common.space$, 'For oral presentations only.');
   common.show_data_row ('Start Time', htf.formText ('stime', 5, 5) ||
				' Format: HHMI - no other puctuation.');
   common.show_data_row ('Duration', htf.formText ('dur', 5, 5));
   common.show_data_row ('Streaming Video URL',	htf.formText ('sv_URL', 50, 200));

end additional_sessions_prompts;

-- ***********************************************************************************************

procedure additional_sessions_add (aid integer) is

begin

   if common.header ('Additional Sessions') then
      common.show_abstract_title (aid);
      htp.para;
      htp.formOpen ('jacow.additional_sessions_save', 'POST');
      htp.formHidden ('aid', aid);

      htp.tableOpen;
      additional_sessions_prompts (aid);
      common.show_data_row (null, htf.formSubmit);
      htp.tableClose;
      htp.formClose;
      common.footer;
   end if;

end additional_sessions_add;

-- ***********************************************************************************************

procedure additional_sessions (aid integer) is

cursor	driver is
select	s.*, sa.presentation_code, sa.session_seq, sa.paper_id,
	nvl (sa.start_time, s.beg_time) start_time,
	sa.duration, sa.primary_flag, pc.presentation_descr,
	sa.abstract_session_id, sa.streaming_video_URL
from	presentation_codes	pc,
	sessions		s,
	abstract_sessions	sa
where	sa.abstract_id		= aid
and	s.session_id		= sa.session_id
and	pc.presentation_code	= sa.presentation_code
order by
	decode (sa.primary_flag, 'Y', 0, 1),
	s.sort_order nulls last,
	s.session_date,
	s.beg_time, s.end_time,
	sa.session_seq,
	sa.start_time;

type	rec_type is table of driver%ROWTYPE;

URL	varchar2(500);
recs	rec_type;

begin

   if common.header ('Additional Sessions') then
      open driver;
      fetch driver BULK COLLECT into recs;
      close driver;

      common.show_abstract_title (aid);
      htp.para;
      htp.anchor ('jacow.additional_sessions_add?aid=' || aid, 'Add New Session');
      htp.para;

      if recs.COUNT > 0 then
         htp.formOpen('jacow.additional_sessions_edt', 'POST');
         htp.formHidden('aid', aid);
         htp.tableOpen ('BORDER');
         htp.tableRowOpen ('LEFT', 'TOP');
         htp.tableHeader (common.space$);
         htp.tableHeader ('Program Code');
         htp.tableHeader ('Presentation Type');
         htp.tableHeader ('Start Time');
         htp.tableHeader ('Duration');
         htp.tableHeader ('Streaming Video URL');
         if recs.COUNT > 1 then
            htp.tableHeader (common.space$);
         end if;
         htp.tableRowClose;
      end if;

      for i in 1..recs.COUNT LOOP
         htp.tableRowOpen ('LEFT', 'TOP');

         if recs(i).primary_flag = 'Y' then
            htp.tableData ('Primary');
         else
            URL := 'jacow.additional_sessions_pri'	||
				'?asid=' || recs(i).abstract_session_id ||
				'&aid='	 || aid;
            htp.tableData (htf.anchor (URL, 'Make Primary'));
         end if;

         htp.tableData (recs(i).paper_id || htf.formHidden('asid', recs(i).abstract_session_id) );

         htp.p('<TD>');
         common.show_popup_table ('presentation_code', 'presentation_descr',
					'presentation_codes', '',
					recs(i).presentation_code, var_name=>'pcode');
         htp.p('</TD>');

         htp.tableData (htf.formText('stime',	4, 4, recs(i).start_time));
         htp.tableData (htf.formText('dur',	3, 3, recs(i).duration));
         htp.tableData (htf.formText('sv_URL',	50, 200, recs(i).streaming_video_URL));

         if recs(i).primary_flag = 'N' then
            URL := 'jacow.additional_sessions_del'	||
			'?asid='	|| recs(i).abstract_session_id ||
			'&aid='		|| aid;
            htp.tableData (htf.anchor (URL, 'Delete'));
         elsif recs.COUNT > 1 then
            htp.tableData (common.space$);
         end if;

         htp.tableRowClose;
      end loop;

      if recs.COUNT > 0 then
         htp.tableClose;
         htp.formSubmit(null, 'Save');
         htp.formClose;
      end if;
      common.footer;
   end if;

end additional_sessions;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure user_status3 (abs_id integer, action varchar2, text varchar2) is

cursor	driver is
select	user_validate_status
from	status_codes
where	status_code	=
	(	select	status_code
		from	abstracts
		where	abstract_id = abs_id);

new_status_code	status_codes.user_validate_status%TYPE;

begin

   common.get_gbl_pid;

   if action = 'Reject' and trim(replace(replace(text,common.eol$,null),common.cr$)) is null then
      common.public_header ('Editor Status');
      htp.header (3, 'You must supply a comment when rejecting an Editor''s change.');
      htp.p (common.click_back$);
      common.footer;

   elsif common.OK_to_edit_abstract (abs_id) then
      open driver;
      fetch driver into new_status_code;
      close driver;

      if action = 'Accept' then
	 update	abstracts	abs
	 set	abs.status_code = new_status_code
	 where	abstract_id	= abs_id;

	 insert into logs (abstract_id, log_code, status_code, comments)
	 values (abs_id, common.dot_reassignment$, new_status_code, trim(text));
      else
	 send_mail (common.editor_email$, 'Author Rejected Editor''s Change ' ||
			common.get_paper_id (abs_id),
			'Author''s comment: ' || trim (text),
			CC=>common.get_user_email (common.gbl_pid) );

	 insert into logs (abstract_id, log_code, comments)
	 values (abs_id, common.reject_ed_change$, trim(text));
      end if;

      common.redirect_URL (common.server || common.vdir$ || 'jacow.html');
   end if;

end user_status3;

-- ***********************************************************************************************

procedure user_status2 (abs_id integer) is

cursor	driver is
select	abs.title, abs.status_code, sc.user_validate_status
from	status_codes	sc,
	abstracts	abs
where	abs.abstract_id	= abs_id
and	sc.status_code	= abs.status_code;

rec	driver%ROWTYPE;

begin

   if common.header ('Editor Status') then
      open driver;
      fetch driver into rec;
      close driver;

      if rec.user_validate_status is null then
	 htp.header (3, 'There is nothing for you to review.');

      elsif common.OK_to_edit_abstract (abs_id) then

	 htp.header (3, 'Please Review The Editor''s Changes');
	 htp.anchor2 (common.get_paper_PDF (abs_id), 'Please review your paper', ctarget=>'_blank');
	 htp.p ('and the Editor''s comments (below).');
	 htp.p ('You may either accept or reject the Editor''s changes.');
	 htp.para;

	 htp.formOpen ('jacow.user_status3', 'POST', cattributes=>'target="_top"');
	 htp.formHidden ('abs_id', abs_id);

	 htp.p ('I ');
	 htp.formSelectOpen ('action');
	 htp.formSelectOption ('Accept', 'SELECTED');
	 htp.formSelectOption ('Reject');
	 htp.formSelectClose;
	 htp.p (' the Editor''s changes.');
	 htp.br;

	 htp.p ('Comments (required if rejecting). ');
	 htp.br;
	 htp.formTextArea ('text', 2, 50);
	 htp.br;

	 htp.formSubmit;
	 htp.formClose;

	 htp.tableOpen;
	 common.show_data_row ('Paper ID',	common.get_paper_id(abs_id) || common.space$ ||
						common.get_dot_image (rec.status_code, common.editor_dot$) );
	 common.show_data_row ('Title',		rec.title);

	 htp.tableRowOpen;
	 htp.tableHeader ('Full Log', 'RIGHT');
	 common.show_abstract_log (abs_id, false);
	 htp.tableClose;
      else
	 htp.header (3, no_privs$, cattributes=>common.red$);
      end if;

      common.footer;
   end if;

end user_status2;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure user_status (abs_id integer) is

begin

   common.get_gbl_pid;
   if common.OK_to_edit_abstract (abs_id) then
      user_status2 (abs_id);
   else
      common.public_header ('Editor Status');
      htp.header (3, no_privs$, cattributes=>common.red$);
      common.footer;
   end if;

end user_status;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure insert_author (abs_id integer, prof_id integer, code varchar2) is

begin

   insert into authors (abstract_id, profile_id, author_code)
   values (abs_id, prof_id, code);

   if code = common.co_author$ then
      profile.new_coauthor_email (abs_id, prof_id);
   end if;

end insert_author;

-- ***********************************************************************************************
-- ***********************************************************************************************

function set_label (true_txt varchar2, false_txt varchar2) return varchar2 is

begin

   if common.PC_mode$ = 'Y' then
      return (true_txt);
   end if;

   return false_txt;

end set_label;

-- ***********************************************************************************************
-- ***********************************************************************************************

function get_eclass_code (ccode varchar2, scode varchar2) return varchar2 is

cursor	driver is
select	eclass_code
from	eclass_codes
where	classification_code	= ccode
and	sub_class_code		= scode;

driver_rec	driver%ROWTYPE;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   return driver_rec.eclass_code;

end get_eclass_code;

-- ***********************************************************************************************

procedure validate_eclass_code (class varchar2, subclass varchar2) is

begin

   if class is null then
      raise_application_error (-20013, 'Abstract classification can not be null.');

   elsif common.require_sub_class$ = 'Y' then

      if subclass is null then
	 if common.user_is_jacow_admin then
	    null;
	 else
	    raise_application_error (-20014, 'Abstract sub-classification can not be null.');
	 end if;

      elsif get_eclass_code (class, subclass) is null then
	 raise_application_error (-20015, 'Abstract classification/sub-classification mis-match. ' ||
			class || '/' || subclass);

      end if;

   end if;

end validate_eclass_code;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure abstract_email (abstract_id integer, paper_id varchar2,
				new_title varchar2, new_description varchar2, new_classification_code varchar2,
				new_presentation_code varchar2, old_title varchar2, old_description varchar2,
				old_classification_code varchar2, old_presentation_code varchar2) is

msg		long := null;
subject$	constant varchar2(500) := common.conf_title$ || ' Abstract ' ||
						nvl (paper_id, abstract_id) || ' Changed';

begin

   if nvl (new_title, '~') <> nvl (old_title, '~') then
      msg := msg ||	'Old Title: ' || old_title || common.eol2$ ||
			'New Title: ' || new_title || common.eol2$;
   end if;

   if nvl (new_description, '~') <> nvl (old_description, '~') then
      msg := msg ||	'Old Description: ' || old_description || common.eol2$ ||
			'New Description: ' || new_description || common.eol2$;
   end if;

   if nvl (new_classification_code, '~') <> nvl (old_classification_code, '~') then
      msg := msg ||	'Old Classification: ' || common.decode_value ('classification_descr', 'classification_codes',
							'classification_code', old_classification_code) || common.eol$ ||
			'New Classification: ' || common.decode_value ('classification_descr', 'classification_codes',
							'classification_code', new_classification_code) || common.eol$;
   end if;

   if nvl (new_presentation_code, '~') <> nvl (old_presentation_code, '~') then
      msg := msg ||	'Old Presentation: ' || common.decode_value ('presentation_descr', 'presentation_codes',
							'presentation_code', old_presentation_code) || common.eol$ ||
			'New Presentation: ' || common.decode_value ('presentation_descr', 'presentation_codes',
							'presentation_code', new_presentation_code) || common.eol$;

   end if;

   if msg is not null then
      if search.requires_QA (abstract_id) = 'N' then -- requires initial QA

	 if paper_id is null then
	    msg := 'Contribution ID: ' || abstract_id || ' changed.' || common.eol2$ || msg;
	 else
	    msg := 'Paper ID: ' || paper_id || ' changed.' || common.eol2$ || msg;
	 end if;
	 msg := msg || common.server || common.vdir$ || 'search.abs_id?aid=' || abstract_id;

	 if common.email_upd_abstract$ = 'Y' then
	    send_mail (common.editor_email$, subject$, msg);
	 end if;

	 if common.email_LOC_upd_abstract$ = 'Y' then
	    send_mail (common.LOC_email_address$, subject$, msg);
	 end if;
      end if;

   end if;

end abstract_email;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure show_owner_info (abs_id integer) is

cursor	driver is
select	*
from	abstracts
where	abstract_id = abs_id;

driver_rec	driver%ROWTYPE;
buffer		varchar2(1000);

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   htp.header (3, 'Owner is: ' || common.get_user_name (driver_rec.person_id) );
   htp.tableOpen;
   common.show_data_row ('ID',	driver_rec.abstract_id);

   buffer := common.get_paper_id (abs_id);
   if buffer is not null AND common.hide_program_codes$ = 'N' then
      common.show_data_row ('Paper ID',	buffer);
   end if;

   label := set_label ('Speakers', 'Authors');

   common.show_data_row ('Title',	common.convert_text(driver_rec.title, common.html_fmt$));
   common.show_data_row (label,		common.get_author_list2(abs_id, true));
   htp.tableClose;

end show_owner_info;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure abs_log (abs_id integer) is

begin

   if common.header ('Abstract Log') then
      htp.p (profile.js$);
      show_owner_info (abs_id);
      htp.hr;

      htp.tableOpen;
      htp.tableRowOpen;
      common.show_abstract_log (abs_id, true);
      htp.tableRowClose;
      htp.tableClose;

      common.footer;
   end if;

end abs_log;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure change_owner3 (abs_id integer, new_id integer) is

begin

   if common.header ('Change Abstract owner') then
      update	abstracts
      set	person_id	= new_id
      where	abstract_id	= abs_id;

      htp.header (3, 'Change Complete');
      htp.bold ('Close this window to return to the alphabetical list.');

      common.footer;
   end if;

end change_owner3;

-- ***********************************************************************************************

procedure change_owner2 (abs_id integer, uid varchar2) is

new_id	integer;

begin

   if common.validate_number (uid) then
      new_id := uid;
   else
      new_id := common.decode_value ('person_id', 'persons', 'user_id', upper (UID) );
   end if;

   if common.header ('Change Abstract owner') then
      if new_id is null then
	 htp.header (3, 'New owner ID must be numeric.', cattributes=>common.red$);
	 htp.p (common.click_back$);
      else
	 show_owner_info (abs_id);
	 htp.header (3, 'You wish to make the new owner ' || common.get_user_name (new_id));

	 htp.formOpen ('jacow.change_owner3', 'POST');
	 htp.formHidden ('abs_id', abs_id);
	 htp.formHidden ('new_id', new_id);
	 htp.formSubmit (null, 'Yes');
	 htp.formClose;
      end if;

      common.footer;
   end if;

end change_owner2;

-- ***********************************************************************************************

procedure change_owner (abs_id integer) is

begin

   if common.header ('Change Abstract owner') then
      htp.p (profile.js$);
      show_owner_info (abs_id);
      htp.formOpen ('jacow.change_owner2', 'POST', cattributes=>'NAME="SPMS"');
      htp.formHidden ('abs_id', abs_id);
      htp.p ('Change Owner ID to: ');
      htp.formText ('uid', 20, 20);
      htp.anchor ('javascript:newWindow(''profile.find_account'')', 'Search for an Account');
      htp.br;
      htp.formSubmit;
      htp.formClose;
      common.footer;
   end if;

end change_owner;

-- ***********************************************************************************************
-- ***********************************************************************************************

function get_abstract_record (abs_id integer) return boolean is

cursor	driver is
select	1
from	profiles
where	profile_id	in
(	select	profile_id
	from	authors
	where	abstract_id	= abs_id
	and	author_code	in (common.primary_author$, common.speaker$, common.presenter$)
)
and	person_id = common.gbl_pid;

dummy		integer;
rec_found	boolean;

begin

   if abs_id is null then  -- new abstract
      return true;
   end if;

   open abstract_cursor (abs_id);
   fetch abstract_cursor into abstract_rec;
   rec_found := abstract_cursor%FOUND;
   close abstract_cursor;

   if NOT rec_found then
      return false; -- no such abstract record
   end if;

   if abstract_rec.person_id = common.gbl_pid then
      return true; -- owner can see their abstract
   end if;

   if common.PC_mode$ = 'Y' then
      return true; -- all PC members can see when in PC mode
   end if;

   if common.has_privs_to_page (common.jacow_admin$, false) then
      return true;
   end if;

   if common.has_privs_to_page (common.editor_page$, false) then
      return true;
   end if;

   if common.has_privs_to_page (common.sort_file_page$, false) then
      return true;
   end if;

-- Is the person fetching the abstract the primary author, or the speaker/presenter?
   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end get_abstract_record;

-- ***********************************************************************************************

function profile_exists return boolean is

cursor	driver is
select	1
from	profiles
where	person_id	= common.gbl_pid
and	deleted		is null;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end profile_exists;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure copyright_sigs is

begin

   htp.tableOpen (cattributes=>'CELLPADDING="5"');
   htp.tableRowOpen;
   htp.tableData (rpad ('_', 50, '_'));
   htp.tableData (rpad ('_', 20, '_'));
   htp.tableRowClose;

   htp.tableRowOpen;
   htp.tableData ('AUTHORIZED SIGNATURE');
   htp.tableData ('DATE' );
   htp.tableRowClose;
   htp.tableClose;
   htp.para;

end copyright_sigs;

-- ***********************************************************************************************

procedure copyright (this_id integer) is

cursor	driver is
select	*
from	abstracts
where	abstract_id = this_id;

driver_rec	driver%ROWTYPE;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   htp.p ('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">');
   htp.htmlOpen;
   htp.headOpen;
   htp.meta('GENERATOR', null, 'Oracle Web Agent');
   htp.meta (null, 'keywords',		'PAC');
   htp.meta (null, 'rating',		'General');
   htp.meta (null, 'revisit-after',	'31 days');
   htp.meta (null, 'ROBOTS',		'ALL');
   htp.meta (null, 'DC.Creator',	'Matt Arena');
   htp.title('IEEE Copyright Form');
   htp.headClose;
   htp.bodyOpen(null,'BGCOLOR="ffffff"');

   htp.header (3, common.get_paper_id (this_id), 'RIGHT');

   htp.header (1, 'IEEE COPYRIGHT FORM', 'CENTER');
   htp.p ('The IEEE has developed this form with great care and with the best interests');
   htp.p ('of its members and contributing authors in mind.  Therefore, in order to');
   htp.p ('maintain uniform treatment among all contributors, other forms may');
   htp.p ('not be substituted for this form, nor may any wording of this form be changed.');
   htp.p ('This form is intended for original material submitted to IEEE.  This form, when completed,');
   htp.p ('must accompany any such material in order to be published by IEEE.  Please');
   htp.p ('read it carefully and keep a copy of it for your files.');
   htp.para;

   htp.p ('TITLE OF PAPER (hereinafter, "the work"):');
   htp.p (common.space2$);
   htp.bold (common.convert_text(driver_rec.title, common.html_fmt$));
   htp.para;

   htp.p ('AUTHORS:');
   htp.p (common.space2$);
   htp.p (common.get_author_list2(this_id, true));
   htp.para;

   htp.p ('PUBLICATION TITLE/DATE:');
   htp.p (common.space2$);
   htp.p (common.conf_title$ || ' Proceedings');
   htp.para;

   htp.hr;
   htp.para;

   htp.header (3, 'PART A -- COPYRIGHT TRANSFER FORM', 'CENTER');
   htp.p ('(U.S. Government employees whose work is not subject to U.S. copyright should');
   htp.p ('so certify by signing Part B below.	Authors of works subject to Crown');
   htp.p ('Copyright should sign Part C below.)');
   htp.para;

   htp.p ('The undersigned hereby assigns all copyright rights in and to the above work');
   htp.p ('to The Institute of Electrical and Electronics Engineers, Inc. (the "IEEE").');
   htp.p ('The undersigned hereby represents and warrants that the work is original and');
   htp.p ('that he/she is the author of the work, except possibly for material such as');
   htp.p ('text passages, figures, and data that clearly identify the original source,');
   htp.p ('with permission notices from the copyright owners where required.  The');
   htp.p ('undersigned represents that he/she has the power and authority to make and');
   htp.p ('execute this assignment.');
   htp.para;

   htp.p ('In return for these rights, the IEEE recognizes the retained rights noted in');
   htp.p ('Items 1 and 4 below, and grants to the above authors and employers for whom');
   htp.p ('the work may have been performed a royalty-free license to use the material as');
   htp.p ('noted in Items 2 and 3.  Item 5 stipulates that authors and employers must');
   htp.p ('seek permission to republish in cases not covered by Items 2, 3, and 4.');
   htp.para;

   htp.olistOpen;
   htp.listItem ('Employers (or authors) retain all proprietary rights in any process, '	||
	'procedure, or article of manufacture described in the work.');
   htp.para;

   htp.listItem ('Authors/employers may reproduce or authorize others to reproduce the above '	||
	'work, material extracted verbatim from the above work, or derivative works for '	||
	'the author''s personal use or for company use provided that the source and the '	||
	'IEEE copyright notice are indicated, that the copies are not used in any way '		||
	'that implies IEEE endorsement of a product or service of an employer, and that '	||
	'the copies themselves are not offered for sale.  (See "Author/Company Rights" '	||
	'overleaf.)');
   htp.para;

   htp.listItem ('Authors/employers may make limited distribution of all or portions of the '	||
	'above work prior to publication if they inform the IEEE of the nature and '		||
	'extent of such limited distribution prior thereto.');
   htp.para;

   htp.listItem ('In the case of work performed under a U.S. Government contract or grant, '	||
	'IEEE recognizes that the U.S. Government has royalty-free permission to '		||
	'reproduce all or portions of the above work, and to authorize others to do so, '	||
	'for official U.S. Government purposes only, if the contract/grant so requires. '	||
	'(Appropriate documentation may be attached, but IEEE''s Copyright Form MUST BE '	||
	'SIGNED.)');
   htp.para;

   htp.listItem ('For all circumstances not covered by Items 2, 3, and 4, authors/employers '	||
	'must request permission from the IEEE Copyrights Office to reproduce or '		||
	'authorize the reproduction of the work or material extracted verbatim from the '	||
	'work, including figures and tables.');
   htp.olistClose;

   htp.p ('Please note that, although authors are permitted to reuse all or portions of');
   htp.p ('their IEEE-copyrighted material in other works, this does not include granting');
   htp.p ('third party requests for reprinting, republishing, or other types of re-use.');
   htp.p ('All third party requests must be handled by the IEEE Copyrights Permissions Office.');
   htp.para;

   htp.p ('In the event the above work is not accepted and published by the IEEE or is');
   htp.p ('withdrawn by the author(s) before acceptance by the IEEE, this agreement');
   htp.p ('becomes null and void.');
   htp.para;

   copyright_sigs;

   htp.header (3, 'JOINT AUTHORSHIP');
   htp.p ('For jointly authored works, all the joint authors should sign, or one of the');
   htp.p ('authors should sign as an authorized agent for the others.  In the case of');
   htp.p ('multiple authorship where one or more authors are Government employees but at');
   htp.p ('least one author is not, the non-Government author should sign Part A of this');
   htp.p ('copyright transfer form.');
   htp.para;
   htp.fontOpen (csize=>'-1');
   htp.p ('revised 6/97');
   htp.fontClose;
   htp.hr;

   htp.header (3, 'PART B -- U.S. GOVERNMENT EMPLOYEE CERTIFICATION', 'CENTER');
   htp.p ('Authors who are U.S. Government employees are not required to sign Part A of');
   htp.p ('the IEEE Copyright Form, but any coauthors outside the U.S. Government are');
   htp.p ('required to sign Part A (see JOINT AUTHORSHIP above).  Authors whose work');
   htp.p ('was performed under a U.S. Government contract or grant, but who are not');
   htp.p ('Government employees, are required to sign Part A of this form.');
   htp.p ('(Note:  If your work was performed under U.S. Government contract but you');
   htp.p ('are not a U.S. Government employee, sign Part A of this form and see item 4).');
   htp.para;

   htp.p ('This will certify that all authors of the above work are employees of the U.S.');
   htp.p ('Government and performed this work as part of their official duties and that');
   htp.p ('the work is therefore not subject to U.S. copyright protection.');
   htp.para;

   copyright_sigs;

   htp.hr;
   htp.header (3, 'PART C -- CROWN COPYRIGHT', 'CENTER');
   htp.p ('Authors who are employees of the British Government (or a British Commonwealth');
   htp.p ('Government) and whose works are subject to Crown Copyright may sign Part C');
   htp.p ('below. IEEE recognizes and will honor Crown Copyright as it does U.S.');
   htp.p ('Copyright.  It is understood that, in asserting Crown Copyright, IEEE in no');
   htp.p ('way diminishes its rights as publisher.  Sign only if ALL authors are subject');
   htp.p ('to Crown Copyright.	Signing Part C will certify that all authors of the above');
   htp.p ('work are subject to Crown Copyright.  (Appropriate documentation and');
   htp.p ('instructions regarding wording of Crown Copyright notice may be attached.)');
   htp.para;

   copyright_sigs;

   htp.para;
   htp.hr;
   htp.para;

   htp.header (3, 'Notes and Information for Authors and Their Employers', 'CENTER');
   htp.header (3, 'IEEE POLICY');
   htp.fontOpen (csize=>'-1');

   htp.p ('In connection with its publishing activities, it is the formal policy of the');
   htp.p ('IEEE to own the copyrights to all copyrightable material in its technical');
   htp.p ('publications and to the individual contributions contained therein, in order');
   htp.p ('to protect the interests of the IEEE, its authors and their employers, and, at');
   htp.p ('the same time, to facilitate the appropriate reuse of this material by');
   htp.p ('others.  The IEEE distributes its technical publications throughout the world');
   htp.p ('and does so by various means such as hard copy, microfiche, microfilm, and');
   htp.p ('electronic media.  It also abstracts and may translate its publications, and');
   htp.p ('articles contained therein, for inclusion in various compendiums and similar');
   htp.p ('publications, etc.  When an article is submitted  to the IEEE for publication,');
   htp.p ('the IEEE understands that its acceptance of the article implies that IEEE has');
   htp.p ('the rights to do all of the things it normally does with such an article.');
   htp.para;

   htp.p ('IEEE Policy 6.17 -- CLEARANCE OF PAPERS -- applies to all material submitted');
   htp.p ('to IEEE:  "The IEEE must of necessity assume that material presented at its');
   htp.p ('meetings or submitted to its publications is properly available for general');
   htp.p ('dissemination to the audiences these activities are organized to serve.  It is');
   htp.p ('the responsibility of the authors, not the IEEE, to determine whether');
   htp.p ('disclosure of their material requires the prior consent of other parties and,');
   htp.p ('if so, to obtain it."');
   htp.para;

   htp.p ('Furthermore, the IEEE must assume, if an author uses within his/her article');
   htp.p ('material that has been previously published and/or is copyrighted by another party,');
   htp.p ('that permission has been obtained for such use and that any required credit lines,');
   htp.p ('copyright notices, etc., are duly noted.');
   htp.fontClose;

   htp.header (3, 'IEEE OBLIGATIONS');
   htp.fontOpen (csize=>'-1');
   htp.p ('In exercising its rights under copyright, the IEEE will make all reasonable');
   htp.p ('efforts to act in the interests of the authors and employers as well as in its');
   htp.p ('own interest.  In handling third-party  reprint/republication requests for an');
   htp.p ('IEEE work, the IEEE requires that 1) the consent of the first-named author be');
   htp.p ('sought as a condition in granting republication (of a full paper) to others;');
   htp.p ('and 2) the consent of the employer be obtained as a condition in granting');
   htp.p ('permission to others to reuse all or portions of a paper for promotion or');
   htp.p ('marketing purposes.');
   htp.fontClose;

   htp.header (3, 'AUTHOR/COMPANY RIGHTS');
   htp.fontOpen (csize=>'-1');
   htp.p ('If you are employed and you prepared your paper as a part of your job, the');
   htp.p ('rights to your work rest initially  with your employer.  In that case, when');
   htp.p ('you sign the copyright transfer form, we assume you are authorized to do so by');
   htp.p ('your employer and that your employer has consented to all the terms and');
   htp.p ('conditions of this form.  If not, it should be signed by someone so');
   htp.p ('authorized. (See also Policy 6.17 above.)');
   htp.para;

   htp.p ('SPECIAL NOTE TO EMPLOYERS: Just as the IEEE requires a signed copyright');
   htp.p ('transfer form (for copyrightable material) in order to do "business as usual,"');
   htp.p ('it is the intent of the transfer portion of the form to return rights to the');
   htp.p ('author and employer so that they, too, may do "business as usual."');
   htp.fontClose;
   htp.para;

   htp.centerOpen;
   htp.p ('PLEASE DIRECT ALL QUESTIONS ABOUT IEEE COPYRIGHT POLICY OR THIS FORM TO:');
   htp.br;
   htp.p ('Manager, Copyrights and Trademarks, IEEE Service Center, 445 Hoes Lane, P.O.');
   htp.p ('Box 1331, Piscataway, NJ 08855-1331.  Telephone: (908) 562-3966.');
   htp.centerClose;

   htp.bodyClose;
   htp.htmlClose;

end copyright;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure set_assignable (abs_id integer, this_file_type varchar2) is

begin

   update abstracts a
   set	  assignable =
	(
	select	sum (nvl (weight, 0) )
	from	presentation_file_codes
	where	file_type_code in
	(	select	file_type_code
		from	files
		where	abstract_id	= a.abstract_id
	)
	and	presentation_code =
	(	select	presentation_code
		from	abstracts
		where	abstract_id	= a.abstract_id
	))
   where  abstract_id = abs_id;

end set_assignable;

-- ***********************************************************************************************

procedure remove_file2 (fid integer, pid varchar2) is

cursor	driver is
select	*
from	files
where	file_id = fid;

driver_rec	driver%ROWTYPE;

begin

   common.get_gbl_pid;
   open driver;
   fetch driver into driver_rec;
   close driver;

   if common.OK_to_edit_abstract (driver_rec.abstract_id, true) then
      delete from files where file_id = fid;
      set_assignable (driver_rec.abstract_id, driver_rec.file_type_code);
      common.redirect_URL ('JACoW.file_info?abs_id=' || driver_rec.abstract_id ||
					'&paper_id=' || pid);

   else
      common.public_header ('File Removal');
      htp.header (3, no_privs$, cattributes=>common.red$);
      htp.formOpen ('jacow.html');
      htp.formSubmit (null, 'Continue');
      htp.formClose;
      common.footer;

   end if;

end remove_file2;

-- ***********************************************************************************************

procedure remove_file (fid integer, pid varchar2) is

cursor	driver is
select	*
from	files
where	file_id = fid;

driver_rec	driver%ROWTYPE;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   common.public_header ('File Removal');
   htp.header (3, 'Are you sure you want to remove the file ' || driver_rec.file_name || '?');

   if driver_rec.file_type_code in ('SRC', 'PS') then
      htp.fontOpen ('RED');
      htp.bold ('Note:');
      htp.p ('Removing a source file or Post Script file may delay the editing of your paper.');
      htp.fontClose;
   end if;


   htp.tableOpen;
   htp.tableRowOpen;

   htp.p ('<TD>');
      htp.formOpen ('jacow.remove_file2', 'POST');
      htp.formHidden ('fid', fid);
      htp.formHidden ('pid', pid);
      htp.formSubmit (null, 'Yes, remove the file.');
      htp.formClose;
   htp.p ('</TD>');

   htp.p ('<TD>');
      htp.formOpen ('jacow.file_info', 'POST');
      htp.formHidden ('abs_id', driver_rec.abstract_id);
      htp.formHidden ('paper_id', pid);
      htp.formSubmit (null, 'No, return to file list.');
      htp.formClose;
   htp.p ('</TD>');

   htp.tableRowClose;
   htp.tableClose;

   common.footer;

end remove_file;

-- ***********************************************************************************************

procedure upload_file_failed (abs_id integer, paper_id varchar2, err_msg varchar2) is

begin

   common.public_header ('File Upload Failed');
   htp.bold (common.font2 ('The file upload failed for the following reason(s).') );
   htp.para;

   htp.ulistOpen;
   htp.p (err_msg);
   htp.ulistClose;

   htp.tableOpen;
   htp.tableRowOpen;
   htp.tableData (	htf.formOpen ('JACoW.file_info', 'POST')		||
			htf.formHidden ('abs_id', abs_id)			||
			htf.formHidden ('paper_id', paper_id)			||
			htf.formSubmit (null, 'Try Again')			||
			htf.formClose);

   htp.tableData (	htf.formOpen ('JACoW.html', 'POST')			||
			htf.formSubmit (null, 'Back To Your Abstract List')	||
			htf.formClose);
   htp.tableRowClose;
   htp.tableClose;

   common.footer;

end upload_file_failed;

-- ***********************************************************************************************

function email_referee (abs_id integer, paper_id varchar2, title varchar2) return boolean is

cursor	driver is
select	person_id
from	referee_abstracts
where	abstract_id		= abs_id;

mrec		mail_blats%ROWTYPE;
email_sent	boolean := false;

begin

   for driver_rec in driver LOOP
      mrec.recipient	:= common.get_user_email (driver_rec.person_id);
      mrec.cc		:= common.editor_email$;
      mrec.subject	:= common.conf_title$ || ' Paper Ready for Refereeing';
      mrec.message	:= 'Dear, ' || common.get_user_name (driver_rec.person_id)	|| common.eol2$	||
				trim (common.referee_notice$)				|| common.eol2$	||
				paper_id || ' ' || title				|| ' ' ||
				common.server || common.vdir$ || 'profile.login?URL=referee.html';
     send_mail (mrec.recipient, mrec.subject, mrec.message, cc=>mrec.cc);
     email_sent := true;
   end loop;

   return email_sent;

end email_referee;

-- ***********************************************************************************************

procedure assign_referee (abs_id integer, ccode varchar2) is

cursor	driver is
select	person_id, referee.papers_assigned (person_id) icount
from	experts
where	classification_code	= ccode
and	referee			= 'Y'
order by 2;

driver_rec	driver%ROWTYPE;

begin

-- cursor finds all experts for the paper's classifcation then
-- assignes it to the referee with the fewest papers

   open driver;
   fetch driver into driver_rec;

   if driver%FOUND then
      insert into referee_abstracts (person_id, abstract_id)
	values (driver_rec.person_id, abs_id);
   end if;

   close driver;

end assign_referee;

-- ***********************************************************************************************

procedure upload_file_succeeded (pid varchar2, abs_id integer, this_file_type varchar2,
				this_platform varchar2, file_name varchar2, comments varchar2,
				paper_id varchar2) is

ipos		integer := length (file_name);
referee_code	abstracts.referee_code%TYPE;
dummy		boolean;
short_filename	files.file_name%TYPE;
buffer		logs.comments%TYPE;

begin

   common.gbl_pid := common.decrypt (pid);
   LOOP
      exit when ipos = 0;
      exit when substr (file_name, ipos, 1) = '/';
      ipos := ipos - 1;
   end loop;

   if substr (file_name, ipos, 1) = '/' then
      ipos := ipos + 1;
   end if;

-- **********

   short_filename := substr(file_name, ipos);
   if trim (comments) is not null then
      buffer := short_filename || common.space2$ ||
		'<B>Author Comments:</B>' || common.space2$ || trim (comments);
   end if;

-- **********

   insert into files (abstract_id, file_name, file_type_code, platform_code, paper_id, comments)
   values (abs_id, short_filename, this_file_type, this_platform, paper_id, comments);

-- **********

   set_assignable (abs_id, this_file_type);
/*
   if	common.referee_conf$ = 'Y'			AND
	trim (common.referee_notice$) is not null	AND
	this_file_type = common.PDF_file$		then

      referee_code := common.decode_value ('referee_code', 'abstracts', 'abstract_id', abs_id);
      if referee_code is null then -- send email to referee on 1st upload only
	 if NOT email_referee (abs_id) then
	    if common.referee_auto_assign$ = 'Y' then
	       assign_referee (abs_id);
	       dummy := email_referee (abs_id);
	    end if;
	 end if;
      end if;

   end if;
*/
   common.redirect_URL ('JACoW.file_info?abs_id=' || abs_id || '&paper_id=' || paper_id);

end upload_file_succeeded;

-- ***********************************************************************************************

procedure upload_file_succeeded (abs_id integer, this_file_type varchar2,
				this_platform varchar2, file_name varchar2, comments varchar2,
				paper_id varchar2) is

begin

   common.get_gbl_pid;
   upload_file_succeeded (common.encrypt (common.gbl_pid), abs_id, this_file_type,
			this_platform, file_name, comments, paper_id);

end upload_file_succeeded;

-- ***********************************************************************************************

/*  Important -- This routine is for testing purposes only.  I do not recommened using this for
		 production purposes.  Use and external Perl or PHP script file server to upload
		 files.
*/

procedure upload_file (abs_id integer, paper_id varchar2, validated varchar2,
		this_file_type varchar2, this_platform varchar2, file_name varchar2,
		root_dir varchar2, return_URL varchar2) is

failed	boolean := false;
buffer	varchar2(2000) := null;

begin

   if this_file_type is null then
      buffer := buffer || htf.listItem ('You must specify a file type.');
      failed := true;
   end if;

   if this_platform is null then
      buffer := buffer || htf.listItem ('You must specify a platform.');
      failed := true;
   end if;

   if file_name is null then
      buffer := buffer || htf.listItem ('You must upload a file.');
      failed := true;
   end if;

   if this_file_type = 'PS' then -- Postscript file
      if upper (file_name) NOT like '%.PS' then
	 buffer := buffer || htf.listItem ('A postscript filename must end with .PS suffix.');
	 failed := true;
      end if;
   end if;

   if this_file_type = 'SRC' then -- Source file
      if NOT (upper (file_name) like '%.DOC' OR upper (file_name) like '%.TEX') then
	 buffer := buffer || htf.listItem ('A source filename must end with .DOC or .TEX suffix.');
	 failed := true;
      end if;
   end if;

   if validated = 'NO' then
      buffer := buffer || 'JavaScript did not execute.';
      failed := true;
   end if;

   if failed then
      common.redirect_URL ('JACoW.upload_file_failed?abs_id=' || abs_id || '&err_msg=' || buffer);

   else
      common.redirect_URL ('JACoW.upload_file_succeeded'			||
				'?abs_id='		|| abs_id		||
				'&this_file_type='	|| this_file_type	||
				'&this_platform='	|| this_platform	||
				'&file_name='		|| file_name);
   end if;

end upload_file;

-- ***********************************************************************************************

procedure show_file_list (abs_id integer, pid varchar2) is

cursor	driver is
select	f.*, pfc.editor_only
from	presentation_file_codes	pfc,
	file_type_codes		fc,
	files			f,
	abstract_sessions	sa
where	sa.abstract_id		= abs_id
and	sa.paper_id		= pid
and	f.abstract_id		= sa.abstract_id
and	fc.file_type_code	= f.file_type_code
and	pfc.presentation_code	= sa.presentation_code
and	pfc.file_type_code	= fc.file_type_code
order by
	f.file_type_code, f.uploaded_date desc;

delete_link	boolean;
editor		boolean := common.has_privs_to_page (common.editor_page$, false);
person_id	integer := common.decode_value ('person_id', 'abstracts', 'abstract_id', abs_id);
status_code	constant status_codes.status_code%TYPE := common.decode_value ('status_code',
							'abstracts', 'abstract_id', abs_id);

begin

   htp.anchor ('JACoW.html', 'Back To Your Abstract List');
   htp.para;

   htp.tableOpen ('BORDER');

   htp.tableRowOpen ('LEFT', 'BOTTOM');
   htp.tableHeader ('File Name');
   htp.tableHeader ('File Type');
   htp.tableHeader ('Platform');
   htp.tableHeader ('Uploaded');
   htp.tableData (common.space$);
   htp.tableRowClose;

   for driver_rec in driver LOOP
      delete_link := false;
      if editor then
	 delete_link := true;
      elsif status_code is null AND driver_rec.editor_only = 'N' then
         if common.gbl_pid in (person_id, common.get_presenter_person_id (abs_id)) then
            delete_link := true;
         end if;
      end if;

      htp.tableRowOpen ('LEFT', 'TOP');
      htp.tableData (driver_rec.file_name);
      htp.tableData (common.decode_value ('file_type_descr', 'file_type_codes', 'file_type_code', driver_rec.file_type_code) );
      htp.tableData (common.decode_value ('platform_descr', 'platform_codes', 'platform_code', driver_rec.platform_code) );
      htp.tableData (common.local_time (driver_rec.uploaded_date));

      if delete_link then
	 htp.tableData (htf.anchor ('jacow.remove_file'	||
					'?fid=' || driver_rec.file_id	||
					'&pid=' || pid,
				'Remove'));
      else
	 htp.tableData (common.space$);
      end if;
      htp.tableRowClose;
   end loop;

   htp.tableClose;

end show_file_list;

-- ***********************************************************************************************

procedure file_type_popup (abs_id integer, pid varchar2) is

cursor	driver is
select	*
from	pfile_type_codes
where	presentation_code	=
(	select	presentation_code
	from	abstracts
	where	abstract_id	= abs_id)
order by file_type_descr;

primary_pid	constant boolean := common.primary_paper_id (pid);
OK_2upload	constant boolean := common.ok_to_upload_files (abs_id);
transp		constant boolean := common.transp_uploadable (abs_id);
editor		constant boolean := common.has_privs_to_page (common.editor_page$, false);
add		boolean;

begin

   htp.tableRowOpen ('LEFT', 'TOP');
   htp.tableHeader ('File Type', 'RIGHT');

   htp.p ('<TD>');
   htp.formSelectOpen ('this_file_type');
   htp.formSelectOption ('', 'SELECTED');

   for rec in driver LOOP
      add := OK_2upload;

      if transp and rec.always_available = 'Y' then
	 add := true;
      end if;

      if rec.editor_only = 'Y' then
	 if editor then
	    add := true;
	 else
	    add := false;
	 end if;
      end if;

      if NOT primary_pid AND rec.upload_2nd_codes = 'N' then
         add := false;
      end if;

      if add then
	 htp.formSelectOption (rec.file_type_descr, cattributes=>'VALUE="' ||
					rec.file_type_code || '"');
      end if;
   end loop;

   htp.formSelectClose;

end file_type_popup;

-- ***********************************************************************************************

procedure file_info (abs_id integer, paper_id varchar2 default null) is

-- Find the most frequently used platform code.
cursor	driver is
select	platform_code, count(1)
from	files
where	abstract_id = abs_id
group by
	platform_code
order by
	count(1) desc;

driver_rec	driver%ROWTYPE;
status_code$	constant abstracts.status_code%TYPE := common.decode_value (
					'status_code', 'abstracts', 'abstract_id', abs_id);
PDF		file_type_codes.file_type_code%TYPE := null;
role		varchar2(10) := 'AUTHOR';
verify_txt$	char(98) := 'Please verify the Title, the Abstract Text, and the Author list before proceeding with the upload.';
is_editor$	boolean;

begin

   common.get_gbl_pid;
   common.public_header ('File Upload');
   is_editor$ := common.has_privs_to_page (common.editor_page$, false);

--

   if NOT is_editor$ then
      htp.header (3, verify_txt$, cattributes=>common.red$);
      htp.formOpen ('jacow.verify_for_upload', 'POST', '_blank');
      htp.formHidden ('abs_id', abs_id);
      htp.formHidden ('paper_id', paper_id);
      htp.formSubmit (null, 'Click here to verify the Title, Abstract Text, and Author List');
      htp.formClose;
   end if;

   common.show_abstract_title (abs_id, paper_id);

   if common.OK_to_upload_files (abs_id) or common.transp_uploadable (abs_id) then
      if common.file_upload_instr_URL$ is not null then
	 htp.anchor (common.file_upload_instr_URL$, 'File Upload Instructions');
	 htp.para;
      end if;

      if is_editor$ then
	 role := 'EDITOR';
      elsif referee.is_a_referee then
	 role := 'REFEREE';
      end if;

      htp.p ('<script language="JavaScript" src="' || common.server ||
			common.vdir$ || 'JACoW.js"></script>');

      htp.formOpen (common.author_upload_script$, 'POST', cenctype=>'multipart/form-data',
		cattributes=>'NAME="FILE_UPLOAD" onSubmit="return validateFileForm()"');
      htp.formHidden ('pid', common.encrypt (common.gbl_pid));
      htp.formHidden ('abs_id', abs_id);
      htp.formHidden ('paper_id', paper_id);
      htp.formHidden ('validated', 'NO');
      htp.formHidden ('role', role);
      htp.formHidden ('hcheck', upper(RAWTOHEX(UTL_RAW.cast_to_raw(dbms_obfuscation_toolkit.md5(input_string => common.pass_phrase_paper_upload$ ||paper_id)))));
      htp.formHidden ('return_URL', common.server || common.vdir$);

      if is_editor$ then
         htp.formHidden ('source_verified', 'Y');
      else
         htp.formHidden ('source_verified', 'N');
      end if;

      htp.tableOpen;

      open driver;
      fetch driver into driver_rec;
      close driver;

      file_type_popup (abs_id, paper_id);
      common.show_lookup_table ('platform',		'Platform', driver_rec.platform_code);
      common.show_data_row ('File to Upload',		'<INPUT TYPE="FILE" NAME="file_name">');
      common.show_data_row ('Comments (Optional)',	htf.formText ('comments', 50, 3500) );

      if common.template_guidelines$ is not null AND
	 NOT is_editor$ then
         common.show_data_row (null, htf.bold ('Please read the ' ||
			htf.anchor2 (common.template_guidelines$, 'JACoW Template Checklist', ctarget=>'_blank') ||
					htf.br || ' document before uploading your manuscript.',
			cattributes=>common.red$));
      end if;

      if is_editor$ then
         common.show_data_row (null, htf.formSubmit (null, 'Upload File'));
      else
         common.show_data_row (null, htf.formSubmit (null, 'Upload File',
			cattributes=>'onclick="return (template_guidelines());"'));
      end if;

      htp.tableClose;
      htp.formClose;

      show_file_list (abs_id, paper_id);
    else
      htp.header (3, 'You may not upload files at this time.');
   end if;

   common.footer;

end file_info;

-- ***********************************************************************************************

procedure verify_for_upload (abs_id integer, paper_id varchar2) is

begin

   common.get_gbl_pid;
   common.public_header ('Abstract and Author List Verification');
   htp.p ('<script language="JavaScript" src="' || common.server ||
			common.vdir$ || 'JACoW.js"></script>');

   view_abstract2 (abs_id, 'N');

   htp.para;
   htp.bold ('Please verify the Title, Abstract and Author(s) as previously', cattributes=>common.red$);
   htp.bold ('entered into the SPMS, as shown above, exactly match, as far', cattributes=>common.red$);
   htp.bold ('as is technically possible, the source file you are about to upload.', cattributes=>common.red$);
   htp.para;
   htp.p ('If they do not match please');
   htp.ulistOpen;
      htp.listItem (htf.anchor2 ('jacow.edit_abstract?abs_id=' || abs_id || '&verify=Y',
					'Edit the title/abstract,', ctarget=>'_blank'));
      htp.listItem (htf.anchor2 ('jacow.abs_authors?abs_id=' || abs_id || '&verify=Y',
					'Update the author list,', ctarget=>'_blank'));
      htp.listItem ('or Edit your paper prior to uploading.');
   htp.ulistClose;
   htp.para;

   htp.p ('<button onclick="return (validatedSource());">Verified</button>');

   common.footer;

end verify_for_upload;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure add_profile (abs_id integer, this_profile_id integer) is

cursor	driver is
select	1
from	authors
where	abstract_id	= abs_id
and	profile_id	= this_profile_id
and	author_type	= common.author$;

cursor	C2 (code$ varchar2) is
select	1
from	authors
where	abstract_id	= abs_id
and	author_code	= code$;

begin

   common.get_gbl_pid;
   if common.valid_entry then

-- ***	Is there a primary author?
      open C2 (common.primary_author$);
      fetch C2 into dummy;
      rec_found := C2%FOUND;
      close C2;

      if NOT rec_found then -- add as the primary author
	  insert_author (abs_id, this_profile_id, common.primary_author$);
      end if;

-- Is this person already an author?
      open driver;
      fetch driver into dummy;
      rec_found := driver%FOUND;
      close driver;

      if NOT rec_found then -- add as a co-author
	  insert_author (abs_id, this_profile_id, common.co_author$);
      end if;

-- ***	Is there a speaker?
      open C2 (common.speaker$);
      fetch C2 into dummy;
      rec_found := C2%FOUND;
      close C2;

      if NOT rec_found then -- add as the speaker
	  insert_author (abs_id, this_profile_id, common.speaker$);
      end if;

   end if;

end add_profile;

-- ***********************************************************************************************

procedure repo_add_profile (auth_id integer, abs_id integer, prof_id integer) is

-- Called via the repository site.

begin

   sync.one_person (auth_id);
   add_profile (abs_id, prof_id);
   common.redirect_URL ('JACoW.abs_authors?abs_id=' || abs_id);

end repo_add_profile;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure save_profile (pid varchar2, URL varchar2, abs_id integer, author_id integer,
			orig_addr_id integer, this_addr_id integer, email varchar2) is

cursor	driver is
select	1
from	profiles
where	person_id	= author_id
and	address_id	= this_addr_id;

new_URL		varchar2(500) := common.decrypt (URL);
continue	boolean := true;
buffer		long	:= null;
new_profile_id	integer;
dummy		integer;
rec_found	boolean;
this_affil_id	constant integer := common.decode_value ('affiliation_id', 'addresses',
							 'address_id', this_addr_id);

begin

   if common.valid_pid (pid) and common.valid_referer (new_URL) then

      if this_addr_id is null then
	 buffer		:= buffer || htf.header (3, 'You must specify an affiliation');
	 continue	:= false;
      end if;

      if email is null then
	 buffer		:= buffer || htf.header (3, 'You must specify an email address');
	 continue	:= false;
      end if;

      open driver;
      fetch driver into dummy;
      rec_found := driver%FOUND;
      close driver;

      if rec_found then
	 buffer		:= buffer || htf.header (3, common.get_user_name (author_id)	||
							' is already affiliated with '	||
					common.get_affil_name (this_affil_id) );
	 continue	:= false;
      end if;

      if continue then
	 select profile_id_seq.nextval into new_profile_id from dual;
	 insert into profiles (profile_id, person_id, address_id, email_address)
	 values (new_profile_id, author_id, this_addr_id, email);

	 common.redirect_URL (new_URL || 'JACoW.repo_add_profile'		||
					'?auth_id='	|| author_id		||
					'&abs_id='	|| abs_id		||
					'&prof_id='	|| new_profile_id);

      else
	 common.public_header ('Add Author Affiliation');
	 common.show_abstract_title (abs_id);
	 htp.para;
	 htp.bold ('Author: ' || common.get_user_name (author_id) );
	 htp.p (buffer);
	 htp.p (common.click_back$);
	 common.footer;
      end if;

   else

      common.public_header ('Add Author Failed');
      htp.header (3, 'Invalid Entry or Server Not Recognized by the JACoW Administrator.', cattributes=>common.red$);
      common.footer;

   end if;

end save_profile;

-- ***********************************************************************************************

procedure create_profile (abs_id integer, author_id integer) is

cursor	driver is
select	email_address, count(1)
from	profiles
where	person_id	= author_id
and	email_address	is not null
group by email_address
order by 2 desc;

driver_rec	driver%ROWTYPE;

begin

   common.public_header ('Add Author Affiliation');
   if common.valid_entry then

      open driver;
      fetch driver into driver_rec;
      close driver;

      htp.p (profile.js$);
      common.show_abstract_title (abs_id);
      htp.para;
      htp.bold ('Author: ' || common.get_user_name (author_id) );


      htp.formOpen (common.repo_profile_URL$ || 'JACoW.save_profile', 'POST',
		cattributes=>'NAME="edt_profile" onSubmit="return validateAffilAddr()"');
      htp.formHidden ('pid', common.encrypt (common.gbl_pid));
      htp.formHidden ('URL', common.encrypt (common.server || common.vdir$));
      htp.formHidden ('abs_id', abs_id);
      htp.formHidden ('author_id', author_id);

      htp.tableOpen;
      profile.show_affil_addr_popup (null);
      common.show_data_row (common.red ('Email*'), htf.formText ('email', 30, 100, driver_rec.email_address) );
      common.show_data_row (null, htf.formSubmit);

      htp.tableClose;
      htp.formClose;
   end if;
   common.footer;

end create_profile;

-- ***********************************************************************************************

procedure select_profile2 (abs_id integer, pid integer, this_profile_id integer) is

begin

   common.get_gbl_pid;

   if this_profile_id is null then
      create_profile (abs_id, pid);

   elsif common.valid_entry then
      add_profile (abs_id, this_profile_id);
      common.redirect_URL ('JACoW.abs_authors?abs_id=' || abs_id);

   end if;

end select_profile2;

-- ***********************************************************************************************

procedure select_profile (abs_id integer, pid integer) is

cursor	driver is
select	pro.email_address, pro.profile_id,
	common.get_affil_name (affil.affiliation_id)	affiliation,
	common.get_address (pro.address_id, htf.br)	address
from	affiliations		affil,
	addresses		addr,
	profiles		pro
where	pro.person_id		= pid
and	pro.deleted		is null
and	addr.address_id		= pro.address_id
and	affil.affiliation_id	= addr.affiliation_id
order by
	affil.name1;

begin

   htp.bold ('Author: ' || common.get_user_name (pid) );

   htp.formOpen ('JACoW.select_profile2', 'POST');
   htp.formHidden ('abs_id', abs_id);
   htp.formHidden ('pid', pid);

   htp.bold ('Select an Affiliation');
   htp.para;

   htp.tableOpen ('BORDER');
   htp.tableRowOpen ('LEFT', 'BOTTOM');
   htp.tableHeader ('Select');
   htp.tableHeader ('Email');
   htp.tableHeader ('Affiliation');
   htp.tableHeader ('Address');
   htp.tableRowClose;

   for driver_rec in driver LOOP
      htp.tableRowOpen ('LEFT', 'TOP');
      htp.tableData (htf.formRadio ('this_profile_id', driver_rec.profile_id), 'CENTER');
      htp.tableData (driver_rec.email_address);
      htp.tableData (driver_rec.affiliation);
      htp.tableData (driver_rec.address);
   end loop;

   htp.tableRowOpen ('LEFT', 'TOP');
   htp.tableData (htf.formRadio ('this_profile_id', '', 'SELECTED'), 'CENTER');
   htp.tableData ('*** Add a Different Affiliation ***', ccolspan=>'3');
   htp.tableRowClose;

   htp.tableClose;
   htp.para;
   htp.formSubmit;
   htp.formClose;

end select_profile;

-- ***********************************************************************************************

procedure save_author (abs_id integer, this_lname varchar2, this_fname varchar2,
			this_mname varchar2, this_country varchar2) is

continue	boolean := true;
message		long := null;
pid		integer;

begin

   common.get_gbl_pid;
   if common.valid_entry then

      if NOT common.OK_to_edit_abstract (abs_id) then
	 message := htf.header (3, no_privs$, cattributes=>common.red$);

	 continue := false;
      else

	 if trim (this_lname) is null then
	    continue := false;
	    message := htf.header (3, 'You must supply a last name.');
	 end if;

	 if trim (this_fname) is null then
	    continue := false;
	    message := htf.header (3, 'You must supply a first name.');
	 end if;

      end if;

      if continue then
	 select person_id_seq.nextval into pid from dual;

	 insert into persons (person_id, fname, mname, lname, country_code)
	 values (pid, this_fname, this_mname, this_lname, this_country);

	 create_profile (abs_id, pid);

      else
	 common.public_header ('Add Author');
	 common.show_abstract_title (abs_id);
	 htp.p (message);
	 htp.para;
	 common.footer;
      end if;

   end if;

end save_author;

-- ***********************************************************************************************

procedure create_author (abs_id integer) is

begin

   common.public_header ('Add Author');
   common.show_abstract_title (abs_id);
   htp.para;

   htp.formOpen ('JACoW.save_author', 'POST');
   htp.formHidden ('abs_id', abs_id);
   htp.tableOpen;

   common.show_data_row ('Last Name',		htf.formText ('this_lname',  40, 40));
   common.show_data_row ('First Name',		htf.formText ('this_fname',  40, 40));
   common.show_data_row ('Middle Name',		htf.formText ('this_mname',  40, 40));
   common.show_lookup_table ('COUNTRY', 'Citizenship', '');

   common.show_data_row (null, htf.formSubmit);
   htp.tableClose;
   htp.formClose;
   common.footer;

end create_author;

-- ***********************************************************************************************

procedure set_author_type (abs_id integer, prof_id integer, code varchar2) is

begin

   if code = common.primary_author$ then
-- 	Make the current primary authors a co-author
      update	authors		a1
      set	author_code	= common.co_author$
      where	abstract_id	= abs_id
      and	author_code	= common.primary_author$
      and	NOT exists
	(	select	1
		from	authors		a2
		where	a2.abstract_id	= abs_id
		and	a2.author_code	= common.co_author$
		and	a2.profile_id	= a1.profile_id
	);

      delete from authors
      where	abstract_id	= abs_id
      and	author_code	= common.primary_author$;

      delete from authors
      where	abstract_id	= abs_id
      and	profile_id	= prof_id
      and	author_code	= common.co_author$;

      insert_author (abs_id, prof_id, common.primary_author$);

   elsif code = common.speaker$ then
      delete from authors
      where	abstract_id	= abs_id
      and	author_code	= common.speaker$;

      insert_author (abs_id, prof_id, common.speaker$);

   else -- co-author
      update	authors
      set	author_code	= code
      where	abstract_id	= abs_id
      and	profile_id	= prof_id;

      if SQL%rowcount = 0 then
	 insert_author (abs_id, prof_id, common.co_author$);
      end if;

   end if;

end set_author_type;

-- ***********************************************************************************************

procedure upd_authors (abs_id integer, prim_auth common.ident_arr,
			speaker common.ident_arr, owner common.ident_arr,
			rem_auth common.ident_arr, this_prof_id common.ident_arr,
			leave common.ident_arr, this_sort common.ident_arr) is

cursor	driver is
select	count(1)
from	authors
where	abstract_id	= abs_id
and	author_code	in (common.primary_author$, common.speaker$);

icount	integer;

begin

   common.get_gbl_pid;
   if common.valid_entry then

      for i in 1..this_prof_id.count LOOP
	 if this_prof_id(i) <> 0 then
	    update	authors
	    set		sort_order		= this_sort(i)
	    where	abstract_id		= abs_id
	    and		profile_id		= this_prof_id(i)
	    and		nvl(sort_order,0)	<> nvl (this_sort(i), 0);

	 end if;
      end loop;

      if prim_auth.count = 2 then -- New primary author
	 set_author_type (abs_id, prim_auth(2), common.primary_author$);

	 if NOT common.favorite_author (prim_auth(2)) then
	    insert into favorite_authors (person_id, profile_id)
	    values ( nvl (common.gbl_priv_pid, common.gbl_pid), prim_auth(2));
	 end if;
      end if;

      if speaker.count = 2 then
	 if common.PC_mode$ = 'Y' then -- the primary speaker will be the primary author
--	    Make the current speaker a co-author
	    set_author_type (abs_id, speaker(2), common.primary_author$);
	 end if;

	 set_author_type (abs_id, speaker(2), common.speaker$);
      end if;

      if owner.count = 2 then
	 update abstracts set person_id = owner(2) where abstract_id = abs_id;
      end if;

      for i in 2..rem_auth.count LOOP
	 delete	from authors
	 where	abstract_id	= abs_id
	 and	profile_id	= rem_auth(i)
	 and	author_code	= common.co_author$;
      end loop;

      update authors set on_leave = null where abstract_id = abs_id;
      for i in 2..leave.count LOOP
	 update	authors
	 set	on_leave	= 'Y'
	 where	abstract_id	= abs_id
	 and	profile_id	= leave(i);
      end loop;

   end if;

   open driver;
   fetch driver into icount;
   close driver;

   if icount <> 2 then
      raise_application_error (-20001, 'Internal Error:  Contact SPMS developer.  ' ||
	'Missing Primary and/or Speaker for abstract ' || abs_id);
   end if;

   common.redirect_URL ('JACoW.abs_authors?abs_id=' || abs_id);

end upd_authors;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure select_author_profile (abs_id integer, this_pid integer, this_profile_id common.ident_arr) is

begin

   for i in 2..this_profile_id.count LOOP
      if this_profile_id(i) <> 0 then
	 add_profile (abs_id, this_profile_id(i));
      end if;
   end loop;

   if this_profile_id (this_profile_id.count) = 0 then -- user wants to add an alternative affiliation
      create_profile (abs_id, this_pid);
   else
      common.redirect_URL ('JACoW.abs_authors?abs_id=' || abs_id);
   end if;

end select_author_profile;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure add_author (abs_id integer, pid integer) is

-- User has selected an author now they must select the proper profile(s) or create a new one.

cursor	driver is
select	pro.profile_id,
	common.get_affil_name (affil.affiliation_id)	affiliation
from	affiliations		affil,
	addresses		addr,
	profiles		pro
where	pro.person_id		= pid
and	addr.address_id		= pro.address_id
and	affil.affiliation_id	= addr.affiliation_id
--and	affil.affiliation_id	> 0
order by
	affil.name1;

begin

   common.get_gbl_pid;
   if common.valid_entry then

      if pid is null then
	 create_author (abs_id);

      else

	 common.public_header ('Add ' || set_label('Speaker', 'Author'));
	 htp.header (3, 'Please select an affiliation for ' || common.get_user_name (pid) );
	 htp.formOpen ('jacow.select_author_profile', 'POST');
	 htp.formHidden ('abs_id', abs_id);
	 htp.formHidden ('this_pid', pid);
	 htp.formHidden ('this_profile_id', -1);

	 for driver_rec in driver LOOP
	    htp.formCheckBox ('this_profile_id', driver_rec.profile_id);
	    htp.p (driver_rec.affiliation);
	    htp.br;
	 end loop;

	 htp.formCheckBox ('this_profile_id', 0);
	 htp.p ('Specify a Different Affiliation.');
	 htp.para;

	 htp.formSubmit;
	 htp.p ('Check all affiliations that apply for work completed on this paper.');
	 htp.p ('You may include additional affiliations via the last check box.');
	 htp.formClose;
	 common.footer;

      end if;
   end if;

end add_author;

-- ***********************************************************************************************

-- This routine is called by the JACoW repository (web browser is "bounced" here).

procedure repo_add_author (pid varchar2, prof_id integer, abs_id integer) is

cursor	driver is
select	person_id
from	repo_profiles
where	profile_id = prof_id;

author_id	integer;

begin

   if common.valid_pid (pid) then
      open driver;
      fetch driver into author_id;
      close driver;

      sync.one_person (author_id);
      add_profile (abs_id, prof_id);
      common.redirect_URL ('jacow.abs_authors?abs_id=' || abs_id);
   else
      common.redirect_URL ('jacow.html');
   end if;

end repo_add_author;

-- ***********************************************************************************************

procedure show_author_list_instructions (abs_id integer) is

begin

   if common.PC_mode$ = 'N' then
      htp.ulistOpen;
      htp.listItem ('If your speaker is not an author first add the speaker''s name as an '	||
				'author then use the radio button to set them as the speaker, next '	||
				'remove their name from the list of authors.');
      htp.listItem ('To add an author with multiple affiliations complete the steps in the '	||
				'"Add a New Author" procedure for each affiliation.');
      htp.listItem ('Sort order applies to individual co-authors with multiple affiliations. ' ||
				'Enter a numeric value to adjust the order in which affiliations appear.');
      htp.ulistClose;
   else
      htp.para;
   end if;

end show_author_list_instructions;

-- ***********************************************************************************************

procedure show_author_list (abs_id integer) is

cursor	driver (pri_auth_id$ integer) is
select	aa.*,
	common.get_user_name (person_id)		name,
	common.get_profile_affil (profile_id)		affiliation,
	lead (person_id, 1) over (order by ctype_order, decode (pri_auth_id$, aa.person_id, 0, 1),
					sort_lname, sort_fname, sort_mname,
					person_id, sort_order nulls last) NEXT_ID,
	lag  (person_id, 1) over (order by ctype_order, decode (pri_auth_id$, aa.person_id, 0, 1),
					sort_lname, sort_fname, sort_mname,
					person_id, sort_order nulls last) LAST_ID
from	abstract_authors	aa
where	abstract_id		= abs_id
order by ctype_order,
	decode (common.PC_mode$, 'Y',sort_order, 0),
	decode (pri_auth_id$, aa.person_id, 0, 1),
	sort_lname, sort_fname, sort_mname, person_id, sort_order nulls last;

type	rec_type is table of driver%ROWTYPE index by binary_integer;
recs	rec_type;

checked		varchar2(7);
buffer		varchar2(200);
jacow_admin	boolean := common.user_is_jacow_admin;
removable	boolean;
show_sort_order	boolean;
first_author$	constant integer := 3;
pri_auth_id	integer;

begin

   pri_auth_id := common.decode_value ('person_id', 'abstracts', 'abstract_id', abs_id);
   open driver (pri_auth_id);
   fetch driver BULK COLLECT into recs;
   close driver;

   htp.tableOpen;
   if jacow_admin OR common.PC_mode$ = 'Y' then
      common.show_data_row (set_label ('Proposed By', 'Owner'), recs(1).name);
   end if;

   if common.get_presentation_type (abs_id) = common.oral$ then
      buffer := set_label ('Preferred Speaker', 'Speaker');
   else
      buffer := 'Presenter';
   end if;

   speaker_rec_exists := false;
   if recs.COUNT > 1 then
      speaker_rec_exists := true;
      common.show_data_row (buffer, recs(2).name || ', ' || recs(2).affiliation);
   end if;

   htp.tableClose;

   htp.formOpen ('JACoW.upd_authors', 'POST');
   htp.formHidden ('abs_id', abs_id);
   htp.formHidden ('prim_auth', 0);
   htp.formHidden ('speaker', 0);
   htp.formHidden ('rem_auth', 0);
   htp.formHidden ('owner', 0);
   htp.formHidden ('leave', 'dummy');

-- **********

   htp.para;
   htp.tableOpen ('BORDER');

   if common.PC_mode$ = 'Y' then
      htp.tableCaption (htf.bold ('Proposed Speakers'));
      buffer := 'Set As Preferred Speaker';
   end if;

   htp.tableRowOpen ('LEFT', 'BOTTOM');

   if jacow_admin then
      htp.tableHeader (set_label ('Proposer', 'Owner'), 'CENTER');
   end if;

   if common.PC_mode$ = 'N' then
      htp.tableHeader ('Primary');
   end if;

   htp.tableHeader (buffer, 'CENTER');
   htp.tableHeader ('Remove');
   htp.tableHeader (set_label ('Name', 'Author'));
   htp.tableHeader ('Affiliation');
   htp.tableHeader ('On Leave');
   htp.tableHeader ('Sort Order');
   htp.tableRowClose;

-- **********

   for i in first_author$..recs.COUNT LOOP
      removable := true;
      htp.tableRowOpen ('LEFT', 'TOP');

--	Owner
      if jacow_admin then
	 if recs(i).person_id = recs(1).person_id then
	    htp.tableData (redX$, 'CENTER');
	 else
	    htp.tableData (htf.formRadio ('owner', recs(i).person_id), 'CENTER');
	 end if;
      end if;

--	Primary Author
      if common.PC_mode$ = 'N' then
	 if i = first_author$ then
	    htp.tableData (redX$, 'CENTER');
	    removable := false;
	 else
	    htp.tableData (htf.formRadio ('prim_auth', recs(i).profile_id), 'CENTER');
	 end if;
      end if;

--	Speaker
      if recs(i).profile_id = recs(2).profile_id then
	 htp.tableData (redX$, 'CENTER');
      else
	 htp.tableData (htf.formRadio ('speaker', recs(i).profile_id), 'CENTER');
      end if;

--	Remove button
      if i = first_author$ or NOT removable then
	 htp.tableData (common.space$);
      else
	 htp.tableData (htf.formCheckBox ('rem_auth', recs(i).profile_id), 'CENTER');
      end if;

      htp.tableData (recs(i).name, cnowrap=>'NOWRAP');
      htp.tableData (recs(i).affiliation);

      if i <= first_author$ then
	 htp.tableData (common.space$);
      else
	 checked := null;
	 if recs(i).on_leave is not null then
	    checked := 'Y';
	 end if;
	 htp.tableData (htf.formCheckBox ('leave', recs(i).profile_id, checked), 'CENTER');
      end if;

-- 	place holders; set profile id to 0 to prevent updates
      buffer := htf.formHidden ('this_prof_id', 0) ||
		htf.formHidden ('this_sort', recs(i).sort_order) || common.space$;

      show_sort_order := false;
      if common.PC_mode$ = 'Y' then
	 show_sort_order := true;
      elsif i > first_author$ then
	 if recs(i).person_id in (recs(i).next_id, recs(i).last_id) then
	    show_sort_order := true;
	 end if;
      end if;

      if show_sort_order then
	 htp.tableData (htf.formHidden ('this_prof_id', recs(i).profile_id) ||
			htf.formText ('this_sort', 5, 5, recs(i).sort_order), 'CENTER');
      else
	 htp.tableData (buffer);
      end if;

      htp.tableRowClose;
   end loop;

   htp.tableClose;
   htp.para;

   if first_author$ <= recs.COUNT then
      htp.formSubmit (null, 'Update');
      htp.fontOpen ('RED');
      htp.bold ('Note:');
      htp.p ('You must click "Update" to save changes in the table above.');
      htp.p ('Clicking "Add a New ');
      htp.p (set_label ('Speaker', 'Author') );
      htp.p ('" or "Return to Abstract List" will not save your changes.');
      htp.fontClose;
   end if;
   htp.formClose;

end show_author_list;

-- ***********************************************************************************************

procedure abs_authors (abs_id integer, verify varchar2 default 'N') is

buffer	varchar2(20)	:= 'Preferred';

begin

   common.get_gbl_pid;
   common.public_header ('Author List');
   if common.valid_entry OR common.has_privs_to_page (common.sort_file_page$, false) then
      if get_abstract_record (abs_id) then
	 common.show_abstract_title (abs_id);
	 htp.para;

	 if common.OK_to_edit_abstract (abs_id) then
	    show_author_list_instructions (abs_id);
	    show_author_list (abs_id);
	    htp.para;

	    htp.tableOpen;
	    htp.tableRowOpen;

	    htp.tableData (
		htf.formOpen ('profile.find_author', 'POST')		||
		htf.formHidden ('abs_id', abs_id)			||
		htf.formSubmit (null, 'Add a New '			||
				set_label (buffer || ' Speaker', 'Co-Author'))	||
		htf.formClose);

            if verify = 'Y' then
               htp.tableData ('<button onclick="window.close();">Return to ' || verify_msg$ || '</button>');
            else
               htp.tableData (
           	htf.formOpen ('JACoW.html', 'POST')			||
           	htf.formSubmit (null, 'Return to Abstract List')	||
           	htf.formClose);
            end if;

            htp.tableRowClose;
            htp.tableClose;

	 elsif common.OK_to_edit_abstract (abs_id) then
	    htp.header (3, 'Updates to Abstracts are not allowed at this time.');

	 end if;

      else
	 htp.header (3, 'No such abstract');
      end if;

   end if;
   common.footer;

end abs_authors;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure journal_abstract (this_id integer) is

cursor	driver is
select	table_name
from	user_tab_columns
where	column_name	= 'ABSTRACT_ID'
and	table_name	NOT in ('FILES', 'ABSTRACTS')
and	table_name	NOT like 'JN_%'
and	table_name	NOT like 'BIN$%'
and	table_name	NOT in
(	select	view_name
	from	user_views);

paper_id$	constant varchar2(100) := common.get_paper_id (this_id);

begin

   if common.valid_entry then
      insert into logs (abstract_id, log_code) values (this_id, common.abstract_withdrawn$);

      insert into JN_abstracts
      select	sysdate, nvl (common.gbl_priv_pid, common.gbl_pid), a.*
      from	abstracts a
      where	abstract_id = this_id;

      insert into JN_authors
      select	*
      from	authors a
      where	abstract_id = this_id;

      insert into JN_logs
      select	*
      from	logs
      where	abstract_id = this_id;

      insert into JN_log_errors
      select	*
      from	log_errors
      where	log_id in
	(select log_id from logs where abstract_id = this_id);

      if paper_id$ is not null then
	 send_mail (common.editor_email$, paper_id$ || ' Withdrawn',
		'Contribution ' || paper_id$ || ' was withdrawn by ' ||
			common.get_user_name (nvl (common.gbl_priv_pid, common.gbl_pid) ) );
      end if;

-- Note: Delete from files creates a log so it must be deleted before the logs table

      delete from files				where abstract_id = this_id;
      delete from log_errors			where log_id in
	(select log_id from logs where abstract_id = this_id);

      for driver_rec in driver LOOP
	 execute immediate 'delete from ' || driver_rec.table_name ||
			' where abstract_id = ' || this_id;
      end loop;

      delete from abstracts where abstract_id = this_id;
   end if;

end journal_abstract;

-- ***********************************************************************************************

procedure delete_abstract (this_id integer, refresh_opener varchar2 default 'N') is

begin

   common.get_gbl_pid;
   if common.valid_entry then
      journal_abstract (this_id);

      if common.user_is_jacow_admin then
	 common.public_header ('Abstract Withdrawn');

	 if refresh_opener = 'Y' then
	    htp.p ('<SCRIPT LANGUAGE="JavaScript1.1" type="text/javascript">');
	    htp.p ('<!--');
	    htp.p ('alert (''Abstract Withdrawn'');');
--	    htp.p ('opener.window.location.reload(true);');
	    htp.p ('self.close();');
	    htp.p ('-->');
	    htp.p ('</SCRIPT>');
	 else
	    htp.formOpen ('jacow.html');
	    htp.formSubmit (null, 'Continue');
	    htp.formClose;
	 end if;

	 common.footer;
      else
	 common.redirect_URL ('jacow.html');
      end if;

   end if;

end delete_abstract;

-- *********************************************************************************************************

procedure withdraw_abstract (abs_id integer, refresh_opener varchar2 default 'N') is

begin

   common.get_gbl_pid;
   common.public_header ('Withdraw Abstract');
   if common.OK_to_edit_abstract (abs_id) then
      if common.freeze_abs_updates$ = 'Y' AND NOT common.user_is_JACoW_admin then
	 htp.header (3, 'Updates to Abstracts are not allowed at this time.');
      elsif get_abstract_record (abs_id) then
	 common.show_abstract_title (abs_id);
	 htp.header (3, 'Are you sure you wish to withdraw the abstract?');

	 htp.tableOpen;
	 htp.tableRowOpen;

	 htp.p ('<TD>');
	    htp.formOpen ('JACoW.delete_abstract', 'POST');
	    htp.formHidden ('this_id', abs_id);
	    htp.formHidden ('refresh_opener', refresh_opener);
	    htp.formSubmit (null, 'Yes, Withdraw Abstract');
	    htp.formClose;
	 htp.p ('</TD>');

	 htp.p ('<TD>');
	    htp.formOpen (null);
	    htp.formSubmit (null, 'No, Return to Abstract Display', cattributes=>'onClick="javascript:window.close();"');
	    htp.formClose;
	 htp.p ('</TD>');

	 htp.tableRowClose;
	 htp.tableClose;
      else
	 htp.header (3, 'No such abstract');
      end if;

   else
      htp.header (3, no_privs$, cattributes=>common.red$);
   end if;

   common.footer;

end withdraw_abstract;

-- *********************************************************************************************************

procedure show_files (abs_id integer) is

cursor	driver is
select	*
from	files
where	abstract_id = abs_id
order by
	file_name;

begin

   if common.accept_file_uploads$ = 'Y' then
      htp.tableOpen;

      htp.tableRowOpen ('LEFT', 'BOTTOM');
      htp.tableHeader ('File Name');
      htp.tableHeader ('File Type');
      htp.tableHeader ('Platform');
      htp.tableHeader ('Uploaded');
      htp.tableRowClose;

      for driver_rec in driver LOOP
	 htp.tableRowOpen ('LEFT', 'TOP');
	 htp.tableData (driver_rec.file_name);
	 htp.tableData (common.decode_value ('file_type_descr', 'file_type_codes',
				'file_type_code', driver_rec.file_type_code));
	 htp.tableData (common.decode_value ('platform_descr', 'platform_codes',
				'platform_code', driver_rec.platform_code));
	 htp.tableData (common.local_time(driver_rec.uploaded_date));
	 htp.tableRowClose;
      end loop;

      htp.tableClose;
   end if;

end show_files;

-- ***********************************************************************************************

function abstract_count (this_abstract varchar2) return varchar2 is

word_count	integer := 0;
byte_count	integer := 0;
byte		integer;
prev_byte	integer := 1;

-- Translate text into decimal format this causes special strings (e.g. \beta) to be one character
buffer		long := common.convert_text (this_abstract, common.decimal_fmt$);

begin

   if buffer is NOT null then

      for i in 1..length(buffer) LOOP
	 byte := ascii(substr(buffer,i,1));

	 if byte NOT in (9, 10, 13, 44, 46, 59) then
	    byte_count := byte_count + 1;
	 end if;

	 if byte in (9, 32) and prev_byte not in (9, 32) then
	    word_count := word_count + 1;
	 end if;

	 prev_byte := byte;
      end loop;

      if prev_byte NOT in (9, 32) then
	 word_count := word_count + 1;
      end if;

   end if;

   return ('Word Count: ' || to_char(word_count) || common.space2$ || 'Character Count: ' || to_char(byte_count));

exception
   when others then
      return (null);

end abstract_count;

-- ***********************************************************************************************

procedure view_abstract2 (abs_id integer, show_files_flag varchar2 default 'Y') is

cursor	driver is
select	*
from	abstracts
where	abstract_id = abs_id;

paper_ID	varchar2(100) := common.get_paper_ID (abs_id);
class_descr	classification_codes.classification_descr%TYPE;
present_descr	presentation_codes.presentation_descr%TYPE;
buffer		long;
speaker_id	integer;
paper_url	varchar2(1000);

begin

   open driver;
   fetch driver into abstract_rec;
   rec_found := driver%FOUND;
   close driver;

   if rec_found then
      class_descr	:= common.decode_value ('classification_descr', 'classification_codes',
						'classification_code', abstract_rec.classification_code);
      present_descr	:= common.decode_value ('presentation_descr', 'presentation_codes',
						'presentation_code', abstract_rec.presentation_code);
      speaker_id	:= common.decode_value ('person_id', 'profiles', 'profile_id',
						common.get_author_profile_id (abs_id, common.speaker$) );
      paper_id		:= common.get_paper_id (abs_id);

      htp.tableOpen (cattributes=>'CELLSPACING="5"');
      common.show_data_row2 ('Title',		htf.bold(common.convert_text(abstract_rec.title, common.html_fmt$)),
				 'Submitted',	common.get_log_date (abs_id, common.abstract_created$));

      common.show_data_row2 ('Classification',	class_descr,
				'Modified',	common.get_log_date (abs_id, common.abstract_updated$));
--    common.show_data_row2 ('Session',	abstract_rec.session_id, 'Presentation', present_descr);
      common.show_data_row2 (null, null, 'Presentation', present_descr);

      if common.get_presentation_type (abs_id) = common.oral$ then
	 label := set_label ('Preferred Speaker', 'Speaker:');
      else
	 label := 'Presenter';
      end if;

      common.show_data_row2 (label, common.convert_text (common.get_user_name (speaker_id), common.html_fmt$),
				'Paper ID', paper_id);

      if paper_ID is not null then
	 paper_URL := common.wanted_file_URL (paper_id);
	 if paper_URL is not null then
	    common.show_data_row2 (null, null, 'Paper PDF', htf.anchor (paper_URL, 'Download'));
	 end if;
      end if;

      htp.tableRowOpen ('LEFT', 'TOP');
      htp.tableHeader ('Author(s)', 'RIGHT');
      htp.tableData (nvl (common.get_author_list2 (abs_id), common.red ('Missing') ), ccolspan=>'3');
      htp.tableRowClose;

      buffer := common.convert_text (abstract_rec.description, common.html_fmt$);
      htp.tableRowOpen ('LEFT', 'TOP');
      htp.tableHeader ('Abstract', 'RIGHT');
      htp.tableData (buffer, ccolspan=>'3');
      htp.tableRowClose;

      htp.tableRowOpen ('LEFT', 'TOP');
      htp.tableData (null);
      htp.tableData (htf.italic (abstract_count (abstract_rec.description)), ccolspan=>'3');
      htp.tableRowClose;

-- ****

      buffer	:= replace (abstract_rec.footnote, chr(10), htf.br);
      htp.tableRowOpen ('LEFT', 'TOP');
      htp.tableHeader ('Footnote', 'RIGHT');
      htp.tableData (buffer, ccolspan=>'3');
      htp.tableRowClose;

-- ****

      buffer := replace (abstract_rec.agency, chr(10), htf.br);
      htp.tableRowOpen ('LEFT', 'TOP');
      htp.tableHeader ('Funding Agency', 'RIGHT');
      htp.tableData (buffer, ccolspan=>'3');
      htp.tableRowClose;

      htp.tableClose;
      htp.para;

      if show_files_flag = 'Y' then
         show_files (abs_id);
      end if;

   else
      htp.header (3, 'No such abstract');
   end if;

end view_abstract2;

-- ***********************************************************************************************

procedure view_abstract (abs_id integer) is

begin

   common.public_header (nvl (common.get_paper_id(abs_id), 'Abstract #' || abs_id));
   view_abstract2 (abs_id);
   common.footer;

end view_abstract;

-- ***********************************************************************************************

procedure print_abstract (abs_id integer) is

begin

   common.public_header ('Abstract');
   view_abstract2 (abs_id);
   htp.script ('window.print()', 'JavaScript');
   htp.script ('window.setTimeout("window.close()",1000);', 'JavaScript');

   common.footer;

end print_abstract;

-- ***********************************************************************************************
-- ***********************************************************************************************

function check_field_supplied (this_field varchar2, prompt varchar2) return varchar2 is

begin

   if this_field is null then
      return htf.header (3, 'Missing ' || prompt);
   end if;

   return null;

end check_field_supplied;

-- ***********************************************************************************************

procedure abstract_saved (verify varchar2 default 'N') is

begin

   common.public_header ('Abstract Saved');
   htp.header (3, 'Your abstract data was successfully saved.');

   if verify = 'Y' then
      htp.tableData ('<button onclick="window.close();">Return to ' || verify_msg$ || '</button>');
   else
      htp.formOpen ('JACoW.html');
      htp.formSubmit (null, 'Continue');
      htp.formClose;
   end if;
   common.footer;

end abstract_saved;

-- ***********************************************************************************************

procedure abstract_saved_editor (verify varchar2 default 'N') is

begin

   common.public_header ('Abstract Saved');
   htp.header (3, 'The abstract data was successfully updated.');

   if verify = 'Y' then
      htp.tableData ('<button onclick="window.close();">Return to ' || verify_msg$ || '</button>');
   else
      htp.formOpen (null);
      htp.formSubmit (null, 'Continue', cattributes=>'onClick="javascript:window.close();"');
      htp.formClose;
   end if;

   common.footer;

end abstract_saved_editor;

-- ***********************************************************************************************
-- ***********************************************************************************************

function sub_classes_exist (this_classification varchar2) return boolean is

cursor	driver is
select	1
from	eclass_codes
where	classification_code = this_classification;

dummy		integer;
rec_found	boolean;

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end sub_classes_exist;

-- ***********************************************************************************************

function validate_abs_data (this_title varchar2, this_presentation varchar2,
			this_description varchar2, this_classification varchar2,
			this_sub_class varchar2, this_agency varchar2,
			this_footnote varchar2) return boolean is

begin

   abs_edt_err_msg := abs_edt_err_msg || check_field_supplied (this_title, 'Title');
   abs_edt_err_msg := abs_edt_err_msg || check_field_supplied (this_presentation,'Presentation Type');
   abs_edt_err_msg := abs_edt_err_msg || check_field_supplied (this_classification, 'Main Classification');

   if common.require_sub_class$ = 'Y' then
      if sub_classes_exist (this_classification) then
	 abs_edt_err_msg := abs_edt_err_msg || check_field_supplied (this_sub_class, 'Sub Classification');
      end if;
   end if;

   if instr (this_description, chr(10)) > 0 OR instr (this_description, chr(13)) > 0 then
      abs_edt_err_msg := abs_edt_err_msg || htf.header (3, 'Abstract contains a carriage return');
   end if;

-- **********

   if length (this_description) > common.max_abstract_len$ then
      abs_edt_err_msg := abs_edt_err_msg ||
			htf.header (3, 'Abstract length (' || length (this_description) ||
					') exceeds ' || common.max_abstract_len$ || ' characters');
   end if;

   if length (this_agency) > common.max_funding_agency_len$ then
      abs_edt_err_msg := abs_edt_err_msg ||
			htf.header (3, 'Agency length (' || length (this_agency) ||
					') exceeds ' || common.max_funding_agency_len$ || ' characters');
   end if;

   if length (this_footnote) > common.max_footnote_len$ then
      abs_edt_err_msg := abs_edt_err_msg ||
			htf.header (3, 'Footnote length (' || length (this_footnote) ||
					') exceeds ' || common.max_footnote_len$ || ' characters');
   end if;

   if abs_edt_err_msg is null then
      return true;
   end if;

   return false;

end validate_abs_data;

-- ***********************************************************************************************

function txt_trim (txt varchar2, remove_crlf boolean default true) return varchar2 is

buffer	varchar2(4000) := substr (trim (txt), 1, 4000);

begin

   if buffer is null then
      return buffer;
   end if;

   buffer := replace (buffer, chr(9), ' ');

   if remove_crlf then
      buffer := replace (buffer, chr(10), ' ');
      buffer := replace (buffer, chr(13), ' ');
   end if;

   LOOP
      exit when instr (buffer, '  ') = 0;
      buffer := replace (buffer, '  ',	' ');
   end loop;

   return buffer;

end txt_trim;

-- ***********************************************************************************************

procedure save_abstract (abs_id integer, this_title varchar2, this_presentation varchar2,
		this_classification varchar2, this_sub_class varchar2, this_description varchar2,
		this_agency varchar2, this_footnote varchar2, primary_profile integer,
		verify varchar2 default 'N') is

new_abs_id	integer := abs_id;
eclass		abstracts.eclass_code%TYPE;
new_abstract	boolean := false;
subject		mail_blats.subject%TYPE;
msg		mail_blats.message%TYPE;

txt_descr	varchar2(4000)	:= txt_trim (this_description);
txt_footnote	varchar2(4000)	:= txt_trim (this_footnote, false);
txt_agency	varchar2(4000)	:= txt_trim (this_agency);

begin

   common.get_gbl_pid;
   if common.valid_entry AND common.OK_to_edit_abstract (abs_id) then

      if validate_abs_data (this_title, this_presentation, txt_descr, this_classification,
				this_sub_class, txt_agency, txt_footnote) then

	 eclass := get_eclass_code (this_classification, this_sub_class);

	 if new_abs_id is null then -- new abstracts

	    new_abstract := true;
	    select abstract_id_seq.nextval into new_abs_id from dual;

	    insert into abstracts (abstract_id, person_id, title, description,
			classification_code, sub_class_code, eclass_code, presentation_code,
			agency, footnote)
	    values (new_abs_id, nvl (common.gbl_priv_pid, common.gbl_pid), trim (this_title), txt_descr,
			this_classification, this_sub_class, eclass, this_presentation,
			txt_agency, txt_footnote);

	    if common.PC_mode$ = 'N' then
	       set_author_type (new_abs_id, primary_profile, common.primary_author$);
	       set_author_type (new_abs_id, primary_profile, common.speaker$);
	    end if;

-- ********** Send emails

	    subject	:= common.conf_title$ || 'Abstract #' || new_abs_id || ' Created by ' ||
				common.get_user_name (nvl (common.gbl_priv_pid, common.gbl_pid));
	    msg		:= common.server || common.vdir$ || 'search.abs_id?aid=' || new_abs_id;

	    if common.email_admn_new_abstracts$ = 'Y' then
	       send_mail (common.editor_email$, subject, msg);
	    end if;

	    if common.email_LOC_new_abstract$ = 'Y' then
	       send_mail (common.LOC_email_address$, subject, msg);
	    end if;

	    if common.email_new_abstract$ = 'Y' then
	       send_mail (common.get_user_email (common.gbl_pid),
			common.conf_title$ || ' Abstract Created',
			'This email is to confirm the successful creation of your abstract submission titled "' ||
			trim (this_title) || '" to ' || common.conf_title$ || '.' || common.eol2$ || 'Thank you.',
			pid=>common.gbl_pid, abs_id=>abs_id);
	    end if;

-- **********

	 else
	    update	abstracts
	    set		title			= trim(this_title),
			description		= txt_descr,
			classification_code	= this_classification,
			sub_class_code		= this_sub_class,
			eclass_code		= eclass,
			presentation_code	= this_presentation,
			agency			= txt_agency,
			footnote		= txt_footnote
	    where	abstract_id		= new_abs_id;
	 end if;

	 if editor_saved_abs then
	    common.redirect_URL ('JACoW.abstract_saved_editor?verify=' || verify);
	 elsif new_abstract then
	    common.redirect_URL ('JACoW.abs_authors?abs_id=' || new_abs_id);
	 else
	    common.redirect_URL ('JACoW.abstract_saved?verify=' || verify);
	 end if;

      else

	 common.public_header ('Invalid Abstract Data');
	 htp.p (common.red (abs_edt_err_msg));
	 htp.para;

--	 Setup the abstract_rec record with the value passed from the from to
--	 edit_abstract2 can re-paint the screen using the values the user entered.

	 abstract_rec				:= null;
	 abstract_rec.abstract_id		:= abs_id;
	 abstract_rec.title			:= trim (this_title);
	 abstract_rec.presentation_code		:= this_presentation;
	 abstract_rec.classification_code	:= this_classification;
	 abstract_rec.sub_class_code		:= this_sub_class;
	 abstract_rec.description		:= substr (txt_descr, 1, 2000);
	 abstract_rec.agency			:= txt_agency;
	 abstract_rec.footnote			:= txt_footnote;

	 edit_abstract2 (abs_id, verify);

	 common.footer;

      end if;  -- valid abstract data

   end if; -- valid entry and OK to edit

end save_abstract;

-- ***********************************************************************************************

procedure save_abs_editor (abs_id integer, this_presentation varchar2,
		this_title varchar2, this_classification varchar2,
		this_sub_class varchar2, this_description varchar2, this_agency varchar2,
		this_footnote varchar2, primary_profile integer,
		attrib common.ident_arr, verify varchar2 default 'N') is

continue	boolean := true;

begin

   editor_saved_abs := true;

   common.get_gbl_pid;
   if common.valid_entry AND common.OK_to_edit_abstract (abs_id) then

      if NOT validate_abs_data (this_title, this_presentation, this_description,
				this_classification, this_sub_class, this_agency, this_footnote) then
	 continue := false;
      end if; -- valid data

-- **********

      if continue then -- oral paper id OK or poster paper

--	 Save the extract abstract attributes
	 delete from abs_attributes where abstract_id = abs_id;
	 for i in 2..attrib.count LOOP
	    insert into abs_attributes (abstract_id, attribute_code)
	    values (abs_id, attrib(i));
	 end loop;

--	 Save the remaining fields

	 save_abstract (abs_id, this_title, this_presentation, this_classification, this_sub_class,
			this_description, this_agency, this_footnote, primary_profile);

      else
	 common.public_header ('Invalid Abstract Data');
	 htp.p (common.red (abs_edt_err_msg));

--		Setup the abstract_rec record with the value passed from the from to
--		edit_abstract2 can re-paint the screen using the values the user entered.

	 abstract_rec				:= null;
	 abstract_rec.abstract_id		:= abs_id;
	 abstract_rec.title			:= this_title;
	 abstract_rec.presentation_code		:= this_presentation;
	 abstract_rec.classification_code	:= this_classification;
	 abstract_rec.description		:= this_description;
	 abstract_rec.agency			:= this_agency;
	 abstract_rec.footnote			:= this_footnote;

	 edit_abstract2 (abs_id);

	 common.footer;

      end if; -- continue

   end if; -- valid entry and abstract data

end save_abs_editor;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure save_title (abs_id integer, this_title varchar2) is

begin

   common.get_gbl_pid;
   if common.valid_entry AND common.OK_to_edit_abstract (abs_id, for_title_change=>true) then
      common.public_header ('Save Abstract Title');

      if trim (this_title) is null then
	 htp.header (3, 'You must supply a title for your abstract.');
	 htp.p (common.click_back$);

      else
	 update abstracts
	 set	title		= trim (this_title)
	 where	abstract_id	= abs_id;

	 htp.header (3, 'Update Complete');
	 htp.formOpen ('jacow.html');
	 htp.formSubmit (null, 'Continue');
	 htp.formClose;

      end if;

      common.footer;
   end if;

end save_title;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure show_favorite_authors_popup is

cursor	driver is
select	p.lname, p.fname, p.mname, pro.profile_id
from	persons			p,
	profiles		pro
where	pro.person_id		= common.gbl_pid
and	pro.deleted		is null
and	p.person_id		= pro.person_id
UNION
select	p.lname, p.fname, p.mname, fa.profile_id
from	persons			p,
	profiles		pro,
	favorite_authors	fa
where	fa.person_id		= common.gbl_pid
and	pro.profile_id		= fa.profile_id
and	pro.deleted		is null
and	p.person_id		= pro.person_id;

icount		integer := 0;
profile_id	integer;

begin

   for driver_rec in driver LOOP
      icount		:= icount + 1;
      profile_id	:= driver_rec.profile_id;
   end loop;

   if icount = 1 then -- no need to display popup
      htp.formHidden ('primary_profile', profile_id);

   else
      htp.tableRowOpen ('LEFT', 'TOP');
      htp.tableData ('Primary Author', 'RIGHT', cattributes=>'class=boldtext');
      htp.p ('<TD>');
      htp.formSelectOpen ('primary_profile');

      for driver_rec in driver LOOP
	 htp.formSelectOption (common.get_user_name_affiliation (driver_rec.profile_id),
				cattributes=>'VALUE="' || driver_rec.profile_id || '"');
      end loop;

      htp.formSelectClose;
      htp.br;
      htp.bold ('Note: ');
      htp.p ('This is a list of previously selected primary authors.');
      htp.p ('If the primary author is not in this list then select any author;');
      htp.p ('you will have an opportunity to change it later.');

      htp.bold ('You will have the opportunity to add co-authors on the next page.',
		cattributes=>common.red$);
      htp.p ('</TD>');
      htp.tableRowClose;

   end if;

end show_favorite_authors_popup;

-- ***********************************************************************************************

procedure show_sub_class_lookup (label varchar2, ccode varchar2, scode varchar2) is

cursor	driver is
select	sub_class_code, sub_class_descr
from	sub_class_codes
where	sub_class_code	in
(	select	sub_class_code
	from	eclass_codes
	where	classification_code = ccode)
or	ccode	is null
order by sub_class_descr;

selected	varchar2(10) := nvl (scode, 'SELECTED');

begin

   htp.tableRowOpen ('LEFT', 'TOP');
   htp.tableHeader (label, 'RIGHT', cattributes=>'class=boldtext');

   htp.p ('<TD>');
      htp.formSelectOpen ('THIS_SUB_CLASS');
      htp.formSelectOption ('', selected);

      for driver_rec in driver LOOP
	 selected := null;
	 if driver_rec.sub_class_code = scode then
	    selected := 'SELECTED';
	 end if;

	 htp.formSelectOption (driver_rec.sub_class_descr, selected,
				cattributes=>'VALUE="' || driver_rec.sub_class_code || '"');
      end loop;

      htp.formSelectClose;

   htp.p ('</TD>');
   htp.tableRowClose;

end show_sub_class_lookup;

-- ***********************************************************************************************

function display_sub_class (abs_id integer) return boolean is

begin

   if common.user_is_JACoW_admin then
      return true;
   end if;

   if abs_id is null AND common.require_sub_class$ = 'Y' then
      return true;
   end if;

   if common.freeze_abs_reclass$ = 'Y' then
      return false;
   end if;

   if common.require_sub_class$ = 'Y' then
      return true;
   end if;

   return false;

end display_sub_class;

-- ***********************************************************************************************

procedure edit_abs_owner_fields (abs_id integer) is

cursor	driver is
select	*
from	presentation_codes
where	presentation_code = abstract_rec.presentation_code;

driver_rec	driver%ROWTYPE;

where_stmt		varchar2(50)		:= 'where editor_only ';
user_is_JACoW_admin	constant boolean	:= common.user_is_JACoW_admin;
display_sub_class$	constant boolean	:= display_sub_class (abs_id);
display_only		constant boolean	:= common.freeze_abs_reclass$ = 'Y'	AND
						   NOT user_is_JACoW_admin		AND
						   abs_id is not null;
show_present		boolean := false;
present_descr		presentation_codes.presentation_descr%TYPE;
class_descr		classification_codes.classification_descr%TYPE;
sub_class_descr		sub_class_codes.sub_class_descr%TYPE;

begin

   open driver;
   fetch driver into driver_rec;
   close driver;

   if user_is_JACoW_admin then
      show_present := true;
   elsif abs_id is null then
      show_present := true;
   elsif common.freeze_abs_present$ = 'Y' then
      show_present := false;
   elsif common.PC_mode$ = 'Y' then
      show_present := false;
   elsif nvl(driver_rec.editor_only, 'N') = 'N' then
      show_present := true;
   end if;

   htp.formHidden ('abs_id', abstract_rec.abstract_id);
   if NOT display_sub_class$ then
      htp.formHidden ('THIS_SUB_CLASS', abstract_rec.sub_class_code);
   end if;

   htp.tableOpen;
   common.show_data_row (null, common.red ('Fields marked with an "*" are required.'));
   abstract_maint.abs_title_form (abstract_rec.title);

   if common.has_privs_to_page (common.editor_page$, false) then
      where_stmt := where_stmt || ' like ''%''';
   else
      where_stmt := where_stmt || ' = ''N''';
   end if;

-- **********

   if show_present then
      common.show_lookup_table ('PRESENTATION', 'Presentation Type*', abstract_rec.presentation_code, where_stmt);
   elsif common.PC_mode$ = 'Y' then
      common.show_data_row ('Presentation Type', 'Under review by the program committee' ||
				htf.formHidden ('this_PRESENTATION',	abstract_rec.presentation_code));
   else
      present_descr := common.decode_value ('presentation_descr', 'presentation_codes',
						'presentation_code', abstract_rec.presentation_code);
      common.show_data_row ('Presentation Type', present_descr ||
				htf.formHidden ('this_PRESENTATION',	abstract_rec.presentation_code));
   end if;

-- **********

   if display_only then
      class_descr := common.decode_value ('classification_descr', 'classification_codes',
					'classification_code', abstract_rec.classification_code);
      common.show_data_row ('Main Classification', class_descr ||
				htf.formHidden ('this_CLASSIFICATION',	abstract_rec.classification_code));
   else
      common.show_lookup_table ('CLASSIFICATION', 'Main Classification*', abstract_rec.classification_code,
				onChange=>'onChange="load_sub_class(this.value);"');

   end if;

-- **********

   if display_sub_class$ then
      show_sub_class_lookup ('Sub Classification*', abstract_rec.classification_code, abstract_rec.sub_class_code);
   elsif abstract_rec.sub_class_code is NOT null then
      sub_class_descr := common.decode_value ('sub_class_descr', 'sub_class_codes',
						'sub_class_code', abstract_rec.sub_class_code);
      common.show_data_row ('Sub Classification', sub_class_descr);
   end if;

-- **********

   common.show_data_row ('Abstract*', 'Abstracts should not exceed ' || common.max_abstract_len$ || ' characters.');
   common.show_data_row (null, htf.formTextAreaOpen ('this_description', 10, 75, cattributes=>'WRAP=VIRTUAL')  ||
				replace (abstract_rec.description, '"', '&quot;') || htf.formTextAreaClose);

   common.show_data_row ('Footnotes',	'Footnotes should not exceed ' || common.max_footnote_len$	||
					' characters. '		||
					'Please use "*", "**", etc., for references to '	||
					'publications as many times as necessary and with a '	||
					'carriage return between each. '			||
					htf.fontOpen ('RED') || 'Please note that this '	||
					'is not the correct place to enter coauthors. You '	||
					'will have the opportunity to add coauthors on the '	||
					'next page.' || htf.fontClose);



   common.show_data_row (null, htf.formTextAreaOpen ('this_footnote', 5, 75, cattributes=>'WRAP=VIRTUAL')  ||
						replace (abstract_rec.footnote, '"', '&quot;') || htf.formTextAreaClose);

   common.show_data_row ('Funding Agency',	'If necessary, enter funding agency and contract. '		||
						'This field should not be used to request sponsorship. '	||
						'Should not exceed ' || common.max_funding_agency_len$ || ' characters');
   common.show_data_row (null, htf.formTextAreaOpen ('this_agency', 5, 75, cattributes=>'WRAP=VIRTUAL')  ||
						replace (abstract_rec.agency, '"', '&quot;') || htf.formTextAreaClose);

   if abstract_rec.abstract_id is null then -- this is a new abstract
      show_favorite_authors_popup;
   else
      htp.formHidden ('primary_profile', '');
   end if;

end edit_abs_owner_fields;

-- ***********************************************************************************************

procedure abs_attrib_fields is

cursor	driver is
select	ac.attribute_code, ac.attribute_descr, aa.abstract_id
from	abs_attributes	aa,
	attribute_codes	ac
where	aa.abstract_id(+)	= abstract_rec.abstract_id
and	aa.attribute_code(+)	= ac.attribute_code
order by
	ac.attribute_descr;

checked	varchar2(7);

begin

   for driver_rec in driver LOOP
      checked := null;
      if driver_rec.abstract_id is not null then
	 checked := 'CHECKED';
      end if;

      htp.tableRowOpen ('RIGHT', 'TOP');
      htp.tableData (htf.formCheckbox ('attrib', driver_rec.attribute_code, checked) );
      htp.tableHeader (driver_rec.attribute_descr, 'LEFT');
      htp.tableRowClose;
   end loop;

end abs_attrib_fields;

-- ***********************************************************************************************

procedure edit_abs_editor_fields is

begin

   common.show_data_sep (2, htf.hr);
   abs_attrib_fields;

end edit_abs_editor_fields;

-- ***********************************************************************************************

procedure edit_abstract_hdr is

begin

   htp.p (jacow.js$);

   if common.abstract_instr_url$ is not null then
      htp.anchor2 (common.abstract_instr_url$, 'Instructions', null, '_blank');
      htp.p (common.space2$);
   end if;

   if common.help_url$ is not null then
      htp.anchor2 (common.help_url$, 'Help', null, '_blank');
   end if;

   htp.para;

end edit_abstract_hdr;

-- ***********************************************************************************************

procedure edit_abstract2 (abs_id integer, verify varchar2 default 'N') is

buffer		varchar2(200) := null;
buffer2		varchar2(200) := null;
buffer3		varchar2(50) := null;

begin

   edit_abstract_hdr;
   if editor_saved_abs AND abstract_rec.abstract_id is NOT null then

-- Editor can update more fields than authors

      htp.formOpen (editor_script$, 'POST', cattributes=>'NAME="ABSTRACT" ' ||
			'onSubmit="return validateJACoWForm(''' || common.require_sub_class$ || ''')"');

      htp.formHidden ('attrib', 'dummy');
      edit_abs_owner_fields (abs_id);
      edit_abs_editor_fields;
   else

      htp.formOpen (user_script$, 'POST', cattributes=>'NAME="ABSTRACT" ' ||
			'onSubmit="return validateJACoWForm(''' || common.require_sub_class$ || ''')"');
      edit_abs_owner_fields (abs_id);

   end if;

   htp.formHidden ('verify', verify);
   buffer3 := 'Save Changes';

   if editor_saved_abs AND abstract_rec.abstract_id is NOT null then
      buffer2	:= common.space2$ ||htf.bold ('Note:') || common.space2$ ||
		'QA is recorded only when data in a field above the horizontal line is updated';
      buffer3	:= 'Save Changes and Record QA';
   elsif verify = 'Y' then
      buffer	:= htf.anchor ('#', 'Return Without Saving', cattributes=>'onclick="window.close();"');
   end if;

   common.show_data_row (buffer, htf.formSubmit (null, buffer3) || buffer2);
   htp.tableClose;
   htp.formClose;
   htp.para;

   if verify='N' AND editor_saved_abs AND abstract_rec.abstract_id is NOT null then
      htp.formOpen ('search.abs_QA');
      htp.formHidden ('abs_id', abs_id);
      htp.formSubmit (null, 'Record QA Only');
      htp.formClose;
      htp.para;
   end if;

end edit_abstract2;

-- ***********************************************************************************************

procedure edit_abstract3 is

begin

   edit_abstract_hdr;
   htp.header (3, 'Updates to abstracts are restricted to the title only.');

   htp.formOpen ('jacow.save_title', 'POST', cattributes=>'NAME="ABSTRACT"');
   htp.formHidden ('abs_id', abstract_rec.abstract_id);
   abstract_maint.abs_title_form (abstract_rec.title);
   htp.br;
   htp.formSubmit;
   htp.formClose;
   htp.anchor ('JACoW.html', 'Back to Abstract Summary');
   htp.para;

end edit_abstract3;

-- ***********************************************************************************************

procedure edit_abstract (abs_id integer, verify varchar2 default 'N') is

editor		boolean;
continue	boolean := true;

begin

   common.public_header ('Abstract', JS_src=>common.server||common.vdir$||'editor.js');
   common.show_abstract_title (abs_id);
   editor := common.has_privs_to_page (common.editor_page$, false);

   if NOT common.valid_entry then
      if common.gbl_priv_pid = common.admin_pid$ then
	 htp.header (3, 'You can not edit an abstract while logged in as JACoW.');
      else
	 htp.header (3, 'You must log in to edit an abstract');
      end if;

      htp.formOpen (common.server || common.vdir$ || 'JACoW.edit_abstract', 'POST', cattributes=>'NAME="SPMS"');
      htp.formHidden ('abs_id', abs_id);
      htp.formSubmit (null, 'Login');
      htp.formClose;
      continue := false;

   elsif NOT get_abstract_record (abs_id) then -- ** abstract record fetched here **
      htp.header (3, 'No such abstract');
      continue := false;

   elsif common.user_is_jacow_admin then
      null;  -- skip the remaining tests

   elsif abstract_rec.editor_id is not null AND
		(	common.uploadable_dot_status (abstract_rec.status_code) OR
			abstract_rec.status_code is null
		) then

      if NOT editor then
	 htp.header (3, 'This abstract is being processed by the editors.  Updates are not allowed.');
	 htp.p ('You must contact the');
	 htp.mailto (common.editor_email$, common.conf_title$ || ' Editor');
	 htp.p ('to make additional changes.');
	 htp.para;
	 continue := false;
      end if;

   elsif common.freeze_abs_updates$ = 'Y' AND NOT editor AND common.PC_mode$ = 'N' then
      htp.header (3, 'Updates to abstracts are frozen by the conference administrator.');
      continue := false;

   elsif NOT common.has_privs_to_page(show_err_msg=>false) then
      continue := false;

   elsif NOT editor_saved_abs and NOT common.OK_to_edit_abstract (abs_id) then
      htp.header (3, no_privs$, cattributes=>common.red$);
      continue := false;

   end if;

   if continue then
      edit_abstract2 (abs_id, verify);
   elsif common.OK_to_edit_abstract (abs_id, for_title_change=>true) then
      if common.has_privs_to_page(show_err_msg=>true) then
	 edit_abstract3;
      end if;
   else
      htp.header (3, 'Updates to Abstracts are not allowed at this time.');
   end if;

   common.footer;

end edit_abstract;

-- ***********************************************************************************************

procedure edit_abstract_editor (abs_id integer) is

begin


   common.get_gbl_pid;
   if common.has_privs_to_page then
      editor_saved_abs := true;
      edit_abstract (abs_id);
   end if;

end edit_abstract_editor;

-- ***********************************************************************************************

procedure new_abstract is

continue	boolean := true;

begin

   common.get_gbl_pid;
   if common.valid_entry then
      if profile_exists then

	 if common.invitation_only$ = 'Y' then
	    continue := common.invitee;
	 end if;

	 if common.PC_mode$ = 'Y' then
	    if NOT common.has_privs_to_page (common.propose_invited$, false) then
	       continue := false;
	    end if;
	 end if;

	 if continue then
	    edit_abstract (null);
	 elsif common.invitation_only$ = 'Y' then
	    common.public_header ('Invitation Only Conference');
	    htp.header (3, invite_msg$);
	    common.footer;
	 else
	    common.public_header ('Invitation Only Conference');
	    htp.header (3, common.conf_title$ || ' is not accepting abstracts at this time.');
	    common.footer;
	 end if;
      end if;
   end if;

end new_abstract;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure upd_editor (abs_id integer, pid integer) is

begin

   if common.header ('Reassign Editor') then
      update	abstracts
      set	editor_id		= pid
      where	abstract_id		= abs_id
      and	nvl(editor_id,0)	<> pid;

      show_owner_info (abs_id);
      htp.header (3, 'Editor is now: ' || common.get_user_name (pid));
      htp.bold ('Close This Window To Continue.');
      htp.para;
      common.footer;
   end if;

end upd_editor;

-- ***********************************************************************************************
-- ***********************************************************************************************

procedure set_editor (abs_id integer) is

cursor	driver is
select	person_id, common.get_user_name (person_id) name
from	persons
where	person_id in
(	select	pp.person_id
	from	person_privs		pp,
		application_privs	ap,
		applications		appl
	where	'editor.html'		like appl.application_name
	and	ap.application_id	= appl.application_id
	and	pp.privilege_code	= ap.privilege_code
)
order by
	lname, fname;

selected	varchar2(10);
editor_pid	constant integer := common.decode_value ('editor_id', 'abstracts', 'abstract_id', abs_id);

begin

   if common.header ('Reassign Editor') then
      show_owner_info (abs_id);
      htp.para;
      htp.bold ('Select An Editor');

      htp.formOpen ('jacow.upd_editor', 'POST', cattributes=>'NAME="SPMS"');
      htp.formHidden ('abs_id', abs_id);
      htp.formSelectOpen ('pid');

      for driver_rec in driver LOOP
	 selected := null;
	 if editor_pid = driver_rec.person_id then
	    selected := 'SELECTED';
	 end if;

	 htp.formSelectOption (driver_rec.name, selected, cattributes=>'VALUE="' || driver_rec.person_id || '"');
      end loop;

      htp.formSelectClose;
      htp.formSubmit;
      htp.formClose;
      common.form_focus ('SPMS', 'pid');

      common.footer;
   end if;

end set_editor;

-- ***********************************************************************************************
-- ***********************************************************************************************

function user_has_abstracts return boolean is

cursor	driver is
select	1
from	abstracts
where	person_id	= common.gbl_pid
UNION
select	1
from	authors
where	profile_id	in (select profile_id from profiles where person_id = common.gbl_pid)
and	author_code	in (common.primary_author$, common.speaker$);

begin

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   return rec_found;

end user_has_abstracts;

-- ***********************************************************************************************

function get_author_requirements (abs_id integer) return varchar2 is

cursor	driver (code varchar2) is
select	1
from	logs
where	abstract_id	= abs_id
and	log_code	= code;

dummy		integer;
rec_found	boolean;
buffer		varchar2(200) := null;
msg$		constant varchar2(60) := 'Please bring to the Proceedings Office at the conference.';

begin

   if common.hardcopy_required$ = 'Y' then
      open driver (common.paper_copy_received$);
      fetch driver into dummy;
      rec_found := driver%FOUND;
      close driver;

      if NOT rec_found then
	 buffer := htf.br || htf.bold ('Waiting For Hard Copy', cattributes=>'STYLE="COLOR:RED"') || htf.br;
      end if;
   end if;

   if common.copyright_required$ = 'Y' then
      open driver (common.copyright_received$);
      fetch driver into dummy;
      rec_found := driver%FOUND;
      close driver;

      if NOT rec_found then
	 buffer := buffer || htf.br || htf.bold ('Waiting For Copyright Form', cattributes=>'STYLE="COLOR:RED"');
      end if;
   end if;

   return buffer;

end get_author_requirements;

-- ***********************************************************************************************

function check_user_dot_status (abs_id integer, editor_code varchar2) return varchar2 is

cursor	driver is
select	1
from	status_codes
where	status_code		= editor_code
and	user_validate		= 'Y'
and	user_validate_status	is not null;

rec_found	boolean;
dummy		integer;

begin

   if editor_code is null then
      return null;
   end if;

   open driver;
   fetch driver into dummy;
   rec_found := driver%FOUND;
   close driver;

   if NOT rec_found then
      return null;
   end if;

   return htf.br || htf.anchor ('jacow.user_status?abs_id=' || abs_id, 'Accept/Reject Editor''s Changes');

end check_user_dot_status;

-- ***********************************************************************************************

function get_editor_status (abs_id integer) return varchar2 is

cursor	driver is
select	status_code, editor_id, assignable
from	abstracts
where	abstract_id = abs_id;

rec	driver%ROWTYPE;

begin

   open driver;
   fetch driver into rec;
   close driver;

   if rec.status_code is null then
      if rec.editor_id is null then
	 if common.accept_file_uploads$ = 'Y' then

	    if rec.assignable >= common.file_weight_threshold$ then
	       return htf.br || 'Ready for editor';

	    elsif rec.assignable < common.file_weight_threshold$ then
	       return htf.br || 'Not all files uploaded';

	    elsif common.get_paper_id (abs_id, 'Y') is not null then
	       return htf.br || 'Ready for file upload';

	    else
	       return htf.br || 'Not Assigned Yet';

	    end if;
	 end if;

      else
	 return htf.br || 'Assigned To Editor: ' || common.get_user_name (rec.editor_id);

      end if;

   else
      return htf.br ||	htf.bold ('Editor Status: ')					||
			common.get_dot_image (rec.status_code, common.editor_dot$)	||
			get_author_requirements (abs_id)				||
			check_user_dot_status (abs_id, rec.status_code);

   end if;

   return null;

end get_editor_status;

-- ***********************************************************************************************

function get_poster_status (abs_id integer) return varchar2 is

poster_status	constant abstracts.poster_status%TYPE := common.decode_value ('poster_status', 'abstracts', 'abstract_id', abs_id);

begin

   if nvl (common.use_poster_police$, 'N') = 'N' then
      return null;
   end if;

   if poster_status is null then
      return null;
   end if;

   return htf.br || htf.bold ('Poster Status: ') || common.get_dot_image (poster_status, common.editor_dot$);

end get_poster_status;

-- ***********************************************************************************************

function get_referee_code (abs_id integer) return varchar2 is

referee_code	constant abstracts.referee_code%TYPE := common.decode_value ('referee_code', 'abstracts', 'abstract_id', abs_id);

begin

   if nvl (common.referee_conf$, 'N') = 'N' then
      return null;
   end if;

   if referee_code is null then
      return null;
   end if;

   return htf.br || htf.bold ('Referee Status: ') ||
	  common.get_dot_image (referee_code, common.referee_dot$);

return null;

end get_referee_code;

-- ***********************************************************************************************

function get_abs_status (abs_id integer) return varchar2 is

begin

   return get_editor_status  (abs_id) ||
	  get_poster_status  (abs_id) ||
	  get_referee_code (abs_id);

end get_abs_status;

-- ***********************************************************************************************

procedure show_missing_coauthers_warning (abs_id integer) is

cursor	driver is
select	count(1)
from	authors
where	abstract_id = abs_id;

icount	integer;

begin

   if common.PC_mode$ = 'N' then
      open driver;
      fetch driver into icount;
      close driver;

      if icount = 0 then
	 htp.tableRowOpen ('LEFT', 'TOP', cattributes=>common.red$);
	 htp.tableHeader ('Note:', 'RIGHT');
	 htp.tableHeader ('No Co-authors Specified.');
	 htp.tableRowClose;
      end if;
   end if;

end show_missing_coauthers_warning;

-- ***********************************************************************************************

procedure show_missing_copyright_warning (abs_id integer) is

cursor	driver is
select	count(1)
from	logs
where	abstract_id	= abs_id
and	log_code	= common.copyright_received$;

icount	integer;

begin

   if sysdate > common.conf_start_monday$ then
      open driver;
      fetch driver into icount;
      close driver;

      if icount = 0 then
	 htp.tableRowOpen ('LEFT', 'TOP', cattributes=>common.red$);
	 htp.tableHeader ('Note:', 'RIGHT');
	 htp.tableHeader ('No Signed Copyright On File.');
	 htp.tableRowClose;
      end if;
   end if;

end show_missing_copyright_warning;

-- ***********************************************************************************************

function format_abs_time
			(	abs_start_time integer, abs_duration integer,
				session_date date, session_beg_time integer, session_end_time integer)
			return varchar2 is

date1	date;
date2	date;

begin

   if abs_start_time is not null and abs_duration is not null then
      date1 := common.add_time (trunc (session_date), abs_start_time);
      date2 := common.add_time (date1,  abs_duration);
   else
      date1 := common.add_time (session_date, session_beg_time);
      date2 := common.add_time (session_date, session_end_time);
   end if;

   return htf.br ||	to_char (date1, 'FMDay,')	|| ' ' ||
			to_char (date1, 'hh24:mi')	|| '-' ||
			to_char (date2, 'hh24:mi');

end format_abs_time;

-- ***********************************************************************************************

procedure display_abstracts is

cursor	driver is
select	s.sort_order, sa.session_id, sa.session_seq, s.session_date, s.beg_time, s.end_time,
	a.abstract_id, a.person_id, a.editor_id, a.status_code, a.title,
	common.get_paper_id (a.abstract_id) paper_id,
	sa.start_time, sa.duration
from	sessions		s,
	abstract_sessions	sa,
	abstracts		a
where	a.person_id 		= common.gbl_pid
and	sa.abstract_id(+)	= a.abstract_id
and	sa.primary_flag(+)	= 'Y'
and	s.session_id(+)		= sa.session_id
UNION
select	s.sort_order, sa.session_id, sa.session_seq, s.session_date, s.beg_time, s.end_time,
	a.abstract_id, a.person_id, a.editor_id, a.status_code, a.title,
	common.get_paper_id (a.abstract_id) paper_id,
	sa.start_time, sa.duration
from	sessions		s,
	abstract_sessions	sa,
	abstracts		a,
	authors			auth
where	auth.profile_id		in (select profile_id from profiles where person_id = common.gbl_pid)
and	auth.author_code	in (common.primary_author$, common.speaker$)
and	a.abstract_id		= auth.abstract_id
and	sa.abstract_id(+)	= a.abstract_id
and	sa.primary_flag(+)	= 'Y'
and	s.session_id(+)		= sa.session_id;

buffer		varchar2(6000) := null;
copyright	boolean;
spk_profile_id	integer;
IDs		common.ident_arr;

begin

   htp.p (profile.js$);
   htp.tableOpen ('BORDER', cattributes=>'CELLPADDING="5"');
   htp.tableRowOpen ('LEFT', 'BOTTOM');

   htp.tableHeader ('Paper&nbsp;ID');
   htp.tableHeader ('Function');
   htp.tableHeader ('Abstract');
   htp.tableHeader ('History');
   htp.tableRowClose;

   for rec in driver LOOP
      spk_profile_id	:= common.get_author_profile_id (rec.abstract_id, common.speaker$);
      copyright		:=	common.copyright_required$ = 'Y'	and
				rec.paper_id is not null		and
				common.hide_program_codes$ = 'N';

      htp.tableRowOpen ('LEFT', 'TOP');

      buffer := rec.abstract_id;

      if rec.paper_id is not null AND (common.hide_program_codes$ = 'N' or common.user_is_jacow_admin) then
	 buffer := common.ifnotnull (rec.session_seq, htf.bold (rec.paper_id));
         buffer := buffer || format_abs_time (rec.start_time, rec.duration, rec.session_date, rec.beg_time, rec.end_time);
      end if;

      buffer := buffer || get_abs_status (rec.abstract_id);

      if buffer is null then
	 if common.user_is_jacow_admin then
	    buffer := rec.abstract_id;
	 else
	    buffer := 'Pending';
	 end if;
      end if;

      htp.tableData (buffer, cnowrap=>'NOWRAP');

-- **********

      buffer := htf.anchor2 ('JACoW.print_abstract?abs_id=' || rec.abstract_id, 'Print', ctarget=>'_blank');

      if rec.editor_id is NOT null AND rec.status_code is null then
	 null;

      elsif common.OK_to_edit_abstract (rec.abstract_id) then
	 buffer := buffer || htf.br ||
		htf.anchor ('JACoW.edit_abstract?abs_id='	|| rec.abstract_id, 'Edit')	|| htf.br ||
		htf.anchor ('JACoW.abs_authors?abs_id='		|| rec.abstract_id, set_label ('Speakers', 'Authors'));

	 if rec.editor_id is null then
	    buffer := buffer || htf.br ||
		htf.anchor ('JACoW.withdraw_abstract?abs_id='	|| rec.abstract_id, 'Withdraw');
	 end if;
      end if;

      if common.OK_to_upload_files (rec.abstract_id) OR
	 common.transp_uploadable (rec.abstract_id) then

         IDs := common.get_paper_ID_list (rec.abstract_id);
         if IDs.COUNT = 1 then
            buffer := buffer || htf.br ||
			htf.anchor ('JACoW.file_info?abs_id=' || rec.abstract_id ||
						'&paper_id=' || rec.paper_id, 'File Upload');
         else
            buffer := buffer || htf.br || 'File Upload';
            for i in 1..IDs.COUNT loop
               buffer := buffer || htf.listItem (
			htf.anchor ('JACoW.file_info?abs_id=' || rec.abstract_id ||
						'&paper_id=' || IDs(i), IDs(i)));
            end loop;
         end if;
      end if;

      if copyright then
	 buffer := buffer || htf.br || htf.anchor ('JACoW.copyright?this_id=' || rec.abstract_id, 'Copyright Form');
      end if;

      if editor.files_uploaded (rec.abstract_id) then
	 buffer := buffer || htf.br || common.paper_anchor_tag (rec.paper_id);
      end if;

      htp.tableData (buffer, cnowrap=>'NOWRAP');

      htp.p ('<TD>');
	 htp.tableOpen;
	 common.show_data_row ('Title:',   common.convert_text(rec.title, common.html_fmt$));

	 if common.get_presentation_type (rec.abstract_id) = common.oral$ then
	    label := 'Speaker:';
	 else
	    label := 'Presenter:';
	 end if;

	 common.show_data_row (label, common.get_user_name_affiliation (spk_profile_id));

	 if common.PC_mode$ = 'Y' then
	    common.show_data_row ('Alternative Speakers:', common.get_author_list2 (rec.abstract_id, false) );
	 else
	    common.show_data_row ('Authors:', nvl (common.get_author_list2 (rec.abstract_id), common.red ('Missing')) );
	 end if;
	 show_missing_coauthers_warning (rec.abstract_id);

	 if copyright then
	    show_missing_copyright_warning (rec.abstract_id);
	 end if;

	 htp.tableClose;
      htp.p ('</TD>');

      common.show_abstract_log (rec.abstract_id, false);

      htp.tableRowClose;
   end loop;

   htp.tableClose;
   htp.para;

end display_abstracts;

-- ***********************************************************************************************

procedure login is

begin

   html;

end login;

-- ***********************************************************************************************

procedure html2 is

begin

   if common.accept_abstracts then
      if profile_exists then
	 if common.PC_mode$ = 'Y' then
	    if common.has_privs_to_page (common.propose_invited$, false) then
	       htp.anchor ('JACoW.new_abstract', propose_abstract$);
	       htp.p (common.space2$);
	    end if;
	 elsif common.has_privs_to_page(show_err_msg=>false) then
	    htp.anchor ('JACoW.new_abstract', new_abstract$);
	 end if;
      else
	 htp.p ('You must create a profile before creating abstracts.');
	 htp.p (common.space2$);
      end if;
   else
      htp.header (3, common.conf_title$ || ' is not accepting abstracts at this time.');
   end if;

   htp.anchor ('profile.manage', mod_profile$);
   htp.p (common.space2$);

   registration.show_links (registration.show_on_contrib$);

   if common.PC_reclassify_enabled$ = 'Y' or common.PC_present_enabled$ = 'Y' then
      if common.has_privs_to_page ('prog_cmtte.html', false)	    OR
		prog_cmtte.is_expert (prog_cmtte.PROPOSE_RECLASS$) OR
		prog_cmtte.is_expert (prog_cmtte.PROPOSE_PRESENT$) OR
		prog_cmtte.is_expert (prog_cmtte.APPROVE_RECLASS$) OR
		prog_cmtte.is_expert (prog_cmtte.APPROVE_PRESENT$) then

	 htp.anchor ('prog_cmtte.html', 'Program Committee Access');
	 htp.p (common.space2$);
      end if;
   end if;

   if referee.is_a_referee then
      htp.anchor ('referee.html', 'Referee Access');
      htp.p (common.space2$);
   end if;

   if common.use_poster_police$ = 'Y' then
      if common.has_privs_to_page (common.poster_police_page$, false) then
	 htp.anchor (common.poster_police_page$, 'Poster Police');
	 htp.p (common.space2$);
      end if;
   end if;

   if owa_util.get_cgi_env ('HTTP_USER_AGENT') like '%MSIE%' then
      htp.anchor ('javascript:window.external.AddFavorite(''' ||
			common.server || common.vdir$ || 'jacow.html'',''' ||
			common.conf_title$ || ' Logon'');',
			'Bookmark This Page');
   end if;

   htp.para;

-- **********

   profile.visa_invite_prompt;
   htp.para;

   if user_has_abstracts then
      display_abstracts;
   elsif common.PC_mode$ = 'Y' then
      htp.header (3, 'You have no proposals on file.');
   else
      htp.header (3, 'You have no abstracts on file.');
   end if;

end html2;

-- ***********************************************************************************************

procedure html is

continue	boolean := true;

begin

   common.get_gbl_pid;

   if common.gbl_priv_pid = common.admin_pid$ and common.gbl_pid is null then
      common.public_header ('Error');
      htp.header (3, 'The JACoW Account can not create contributions.', cattributes=>common.red$);
      common.footer;

   elsif common.valid_entry then
      if common.has_privs_to_page (common.jacow_admin$, false) then
	 maint.header ('Abstract List');
	 htp.tableOpen;
	 htp.tableRowOpen ('LEFT', 'TOP');
	 htp.p ('<TD>');
	 maint.menu(0);
	 htp.p ('</TD>');
	 htp.p ('<TD>');
	 htp.para;

	 html2;
	 htp.p ('</TD>');
	 htp.tableRowClose;
	 htp.tableClose;

      else
	 common.public_header ('Abstract List');

	 if common.invitation_only$ = 'Y' then
	    htp.header (3, invite_msg$);
	    continue := common.invitee;
	 end if;

	 if continue then
	    html2;
	 end if;

      end if;

      common.footer;
   end if;

end html;

-- ***********************************************************************************************

end JACoW;

/
show error

set define on

--	Copyright (C) 2004-2008 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
