set define off

create or replace package body oral_extract as

-- ***********************************************************************************

procedure TAB is

cursor	driver is
select	sa.paper_id, a.title,
	common.get_user_name (
	  common.decode_value ('person_id', 'profiles', 'profile_id',
	    common.get_author_profile_id (a.abstract_id, common.speaker$) ) ) speaker
from	abstracts			a,
	abstract_sessions		sa,
	sessions			s,
	presentation_option_codes	poc
where	poc.presentation_type_code	= common.oral$
and	s.presentation_option_code	= poc.presentation_option_code
and	sa.session_id			= s.session_id
and	a.abstract_id			= sa.abstract_id
order by
	s.sort_order nulls last, s.session_date, s.beg_time, sa.session_seq;

type	rec_type is table of driver%ROWTYPE index by binary_integer;
recs	rec_type;

begin

   open driver;
   fetch driver BULK COLLECT into recs;
   close driver;

   owa_util.mime_header('application/vnd.excel', TRUE);
   reports.write ('Program Code');
   reports.write ('Title');
   reports.write ('Speaker', true);

   for i in 1..recs.COUNT LOOP
      reports.write (recs(i).paper_id);
      reports.write (recs(i).title);
      reports.write (recs(i).speaker, true);
   end loop;

end TAB;

-- ***********************************************************************************

end oral_extract;
/
show error

set define off

--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

