set define off

create or replace package body PDF_only as

procedure html is

cursor	driver is
select	a.abstract_id, common.get_paper_id (a.abstract_id) paper_id
from	sessions		s,
	abstract_sessions	sa,
	abstracts		a
where	a.editor_id		is null
and	a.assignable		> 0
and	exists
	(	select	1
		from	files	f1
		where	f1.abstract_id	= a.abstract_id
		and	f1.file_name	like '%AUTHOR.PDF')
and	not exists
	(	select	1
		from	files	f2
		where	f2.abstract_id	= a.abstract_id
		and	REGEXP_LIKE (f2.file_name, '\.(TEX|DOC|DOCX|ODT)$', 'i')
	)
and	sa.abstract_id	= a.abstract_id
and	s.session_id	= sa.session_id
order by
	s.sort_order nulls last,
	s.session_date,
	s.beg_time,
	sa.session_seq;

type		recs_type is table of driver%ROWTYPE index by binary_integer;
recs		recs_type;

begin

   open driver;
   fetch driver BULK COLLECT into recs;
   close driver;

   htp.header (3, 'PDF-Only Paper Count: ' || recs.COUNT);
   htp.bold ('Click on a paper ID to assign it to yourself.', cattributes=>common.red$);
   htp.para;

   for i in 1..recs.COUNT loop
      htp.anchor ('editor.assign_next_paper'	||
			'?abs_id='	|| recs(i).abstract_id ||
			'&ppid=&this_platform=&this_source=',
			recs(i).paper_id);

      htp.br;
   end loop;

end HTML;

end PDF_only;
/
show error

set define on