--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace package paper_ids as

   procedure html;
   procedure poster;
   procedure assign_poster;
   procedure move (aid varchar2, sid varchar2, seq varchar2);
   procedure validate;
   procedure set_paper_id (this_abstract integer, this_session varchar2, this_seq integer);
   procedure close_gaps (this_session varchar2);

   procedure bulk_search;
   procedure results (name_array owa.vc_arr, value_array owa.vc_arr);
   procedure bulk_assign (abs_id common.ident_arr, sid varchar2, pcode varchar2, pflag varchar2, stime varchar2, dur varchar2);

   function valid_sequences (this_session varchar2) return boolean;
   function gen_sort_order (abs_id integer, sorder number) return varchar2;
   function fmt_paper_seq (sid varchar2, seq integer, present_code varchar2) return varchar2;
   function get_next_session_seq (sid varchar2) return integer;

end paper_ids;
/
show error
