create or replace package body param as

-- ************************************************************

procedure load_param (this_id integer) is

cursor	driver is
select	value
from	parameters
where	id = this_id;

value	parameters.value%TYPE;

begin

   if NOT params.exists(this_id) then
      open driver;
      fetch driver into value;
      close driver;

      params(this_id) := value;
   end if;

end load_param;

-- ************************************************************

function param_text (this_id integer) return varchar2 is

begin
   load_param (this_id);
   return params(this_id);
end param_text;

-- ************************************************************

function param_date (this_id integer) return date is

begin
   load_param (this_id);
   return to_date (params(this_id), 'mm/dd/yyyy');
end param_date;

-- ************************************************************

function param_numb (this_id integer) return number is

begin
   load_param (this_id);
   return to_number (params(this_id));
end param_numb;

-- ************************************************************
-- ************************************************************

function repo_db$			return varchar2 is begin return param_text (0);   end repo_db$;
function conf_title$			return varchar2 is begin return param_text (1);   end conf_title$;
function pubs_home_page$		return varchar2 is begin return param_text (2);   end pubs_home_page$;
function file_upload_instr_URL$		return varchar2 is begin return param_text (3);   end file_upload_instr_URL$;
function chairs_email$			return varchar2 is begin return param_text (4);   end chairs_email$;
function conf_start_monday$		return date	is begin return param_date (5);   end conf_start_monday$;
function logo_url$			return varchar2 is begin return param_text (6);   end logo_url$;
function require_sub_class$		return varchar2 is begin return param_text (7);   end require_sub_class$;
function freeze_abs_updates$		return varchar2 is begin return param_text (8);   end freeze_abs_updates$;
function repo_profile_URL$		return varchar2 is begin return param_text (9);   end repo_profile_URL$;
function acct_instr$			return varchar2 is begin return param_text (10);  end acct_instr$;
function invitation_only$		return varchar2 is begin return param_text (11);  end invitation_only$;
function proceedings_base_URL$		return varchar2 is begin return param_text (12);  end proceedings_base_URL$;
function abstract_instr_url$		return varchar2 is begin return param_text (15);  end abstract_instr_url$;
function help_url$			return varchar2 is begin return param_text (16);  end help_url$;
function accept_abstracts$		return varchar2 is begin return param_text (17);  end accept_abstracts$;
function accept_file_uploads$		return varchar2 is begin return param_text (18);  end accept_file_uploads$;
function editor_email$			return varchar2 is begin return param_text (19);  end editor_email$;
function email_new_accounts$		return varchar2 is begin return param_text (20);  end email_new_accounts$;
function date_fmt_str$			return varchar2 is begin return param_text (21);  end date_fmt_str$;
function login_info_text$		return varchar2 is begin return param_text (22);  end login_info_text$;
function login_info_URL$		return varchar2 is begin return param_text (23);  end login_info_URL$;
function PC_present_enabled$		return varchar2 is begin return param_text (24);  end PC_present_enabled$;
function referee_auto_assign$		return varchar2 is begin return param_text (25);  end referee_auto_assign$;
function referee_notify_decline$	return varchar2 is begin return param_text (26);  end referee_notify_decline$;
function standalone_DB$			return varchar2 is begin return param_text (27);  end standalone_DB$;
function LI_dot_URL$			return varchar2 is begin return param_text (28);  end LI_dot_URL$;
function referee_notify_revisions$	return varchar2 is begin return param_text (29);  end referee_notify_revisions$;
function CSS_URL$			return varchar2 is begin return param_text (30);  end CSS_URL$;
function referee_PC_notify_decline$	return varchar2 is begin return param_text (31);  end referee_PC_notify_decline$;
function smtp_host$			return varchar2 is begin return param_text (33);  end smtp_host$;
function vdir_dflt$			return varchar2 is begin return param_text (34);  end vdir_dflt$;
function version_string$		return varchar2 is begin return param_text (35);  end version_string$;
function author_upload_script$		return varchar2 is begin return param_text (36);  end author_upload_script$;
function editor_download_script$	return varchar2 is begin return param_text (37);  end editor_download_script$;
function use_SSL$			return varchar2 is begin return param_text (38);  end use_SSL$;
function SSL_port$			return varchar2 is begin return param_text (39);  end SSL_port$;
function legal_footer_text$		return varchar2 is begin return param_text (40);  end legal_footer_text$;
function legal_footer_URL$		return varchar2 is begin return param_text (41);  end legal_footer_URL$;
function credits_footer$		return varchar2 is begin return param_text (42);  end credits_footer$;
function conf_location$			return varchar2 is begin return param_text (43);  end conf_location$;
function email_new_abstract$		return varchar2 is begin return param_text (44);  end email_new_abstract$;
function conf_len_days$			return number	is begin return param_numb (45);  end conf_len_days$;
function program_download_URL$		return varchar2 is begin return param_text (46);  end program_download_URL$;
function cc_new_affil_reqs$		return varchar2 is begin return param_text (47);  end cc_new_affil_reqs$;
function auto_session_ids$		return varchar2 is begin return param_text (48);  end auto_session_ids$;
function paper_id_oral_len$		return number	is begin return param_numb (49);  end paper_id_oral_len$;
function paper_id_poster_len$		return number	is begin return param_numb (50);  end paper_id_poster_len$;
function HTML_path$			return varchar2 is begin return param_text (51);  end HTML_path$;
function TEXT_path$			return varchar2 is begin return param_text (52);  end TEXT_path$;
function spires_meeting_note$		return varchar2 is begin return param_text (53);  end spires_meeting_note$;
function spires_conf_number$		return varchar2 is begin return param_text (54);  end spires_conf_number$;
function post_log_file$			return varchar2 is begin return param_text (55);  end post_log_file$;
function JACoW_URL$			return varchar2 is begin return param_text (56);  end JACoW_URL$;
function max_keywords$			return number	is begin return param_numb (57);  end max_keywords$;
function poster_id_assign_enabled$	return varchar2 is begin return param_text (58);  end poster_id_assign_enabled$;
function email_upd_abstract$		return varchar2 is begin return param_text (59);  end email_upd_abstract$;
function email_LOC_new_abstract$	return varchar2 is begin return param_text (60);  end email_LOC_new_abstract$;
function email_LOC_upd_abstract$	return varchar2 is begin return param_text (61);  end email_LOC_upd_abstract$;
function LOC_email_address$		return varchar2 is begin return param_text (62);  end LOC_email_address$;
function email_admn_new_abstracts$	return varchar2 is begin return param_text (63);  end email_admn_new_abstracts$;
function date_input_fmt_str$		return varchar2 is begin return param_text (64);  end date_input_fmt_str$;
function PC_reclassify_enabled$		return varchar2 is begin return param_text (65);  end PC_reclassify_enabled$;
function dtree_URL$			return varchar2 is begin return param_text (66);  end dtree_URL$;
function max_abstract_len$		return number	is begin return param_numb (67);  end max_abstract_len$;
function max_footnote_len$		return number	is begin return param_numb (68);  end max_footnote_len$;
function max_funding_agency_len$	return number	is begin return param_numb (69);  end max_funding_agency_len$;
function copyright_required$		return varchar2 is begin return param_text (70);  end copyright_required$;
function grace_period$			return number	is begin return param_numb (71);  end grace_period$;
function currency_symbol$		return varchar2 is begin return param_text (72);  end currency_symbol$;
function http_port$			return number	is begin return param_numb (73);  end http_port$;
function use_poster_police$		return varchar2 is begin return param_text (74);  end use_poster_police$;
function freeze_abs_reclass$		return varchar2 is begin return param_text (75);  end freeze_abs_reclass$;
function vdir_debug$			return varchar2 is begin return param_text (76);  end vdir_debug$;
function cc_all_email$			return varchar2 is begin return param_text (77);  end cc_all_email$;
function no_payment_email_msg$		return varchar2 is begin return param_text (78);  end no_payment_email_msg$;
function reclass_instr_URL$		return varchar2 is begin return param_text (79);  end reclass_instr_URL$;
function referee_conf$			return varchar2 is begin return param_text (80);  end referee_conf$;
function referee_instr$			return varchar2 is begin return param_text (81);  end referee_instr$;
function referees_per_paper$		return number	is begin return param_numb (82);  end referees_per_paper$;
function show_invoices$			return varchar2 is begin return param_text (83);  end show_invoices$;
function referee_PC_notify_revision$	return varchar2 is begin return param_text (85);  end referee_PC_notify_revision$;
function no_admin_coauthor_email$	return varchar2 is begin return param_text (86);  end no_admin_coauthor_email$;
function repo_URL$			return varchar2 is begin return param_text (87);  end repo_URL$;
function repo_URL_text$			return varchar2 is begin return param_text (88);  end repo_URL_text$;
function program_interval$		return number	is begin return param_numb (89);  end program_interval$;
function referee_notice$		return varchar2 is begin return param_text (90);  end referee_notice$;
function referee_assigned$		return varchar2 is begin return param_text (91);  end referee_assigned$;
function pmt_prompt_notes$		return varchar2 is begin return param_text (93);  end pmt_prompt_notes$;
function toc_by_present$		return varchar2 is begin return param_text (94);  end toc_by_present$;
function file_weight_threshold$		return varchar2 is begin return param_text (95);  end file_weight_threshold$;
function IP_addr_list$			return varchar2 is begin return param_text (96);  end IP_addr_list$;
function IP_addr_var$			return varchar2 is begin return param_text (97);  end IP_addr_var$;
function freeze_abs_present$		return varchar2 is begin return param_text (98);  end freeze_abs_present$;
function PC_mode$			return varchar2 is begin return param_text (100); end PC_mode$;
function PC_edit$			return varchar2 is begin return param_text (103); end PC_edit$;
function tz_offset$			return number	is begin return param_numb (104); end tz_offset$;
function cc_vendor$			return varchar2 is begin return param_text (105); end cc_vendor$;
function invite_letter$			return varchar2 is begin return param_text (106); end invite_letter$;
function CTX_rebuild_online$		return varchar2 is begin return param_text (107); end CTX_rebuild_online$;
function server_override$		return varchar2 is begin return param_text (108); end server_override$;
function new_affil_email$		return varchar2 is begin return param_text (109); end new_affil_email$;
function edot_hdr_text_color$		return varchar2 is begin return param_text (110); end edot_hdr_text_color$;
function edot_hdr_back_color$		return varchar2 is begin return param_text (111); end edot_hdr_back_color$;
function edot_hdr_font_size$		return varchar2 is begin return param_text (112); end edot_hdr_font_size$;
function edot_instr_font_size$		return varchar2 is begin return param_text (115); end edot_instr_font_size$;
function edot_cell_font_size$		return varchar2 is begin return param_text (116); end edot_cell_font_size$;
function edot_row_count$		return varchar2 is begin return param_text (117); end edot_row_count$;
function edot_column_count$		return varchar2 is begin return param_text (118); end edot_column_count$;
function edot_refresh_rate$		return varchar2 is begin return param_text (119); end edot_refresh_rate$;
function poster_transparencies$		return varchar2 is begin return param_text (120); end poster_transparencies$;
function deleteImg$			return varchar2 is begin return param_text (121); end deleteImg$;
function editImg$			return varchar2 is begin return param_text (122); end editImg$;
function usedImg$			return varchar2 is begin return param_text (123); end usedImg$;
function newImg$			return varchar2 is begin return param_text (124); end newImg$;
function nextImg$			return varchar2 is begin return param_text (125); end nextImg$;
function prevImg$			return varchar2 is begin return param_text (126); end prevImg$;
function cancelImg$			return varchar2 is begin return param_text (127); end cancelImg$;
function ht_booking$			return varchar2 is begin return param_text (128); end ht_booking$;
function ht_manager$			return varchar2 is begin return param_text (129); end ht_manager$;
function abs_book_initials_only$	return varchar2 is begin return param_text (130); end abs_book_initials_only$;
function same_editor_and_qa_allowed$	return varchar2 is begin return param_text (132); end same_editor_and_qa_allowed$;

-- ************************************************************

end param;
/
show error
