--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

set define off

Create or Replace package profile as

   type lnames	is table of varchar2(150) index by binary_integer;
   procedure html;
   procedure check_CTX_index;
   procedure login (URL varchar2);
   procedure vlogin;
   procedure new_vendor;
   procedure repo_new_vendor (URL varchar2, this_user_id varchar2, pwd1 varchar2, pwd2 varchar2, this_lname varchar2, this_fname varchar2, orig_addr_id number, this_addr_id number);

   procedure set_SPMS_privs (privs common.ident_arr, URL varchar2 default null);
   procedure prompt_SPMS_privs (URL varchar2 default null);


   procedure js;
   procedure psync (pid varchar2, code varchar2);
   procedure new_account;
   procedure mailing_lists;
   procedure xls (this_conference common.ident_arr);

   procedure show_find_form (admin_fields boolean default false, attrib_fields boolean default false);

   procedure maint;
   procedure maint2 (alpha varchar2);
   procedure maint3 (pid varchar2);
   procedure del_person (pid integer);
   procedure del_person2 (pid integer);

   procedure login_verify (URL varchar2, uid varchar2, pwd varchar2, action varchar2);
   procedure repo_authorize (pid varchar2, URL varchar2, response varchar2);
   procedure authorize (pid integer, response varchar2);

   procedure lost_pwd (pid integer);
   procedure lost_pwd2 (p integer, h number);
   procedure lost_pwd3 (p integer, h number, pwd1 varchar2, pwd2 varchar2, URL varchar2);

   procedure manage;
   procedure my_profile;
   procedure edit_profile (prof_id integer);
   procedure affil_search;
   procedure affil_search2 (string varchar2);

   procedure find_account;
   procedure find_account2 (this_lname varchar2, this_email varchar2);

   procedure find_user;
   procedure find_user2 (this_lname varchar2, this_email varchar2);
   procedure find_user3 (pid integer);
   procedure find_new_user (pid integer);

   procedure find_author (abs_id integer);
   procedure find_author2 (abs_id integer, this_lname varchar2, this_email varchar2);
   procedure find_new_author (abs_id integer);

   procedure find_repo;
   procedure find_repo2 (this_lname varchar2, this_email varchar2, string varchar2, attr common.ident_arr);
   procedure find_repo3 (pid integer);

   procedure find_regist;
   procedure find_regist2 (this_lname varchar2, this_email varchar2, string varchar2, attr common.ident_arr);
   procedure find_regist3 (pid integer);

   procedure find_invite;
   procedure find_invite2 (this_lname varchar2, this_email varchar2, string varchar2);
   procedure find_invite3 (pid common.ident_arr, invite common.ident_arr);
   procedure invitee_load (emails varchar2);

   procedure find_save_author (pid varchar2, URL varchar2, abs_id integer, this_lname varchar2,
			this_fname  varchar2, this_mname varchar2, this_initials varchar2,
			this_pname varchar2, orig_addr_id integer, this_addr_id integer,
			email varchar2, this_gender varchar2);

   procedure new_account (verified varchar2, pid integer, prof_id integer, this_user_id varchar2,
			pwd1 varchar2, pwd2 varchar2, this_lname varchar2, this_fname  varchar2,
			this_mname varchar2, this_initials varchar2, this_pname varchar2, orig_addr_id integer,
			this_addr_id integer, email varchar2, ms varchar2, po varchar2, phone varchar2,
			fax varchar2, this_sort varchar2, curr common.ident_arr, this_country varchar2,
			this_time_zone varchar2, this_date_fmt varchar2, this_membership_code common.ident_arr,
			this_membership_number common.ident_arr, this_conference_code common.ident_arr, this_gender varchar2);

   procedure repo_new_account (verified varchar2, URL varchar2, pid integer, priv_pid varchar2, prof_id integer, this_user_id varchar2,
			pwd1 varchar2, pwd2 varchar2, this_lname varchar2, this_fname  varchar2, this_mname varchar2,
			this_initials varchar2, this_pname varchar2, orig_addr_id integer, this_addr_id integer,
			email varchar2, ms varchar2, po varchar2, phone varchar2, fax varchar2, this_sort varchar2,
			curr common.ident_arr, this_country varchar2, this_time_zone varchar2, this_date_fmt varchar2,
			this_membership_code common.ident_arr, this_membership_number common.ident_arr,
			this_conference_code common.ident_arr, this_gender varchar2);

   procedure save_profile (prof_id integer, orig_addr_id integer, this_addr_id integer, email varchar2,
			ms varchar2, po varchar2, phone varchar2, fax varchar2, this_sort varchar2,
			curr common.ident_arr);
   procedure repo_save_profile (pid varchar2, ppid varchar2, URL varchar2, prof_id integer, orig_addr_id integer,
		this_addr_id integer, email varchar2, ms varchar2, po varchar2,
		phone varchar2, fax varchar2, this_sort varchar2, curr common.ident_arr);

   procedure edit_uidpwd;
   procedure save_uidpwd (this_user_id varchar2, pwd1 varchar2, pwd2 varchar2);
   procedure repo_save_uidpwd (pid varchar2, ppid varchar2, URL varchar2,
			this_user_id varchar2, pwd1 varchar2, pwd2 varchar2);

   procedure admin (comments varchar2);
   procedure affil_req;
   procedure affil_req_save (pid varchar2, URL varchar2, affil common.ident_arr, this_affil_type varchar2, addr common.ident_arr, this_country varchar2);

   procedure delete_profile (prof_id integer);
   procedure delete_profile2 (prof_id varchar2, URL varchar2);
   procedure show_affil_addr_popup (this_addr_id integer, vendor boolean default false);

   procedure edit_account_info;
   procedure edit_country_tz_info;
   procedure edit_membership_info;
   procedure edit_mailing_lists;
   procedure edit_addit_attr;
   procedure save_addit_attr (attr common.ident_arr);

   procedure save_account_info (this_lname varchar2, this_fname varchar2, this_mname varchar2, this_initials varchar2, this_gender varchar2, this_pname varchar2);
   procedure repo_save_account_info (pid varchar2, ppid varchar2, URL varchar2, this_lname varchar2,
			this_fname varchar2, this_mname varchar2, this_initials varchar2, this_pname varchar2, this_gender varchar2);

   procedure save_country_tz_info (this_country varchar2, this_time_zone varchar2, this_date_fmt varchar2);
   procedure repo_save_country_tz_info (pid varchar2, ppid varchar2, URL varchar2, this_country varchar2,
					this_time_zone varchar2, this_date_fmt varchar2);

   procedure save_membership_info (this_membership_code common.ident_arr, this_membership_number common.ident_arr);
   procedure repo_save_membership_info (pid varchar2, ppid varchar2, URL varchar2,
					this_membership_code common.ident_arr, this_membership_number common.ident_arr);

   procedure save_mailing_lists_info (this_conference_code common.ident_arr);
   procedure repo_save_mailing_lists_info (pid varchar2, ppid varchar2, URL varchar2,
					this_conference_code common.ident_arr);

   procedure merge (alpha varchar2, pids common.ident_arr);
   procedure merge2 (alpha varchar2, pids common.ident_arr, pid integer);
   procedure merge3 (old_pid integer, new_pid integer);

   procedure show_profile_header (show_select boolean, show_invitee boolean default false, show_abstract boolean default false);
   procedure show_search_results (this_lname varchar2, this_email varchar2,
			person_ids	in out common.int_arr,
			show_invitee	boolean default false,
			select_account	boolean default false,
			show_abstract	boolean default false);

   procedure new_coauthor_email (abs_id integer, prof_id integer);
   procedure affil_req_sync_complete (addr_id integer);
   procedure invite (invite varchar2);
   procedure log_activity (this_activity varchar2);
   procedure priv_addr (addr_id integer);
   procedure priv_addr_save (URL varchar2, addr_id integer, cpid varchar2, cppid varchar2,
			email varchar2, phone varchar2, fax varchar2, curr common.ident_arr,
			addr common.ident_arr, this_country varchar2);
   procedure del_priv_addr (URL varchar2, cpid varchar2, addr_id integer);
   procedure visa_invite_prompt;

   function js$ return varchar2;
   function find_search_db (this_lname varchar2 default null, this_email varchar2 default null, string varchar2 default null, attr common.ident_arr) return common.int_arr;
   function gen_password_hash (uid varchar2, pwd varchar2) return number;
   function get_lnames(names varchar2) return lnames;



acct_created$	constant activity_codes.activity_code%TYPE := 'AC';
acct_updated$	constant activity_codes.activity_code%TYPE := 'AU';
prof_created$	constant activity_codes.activity_code%TYPE := 'PC';
prof_updated$	constant activity_codes.activity_code%TYPE := 'PU';
prof_deleted$	constant activity_codes.activity_code%TYPE := 'PD';
mbrs_updated$	constant activity_codes.activity_code%TYPE := 'MSU';
mail_updated$	constant activity_codes.activity_code%TYPE := 'MLU';
attrib_updated$	constant activity_codes.activity_code%TYPE := 'AAU';

private_addr$	constant integer := -1;

end profile;
/
show error

set define on
