--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace package prog_cmtte as

   procedure html;
   procedure JS;
   procedure list (this_classification varchar2, this_sub_class varchar2, sortby varchar2, opt varchar2);
   procedure reclass_list;

   procedure present (aid integer);
   procedure present2 (aid integer, this_presentation varchar2 default null);
   procedure present_withd (aid integer, this_present varchar2) ;

   procedure class (aid integer, ptype varchar2);
   procedure class2 (aid integer, this_classification varchar2 default null, this_sub_class varchar2 default null);
   procedure class_withd (aid integer, this_Class varchar2);

   procedure accept_present (abs_id integer, code varchar2);
   procedure accept_present2 (abs_id integer, code varchar2);

   procedure reject_present (abs_id integer, code varchar2);
   procedure reject_present2 (abs_id integer, code varchar2);

   procedure accept_cls (abs_id integer, ccode varchar2, scode varchar2);
   procedure accept_cls2 (abs_id integer, ccode varchar2, scode varchar2);

   procedure reject_cls (abs_id integer, ccode varchar2, scode varchar2);
   procedure reject_cls2 (abs_id integer, ccode varchar2, scode varchar2);

   procedure set_priority (aid integer, code varchar2);
   procedure set_proposal (aid integer, flag integer, code varchar2);

   procedure edit_abs (abs_id integer);
   procedure save_abs (abs_id integer, this_title varchar2, this_description varchar2);

   function is_expert (expert_role integer, pid integer default common.gbl_pid, ccode varchar2 default '%') return boolean;
   function is_coordinator (class_code varchar2, pid integer default common.gbl_pid) return boolean;
   function is_coordinator (aid integer) return boolean;

PROPOSE_RECLASS$	constant integer := 1;
APPROVE_RECLASS$	constant integer := 2;
PROPOSE_PRESENT$	constant integer := 3;
APPROVE_PRESENT$	constant integer := 4;

proposal_accepted$	constant integer := 1;
proposal_rejected$	constant integer := 2;
proposal_clear$		constant integer := 3;

end prog_cmtte;
/
show error
