set define off

create or replace package body rpt_author_green as

rpt_title$	constant char(24)	:= 'Author Dot Reassignement';

-- **********************************************************************************

procedure html is

cursor	driver is
select	sa.paper_id
from	abstracts		a,
	abstract_sessions	sa,
	sessions		s
where	a.abstract_id		in
	(	select	abstract_id
		from	logs	l
		where	l.status_code	in
		(	select	status_code
			from	status_codes
			where	publishable	= 'Y')
		and	l.log_date	=
		(	select	max (l2.log_date)
			from	logs		l2
			where	l2.status_code	is not null)
		and	l.person_id	in
		(	select		aa.person_id
			from		abstract_authors	aa
			where		aa.abstract_id		= a.abstract_id)
	)
and	sa.abstract_id		= a.abstract_id
and	s.session_id		= sa.session_id
order by
	s.session_date, s.beg_time, s.end_time, sa.session_id, sa.session_seq;

recs	common.ident_arr;

begin

   if common.header (rpt_title$) then
      open driver;
      fetch driver BULK COLLECT into recs;
      close driver;

      htp.header (3, 'List of Papers with a Dot Reassignement by an Author');

      for i in 1..recs.COUNT loop
         htp.p (recs(i));
         htp.br;
      end loop;

      common.footer;
   end if;

end html;

-- **********************************************************************************

end rpt_author_green;
/
show error

set define on

--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

