set define off

Create or Replace package body rpt_per_diem as

-- ***********************************************************************************

procedure rpt_data (this_log varchar2) is

cursor	driver is
select	trunc (common.local_time_stamp (log_date)) log_date, count(1) icount
from	logs
where	log_code = this_log
group by
	trunc (common.local_time_stamp (log_date))
order by 1;

gbl_abs_count	integer;
total		integer := 0;

begin

      gbl_abs_count := reports.get_abs_count (this_log);
      htp.tableOpen ('BORDER', cattributes=>'CELLPADDING="3"');

      htp.tableRowOpen ('LEFT', 'BOTTOM');
      htp.tableHeader (common.decode_value ('log_descr', 'log_codes', 'log_code', this_log), ccolspan=>'2', crowspan=>'2');
      htp.tableHeader ('Daily Counts', 'CENTER', ccolspan=>'2');
      htp.tableHeader ('Running Totals', 'CENTER', ccolspan=>'3');
      htp.tableRowClose;

      htp.tableRowOpen ('LEFT', 'BOTTOM');
      htp.tableHeader ('Count');
      htp.tableHeader ('% Total');
      htp.tableHeader ('Count');
      htp.tableHeader ('% Total');
      htp.tableHeader ('% Running');
      htp.tableRowClose;

      for rec in driver LOOP
         total := total + rec.icount;

         htp.tableRowOpen ('CENTER', 'TOP');
         htp.tableData (to_char (rec.log_date, 'Day'), 'LEFT');
         htp.tableData (to_char (rec.log_date, 'dd-Mon-yy'), 'LEFT');
         htp.tableData (rec.icount);
         htp.tableData (reports.show_pct (rec.icount, gbl_abs_count));
         htp.tableData (total);
         htp.tableData (reports.show_pct (total, gbl_abs_count));
         htp.tableData (reports.show_pct (rec.icount, total-rec.icount));
         htp.tableRowClose;
      end loop;

      htp.tableClose;

end rpt_data;

-- ****************************************************************************************************

procedure rpt (this_log varchar2) is

this_descr	log_codes.log_descr%TYPE;

begin

   if common.header ('Contribution Activity Per Diem') then
      this_descr := common.decode_value ('log_descr', 'log_codes', 'log_code', this_log);

      htp.tableOpen;
      htp.tableRowOpen ('LEFT', 'TOP');

      htp.p ('<TD>');
         rpt_data (this_log);
      htp.p ('</TD>');

      htp.p ('<TD>');
         rpt_chart.log_chart2 (this_log, this_descr);
      htp.p ('</TD>');

      htp.tableRowClose;
      common.footer;
   end if;

end rpt;

-- ************************************************************************************************

procedure html is

begin

   if common.header ('Contribution Activity Per Diem') then
      htp.formOpen ('rpt_per_diem.rpt', 'POST');
      htp.header (3, 'Select An Activity');
      common.show_popup_list ('log');
      htp.para;
      htp.formSubmit;
      htp.formClose;
      common.footer;
   end if;

end html;

-- ***********************************************************************************************

end rpt_per_diem;

/
show error

set define on

--	Copyright (C) 2004-2008 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
