-- SPMS - Scientific Programme Management System
-- see at the bottom of this file for licensing
-- and copyright information

set define off

Create or Replace PACKAGE regist_maint AS

  empty_arr		   	owa_util.ident_arr;
  empty_arr_vc	    owa.vc_arr;
  empty_pmt_arr	   	common.ident_arr;
  pmt_id_arr	   		common.ident_arr;
  subject$			CONSTANT VARCHAR2(500) := common.conf_title$ || ' Registration';

  is_available$		CONSTANT INTEGER := 1;
  login_required$		CONSTANT INTEGER := 2;
  admin_required$		CONSTANT INTEGER := 3;
  show_on_profile$	CONSTANT INTEGER := 4;
  show_on_contrib$	CONSTANT INTEGER := 5;
  personId			INTEGER := NULL;

--	Procedure / Function intended for end user and for administrative manager too
  PROCEDURE CANCEL (action VARCHAR2, this_page INTEGER, crypt_pid VARCHAR2,
  redirect VARCHAR DEFAULT NULL);
  PROCEDURE show_invoice (this_page INTEGER, crypt_pid VARCHAR2, print_only BOOLEAN DEFAULT FALSE);
  PROCEDURE show_registration_page (ID INTEGER, crypt_pid VARCHAR2);


--	Procedure / Function for administrative manager

  PROCEDURE invoices;
  PROCEDURE show_selected_receipts(selected owa_util.ident_arr DEFAULT empty_arr,
  crypt_pid owa.vc_arr DEFAULT empty_arr_vc, pageid owa_util.ident_arr DEFAULT empty_arr);
  PROCEDURE process_payments(action VARCHAR, this_page INTEGER DEFAULT NULL, crypt_pid VARCHAR2 DEFAULT NULL,
  reg_id common.ident_arr,  pay_id common.ident_arr,
  amt common.ident_arr, payment_type common.ident_arr);
  PROCEDURE add_payment (action VARCHAR2, amt payments.AMOUNT%TYPE DEFAULT NULL,
  reg_id registrations.REGISTRATION_ID%TYPE, page registrations.PAGE_ID%TYPE,
  note payments.COMMENTS%TYPE DEFAULT NULL , pmt_type VARCHAR2 DEFAULT NULL);
  PROCEDURE reassign_payment(action VARCHAR2, reg_id NUMBER, pmt_id NUMBER, amount_to_move NUMBER DEFAULT 0,
  fee_id VARCHAR2 DEFAULT NULL);
  PROCEDURE input_request(action VARCHAR2, reg_id NUMBER, pmt_id NUMBER, amount_to_move NUMBER DEFAULT 0,
  meta meta_data_codes.META_DATA_CODE%TYPE, poplist poplist_items.POPLIST_ITEM_ID%TYPE ,
  page pages.PAGE_ID%TYPE, crypt_pid VARCHAR2, choice registrations.VALUE%TYPE DEFAULT NULL);
  PROCEDURE process_baldue;
  PROCEDURE show_profile (crypt_pid VARCHAR2);
  PROCEDURE show_search_fields;
  PROCEDURE show_search_registrants(fname VARCHAR2 DEFAULT NULL, lname VARCHAR2 DEFAULT NULL,
  affiliation VARCHAR2 DEFAULT NULL, cat_code VARCHAR2 DEFAULT NULL,
  checked VARCHAR2 DEFAULT NULL, balancedue VARCHAR2 DEFAULT NULL,
  sponsored VARCHAR2 DEFAULT NULL,	stPage NUMBER DEFAULT 1,
  startDate DATE DEFAULT NULL, endDate DATE DEFAULT NULL );
  PROCEDURE check_in_registrants(checkedin VARCHAR2, crypt_pid VARCHAR2, pageid NUMBER,
  fname VARCHAR2 DEFAULT NULL,
  lname VARCHAR2 DEFAULT NULL, affiliation VARCHAR2 DEFAULT NULL,
  cat_code VARCHAR2 DEFAULT NULL, checked VARCHAR2 DEFAULT NULL,
  balancedue VARCHAR2 DEFAULT NULL, sponsored VARCHAR2 DEFAULT NULL,
  stPage NUMBER DEFAULT 1, startDate DATE DEFAULT NULL,
  endDate DATE DEFAULT NULL );
  PROCEDURE add_registrant_delegates_notes(pgid NUMBER, crypt_pid VARCHAR2, action VARCHAR2, del_notes VARCHAR2 DEFAULT NULL);
  PROCEDURE notices;
  PROCEDURE send_notices (flag INTEGER);
  PROCEDURE new_item (crypt_pid VARCHAR2, this_page NUMBER DEFAULT NULL, redirect VARCHAR2 DEFAULT NULL);
  PROCEDURE new_item2 (crypt_pid VARCHAR2, code VARCHAR2, this_page NUMBER DEFAULT NULL,
  redirect VARCHAR2 DEFAULT NULL);
  PROCEDURE new_item3 (crypt_pid VARCHAR2, descr VARCHAR2, amt VARCHAR2, this_page NUMBER DEFAULT NULL,
  redirect VARCHAR2 DEFAULT NULL);
  PROCEDURE del_item (crypt_pid VARCHAR2, code INTEGER, this_page NUMBER DEFAULT NULL);
  PROCEDURE show_export_templates;
  PROCEDURE remove_template(tid INTEGER DEFAULT - 1);
  PROCEDURE edit_template(tid INTEGER DEFAULT - 1);
  PROCEDURE add_template(chk_arr IN owa_util.ident_arr DEFAULT	empty_arr, indx_arr IN owa_util.ident_arr DEFAULT empty_arr );
  PROCEDURE export_search_registrants(fname VARCHAR2 DEFAULT NULL, lname VARCHAR2 DEFAULT NULL, affiliation VARCHAR2 DEFAULT NULL,
  cat_code VARCHAR2 DEFAULT NULL, checked VARCHAR2 DEFAULT NULL, balancedue VARCHAR2 DEFAULT NULL,
  sponsored VARCHAR2 DEFAULT NULL, startDate DATE DEFAULT NULL, endDate DATE DEFAULT NULL,
  temp_id INTEGER DEFAULT - 1);
  PROCEDURE extract;
  PROCEDURE xls (baldue common.ident_arr, this_page INTEGER);
  PROCEDURE auto_notices;

  PROCEDURE jsFunctions;
  PROCEDURE JS;
  FUNCTION  JS$ RETURN VARCHAR2;
  FUNCTION  person_list (abs_id INTEGER, sepchr VARCHAR2 DEFAULT ', ') RETURN VARCHAR2;
  function  get_reg_descr (item_id integer) return varchar2;
  FUNCTION  get_fee_amt (item_id INTEGER, tmsdate DATE, considergraceperiod BOOLEAN DEFAULT TRUE) RETURN NUMBER;
  FUNCTION  get_fee_total (this_page INTEGER DEFAULT NULL, crypt_pid VARCHAR2 DEFAULT NULL,
  print BOOLEAN DEFAULT TRUE, show_prompt OUT BOOLEAN) RETURN NUMBER;
  FUNCTION  get_fee_total_query (this_page INTEGER DEFAULT NULL, crypt_pid VARCHAR2 DEFAULT NULL) RETURN NUMBER;
  FUNCTION  get_fee_received (this_page INTEGER DEFAULT NULL, crypt_pid VARCHAR2 DEFAULT NULL) RETURN NUMBER;
  FUNCTION  get_fee_waived (this_page INTEGER DEFAULT NULL, crypt_pid VARCHAR2 DEFAULT NULL) RETURN NUMBER;
  FUNCTION  is_erasable (this_page pages.PAGE_ID%TYPE, pid registrations.PERSON_ID%TYPE) RETURN BOOLEAN;
  FUNCTION  is_registered (pid INTEGER) RETURN VARCHAR2;
  FUNCTION  balancedue (crypt_pid VARCHAR2, pid registrants.PAGE_ID%TYPE) RETURN payments.AMOUNT%TYPE;
  FUNCTION  create_checked_arr(driver_rec IN OUT export_templates%ROWTYPE) RETURN owa_util.ident_arr;
  FUNCTION  get_status (ID INTEGER, flag INTEGER) RETURN BOOLEAN;
  FUNCTION  trimall (buffer VARCHAR2) RETURN VARCHAR2;

-- I don't know what they do

  PROCEDURE webServiceTest;

END regist_maint;

/
show error

set define on

--	Copyright (C) 2004-2008 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
