-- SPMS - Scientific Programme Management System
-- see at the bottom of this file for licensing
-- and copyright information

set define off

Create or Replace PACKAGE BODY registration AS

  record_per_page$ CONSTANT INTEGER := 10 ;
  rpt_title$	CONSTANT VARCHAR2(30)	:= 'Registration ';
  rpt_title2$	CONSTANT VARCHAR2(30)	:= rpt_title$ || 'Payments';
  rpt_title3$	CONSTANT VARCHAR2(30)	:= rpt_title$ || 'Statistics';
  rpt_title4$	CONSTANT VARCHAR2(30)	:= rpt_title$ || 'Receipt';
  rpt_title5$	CONSTANT VARCHAR2(30)	:= rpt_title$ || 'List';
  rpt_title6$	CONSTANT VARCHAR2(30)	:= rpt_title$ || 'Payment Failed';
  rpt_title7$	CONSTANT VARCHAR2(40)	:= 'All Attendees - View/Edit/Cancel';
  select_one$	CONSTANT VARCHAR2(40)	:= 'Select at least one attendee';

  disp_txt$	CONSTANT display_codes.display_code%TYPE := 'TXT';
  disp_YN$	CONSTANT display_codes.display_code%TYPE := 'YN';
  disp_popup$	CONSTANT display_codes.display_code%TYPE := 'POP';
  disp_multi$	CONSTANT display_codes.display_code%TYPE := 'MULT';
  disp_checkbox$	CONSTANT display_codes.display_code%TYPE := 'CHK';
  disp_mcb$	CONSTANT display_codes.display_code%TYPE := 'MCB';

  dataTnum$	CONSTANT data_type_codes.data_type_code%TYPE := 'NUM';
  dataTstr$	CONSTANT data_type_codes.data_type_code%TYPE := 'STR';
  dataTdte$	CONSTANT data_type_codes.data_type_code%TYPE := 'DTE';
  dataTfee$	CONSTANT data_type_codes.data_type_code%TYPE := 'FEE';
  dataTfee2$	CONSTANT data_type_codes.data_type_code%TYPE := 'FEE2';
  dataTsps$	CONSTANT data_type_codes.data_type_code%TYPE := 'SPS';

  checkbox$	CONSTANT VARCHAR2(8)	:= 'checkbox';
  non_present$	CONSTANT VARCHAR2(2)	:= 'ZZ';
  waived$		CONSTANT payment_codes.payment_code%TYPE := 'WAVE';
  back2_pay_inv$	CONSTANT VARCHAR2(200)	:= htf.anchor ('registration.record', 'Back to Payments and Receipts') || htf.para;

  js_close_win$	CONSTANT VARCHAR2(99)	:= '<input type="button" value="No" name="close" onClick="window.close()">';
  notices_1st$	CONSTANT INTEGER := 1;
  notices_all$	CONSTANT INTEGER := 2;

  regist_ID_meta$	CONSTANT VARCHAR2(4) := 'meta';
  regist_ID_popl$	CONSTANT VARCHAR2(4) := 'popl';
  regist_ID_mtrx$	CONSTANT VARCHAR2(4) := 'mtrx';
  regist_ID_paym$	CONSTANT VARCHAR2(4) := 'paym';
  regist_ID_ccpm$	CONSTANT VARCHAR2(4) := 'ccpm';
  regist_ID_chkb$	CONSTANT VARCHAR2(4) := 'chkb';

  not_authorized$	CONSTANT VARCHAR2(50) := 'You are not authorized to access this page.';

  HTML_output	BOOLEAN DEFAULT FALSE;
  print_only	BOOLEAN DEFAULT FALSE;
  ignore_admin$	BOOLEAN DEFAULT TRUE;
  validate_IP$	BOOLEAN DEFAULT TRUE;

  TYPE		pcode_type IS TABLE OF NUMBER INDEX BY presentation_codes.presentation_code%TYPE;
  TYPE		pmt_type IS TABLE OF payment_codes.instructions%TYPE INDEX BY VARCHAR2(4);
  pmt_instr	pmt_type;
  init_pcode	pcode_type;

  TYPE		page_type IS RECORD (
  page_id		INTEGER,
  page_name	pages.page_name%TYPE);
  TYPE		page_tbl IS TABLE OF page_type INDEX BY BINARY_INTEGER;
  page_rec	page_tbl;

  pcodes		common.ident_arr;

-- *******************************************************************************************
-- *******************************************************************************************

  PROCEDURE hide_bypass_vars (pg_id INTEGER) IS

  CURSOR	driver IS
    SELECT	*
    FROM	regist_bypass_vars
    WHERE	page_id = pg_id;

  CURSOR	C1 IS
    SELECT	fname, lname, authorization_given, country_code
    FROM	persons
    WHERE	person_id = common.gbl_pid;

  CURSOR	C2 IS
    SELECT	email_address, phone_number, fax_number, address_id
    FROM	profiles
    WHERE	person_id	= common.gbl_pid
    AND	deleted		IS NULL
    ORDER BY
    current_address	nulls last,
    update_date;

  CURSOR	C3 (addr_id$ INTEGER) IS
    SELECT	addr.*, affil.name1
    FROM	affiliations		affil,
    addresses		addr
    WHERE	addr.address_id		= addr_id$
    AND	affil.affiliation_id	= addr.affiliation_id;

  C1_rec	C1%ROWTYPE;
  C2_rec	C2%ROWTYPE;
  C3_rec	C3%ROWTYPE;

  country_name	country_codes.country_descr%TYPE;

  BEGIN

    OPEN C1;
    FETCH C1 INTO C1_rec;
    CLOSE C1;

-- Find the primary profile record for the Affiliation data
    OPEN C2;
    FETCH C2 INTO C2_rec;
    CLOSE C2;

    OPEN C3 (C2_rec.address_id);
    FETCH C3 INTO C3_rec;
    CLOSE C3;

    FOR i IN 1..2 LOOP
      IF C3_rec.address1 IS NULL THEN
	C3_rec.address1	:= C3_rec.address2;
	C3_rec.address2	:= C3_rec.po_box;
	C3_rec.po_box		:= NULL;
      END IF;
    END LOOP;

    IF C3_rec.address2 IS NULL THEN
      C3_rec.address2	:= C3_rec.po_box;
      C3_rec.po_box	:= NULL;
    END IF;

-- Primary profile record may not contain an email address
    IF C2_rec.email_address IS NULL THEN
      OPEN C2;
      LOOP
	FETCH C2 INTO C2_rec;
	EXIT WHEN C2%NOTFOUND;
	EXIT WHEN C2_rec.email_address IS NOT NULL;
      END LOOP;
      CLOSE C2;
    END IF;

    C1_rec.country_code := nvl (C1_rec.country_code, C3_rec.country_code);
    country_name	:= common.decode_value ('country_descr', 'country_codes',
    'country_code', C1_rec.country_code);

    FOR driver_rec IN driver LOOP
      IF driver_rec.value IS NOT NULL THEN
	htp.formHidden (driver_rec.var_name, driver_rec.value);
      END IF;

      IF driver_rec.bypass_var_code IS NOT NULL THEN
	IF driver_rec.bypass_var_code = 'uq_id' THEN
	  htp.formHidden (driver_rec.var_name, common.gbl_pid);
	ELSIF driver_rec.bypass_var_code = 'email' THEN
	  htp.formHidden (driver_rec.var_name, C2_rec.email_address);
	ELSIF driver_rec.bypass_var_code = 'lname' THEN
	  htp.formHidden (driver_rec.var_name, C1_rec.lname);
	ELSIF driver_rec.bypass_var_code = 'fname' THEN
	  htp.formHidden (driver_rec.var_name, C1_rec.fname);
	ELSIF driver_rec.bypass_var_code = 'affil' THEN
	  htp.formHidden (driver_rec.var_name, C3_rec.name1);
	ELSIF driver_rec.bypass_var_code = 'addr1' THEN
	  htp.formHidden (driver_rec.var_name, C3_rec.address1);
	ELSIF driver_rec.bypass_var_code = 'addr2' THEN
	  htp.formHidden (driver_rec.var_name, C3_rec.address2);
	ELSIF driver_rec.bypass_var_code = 'city' THEN
	  htp.formHidden (driver_rec.var_name, C3_rec.town);
	ELSIF driver_rec.bypass_var_code = 'state' THEN
	  htp.formHidden (driver_rec.var_name, C3_rec.postal_code);
	ELSIF driver_rec.bypass_var_code = 'country' THEN
	  htp.formHidden (driver_rec.var_name, C1_rec.country_code);
	ELSIF driver_rec.bypass_var_code = 'zip' THEN
	  htp.formHidden (driver_rec.var_name, C3_rec.zip_code);
	ELSIF driver_rec.bypass_var_code = 'fax' THEN
	  htp.formHidden (driver_rec.var_name, C2_rec.fax_number);
	ELSIF driver_rec.bypass_var_code = 'phone' THEN
	  htp.formHidden (driver_rec.var_name, C2_rec.phone_number);
	ELSIF driver_rec.bypass_var_code = 'retain' THEN
	  htp.formHidden (driver_rec.var_name, C1_rec.authorization_given);
	ELSIF driver_rec.bypass_var_code = 'rURL' THEN
	  htp.formHidden (driver_rec.var_name, common.server || common.vdir$ || 'jacow.html');
	ELSIF driver_rec.bypass_var_code = 'acountry' THEN
	  htp.formHidden (driver_rec.var_name, C3_rec.country_code);
	ELSIF driver_rec.bypass_var_code = 'postal' THEN
	  htp.formHidden (driver_rec.var_name, C3_rec.postal_code);
	END IF;
      END IF;
    END LOOP;

  END hide_bypass_vars;

-- *******************************************************************************************

  PROCEDURE bypass (pg_id INTEGER) IS

  CURSOR	driver IS
    SELECT	page_name, bypass_URL, admin_email
    FROM	pages
    WHERE	page_id = pg_id;

  driver_rec	driver%ROWTYPE;

  BEGIN

    common.public_header (rpt_title$);
    OPEN driver;
    FETCH driver INTO driver_rec;
    CLOSE driver;

    driver_rec.admin_email := nvl (driver_rec.admin_email, common.editor_email$);

    htp.header (3, driver_rec.page_name);
    htp.p ('You are about to leave SPMS to register for');
    htp.p ('"' || common.conf_title$ || '".');
    htp.p ('Some of your SPMS account information will be forwarded');
    htp.p ('to create your account in the external registration system.');
    htp.p ('If you encounter any problems with registration please send email to');

    IF driver_rec.admin_email IS NOT NULL THEN
      htp.mailto (driver_rec.admin_email, driver_rec.admin_email);
    END IF;

    htp.formOpen (driver_rec.bypass_URL, 'POST');
    hide_bypass_vars (pg_id);
    htp.para;
    htp.formSubmit (NULL, 'Proceed With Registration');
    htp.formClose;
    htp.para;
    common.footer;

  END bypass;

-- *******************************************************************************************
-- *******************************************************************************************

  FUNCTION get_reg_page_URL (pg_id INTEGER, page_name VARCHAR2, login_first BOOLEAN DEFAULT FALSE) RETURN VARCHAR2 IS

  CURSOR	driver IS
    SELECT	*
    FROM	pages
    WHERE	page_id = pg_id;

  driver_rec	driver%ROWTYPE;
  URL		VARCHAR2(200);
  script		VARCHAR2(200);
  query_string	VARCHAR2(4000) := 'Return the URL';
  dummy		common.ident_arr;

  BEGIN

    OPEN driver;
    FETCH driver INTO driver_rec;
    CLOSE driver;

    IF driver_rec.bypass_URL IS NOT NULL THEN
      RETURN 'registration.bypass?pg_id=' || pg_id;
    END IF;

    IF driver_rec.external_URL IS NOT NULL THEN
      cc_vendor.forwarder (common.gbl_pid, 0, dummy, dummy, query_string);
      RETURN driver_rec.external_URL || REPLACE (query_string, '?', '&');
    END IF;

    URL := common.server;
    IF driver_rec.admin_privs = 'Y' THEN
      URL := common.sserver;
    END IF;

    script := 'registration.' || page_name || '?ID=' || driver_rec.page_id;

    IF login_first THEN
      script := REPLACE (script, '?', '%3F');
      script := REPLACE (script, '=', '%3D');
      RETURN URL || common.vdir$ || 'profile.login?URL=' || script;
    END IF;

    RETURN URL || common.vdir$ || script;

  END get_reg_page_URL;

-- *******************************************************************************************

  FUNCTION item_is_late (the_date DATE, cutoff_date DATE, considergraceperiod BOOLEAN DEFAULT TRUE) RETURN BOOLEAN IS

  grace_period NUMBER := common.grace_period$;

  BEGIN
  -- consider grace_period or not?
    IF (considergraceperiod) THEN
      grace_period := common.grace_period$;
    ELSE
      grace_period := 0;
    END IF;

    IF trunc (nvl (the_date, SYSDATE - common.tz_offset$ / 24)) > cutoff_date + grace_period THEN
      RETURN TRUE;
    END IF;
    RETURN FALSE;

  END item_is_late;

-- *******************************************************************************************

  FUNCTION get_cutoff_date (ID INTEGER, id_type VARCHAR2) RETURN DATE IS

  CURSOR	driver IS
    SELECT	cutoff_date
    FROM	meta_data_codes
    WHERE	meta_data_code = ID;

  cutoff		DATE;
  meta_code	INTEGER;
  pop_id		INTEGER;

  BEGIN

    IF id_type = regist_ID_meta$ THEN
      OPEN driver;
      FETCH driver INTO cutoff;
      CLOSE driver;

      RETURN nvl (cutoff, SYSDATE + 100);

    ELSIF id_type = regist_ID_popl$ THEN
      meta_code := common.decode_value ('meta_data_code', 'poplist_items', 'poplist_item_id', id);
      RETURN get_cutoff_date (meta_code, regist_ID_meta$);

    ELSIF id_type = regist_ID_mtrx$ THEN
      pop_id := common.decode_value ('poplist_item_id1', 'fee_matrix', 'fee_matrix_id', ID);
      cutoff := get_cutoff_date (pop_id, regist_ID_popl$);
      pop_id := common.decode_value ('poplist_item_id2', 'fee_matrix', 'fee_matrix_id', ID);
      RETURN greatest (cutoff, get_cutoff_date (pop_id, regist_ID_popl$) );

    ELSIF id_type = regist_ID_chkb$ THEN
      pop_id := common.decode_value ('poplist_item_id', 'checkbox_items', 'checkbox_item_id', ID);
      RETURN get_cutoff_date (pop_id, regist_ID_popl$);

    END IF;

    RETURN NULL;

  END get_cutoff_date;

-- *******************************************************************************************


  FUNCTION item_selectable (pop_id INTEGER, meta_code INTEGER, page NUMBER, pid NUMBER DEFAULT NULL) RETURN BOOLEAN IS

  CURSOR	driver IS
    SELECT	1
    FROM	registrations r
    WHERE	r.poplist_item_id	= pop_id AND r.META_DATA_CODE = meta_code
    AND	r.person_id <> pid
    AND r.PAGE_ID = page
    AND	NOT EXISTS (SELECT * FROM registrants rg WHERE rg.PERSON_ID = r.person_id AND rg.PAGE_ID = page AND rg.cancel IS NOT NULL);


  dummy		INTEGER;
  rec_found	BOOLEAN;
  single		CONSTANT meta_data_codes.single_selection%TYPE := common.decode_value ('single_selection',
  'meta_data_codes', 'meta_data_code', meta_code);

  BEGIN

    IF nvl (single, 'N') = 'N' THEN
      RETURN TRUE;
    END IF;

    OPEN driver;
    FETCH driver INTO dummy;
    rec_found := driver%FOUND;
    CLOSE driver;

    RETURN NOT rec_found;

  END item_selectable;

-- *******************************************************************************************
-- *******************************************************************************************

  PROCEDURE show_row (chk_exist OUT BOOLEAN, buffer VARCHAR2, fee NUMBER DEFAULT 0, msg VARCHAR2 DEFAULT NULL,
  total BOOLEAN DEFAULT FALSE, due BOOLEAN DEFAULT TRUE, regist_ID INTEGER DEFAULT NULL ) IS

  checked		VARCHAR2(7) := NULL;
  param		VARCHAR2(10);
  amt NUMBER := fee;
  ccspan NUMBER;

  CURSOR payments (reg NUMBER) IS
    SELECT rp.REGISTRATION_ID, rp.amount paid , p.*
    FROM
    registrations_payments rp
    inner join payments p ON rp.PAYMENT_ID = p.PAYMENT_ID
    WHERE rp.REGISTRATION_ID = reg
    ORDER BY p.PROCESSED nulls last, p.TIMESTAMP;

  payment_rec payments%ROWTYPE;
  found BOOLEAN := FALSE;

  BEGIN
    chk_exist := false;
    if true or html_output	then -- html_output only was producing no output in "print all receipts"

      htp.tableRowOpen ('RIGHT', 'TOP');

      IF amt > 0 THEN
	htp.tableData (buffer || common.space$ || msg, cnowrap => 'NOWRAP',
	cattributes => 'class=boldtext');
      ELSE
	htp.tableData (buffer, cnowrap => 'NOWRAP', cattributes => 'class=boldtext');
      END IF;

      IF total THEN
	ccspan := 4;
	IF NOT due THEN
	  htp.tabledata(common.space$);
	  ccspan := ccspan - 1;
	end if;
	htp.tableData (htf.underline (common.currency_symbol$ || to_char (fee, common.currency_fmt$))
	, cattributes => 'class=boldtext');
	htp.tabledata(common.space$, ccolspan => ccspan);
      else
	htp.tableData (to_char (amt, common.currency_fmt$));
	OPEN payments(regist_id);
	FETCH payments INTO payment_rec;
	found := payments%FOUND;

	IF found THEN
	  htp.tableData (to_char (payment_rec.paid, common.currency_fmt$), 'RIGHT');
	  htp.tabledata(common.space$);
	  htp.tabledata(payment_rec.comments || common.space$, 'LEFT');
	  htp.p('<TD ALIGN="left">');
	  IF payment_rec.processed IS NOT NULL THEN
	    htp.p('Processed on ' ||	common.local_time (payment_rec.processed));
	  ELSE
	    htp.p('Promised to pay via ');
	  END IF;
	  htp.p(common.decode_value('payment_descr', 'payment_codes', 'payment_code', payment_rec.payment_code));
	  htp.p('</TD>');
	  amt := amt - payment_rec.paid;
	  FETCH payments INTO payment_rec;
	  found := payments%FOUND;
	  WHILE found LOOP
	    htp.tableRowClose;
	    htp.tableRowOpen;
	    htp.tabledata(common.space$);
	    htp.tabledata(common.space$);
	    htp.tableData ( to_char (payment_rec.paid, common.currency_fmt$), 'RIGHT');
	    htp.tabledata(common.space$);
	    htp.tabledata(payment_rec.comments || common.space$, 'LEFT');
	    htp.p('<TD ALIGN="left">');
	    IF payment_rec.processed IS NOT NULL THEN
	      htp.p('Processed on ' ||	common.local_time (payment_rec.processed));
	    ELSE
	      htp.p('Promised to pay via ');
	    END IF;
	    htp.p(common.decode_value('payment_descr', 'payment_codes', 'payment_code', payment_rec.payment_code));
	    htp.p('</TD>');
	    amt := amt - payment_rec.paid;
	    FETCH payments INTO payment_rec;
	    found := payments%FOUND;
	  END LOOP;
	  htp.tableRowClose;
	  CLOSE payments;
	  IF amt != 0 THEN  -- something is waiting to be paid
	    htp.tableRowOpen;
	    htp.tabledata(common.space$);
	    htp.tabledata(common.space$);
	    htp.tableData ('<em>' || to_char (amt, common.currency_fmt$) || '</em>', 'RIGHT');
	    IF NOT print_only THEN
	      htp.formhidden('amt', amt);
	      htp.formhidden('reg_id', regist_id);
	      htp.tableData (htf.formCheckbox ('sel_reg_id', regist_id, 'CHECKED') );
	      chk_exist := TRUE;
	    ELSE
	      htp.tabledata(common.space$);
	    END IF;
	    htp.tabledata('<em>Still Due</em>', 'LEFT' , ccolspan => '2');
	    htp.tableRowclose;
	  END IF;
	ELSE
	  IF NOT print_only THEN
	    htp.tabledata(common.space$);
	    htp.formhidden('reg_id', regist_id);
	    htp.formhidden('amt', amt);
	    htp.tabledata ( htf.formcheckbox ('sel_reg_id', regist_id, 'CHECKED'), 'LEFT' );
	    htp.tabledata(common.space$, ccolspan => '2');
	    chk_exist := TRUE;
	  ELSE
	    htp.tabledata(common.space$, ccolspan => '3');
	  END IF;
	END IF;
      END IF;

      htp.tableRowClose;
    END IF;

  END show_row;

-- *******************************************************************************************
-- *******************************************************************************************

  PROCEDURE LIST IS

  CURSOR	driver IS
    SELECT DISTINCT r.PERSON_ID, common.GET_USER_NAME(r.PERSON_ID, 'Y') name, common.GET_USER_AFFIL_LIST(r.PERSON_ID, '<br>') aff
    FROM	registrants r
    WHERE	r.cancel IS NULL
    AND	r.PAGE_ID IN (	SELECT page_id
    FROM pages
    WHERE 'Y' = nvl (include_participant_rpt, 'Y'))
    ORDER BY name;

  show_list	BOOLEAN;
  icount	integer := 0;

  BEGIN

    IF common.regist_list_public$ = 'Y' THEN
      show_list := TRUE;
    ELSE
      show_list := common.header (NULL, test_only => TRUE);
    END IF;

    IF show_list THEN
      common.public_header (rpt_title5$);
      htp.tableOpen ('BORDER');
      htp.tableRowOpen ('LEFT', 'BOTTOM');
      htp.tableHeader (common.space$);
      htp.tableHeader ('Name');
      htp.tableHeader ('Affiliation');
      FOR driver_rec IN driver LOOP
	icount := icount + 1;
	htp.tableRowOpen ('LEFT', 'TOP');
	htp.tableData (icount);
	htp.tableData (driver_rec.name);
	htp.tableData (driver_rec.aff);
	htp.tableRowClose;
      END LOOP;
      htp.tableClose;
      common.footer;
    END IF;

  END LIST;

-- *******************************************************************************************
-- *******************************************************************************************

  PROCEDURE show_invoice_link IS

  CURSOR	driver(person NUMBER) IS
    SELECT	DISTINCT registrants.page_id
    FROM	registrants
    WHERE	registrants.PERSON_ID = person AND registrants.CANCEL IS NULL;

  CURSOR pager(pid INTEGER) IS
    SELECT page_name, hide_invoice
    FROM pages
    WHERE page_id = pid;

  dummy		INTEGER;
  dummy2		BOOLEAN;
  rec_found	BOOLEAN;
  page		INTEGER;
  driver_rec	driver%ROWTYPE;
  pname		pages.PAGE_NAME%TYPE;
  hide 		pages.HIDE_INVOICE%TYPE;

  BEGIN
    common.GET_GBL_PID;
    OPEN driver(common.gbl_pid);

    LOOP
      FETCH driver INTO driver_rec;
      EXIT WHEN driver%NOTFOUND;
      OPEN pager(driver_rec.page_id);
      FETCH pager INTO pname, hide;
      CLOSE pager;
      IF nvl (hide, 'N') = 'N' THEN
	IF regist_maint.get_fee_total (driver_rec.page_id, common.ENCRYPT(common.gbl_pid), FALSE, dummy2) != 0 THEN
	  htp.anchor (common.sserver || common.vdir$ || 'registration.invoice2'	||
	  '?this_page=' || driver_rec.page_id || '&crypt_pid=' ||
	  common.encrypt (common.gbl_pid), pname || ' Receipt');
	  htp.p (common.space2$);
	END IF;
      END IF;
    END LOOP;
    CLOSE driver;

  END show_invoice_link;

-- *******************************************************************************************

  PROCEDURE show_booking_link IS


  BEGIN
    IF(common.ht_booking$ = 'Y') THEN
      htp.anchor (common.sserver || common.vdir$ || 'hotel_handling.search_free_rooms', 'Hotel booking');
    END IF;
  END	  show_booking_link;

-- *******************************************************************************************

  PROCEDURE show_links (flag INTEGER) IS

  CURSOR	driver IS
    SELECT	*
    FROM	pages
    WHERE	available = 'Y';

  URL	VARCHAR2(200);

  BEGIN

    common.get_gbl_pid;
    IF common.invitation_only$ = 'N' OR (common.invitation_only$ = 'Y' AND common.invitee) THEN

      FOR driver_rec IN driver LOOP
	IF (flag = show_on_profile$ AND driver_rec.show_on_profile  = 'Y') OR
	  (flag = show_on_contrib$ AND driver_rec.show_on_abstract = 'Y') THEN

	  URL := get_reg_page_URL (driver_rec.page_id, 'page');
	  htp.anchor2 (URL, driver_rec.page_name, ctarget => 'SPMS-Regist');
	  htp.p (common.space2$);
	END IF;
      END LOOP;

      show_invoice_link;

      show_booking_link;

    END IF;

  END show_links;

-- *******************************************************************************************
-- *******************************************************************************************

  FUNCTION get_poplist_ID (meta_code INTEGER, string VARCHAR2) RETURN INTEGER IS

  CURSOR	driver IS
    SELECT	poplist_item_id
    FROM	poplist_items
    WHERE	meta_data_code	= meta_code
    AND	item_value	= string;

  ID	INTEGER;

  BEGIN

    OPEN driver;
    FETCH driver INTO ID;
    CLOSE driver;

    RETURN ID;

  END get_poplist_ID;

-- *******************************************************************************************

  FUNCTION conditionaly_required (code INTEGER, yesno_list common.int_arr) RETURN BOOLEAN IS

  CURSOR	driver IS
    SELECT	yesno_meta_code
    FROM	conditional_requirements
    WHERE	meta_data_code = code;

  BEGIN

    IF yesno_list.count = 0 THEN
      RETURN FALSE;
    END IF;

    FOR driver_rec IN driver LOOP
      FOR i IN 1..yesno_list.count LOOP
	IF yesno_list(i) = driver_rec.yesno_meta_code THEN
	  RETURN TRUE;
	END IF;
      END LOOP;
    END LOOP;

    RETURN FALSE;

  END conditionaly_required;

-- *******************************************************************************************

  FUNCTION already_paid (meta_code INTEGER) RETURN BOOLEAN IS

  CURSOR	driver IS
    SELECT	1
    FROM	registrations
    WHERE	meta_data_code	= meta_code
    AND	paid		IS NOT NULL
    AND	reversed	IS NOT NULL;

  dummy		INTEGER;
  rec_found	BOOLEAN;

  BEGIN

    OPEN driver;
    FETCH driver INTO dummy;
    rec_found := driver%FOUND;
    CLOSE driver;

    RETURN rec_found;

  END already_paid;

-- *******************************************************************************************

  FUNCTION validate_data (meta_code VARCHAR2, string VARCHAR2,
  poplist_ids IN OUT common.int_arr,
  yesno_list common.int_arr) RETURN VARCHAR2 IS

  CURSOR	driver IS
    SELECT	*
    FROM	meta_data_codes
    WHERE	meta_data_code = meta_code;

  driver_rec	driver%ROWTYPE;
  required	BOOLEAN;

  BEGIN

    IF meta_code = checkbox$ THEN
      RETURN NULL;
    END IF;

    OPEN driver;
    FETCH driver INTO driver_rec;
    CLOSE driver;

-- Build a list of all values selected from popup fees.
-- The calling routine will check the matrix for valid combinations.

    IF driver_rec.data_type_code = dataTfee$ AND driver_rec.display_code = disp_popup$ THEN
      poplist_ids(poplist_ids.count + 1) := get_poplist_ID (meta_code, string);
    END IF;

    required := FALSE;
    IF driver_rec.required = 'Y' THEN
      required := TRUE;
    ELSE
      required := conditionaly_required (meta_code, yesno_list);
    END IF;

    IF already_paid (meta_code) THEN
      required := FALSE;
    END IF;

    IF required THEN

      IF regist_maint.trimall(string) IS NULL THEN
	RETURN htf.header (3, '"' || driver_rec.meta_data_descr || '" is required.');
      END IF;

      IF driver_rec.display_code = disp_YN$ AND nvl (string, '?') = '?' THEN
	RETURN htf.header (3, '"' || driver_rec.meta_data_descr || '" is required.');
      END IF;

    END IF;

    IF driver_rec.data_type_code IN (dataTnum$, dataTfee2$) THEN
      IF NOT common.validate_number (string) THEN
	RETURN htf.header (3, '"' || driver_rec.meta_data_descr || '" must be a number.');
      END IF;

    ELSIF driver_rec.data_type_code = dataTdte$ THEN
      IF NOT common.validate_date (string, common.date_input_fmt_str$) THEN
	RETURN htf.header (3, '"' || driver_rec.meta_data_descr || '" must be a date in the format ' ||
	upper (common.date_input_fmt_str$) || ', for example ' ||
	to_char (common.get_UTC_time, common.date_input_fmt_str$) );
      END IF;

    ELSIF driver_rec.data_type_code = dataTstr$ THEN
      IF driver_rec.fixed_length = 'Y' THEN
	IF driver_rec.data_length <> length (trim(string)) THEN
	  RETURN htf.header (3, '"' || driver_rec.meta_data_descr || '" must be ' ||
	  driver_rec.data_length || ' characters in length.');
	END IF;
      END IF;

    END IF;

    RETURN NULL;

  END validate_data;

-- *******************************************************************************************

  FUNCTION find_poplist_id (meta_code INTEGER, string VARCHAR2) RETURN VARCHAR2 IS

  CURSOR	driver IS
    SELECT	*
    FROM	meta_data_codes
    WHERE	meta_data_code = meta_code;

  CURSOR	C2 IS
    SELECT	poplist_item_id
    FROM	poplist_items
    WHERE	meta_data_code	= meta_code
    AND	    item_value	= string;

  driver_rec	driver%ROWTYPE;
  poplist_item_id	INTEGER;

  BEGIN

    OPEN driver;
    FETCH driver INTO driver_rec;
    CLOSE driver;

    IF driver_rec.display_code = disp_popup$ THEN
      OPEN C2;
      FETCH C2 INTO poplist_item_id;
      CLOSE C2;

      RETURN poplist_item_id;
    END IF;

    RETURN NULL;

  END find_poplist_id;

-- *******************************************************************************************

  FUNCTION check_poplist_combo (ID1 INTEGER, ID2 INTEGER) RETURN VARCHAR2 IS

  CURSOR	driver IS
    SELECT	*
    FROM	fee_matrix
    WHERE	poplist_item_id1	= ID1
    AND	poplist_item_id2	= ID2;

  driver_rec	driver%ROWTYPE;
  rec_found	BOOLEAN;
  msg		LONG;

  CURSOR	c2 (ID INTEGER) IS
    SELECT	p.item_value, m.meta_data_descr
    FROM	meta_data_codes		m,
    poplist_items		p
    WHERE	p.poplist_item_id	= ID
    AND	m.meta_data_code	= p.meta_data_code;

  c2_rec	c2%ROWTYPE;

  BEGIN

    OPEN driver;
    FETCH driver INTO driver_rec;
    rec_found := driver%FOUND;
    CLOSE driver;

    IF NOT rec_found THEN
      RETURN NULL; -- These two fees are not part of a fee matrix
    END IF;

    IF driver_rec.fee IS NULL THEN
      msg := htf.header (3, 'Invalid combination of items selected.');

      OPEN c2 (ID1);
      FETCH c2 INTO c2_rec;
      CLOSE c2;
      msg := msg || 'You selected ' || htf.bold (c2_rec.item_value) || ' for ' || htf.bold (c2_rec.meta_data_descr);

      OPEN c2 (ID2);
      FETCH c2 INTO c2_rec;
      CLOSE c2;
      msg := msg || ' and ' || htf.bold (c2_rec.item_value) || ' for ' || htf.bold (c2_rec.meta_data_descr);

      msg := msg || '. This combination is invalid.  Please select another combination.' || htf.para;
      RETURN msg;
    END IF;

    RETURN NULL;

  END check_poplist_combo;

-- *******************************************************************************************

  FUNCTION get_fee_matrix_id (ID1 INTEGER, ID2 INTEGER) RETURN INTEGER IS

  CURSOR	driver IS
    SELECT	fee_matrix_id
    FROM	fee_matrix
    WHERE (	poplist_item_id1	= ID1
    AND	poplist_item_id2	= ID2)
    OR (	poplist_item_id2	= ID1
    AND	poplist_item_id1	= ID2);

  driver_rec	driver%ROWTYPE;

  BEGIN

    OPEN driver;
    FETCH driver INTO driver_rec;
    CLOSE driver;

    RETURN driver_rec.fee_matrix_id;

  END get_fee_matrix_id;

-- *******************************************************************************************

  FUNCTION get_curr_fee_matrix_id (ID1 INTEGER, ID2 INTEGER) RETURN INTEGER IS

/* Use the two poplist IDs the user has selected to see if there is already
  a combination selected from the same poplist */

  CURSOR	driver IS
    SELECT	meta_data_code
    FROM	poplist_items
    WHERE	poplist_item_id IN (ID1, ID2);

  CURSOR	C2 (md1$ INTEGER, md2$ INTEGER) IS
    SELECT	fee_matrix_id
    FROM	registrations
    WHERE	person_id	= common.gbl_pid
    AND	fee_matrix_id	IN
    (	SELECT	fee_matrix_id
    FROM	fee_matrix
    WHERE	poplist_item_id1 IN
    (	SELECT	poplist_item_id
    FROM	poplist_items
    WHERE	meta_data_code = md1$)
    AND	poplist_item_id2 IN
    (	SELECT	poplist_item_id
    FROM	poplist_items
    WHERE	meta_data_code = md2$)
    );

  meta_data_codes	common.int_arr;
  matrix_id	INTEGER;
  rec_found	BOOLEAN;

  BEGIN

    IF ID1 IS NULL OR ID2 IS NULL THEN
      RETURN NULL;
    END IF;

    OPEN driver;
    FETCH driver BULK COLLECT INTO meta_data_codes;
    CLOSE driver;

    OPEN C2 (meta_data_codes(1), meta_data_codes(2));
    FETCH C2 INTO matrix_id;
    rec_found := C2%FOUND;
    CLOSE C2;

    IF NOT rec_found THEN
      OPEN C2 (meta_data_codes(2), meta_data_codes(1));
      FETCH C2 INTO matrix_id;
      CLOSE C2;
    END IF;

    RETURN matrix_id;

-- exception when others then return null;

  END get_curr_fee_matrix_id;

-- *******************************************************************************************

  PROCEDURE registrant_log (this_page INTEGER, crypt_pid VARCHAR2 ) IS

  person persons.PERSON_ID%TYPE := common.DECRYPT(crypt_pid);

  CURSOR	driver IS
    SELECT	1
    FROM	registrants
    WHERE	person_id	= person
    AND	page_id		= this_page;

  dummy		INTEGER;
  rec_found	BOOLEAN;
  sub_found	BOOLEAN;
  dummy2		BOOLEAN;
  email		pages.admin_email%TYPE;

  subject		mail_blats.subject%TYPE;
  recipient	mail_blats.recipient%TYPE;
  message		mail_blats.message%TYPE;
  page_name$	CONSTANT pages.page_name%TYPE := common.decode_value('page_name', 'pages', 'page_id', this_page);

  BEGIN

    IF this_page IS NOT NULL THEN
      email	:= common.decode_value ('admin_email', 'pages', 'page_id', this_page);
      recipient	:= common.get_user_email (person);
      subject	:= subject$;
      message	:= 'Dear ' || common.get_user_name (person) || common.eol2$ ||
      'This email is to inform you that your registration information was ';

      OPEN driver;
      FETCH driver INTO dummy;
      rec_found := driver%FOUND;
      CLOSE driver;

      IF rec_found THEN
	subject	:= subject || ' Changes';
	message	:= message || 'updated.';
      ELSE
	INSERT INTO registrants (page_id, person_id, attended) VALUES (this_page, person, 'no');
	subject	:= subject || ' Saved';
	message	:= message || 'saved.';
      END IF;

      IF regist_maint.get_fee_total (this_page, crypt_pid, FALSE, dummy2) != 0 THEN
	message := message || '  You may view your receipt at any time by returning to the ' ||
	common.conf_title$ || ' web site (' || common.server (TRUE)		||
	common.vdir$ || 'jacow.html) and clicking the "' || page_name$ || ' Receipt" link.';
      END IF;

      message := message || common.eol2$ || 'For any further requirement, please reply directly to this email.' ||
      common.eol2$ || 'Thank you' || common.eol2$ || subject$;

      IF recipient IS NOT NULL THEN
	send_mail (recipient, subject || ' - ' || page_name$,
	message, email, email, pid => person);
      END IF;
    END IF;

  END registrant_log;

-- *******************************************************************************************

  PROCEDURE end_registration (this_page INTEGER) IS

  URL	CONSTANT pages.return_URL%TYPE :=
  common.decode_value ('return_URL', 'pages', 'page_id', this_page);

  BEGIN

    htp.para;

    IF URL IS NOT NULL THEN
      htp.formOpen (URL);
      htp.formSubmit (NULL, 'Continue');
      htp.formClose;
    END IF;

  END end_registration;

-- *******************************************************************************************
-- *******************************************************************************************


  PROCEDURE show_page_info (this_page INTEGER) IS

  CURSOR	driver IS
    SELECT	post_info
    FROM	pages
    WHERE	page_id = this_page;

  driver_rec	driver%ROWTYPE;

  BEGIN

    OPEN driver;
    FETCH driver INTO driver_rec;
    CLOSE driver;

    htp.p (driver_rec.post_info);

  END show_page_info;

-- *******************************************************************************************

  PROCEDURE delete_checkboxes (name_array owa.vc_arr, value_array owa.vc_arr) IS

  buffer	LONG := NULL;
  query VARCHAR2(1000);

  BEGIN

    FOR i IN 3..name_array.count LOOP
      IF name_array(i) = checkbox$ THEN
	buffer := buffer || ',' || value_array(i);
      END IF;
    END LOOP;
    buffer := substr (buffer, 2);

    query := 'delete from registrations r
			where r.page_id=' || value_array(1) || ' and r.person_id=' || common.DECRYPT(value_array(2)) ||
    ' and r.meta_data_code in (Select pd.meta_data_code
				      			   from page_data pd
				      				inner join meta_data_codes mdc on pd.META_DATA_CODE=mdc.META_DATA_CODE
				      			   where mdc.display_code=''' || disp_checkbox$ || ''')';

    IF buffer IS NOT NULL THEN
      query := query || ' and r.poplist_item_id NOT in (' || buffer || ')';
    END IF;

    EXECUTE IMMEDIATE query;


  END delete_checkboxes;



-- *******************************************************************************************

  FUNCTION item_checked (item_id INTEGER, pid NUMBER, page NUMBER) RETURN BOOLEAN IS


  CURSOR	driver IS
    SELECT	1
    FROM	registrations
    WHERE	poplist_item_id	= item_id
    AND	person_id	= pid
    AND page_id = page;

  dummy		INTEGER;
  rec_found	BOOLEAN;

  BEGIN

    OPEN driver;
    FETCH driver INTO dummy;
    rec_found := driver%FOUND;
    CLOSE driver;

    RETURN rec_found;

  END item_checked;

-- *******************************************************************************************

  FUNCTION missing_checkboxes (name_array owa.vc_arr, value_array owa.vc_arr) RETURN VARCHAR2 IS

  CURSOR	driver IS
    SELECT	meta_data_code, meta_data_descr, required, checkbox_max_items
    FROM	meta_data_codes
    WHERE	display_code	= disp_checkbox$
    AND	meta_data_code	IN
    (	SELECT	meta_data_code
    FROM	page_data
    WHERE	page_id	= value_array(1) );

  CURSOR	C2 (code VARCHAR2) IS
    SELECT	poplist_item_id
    FROM	poplist_items
    WHERE	meta_data_code = code;

  msg		LONG := NULL;
  checkbox_count	INTEGER;

  b1	VARCHAR2(100);
  b2	VARCHAR2(100);

  BEGIN

    FOR driver_rec IN driver LOOP
      checkbox_count := 0;

      FOR C2_rec IN C2 (driver_rec.meta_data_code) LOOP
	FOR i IN 2..value_array.COUNT LOOP

	  IF name_array(i) = checkbox$ THEN
	    IF value_array(i) = C2_rec.poplist_item_id THEN
	      checkbox_count := checkbox_count + 1;
	    END IF;
	  END IF;

	END LOOP;

      END LOOP;

      IF driver_rec.required = 'Y' THEN
	IF checkbox_count = 0 THEN
	  msg := msg || htf.header (3, driver_rec.meta_data_descr || ' is required.');
	END IF;
      END IF;

      IF checkbox_count > driver_rec.checkbox_max_items THEN
	msg := msg || htf.header (3, 'Too many items selected for "' ||
	driver_rec.meta_data_descr || '" Check a maximum of ' ||
	driver_rec.checkbox_max_items || ' items.');
      END IF;

    END LOOP;

    RETURN msg;

  END missing_checkboxes;

-- *******************************************************************************************

  FUNCTION is_fee_mult (meta_code INTEGER) RETURN BOOLEAN IS

  CURSOR	driver IS
    SELECT	1
    FROM	meta_data_codes
    WHERE	meta_data_code	= meta_code
    AND	data_type_code	= dataTfee2$;

  dummy		INTEGER;
  rec_found	BOOLEAN;

  BEGIN

    OPEN driver;
    FETCH driver INTO dummy;
    rec_found := driver%FOUND;
    CLOSE driver;

    RETURN rec_found;

  END is_fee_mult;

-- *******************************************************************************************

/*	The user may change the number of items for a fee with a multiplier (FEE_MULT).  When
  this happens do not change any of the items already marked for payment, those must be
  cancelled.  Calculdate the difference then adjust the unpaid (payment_id is null)
  record accordingly. */

  PROCEDURE process_fee_mult (meta_code INTEGER, new_value INTEGER, page INTEGER, person INTEGER) IS

  CURSOR	driver IS
    SELECT	registration_id, VALUE, payment_id
    FROM	registrations
    WHERE	person_id	= person AND page_id = page
    AND	meta_data_code	= meta_code
    AND	payment_id	IS NOT NULL
    AND	reversed	IS NULL;

  total_paid	INTEGER := 0;
  new_amount	INTEGER;

  BEGIN

    FOR driver_rec IN driver LOOP
      total_paid := total_paid + to_number (driver_rec.value);
    END LOOP;

    new_amount := new_value - total_paid;

    IF new_value > total_paid THEN
      UPDATE	registrations
      SET	VALUE		= new_amount
      WHERE	person_id	= person AND page_id = page
      AND	meta_data_code	= meta_code
      AND	payment_id	IS NULL;

      IF SQL%rowcount = 0 THEN
	INSERT INTO registrations (person_id, meta_data_code, VALUE, page_id)
	VALUES (person, meta_code, new_amount, page);
      END IF;

    ELSIF new_value <= total_paid THEN
      DELETE FROM registrations
      WHERE	person_id	= person AND page_id = page
      AND	meta_data_code	= meta_code
      AND	payment_id	IS NULL;

    END IF;

  END process_fee_mult;

-- *******************************************************************************************

  PROCEDURE usave (name_array owa.vc_arr, value_array owa.vc_arr) IS

  CURSOR	driver (code INTEGER) IS
    SELECT	1
    FROM	conditional_requirements
    WHERE	yesno_meta_code = code;

  msg		LONG := NULL;
  pop_id		INTEGER;
  this_page	INTEGER := value_array(1);
  personId	INTEGER := common.DECRYPT(value_array(2));
  crypt_pid 	VARCHAR2(32767) := value_array(2);
  URL		pages.return_URL%TYPE;
  new_matrix_id	INTEGER;
  old_matrix_id	INTEGER;
  dummy		INTEGER;
  mdc 		INTEGER;
  rec_found	BOOLEAN;
  poplist_ids	common.int_arr;
  yesno_list	common.int_arr;
  page_name$	pages.page_name%TYPE := common.decode_value ('page_name', 'pages', 'page_id', this_page);
  new_value	registrations.value%TYPE;
  next_id		INTEGER;
  new_fee		BOOLEAN;
  k		INTEGER := 0;
  pid		owa_util.ident_arr := empty_arr;
  meta_code	NUMBER := NULL;
  perArr_name	VARCHAR2(1000);
  perArr_value	VARCHAR2(1000);
  BEGIN

    common.get_gbl_pid;

-- delete registrants sponsorship



    UPDATE registrants SET sponsored_by = NULL, meta_data_code = NULL WHERE sponsored_by = personId;



-- Build a list of all Yes/No questions that were answered Yes
-- and by definition, force other questions to be required.


    FOR i IN 2..name_array.count LOOP
      IF value_array(i) = 'Y' AND common.decode_value ('display_code', 'meta_data_codes',
	'meta_data_code', name_array(i)) = disp_YN$ THEN
	OPEN driver (name_array(i));
	FETCH driver INTO dummy;
	rec_found := driver%FOUND;
	CLOSE driver;

	IF rec_found THEN
	  yesno_list(yesno_list.count + 1) := name_array(i);
	END IF;
      END IF;
    END LOOP;

    common.public_header (page_name$);

    msg := missing_checkboxes (name_array, value_array);

    FOR i IN 3..name_array.count LOOP
      IF(instr(name_array(i), 'persons_') = 0 AND instr(name_array(i), 'pid_') = 0 AND name_array(i) != 'meta_code') THEN
	msg := msg || validate_data (name_array(i), value_array(i), poplist_ids, yesno_list);
      END IF;
    END LOOP;

-- Check the poplists for valid combinations in the matrix
    IF poplist_ids.count > 1 THEN
      FOR i IN 1..poplist_ids.count LOOP
	FOR j IN i + 1..poplist_ids.count LOOP
	  msg := msg || check_poplist_combo (poplist_ids(i), poplist_ids(j));
	END LOOP;
      END LOOP;
    END IF;

-- **********

    IF msg IS NULL THEN

      delete_checkboxes (name_array, value_array);

      FOR i IN 3..name_array.count LOOP


	IF(name_array(i) = 'meta_code') THEN
	  meta_code := value_array(i);
	  DELETE FROM registrations WHERE meta_data_code = meta_code AND person_id = personId;
	END IF;

	IF name_array(i) = checkbox$ THEN
	  IF NOT item_checked (value_array(i), personId, this_page) THEN
	    SELECT meta_data_code INTO mdc FROM poplist_items WHERE poplist_item_id = value_array(i);
	    SELECT registration_id_seq.nextval INTO next_id FROM dual;
	    INSERT INTO registrations (registration_id, person_id, poplist_item_id, meta_data_code, page_id)
	    VALUES (next_id, personId, value_array(i), mdc, this_page);
	  END IF;
	ELSE
	  IF(instr(name_array(i), 'persons_') = 0 AND instr(name_array(i), 'pid_') = 0 AND name_array(i) != 'meta_code') THEN

	    pop_id := find_poplist_id (name_array(i), value_array(i));
	    new_value := regist_maint.trimall (value_array(i));

	    IF new_value IS NOT NULL THEN
	      IF common.decode_value ('encrypt', 'meta_data_codes', 'meta_data_code', name_array(i)) = 'Y' THEN
		new_value := common.encrypt (new_value);
	      END IF;
	    END IF;

	    IF new_value IS NULL AND pop_id IS NULL AND NOT already_paid (name_array(i)) THEN
	      DELETE	FROM registrations
	      WHERE	person_id	= personId
	      AND	meta_data_code	= name_array(i)
	      AND page_id = this_page;
	    ELSIF is_fee_mult (name_array(i)) THEN
	      process_fee_mult (name_array(i), new_value, this_page, personId);
	    ELSE
	      UPDATE	registrations	r
	      SET	VALUE		= new_value,
	      poplist_item_id	= pop_id
	      WHERE	person_id	= personId
	      AND	meta_data_code	= name_array(i)
	      AND page_id = this_page;
	      IF SQL%ROWCOUNT = 0 THEN
		SELECT registration_id_seq.nextval INTO next_id FROM dual;
		INSERT INTO registrations (registration_id, person_id, meta_data_code,
		VALUE, poplist_item_id, page_id)
		VALUES (next_id, personId, name_array(i), new_value, pop_id, this_page);
	      END IF;

	    END IF;
	  ELSE
	    IF(name_array(i) IS NOT NULL AND instr(name_array(i), 'persons_') != 0) THEN
	      IF(value_array(i + 1) IS NOT NULL AND value_array(i) IS NOT NULL) THEN
		SELECT registration_id_seq.nextval INTO next_id FROM dual;
		INSERT INTO registrations (registration_id, person_id, VALUE, meta_data_code, page_id)
		VALUES (next_id, personId, value_array(i + 1), meta_code, this_page);

		UPDATE registrants
		SET 	sponsored_by = personId,
		meta_data_code = meta_code
		WHERE person_id = value_array(i + 1)
		AND page_id <> this_page;
	      END IF;
	    END IF;
	  END IF;
	END IF;
      END LOOP;

-- **********

      IF poplist_ids.count > 1 THEN
	FOR i IN 1..poplist_ids.count LOOP
	  FOR j IN i + 1..poplist_ids.count LOOP
	    new_matrix_id := get_fee_matrix_id (poplist_ids(i), poplist_ids(j));
	    old_matrix_id := get_curr_fee_matrix_id (poplist_ids(i), poplist_ids(j));

	    IF nvl(new_matrix_id, 0) <> nvl (old_matrix_id, 0) THEN
	      DELETE FROM registrations
	      WHERE  person_id	= personId AND page_id = this_page
	      AND	 fee_matrix_id	= old_matrix_id;

	      INSERT INTO registrations (person_id, fee_matrix_id, page_id)
	      VALUES (personId, new_matrix_id, this_page);
	    END IF;
	  END LOOP;
	END LOOP;
      END IF;

-- **********

      show_page_info (this_page);

      registrant_log (this_page, crypt_pid);

      IF nvl (common.decode_value ('hide_invoice', 'pages', 'page_id', this_page), 'N') = 'N' THEN
	HTML_output := TRUE;
	regist_maint.show_invoice (this_page, crypt_pid, FALSE);
      ELSE
	htp.header (3, common.decode_value ('page_name', 'pages', 'page_id', this_page) || 'Registration Complete');
	htp.p ('Thank you, your data was saved.');
	htp.p (common.space$);
	htp.anchor (common.server(TRUE) || common.vdir$ || 'jacow.html', 'Return to your abstract list.');
      END IF;

-- **********

    ELSE
      htp.p (msg);
    END IF;

    htp.para;
    common.footer;

  END usave;

-- *******************************************************************************************
-- *******************************************************************************************

  PROCEDURE payment (this_page INTEGER, crypt_pid VARCHAR2, reg_id common.ident_arr,
  amt common.ident_arr, sel_reg_id common.ident_arr, this_payment_code VARCHAR2,
  text VARCHAR2) IS

  credit_card$	CONSTANT payment_codes.credit_card%TYPE := common.decode_value ('credit_card',
  'payment_codes', 'payment_code', this_payment_code);
  pid$		CONSTANT INTEGER := common.decrypt (crypt_pid);

  msg		LONG := NULL;
  total		NUMBER := 0;
  calc_amt	NUMBER := 0;
  new_reg_id	common.ident_arr;
  new_amt		common.ident_arr;
  ADMIN		BOOLEAN;
  dummy		VARCHAR2(1);
  tsmdate 	DATE;
  pmt_id NUMBER;
  j INTEGER;
  z INTEGER;

  BEGIN

    common.get_gbl_pid;

    IF this_payment_code = 'dummy' THEN
      msg := htf.header (3, 'You must select a payment type.');
    END IF;

    IF sel_reg_id.count = 1 THEN
      msg := msg || htf.header (3, 'You must select at least one fee for this payment.');
    END IF;

-- **********

    IF msg IS NULL THEN
      registrant_log (this_page, crypt_pid);

      IF credit_card$ = 'Y' THEN
	tsmdate := SYSDATE;
	j := 2;
	z := 1;
	FOR i IN 2..reg_id.count LOOP
	  IF sel_reg_id(j) = reg_id(i) THEN
	    new_amt(z) := regist_maint.get_fee_amt(reg_id(i), tsmdate, FALSE);
	    new_reg_id(z) := reg_id(i);
	    calc_amt := calc_amt + new_amt(z);
	    z := z + 1;
	    j := j + 1;
	  END IF;

	  EXIT WHEN j > sel_reg_id.COUNT;
	END LOOP;

	IF common.cc_vendor$ IS NOT NULL THEN
	  cc_vendor.forwarder (pid$, calc_amt, new_reg_id, new_amt, dummy, page_id => this_page);
	END IF;

      ELSE
	SELECT payment_id_seq.nextval INTO pmt_id FROM dual;
	INSERT INTO payments (payment_id, person_id, amount, payment_code, comments)
	VALUES (pmt_id, pid$, 0, this_payment_code , trim (text) );

	j := 2;
	FOR i IN 2..reg_id.count LOOP
	  IF sel_reg_id(j) = reg_id(i) THEN
	    INSERT INTO registrations_payments (registration_id, payment_id, amount)
	    VALUES (reg_id(i), pmt_id, amt(i));

	    IF j<sel_reg_id.count THEN
	      j := j + 1;
	    END IF;
	  END IF;
	END LOOP;

	common.redirect_URL (common.sserver	|| common.vdir$	||
	'registration.invoice'		||
	'?this_page='	|| this_page	||
	'&crypt_pid='	|| crypt_pid);
      END IF;

    ELSE
      common.public_header (rpt_title$);
      htp.p (msg);
      htp.bold (common.click_back$);
      common.footer;
    END IF;

  END payment;

-- *******************************************************************************************
-- *******************************************************************************************

  PROCEDURE invoice (this_page INTEGER, crypt_pid VARCHAR2) IS

  BEGIN

    common.public_header (rpt_title2$);
    htp.header (3, 'Thank You.');
    htp.header (4, 'Your payment information was saved. ' || common.space2$ ||
    'Your payment will be posted as soon as it is processed.');
    HTML_output := TRUE;
    regist_maint.show_invoice (this_page, crypt_pid, FALSE);

    common.footer;

  END invoice;

-- *******************************************************************************************
-- *******************************************************************************************

  PROCEDURE invoice2 (this_page INTEGER, crypt_pid VARCHAR2, msg VARCHAR2 DEFAULT NULL) IS

  BEGIN

    common.public_header (rpt_title2$);
    HTML_output := TRUE;
    htp.p (msg);
    regist_maint.show_invoice (this_page, crypt_pid, FALSE);

    common.footer;

  END invoice2;

-- *******************************************************************************************
-- *******************************************************************************************

  FUNCTION get_registrant_count (ID INTEGER) RETURN INTEGER IS

  CURSOR	driver IS
    SELECT	COUNT(1)
    FROM	registrants
    WHERE	page_id = ID;

  icount	INTEGER;

  BEGIN

    OPEN driver;
    FETCH driver INTO icount;
    CLOSE driver;

    RETURN nvl (icount, 0);

  END get_registrant_count;

-- *******************************************************************************************

  PROCEDURE page (ID INTEGER) IS

  CURSOR	driver IS
    SELECT	*
    FROM	pages
    WHERE	page_id = ID;

  driver_rec	driver%ROWTYPE;
  rec_found	BOOLEAN;
  URL		VARCHAR2(200);
  CONTINUE	BOOLEAN := TRUE;
  registrants	INTEGER;

-- User data entry interface.

  BEGIN

    OPEN driver;
    FETCH driver INTO driver_rec;
    rec_found := driver%FOUND;
    CLOSE driver;

    common.get_gbl_pid;

    URL := get_reg_page_URL (ID, 'page', TRUE);

    IF common.gbl_pid IS NULL THEN -- user not logged in
      CONTINUE	:= FALSE;
      common.write_cookie ('URL', URL);
      common.redirect_URL (URL);

    ELSIF driver_rec.admin_privs = 'Y' AND NOT common.secure_login THEN
      CONTINUE	:= FALSE;
      common.redirect_URL (URL);

    ELSIF driver_rec.max_registrants IS NOT NULL THEN
      registrants := get_registrant_count (ID);
      IF registrants >= driver_rec.max_registrants THEN
	CONTINUE := FALSE;

	common.public_header (rpt_title$);
	htp.header (3, driver_rec.page_name);
	htp.header (3, 'Registration Closed', cattributes => common.red$);
	htp.bold ('Registration has reached maximum capacity.');
	htp.para;
	common.footer;
      END IF;

    END IF;

    IF CONTINUE THEN
      common.public_header (driver_rec.page_name, cache_timeout => 5, js_src => regist_maint.JS$);

      IF NOT rec_found THEN
	htp.header (3, 'Page #' || ID || ' does not exist.', cattributes => common.red$);
      ELSIF NOT regist_maint.get_status (ID, is_available$) THEN
	htp.header (3, 'This page is not available at this time.', cattributes => common.red$);
      ELSE
	htp.formOpen ('!registration.usave', 'POST', cattributes => 'name="saveForm"');
	htp.formHidden ('PID', ID);
	build_data_entry_form (id, TRUE, NULL);
	htp.formClose;
      END IF;
      common.footer;
    END IF;

  END page;

-- *******************************************************************************************
-- *******************************************************************************************

  PROCEDURE show_popup_list (meta_code VARCHAR2, data_value VARCHAR2) IS

  CURSOR	driver IS
    SELECT	*
    FROM	poplist_items
    WHERE	meta_data_code = meta_code
    ORDER BY
    sort_order nulls last, item_value;

  selected	VARCHAR2(8) := NULL;
  buffer		VARCHAR2(20);

  BEGIN

    IF data_value IS NULL THEN
      selected := 'SELECTED';
    END IF;

    htp.formSelectOption (NULL, selected);

    FOR driver_rec IN driver LOOP
      selected	:= NULL;
      buffer	:= NULL;

      IF driver_rec.item_value = data_value THEN
	selected := 'SELECTED';
      END IF;

      IF item_is_late (NULL, get_cutoff_date (meta_code, regist_ID_meta$)) THEN
	driver_rec.fee := nvl (driver_rec.late_fee, driver_rec.fee);
      END IF;

      IF driver_rec.fee IS NOT NULL THEN
	buffer := ' @ ' || common.currency_symbol$ || to_char(driver_rec.fee, common.currency_fmt$);
      END IF;

      htp.formSelectOption (driver_rec.item_value || buffer, selected,
      cattributes => 'VALUE="' || driver_rec.item_value || '"');
    END LOOP;

  END show_popup_list;

-- *******************************************************************************************

  FUNCTION checkbox_selected (person NUMBER, pid NUMBER, pop_id INTEGER, payment_id IN OUT NUMBER, processed IN OUT DATE) RETURN BOOLEAN IS


  CURSOR	driver IS
    SELECT	rpp.payment_id, rpp.processed
    FROM	registrations r
    left outer join
    (SELECT rp.REGISTRATION_ID, rp.AMOUNT paid, p.*
    FROM
    registrations_payments rp
    inner join payments p ON rp.PAYMENT_ID = p.PAYMENT_ID) rpp ON r.REGISTRATION_ID = rpp.registration_id
    WHERE	r.poplist_item_id	= pop_id
    AND	r.person_id	= person
    AND r.page_id = pid
    AND NOT EXISTS (SELECT * FROM registrants WHERE person_id = person AND page_id = pid AND CANCEL IS NOT NULL)
    ORDER BY rpp.timestamp DESC;

  rec_found	BOOLEAN;

  BEGIN

    OPEN driver;
    FETCH driver INTO payment_id, processed;
    rec_found := driver%FOUND;
    CLOSE driver;

    RETURN rec_found;

  END checkbox_selected;

-- *******************************************************************************************

  PROCEDURE show_checkbox_items (person NUMBER , pid NUMBER, meta_code INTEGER, freeze_updates VARCHAR2, islate BOOLEAN) IS

  CURSOR	driver IS
    SELECT	*
    FROM	poplist_items
    WHERE	meta_data_code	= meta_code
    ORDER BY
    sort_order nulls last,
    item_value;

  checked		VARCHAR2(7);
  processed	DATE;
  pmt_id 		NUMBER;
  frozen		BOOLEAN;
  buffer 		VARCHAR2(100) := '';

  BEGIN

    FOR driver_rec IN driver LOOP
      frozen := FALSE;
      checked	:= NULL;
      processed	:= NULL;
      pmt_id := NULL;
      IF islate THEN
	driver_rec.fee := driver_rec.late_fee;
      END IF;
      IF item_selectable (driver_rec.poplist_item_id, meta_code, pid, person) THEN
	IF checkbox_selected (person, pid, driver_rec.poplist_item_id, pmt_id, processed) THEN
	  checked := 'CHECKED';
	END IF;
	IF (freeze_updates = 'Y' OR processed IS NOT NULL OR pmt_id IS NOT NULL) THEN
	  frozen := TRUE;
	END IF;
	IF driver_rec.fee IS NOT NULL THEN
	  buffer := ' @ ' || common.currency_symbol$ || to_char (driver_rec.fee, common.currency_fmt$);
	END IF;
	IF NOT frozen THEN
	  htp.formCheckbox (checkbox$, driver_rec.poplist_item_id , checked);
	ELSE
	  htp.formCheckbox (NULL, NULL, checked, cattributes => 'disabled="true"');
	  htp.formhidden(checkbox$, driver_rec.poplist_item_id);
	END IF;
	htp.p (driver_rec.item_value || buffer);
	IF processed IS NOT NULL THEN
	  htp.p ('Processed: ' || to_char (processed, common.date_fmt_str$));
	END IF;
	htp.br;
      END IF;
    END LOOP;

  END show_checkbox_items;

-- *******************************************************************************************

  FUNCTION is_fee_processed (reg_id INTEGER) RETURN DATE IS

  CURSOR	driver IS
    SELECT	p.PROCESSED
    FROM	payments p
    inner join registrations_payments rp ON p.PAYMENT_ID = rp.PAYMENT_ID
    WHERE	p.PROCESSED IS NOT NULL AND rp.REGISTRATION_ID = reg_id;

  found	BOOLEAN;
  processed 	payments.PROCESSED%TYPE;
  BEGIN

    OPEN driver;
    FETCH driver INTO processed;
    found := driver%FOUND;
    CLOSE driver;
    IF found THEN
      RETURN processed;
    ELSE
      RETURN NULL;
    END IF;

  END is_fee_processed;

-- *******************************************************************************************

  PROCEDURE reset_value (VALUE IN OUT registrations.value%TYPE, code INTEGER) IS

  BEGIN

    htp.tableRowClose;
    htp.tableRowOpen;
    htp.tableData (common.space$ || htf.formHidden (code, VALUE) );
    VALUE := NULL;

  END reset_value;

-- *******************************************************************************************

  PROCEDURE display_data_entry_field (pid NUMBER, meta_code INTEGER, personId NUMBER) IS

  CURSOR	driver IS
    SELECT	*
    FROM	meta_data_codes
    WHERE	meta_data_code = meta_code;

  CURSOR a2 IS
    SELECT	*
    FROM	registrations
    WHERE	person_id	= personId AND page_id = pid
    AND meta_data_code	= meta_code;

  CURSOR to_freeze(reg NUMBER) IS
    SELECT 'Y'
    FROM registrations_payments
    WHERE registration_id = reg;

  driver_rec	driver%ROWTYPE;
  a2_rec a2%ROWTYPE;
  to_freeze_rec to_freeze%ROWTYPE;

  found BOOLEAN ;

  dummy 		VARCHAR2(1);
  ilen		CONSTANT INTEGER := length (common.date_input_fmt_str$);
  freeze		meta_data_codes.FREEZE_UPDATES%TYPE;
  processed 	DATE := NULL;
  islate  BOOLEAN := FALSE;

  BEGIN

    OPEN driver;
    FETCH driver INTO driver_rec;
    CLOSE driver;

    islate := item_is_late (NULL, driver_rec.cutoff_date);
    IF islate THEN
      driver_rec.fee := driver_rec.late_fee;
    END IF;

    OPEN a2;
    FETCH a2 INTO a2_rec;
    found := a2%FOUND;
    CLOSE a2;

    freeze := driver_rec.freeze_updates;
    IF found THEN
      processed := is_fee_processed (a2_rec.registration_id);

      IF driver_rec.encrypt = 'Y' THEN
	a2_rec.value := common.decrypt (a2_rec.value);
      END IF;

      IF freeze = 'N' THEN
	OPEN to_freeze(a2_rec.registration_id);
	FETCH to_freeze INTO dummy;
	found := to_freeze%FOUND;
	CLOSE to_freeze;
	IF found THEN
	  freeze := 'Y';
	END IF;
      END IF;
    END IF;


    IF driver_rec.display_code = disp_txt$ THEN
      IF driver_rec.data_type_code = dataTdte$ THEN
	IF processed IS NOT NULL THEN
	  htp.tableData (a2_rec.value || ' Processed: ' || processed);
	  reset_value (a2_rec.value, driver_rec.meta_data_code);
	ELSE
	  htp.tableData (htf.formText (meta_code, ilen, ilen, a2_rec.value) ||
	  ' Format: ' || upper (common.date_input_fmt_str$) );
	END IF;
      ELSIF driver_rec.data_type_code = dataTfee2$ THEN
	IF processed IS NOT NULL THEN
	  htp.tableData (common.currency_symbol$ || to_char(a2_rec.value * driver_rec.fee, common.currency_fmt$) ||
	  ' (' || a2_rec.value || ' @ ' || to_char(driver_rec.fee, common.currency_fmt$) || ' each). Processed: ' || processed );
	  reset_value (a2_rec.value, driver_rec.meta_data_code);
	ELSE
	  htp.tableData (htf.formText (meta_code,
	  driver_rec.view_length, driver_rec.data_length, a2_rec.value) ||
	  ' @ ' || common.currency_symbol$ || to_char(driver_rec.fee, common.currency_fmt$) || ' each');
	END IF;
      ELSIF driver_rec.data_type_code = dataTfee$ THEN
	IF processed IS NOT NULL THEN
	  htp.tableData (common.currency_symbol$ || to_char(a2_rec.fee, common.currency_fmt$) ||
	  ' (' || a2_rec.value || ' @ ' || to_char(driver_rec.fee, common.currency_fmt$) || ' each). Processed: ' || processed );
	  reset_value (a2_rec.value, driver_rec.meta_data_code);
	ELSE
	  htp.tableData (htf.formText (meta_code,
	  driver_rec.view_length, driver_rec.data_length, a2_rec.value) ||
	  ' @ ' || common.currency_symbol$ || to_char(driver_rec.fee, common.currency_fmt$) || ' each');
	END IF;
      ELSE
	IF processed IS NOT NULL THEN
	  htp.tableData (a2_rec.value || ' Processed: ' || processed );
	  reset_value (a2_rec.value, driver_rec.meta_data_code);
	END IF;
	htp.tableData (htf.formText (meta_code,
	driver_rec.view_length, driver_rec.data_length, a2_rec.value) );
      END IF;
    ELSIF driver_rec.display_code = disp_YN$ THEN
      IF processed IS NOT NULL THEN
	htp.tableData (common.yes_no (a2_rec.value) || ' Processed: ' || processed );
	reset_value (a2_rec.value, driver_rec.meta_data_code);
      ELSE
	htp.p ('<TD>');
	htp.p (common.popup_yes_no (meta_code, a2_rec.value) );
	htp.p ('</TD>');
      END IF;
    ELSIF driver_rec.display_code = disp_popup$ THEN
      IF processed IS NOT NULL THEN
	htp.tableData (common.decode_value ('item_value', 'poplist_items',
	'poplist_item_id', a2_rec.poplist_item_id) ||
	' Processed: ' || processed );
      ELSE
	htp.p ('<TD>');
	htp.formSelectOpen (meta_code);
	show_popup_list (meta_code, a2_rec.value);
	htp.formSelectClose;
	htp.p ('</TD>');
      END IF;
    ELSIF driver_rec.display_code = disp_multi$ THEN
      IF processed IS NOT NULL THEN
	htp.tableData (REPLACE (a2_rec.value, chr(10), htf.br) || ' Processed: ' || processed);
	reset_value (a2_rec.value, driver_rec.meta_data_code);
      ELSE
	htp.p ('<TD>');
	htp.formTextAreaOpen (meta_code, 3, 50);
	htp.p (a2_rec.value);
	htp.formTextAreaClose;
	htp.p ('</TD>');
      END IF;
    ELSIF driver_rec.display_code = disp_checkbox$ THEN
      htp.p ('<TD>');
      show_checkbox_items (personId, pid, meta_code, driver_rec.freeze_updates, islate);
      htp.p ('</TD>');
    END IF;

  END display_data_entry_field;

  PROCEDURE display_multi_dropdown(max_items NUMBER DEFAULT 0, meta_code NUMBER DEFAULT NULL, page NUMBER, personID NUMBER) IS

  CURSOR driver  IS
    SELECT rg.person_id, ps.lname, ps.fname
    FROM registrants rg
    inner join persons ps ON rg.person_id = ps.person_id
    WHERE rg.person_id IN (SELECT r.value
    FROM registrations r
    WHERE r.PERSON_ID = personID AND r.PAGE_ID = page AND r.meta_data_code = meta_code)
    AND rg.sponsored_by = personID
    ORDER BY ps.lname, ps.fname;

  driver_rec driver%ROWTYPE;
  found BOOLEAN DEFAULT FALSE;
  i NUMBER;

  BEGIN
    --common.get_gbl_pid;
    htp.p('<td>');
    htp.tableOpen();
    htp.formHidden('meta_code', meta_code);
    htp.anchor('#', NULL, meta_code);
    i := 0;
    OPEN driver;
    LOOP
      FETCH driver INTO driver_rec;
      found := driver%FOUND;
      EXIT WHEN found = FALSE;
      i := i + 1;
      htp.tableRowOpen();
      htp.p('<td>');
      htp.formText('persons_' || meta_code || '[' || (i - 1) || ']', cvalue => driver_rec.lname || ' ' || driver_rec.fname);
      htp.formHidden('pid_' || meta_code || '[' || (i - 1) || ']', driver_rec.person_id);
      htp.p(common.space$);
      htp.p(htf.anchor('javascript:popUp(''registration.sponsored_search_attendees?meta_code=' || meta_code || '&pos=' || (i - 1) || ''')', 'Add'));
      htp.p(htf.anchor('#' || meta_code, 'Delete', cattributes => 'onclick="window.document.forms[''saveForm''].elements[''persons_' || meta_code || '[' || (i - 1) || ']''].value='''';' ||
      'window.document.forms[''saveForm''].elements[''pid_' || meta_code || '[' || (i - 1) || ']''].value='''';"'));
      htp.p('</td>');
      htp.tableRowClose();
    END LOOP;
    FOR j IN i + 1..max_items LOOP
      htp.tableRowOpen();
      htp.p('<td>');
      htp.formText('persons_' || meta_code || '[' || (j - 1) || ']', cvalue => '');
      htp.formHidden('pid_' || meta_code || '[' || (j - 1) || ']', '');
      htp.p(common.space$);
      htp.p(htf.anchor('javascript:popUp(''registration.sponsored_search_attendees?meta_code=' || meta_code || '&pos=' || (j - 1) || ''')', 'Add'));
      htp.p(htf.anchor('#' || meta_code, 'Delete', cattributes => 'onclick="window.document.forms[''saveForm''].elements[''persons_' || meta_code || '[' || (i - 1) || ']''].value='''';' ||
      'window.document.forms[''saveForm''].elements[''pid_' || meta_code || '[' || (j - 1) || ']''].value='''';"'));
      htp.p('</td>');
      htp.tableRowClose();
    END LOOP;
    htp.tableClose();
    htp.p('</td>');
    CLOSE driver;
  END display_multi_dropdown;

-- *******************************************************************************************

  PROCEDURE build_data_entry_form (pid INTEGER, show_submit BOOLEAN, crypt_pid VARCHAR2) IS

  CURSOR	driver IS
    SELECT	pd.*, meta.meta_data_descr, meta.data_type_code, meta.required,
    meta.dropdown_max_items
    FROM	meta_data_codes		meta,
    page_data		pd
    WHERE	pd.page_id		= pid
    AND	meta.meta_data_code	= pd.meta_data_code
    ORDER BY
    pd.sort_order nulls last, page_data_id;

  CURSOR driver2(page NUMBER, person NUMBER) IS
    SELECT r.cancel
    FROM registrants r
    WHERE r.PAGE_ID = page AND r.PERSON_ID = person;


  CANCEL driver2%ROWTYPE;
  found BOOLEAN;

  red_star$	CONSTANT VARCHAR2(30) := htf.fontOpen ('RED') || '* ' || htf.fontClose;
  buffer		VARCHAR2(30);

  person 	persons.PERSON_ID%TYPE;

  BEGIN

    common.get_gbl_pid;

    IF crypt_pid IS NULL THEN
      person := common.gbl_pid;
      htp.formHidden ('personId', common.ENCRYPT(person));
    ELSE
      person := common.DECRYPT(crypt_pid);
      htp.formHidden ('personId', crypt_pid );
    END IF;

    htp.tableOpen;
    common.show_data_row (red_star$, 'Indicates required data');

    OPEN driver2(pid, person);
    FETCH driver2 INTO CANCEL;
    found := driver2%FOUND;
    CLOSE driver2;

    IF found = TRUE AND cancel.cancel IS NOT NULL THEN
      UPDATE registrants SET CANCEL = NULL WHERE PAGE_ID = pid AND PERSON_ID = person;
    END IF;

    FOR driver_rec IN driver LOOP

      IF driver_rec.text IS NOT NULL THEN
	common.show_data_row (NULL, driver_rec.text);
      END IF;

      buffer := NULL;
      IF driver_rec.required = 'Y' THEN
	buffer := red_star$;
      END IF;

      IF driver_rec.meta_data_code IS NOT NULL THEN
	htp.tableRowOpen ('LEFT', 'TOP');
	htp.tableData (buffer || driver_rec.meta_data_descr, 'RIGHT', cattributes => 'class=boldtext');
	IF (driver_rec.data_type_code = dataTsps$ ) THEN
	  display_multi_dropdown(driver_rec.dropdown_max_items, driver_rec.meta_data_code, pid, person);
	ELSE
	  display_data_entry_field (pid, driver_rec.meta_data_code, person);
	END IF;
	htp.tableRowClose;
      END IF;
    END LOOP;

    IF show_submit THEN
      common.show_data_row (NULL, htf.formSubmit);
    END IF;

    htp.tableClose;

  END build_data_entry_form;

  PROCEDURE sponsored_search_attendees(action VARCHAR2 DEFAULT NULL, l_name VARCHAR2 DEFAULT NULL, meta_code NUMBER DEFAULT NULL, pos NUMBER DEFAULT 0) IS

  query VARCHAR2(4000);
  TYPE	cursor_type IS REF CURSOR;
  driver	cursor_type;
  token$ LONG;
  pid NUMBER;
  firstname VARCHAR2(100);
  surname VARCHAR2(100);
  counter INTEGER := 0;
  y INTEGER := 0;


  BEGIN
    common.get_gbl_pid;
    common.public_header('Sponsor search attendees');
    regist_maint.jsFunctions;
    htp.tableOpen();
    htp.tableRowOpen();
    htp.p('<td width=25%>');
    htp.p('&nbsp');
    htp.p('</td>');
    htp.p('<td>');
    htp.tableOpen(cattributes => 'class="filter"');
    htp.p('<td colspan="2">');
    htp.p('You can search multiple attendees. Use % as a separator between two last names. If you want all the attendees just leave every field blank an click on the search button.');
    htp.p('</td>');
    htp.formOpen(curl => 'registration.sponsored_search_attendees', cmethod => 'post');
    htp.formHidden(cname => 'action', cvalue => 'search');
    htp.formHidden(cname => 'meta_code', cvalue => meta_code);
    htp.formHidden(cname => 'pos', cvalue => pos);
    htp.tableRowOpen();
    htp.tableData('Last name', cattributes => 'align="right"');
    htp.tableData(htf.formText(cname => 'l_name', csize => '30'), cattributes => 'align="left"');
    htp.tableRowClose();
    htp.tableRowOpen();
    htp.tableData(htf.formSubmit(cvalue => 'Search'), cattributes => 'align="left" colspan="2"');
    htp.tableRowClose();
    htp.formClose();
    htp.tableClose();
    htp.p('</td>');
    htp.tableRowClose();
    htp.tableClose();
    IF(action = 'search') THEN
      query := 'select distinct(p.person_id),p.fname,p.lname from persons p inner join registrants r on r.person_id = p.person_id
		    inner join registrations rg on rg.person_id = p.person_id';

      IF(l_name IS NOT NULL) THEN
	y := 1;
	LOOP
	  token$ := common.stringTokenizer(l_name, y , '%');
	  EXIT WHEN token$ IS  NULL;
	  IF(y = 1) THEN
	    query := query || ' and (lower(p.lname) like lower(''%' || token$ || '%'')';
	  ELSE
	    query := query || ' or lower(p.lname) like lower(''%' || token$ || '%'')';
	  END IF;
	  y := y + 1;
	END LOOP;
	query := query || ')';
      END IF;
      query := query || ' order by lname asc';
      htp.formOpen(curl => '#', cmethod => 'post', cattributes => 'name="attendees"');
      htp.tableOpen(cattributes => 'border="1px"');
      htp.tableRowOpen();
      htp.tableHeader('Select');
      htp.tableHeader('Last Name');
      htp.tableHeader('First Name');
      htp.tableRowClose();
      htp.formHidden(cname => 'selected[]', cvalue => 'dummy');
      htp.formHidden(cname => 'person[]', cvalue => 'dummy');
      OPEN driver FOR query;
      LOOP
	FETCH driver INTO pid, firstname, surname;
	EXIT WHEN driver%NOTFOUND;
	htp.tableRowOpen();
	htp.tableData(htf.formradio('selected[]', pid));
	htp.formHidden(cname => 'person[]', cvalue => surname ||  ' ' || firstname);
	htp.tableData(surname);
	htp.tableData(firstname);
	htp.tableRowClose();
	counter := counter + 1;
      END LOOP;
      CLOSE driver;
      htp.tableRowOpen();
      htp.p('<td colspan="4">');
      IF(counter != 0) THEN
	htp.p('<input type="button" value="Add selected attendees" onclick="addSelected(' || pos || ',' || meta_code || ');" />');
      END IF;
      htp.p('</td>');
      htp.tableRowOpen();
      htp.tableClose();
      htp.formClose();
    END IF;
    common.footer;
  END sponsored_search_attendees;

-- ***************************************************************************************
-- ***************************************************************************************

  PROCEDURE show_popup_table_payments (query VARCHAR2, cname  VARCHAR2, cprompt  VARCHAR2 DEFAULT NULL,
  nsize INTEGER	DEFAULT NULL, cattributes  VARCHAR2   DEFAULT NULL,
  this_value VARCHAR2 DEFAULT NULL, show_blank BOOLEAN DEFAULT TRUE,
  with_creditcard BOOLEAN DEFAULT TRUE) IS

  TYPE pmt_type IS REF CURSOR;
  driver pmt_type;

  code 	payment_codes.PAYMENT_CODE%TYPE;
  descr	payment_codes.PAYMENT_DESCR%TYPE;
  credit_card	 payment_codes.credit_card%TYPE;
  checked		VARCHAR2(7) := NULL;

  BEGIN


    htp.formSelectOpen (cname, cprompt, nsize, cattributes);
    IF show_blank THEN
      IF this_value IS NULL THEN
	checked := 'CHECKED';
      END IF;
      htp.formSelectOption ('', checked, cattributes => 'VALUE="dummy"');
    END IF;

    OPEN driver FOR query;

    LOOP
      FETCH driver INTO code, descr;
      EXIT WHEN driver%NOTFOUND;
      checked := NULL;
      IF this_value = code THEN
	checked := 'CHECKED';
      END IF;
      credit_card := common.decode_value ('credit_card', 'payment_codes', 'payment_code', code);
      IF with_creditcard OR credit_card != 'Y' THEN
	htp.formSelectOption (descr, checked, cattributes => 'VALUE="' || code || '"');
      END IF;
    END LOOP;
    CLOSE driver;

    htp.formSelectClose;

  END show_popup_table_payments;

-- *******************************************************************************************
-- *******************************************************************************************

  PROCEDURE find_regist(pid INTEGER DEFAULT NULL) IS
  BEGIN
    profile.find_regist3 (pid);
  END find_regist;

END registration;

/
show error

set define on

--	Copyright (C) 2004-2008 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
