-- SPMS - Scientific Programme Management System
-- see at the bottom of this file for licensing
-- and copyright information

set define off

CREATE OR REPLACE PACKAGE registration AS
  
  empty_arr		   	owa_util.ident_arr;
  empty_arr_vc	    owa.vc_arr;
  empty_pmt_arr	   	common.ident_arr;
  pmt_id_arr	   		common.ident_arr;
  subject$			CONSTANT VARCHAR2(500) := common.conf_title$ || ' Registration';
  
  is_available$		CONSTANT INTEGER := 1;
  login_required$		CONSTANT INTEGER := 2;
  admin_required$		CONSTANT INTEGER := 3;
  show_on_profile$	CONSTANT INTEGER := 4;
  show_on_contrib$	CONSTANT INTEGER := 5;
  personId			INTEGER := NULL;
  
--	Procedure / Function intended for end user
  
  PROCEDURE page (ID INTEGER);
  PROCEDURE payment (this_page INTEGER, crypt_pid VARCHAR2, reg_id common.ident_arr,
  amt common.ident_arr, sel_reg_id common.ident_arr,
  this_payment_code VARCHAR2, text VARCHAR2);
  PROCEDURE build_data_entry_form (pid INTEGER, show_submit BOOLEAN, crypt_pid VARCHAR2);
  PROCEDURE usave (name_array owa.vc_arr, value_array owa.vc_arr);
  PROCEDURE invoice (this_page INTEGER, crypt_pid VARCHAR2);
  PROCEDURE invoice2 (this_page INTEGER, crypt_pid VARCHAR2, msg VARCHAR2 DEFAULT NULL);
  PROCEDURE show_popup_table_payments (query VARCHAR2, cname  VARCHAR2, cprompt  VARCHAR2 DEFAULT NULL,
  nsize INTEGER	DEFAULT NULL, cattributes  VARCHAR2   DEFAULT NULL,
  this_value VARCHAR2 DEFAULT NULL, show_blank BOOLEAN DEFAULT TRUE,
  with_creditcard BOOLEAN DEFAULT TRUE);
  PROCEDURE bypass (pg_id INTEGER);
  PROCEDURE show_links (flag INTEGER);
  PROCEDURE LIST;
  PROCEDURE show_row (chk_exist OUT BOOLEAN, buffer VARCHAR2, fee NUMBER DEFAULT 0, msg VARCHAR2 DEFAULT NULL,
  total BOOLEAN DEFAULT FALSE, due BOOLEAN DEFAULT TRUE, regist_ID INTEGER DEFAULT NULL );
  PROCEDURE sponsored_search_attendees(action VARCHAR2 DEFAULT NULL, l_name VARCHAR2 DEFAULT NULL,
  meta_code NUMBER DEFAULT NULL, pos NUMBER DEFAULT 0);
  
  PROCEDURE registrant_log (this_page INTEGER, crypt_pid VARCHAR2 );
  PROCEDURE end_registration (this_page INTEGER);
  FUNCTION get_reg_page_URL (pg_id INTEGER, page_name VARCHAR2, login_first BOOLEAN DEFAULT FALSE) RETURN VARCHAR2;
  FUNCTION get_registrant_count (ID INTEGER) RETURN INTEGER;
  FUNCTION get_cutoff_date (ID INTEGER, id_type VARCHAR2) RETURN DATE;
  FUNCTION already_paid (meta_code INTEGER) RETURN BOOLEAN;
  FUNCTION item_is_late (the_date DATE, cutoff_date DATE, considergraceperiod BOOLEAN DEFAULT TRUE) RETURN BOOLEAN;
  
--	Procedure / Function for administrative manager
  
  
  PROCEDURE find_regist(pid INTEGER DEFAULT NULL);
  
  
END registration;

/
show error

SET define ON

--	Copyright (C) 2004-2008 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
