--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace package reports as

   procedure abstract_book;
   procedure AIP;
   procedure author_index;
   procedure black_dot_received;
   procedure by_page_count;
   procedure by_time;
   procedure conference_guide;
   procedure disjointed_authors;
   procedure dummy;
   procedure dup_abs;
   procedure edit_time;
   procedure extracts;
   procedure green_dot_report (this_code varchar2);
   procedure hc_nofiles;
   procedure html;
   procedure no_dots;
   procedure no_status;
   procedure police_no_files;
   procedure police_no_qual;
   procedure poster_counts;
   procedure QA_PDF;
   procedure red_dots;
   procedure registered;
   procedure session_info;
   procedure show_author_counts;
   procedure show_classification_counts (present_type varchar2 default '%', present_code varchar2 default '%');
   procedure show_counts_by_present_code;
   procedure show_counts_summary;
   procedure show_CR_counts;
   procedure show_invitees;
   procedure show_presentation_counts;
   procedure show_session_counts;
   procedure show_sub_class_counts;
   procedure toc;
   procedure unreg_papers;
   procedure write (buffer varchar2, eol boolean default false);

   function get_abs_count (this_code logs.log_code%TYPE default 'AC') return integer;
   function show_pct (icount1 integer, icount2 integer) return varchar2;

end reports;
/
show errors
