--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace package repository as

   procedure html;
   procedure xls;
   procedure jobs;
   procedure rebuild_CTX;
   procedure kill_job (ID integer);
   procedure start_jobs;
   procedure start_batch_jobs;

   procedure affiliations;
   procedure affil_indx;
   procedure affil (affil_id integer, include_comment boolean default true);
   procedure affil_addr (addr_id integer);

   procedure search (string varchar2);
   procedure affil_list (letter varchar2);

   procedure edit_affil (affil_id integer, addr_id integer, letter varchar2, string varchar2);

   procedure save_affil (letter varchar2, string varchar2, affil_id integer, addr_id integer,
			affil common.ident_arr, this_affil_type varchar2,
			addr common.ident_arr, this_country varchar2, ctxt varchar2);

   procedure del_addr (addr_id integer, letter varchar2, string varchar2);
   procedure del_addr2 (addr_id integer, letter varchar2, string varchar2);

   procedure del_affil (affil_id integer, letter varchar2);
   procedure del_affil2 (affil_id integer, letter varchar2);

   procedure copy_affil (affil_id integer, letter varchar2, string varchar2);
   procedure copy_affil2 (aid1 integer, aid2 integer, letter varchar2, string varchar2);
   procedure optimize_ctx;
   procedure merge (merge common.ident_arr, letter varchar2, string varchar2, req_id integer default null);
   procedure merge2 (merge integer, list common.ident_arr, letter varchar2, string varchar2, req_id integer default null);

   procedure status;
   procedure show_errors;

   procedure merge_addr (affil_id integer, letter varchar2, string varchar2);
   procedure merge_addr2 (affil_id integer, letter varchar2, string varchar2, addr_id common.ident_arr);
   procedure merge_addr3 (letter varchar2, string varchar2, addrs common.ident_arr, merge_into_id integer);
   procedure merge_addr3b (addrs common.ident_arr, merge_into_id integer);
   procedure save_errors (err_delete common.ident_arr, err_resend common.ident_arr);

end repository;
/
show error
