--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

create or replace package search as

NULL_ident_arr	common.ident_arr;

sort_AUTH$	constant search_sort_codes.search_sort_code%TYPE	:= 'AUTH';
sort_MC$	constant search_sort_codes.search_sort_code%TYPE	:= 'MC';
sort_SC$	constant search_sort_codes.search_sort_code%TYPE	:= 'SC';
sort_AID$	constant search_sort_codes.search_sort_code%TYPE	:= 'AID';
sort_PID$	constant search_sort_codes.search_sort_code%TYPE	:= 'PID';
sort_PAFF$	constant search_sort_codes.search_sort_code%TYPE	:= 'PAFF';
sort_poster$	constant search_sort_codes.search_sort_code%TYPE	:= 'POST';

display_CO$	constant search_display_codes.search_display_code%TYPE	:= 'CO';
display_AT$	constant search_display_codes.search_display_code%TYPE	:= 'AT';
display_FA$	constant search_display_codes.search_display_code%TYPE	:= 'FA';
display_PRET$	constant search_display_codes.search_display_code%TYPE	:= 'PRET';
display_SPK$	constant search_display_codes.search_display_code%TYPE	:= 'SPK';
display_MC$	constant search_display_codes.search_display_code%TYPE	:= 'MC';
display_SC$	constant search_display_codes.search_display_code%TYPE	:= 'SC';

sql_stmt	varchar2(20000) := null;
search_flag	char(1)		:= 'Y';
show_admin_data	boolean		:= true;
show_links	boolean		:= true;

type	search_type is record (
		AID			common.ident_arr default NULL_ident_arr,
		PID			varchar2(13) default null,
		this_text		varchar2(100) default null,
		exact			common.ident_arr default NULL_ident_arr,
		this_name		varchar2(100) default null,
		this_affil		varchar2(200) default null,
		xcoauth			common.ident_arr default NULL_ident_arr,
		this_classification	varchar2(100) default null,
		this_sub_class		varchar2(100) default null,
		this_session		varchar2(10) default null,
		this_presentation	varchar2(100) default null,
		this_search_sort	common.ident_arr default NULL_ident_arr,
		display			common.ident_arr default NULL_ident_arr,
		this_status		varchar2(50) default null,
		this_referee		varchar2(50) default null,
		QA			varchar2(50) default null,
		QAED			varchar2(50) default null,
		POSTED			varchar2(50) default null,
		MANNED			varchar2(50) default null,
		QUALOK			varchar2(50) default null,
		ACCEPT			varchar2(50) default null,
		FILES			varchar2(50) default null,
		this_platform		varchar2(50) default null,
		PDF			varchar2(50) default null,
		SLIDES			varchar2(50) default null,
		NEW_AFFILS		varchar2(50) default null,
		CRF			varchar2(50) default null,
		attrib			common.ident_arr default NULL_ident_arr,
		this_priority		varchar2(50) default null,
		this_proposal_status	varchar2(50) default null,
		sdte			varchar2(20) default null,
		this_PRESENTATION_TYPE	varchar2(50) default null);

type		abs_record is RECORD (
		abstract_id		abstracts.abstract_id%TYPE,
		paper_id		varchar2(100),
		title			abstracts.title%TYPE,
		description		abstracts.description%TYPE,
		footnote		abstracts.footnote%TYPE,
		agency			abstracts.agency%TYPE,
		status_code		abstracts.status_code%TYPE,
		referee_code		abstracts.referee_code%TYPE,
		spk_profile_id		profiles.profile_id%TYPE,
		presentation_descr	presentation_codes.presentation_descr%TYPE,
		classification_descr	classification_codes.classification_descr%TYPE,
		sub_class_descr		sub_class_codes.sub_class_descr%TYPE,
		sort_lname		persons.sort_lname%TYPE,
		sort_fname		persons.sort_fname%TYPE,
		sort_mname		persons.sort_mname%TYPE,
		person_id		abstracts.person_id%TYPE,
		editor_id		abstracts.editor_id%TYPE,
		classification_code	abstracts.classification_code%TYPE);

type		abs_coll_type is table of abs_record index by binary_integer;
abs_recs	abs_coll_type;

procedure html;
procedure JS;
procedure new_search (URL varchar2);
procedure results (name_array owa.vc_arr, value_array owa.vc_arr);
procedure results2 (rec search_type, new_search_URL varchar2 default 'search.html');
procedure author_list (letter varchar2);
procedure show_session (this_session varchar2);
procedure show_session_HDR (this_session varchar2);
procedure check_CTX_index;
procedure abs_id (aid integer);
procedure pcode (pcode varchar2);
procedure abstract_id (aid integer);
procedure abs_QA (abs_id integer);
procedure list;
procedure add (aid integer);
procedure schedule;
procedure print_schedule (sdate varchar2, show_abstract common.ident_arr);
procedure remove (aid integer);
procedure withdraw_nopriority;
procedure withdraw_nopriority2;
procedure html_form(target varchar2);
procedure load_abstracts;
procedure session_search;

function build_sql_stmt (rec search_type) return varchar2;
function get_user_sort_name (prof_id integer, name_flag integer default 1) return varchar2;
function requires_QA (abs_id integer) return varchar2;
function get_session_sort_string (abs_id integer) return varchar2;
function search_params_to_rec (name_array owa.vc_arr, value_array owa.vc_arr) return search_type;

end search;
/
show error
