--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

-- *******************************************************************

create or replace function send_mail2
 (recipient	varchar2, 
  subject	varchar2,
  message	varchar2,
  from_addr	varchar2 default null,
  cc		varchar2 default null,
  bcc		varchar2 default null,
  pid		integer  default null,
  abs_id	integer  default null) return integer as

next_ID		integer;
new_cc		mail_blats.cc%TYPE := cc;

begin

   select mail_blats_id_seq.nextval into next_id from dual;

   new_cc := common.cc_admin (new_cc, subject);

   insert into mail_blats
	(mail_id, from_addr, recipient, subject, cc, bcc, message, person_id, abstract_id)
	 values (next_id, from_addr, recipient, subject, new_cc, bcc, message, pid, abs_id);

   return next_id;

end send_mail2;
/
show error

-- *******************************************************************

create or replace procedure send_mail
 (recipient	varchar2, 
  subject	varchar2,
  message	varchar2,
  from_addr	varchar2 default null,
  cc		varchar2 default null,
  bcc		varchar2 default null,
  pid		integer  default null,
  abs_id	integer  default null) as

next_ID		integer;

begin

   next_id := send_mail2 (recipient, subject, message, from_addr, cc, bcc, pid, abs_id);

end send_mail;
/
show error

-- *******************************************************************
