set define off

create or replace package body session_maint as

rpt_title$	constant varchar2(30) := 'Session Maintenance';

onChange$	constant varchar2(500) := 'onChange="set_sid('					||
		 'document.SESSION_MAINT.this_presentation_option'				||
		'[document.SESSION_MAINT.this_presentation_option.selectedIndex].value,'	||
		 'document.SESSION_MAINT.sdate.options'						||
		'[document.SESSION_MAINT.sdate.selectedIndex].value,'				||
		 'document.SESSION_MAINT.this_location.options'					||
		'[document.SESSION_MAINT.this_location.selectedIndex].value);"';

-- ****************************************************************************
-- ****************************************************************************

procedure js is

buffer		varchar2(100) := 'var dow_str = new Array (""';
conf_date	date := common.conf_start_monday$;  -- may not be a Monday.

begin

   for i in 1..common.conf_len_days$ LOOP
      buffer := buffer || ', "' || substr (to_char (conf_date, 'DAY'), 1, 2) || '"';
      conf_date := conf_date + 1;
   end loop;
   buffer := buffer || ');';

   htp.p ('
function set_sid (ptype, dow, loc) {
');

   htp.p (buffer);
/*
   htp.prn ('

   if (ptype.substring(0,1) == "P") {
      ptype = "P";
   }
*/
   htp.prn ('
   document.SESSION_MAINT.sid.value = dow_str[dow] + ptype + loc;
   document.SESSION_MAINT.sid2.value = dow_str[dow] + ptype + loc;

   return true;

}');

-- **********

   htp.prn ('

function validate () {

   if (document.SESSION_MAINT.this_presentation_option.value == "") {
      alert ("You must select a Type");
      return false;
   }

   if (document.SESSION_MAINT.sdate.value == "0") {
      alert ("You must select a Date");
      return false;
   }

   if (document.SESSION_MAINT.btime.value == "") {
      alert ("You must enter a Start Time");
      return false;
   }

   if (document.SESSION_MAINT.etime.value == "") {
      alert ("You must enter an End Time");
      return false;
   }

   if (document.SESSION_MAINT.stitle.value == "") {
      alert ("You must enter Title");
      return false;
   }

   if (document.SESSION_MAINT.this_location.value == "") {
      alert ("You must select a Location");
      return false;
   }

   return true;

}');

end js;

-- ****************************************************************************
-- ****************************************************************************

procedure del_chair (sid varchar2) is

begin

   update sessions
   set    chair_profile_id = null
   where  session_id = sid;

   common.redirect_URL ('session_maint.html');

end del_chair;

-- ****************************************************************************
-- ****************************************************************************

procedure save_chair (sid varchar2, pro_id integer) is

begin

   update sessions
   set	  chair_profile_id	= pro_id
   where  session_id		= sid;

   common.redirect_URL ('session_maint.html');

end save_chair;

-- ****************************************************************************
-- ****************************************************************************

procedure add_chair3 (sid varchar2, pid integer) is

cursor	driver is
select	pro.profile_id,
	common.get_affil_name (affil.affiliation_id)	affiliation
from	affiliations		affil,
	addresses		addr,
	profiles		pro
where	pro.person_id		= pid
and	addr.address_id		= pro.address_id
and	affil.affiliation_id	= addr.affiliation_id
order by
	affil.name1;

profile_ids	common.int_arr;
affiliations	common.ident_arr;
selected	varchar2(8) := 'SELECTED';

begin

   if common.header (rpt_title$, test_only=>true) then
      open driver;
      fetch driver BULK COLLECT into profile_ids, affiliations;
      close driver;

      if profile_ids.count = 1 then
         save_chair (sid, profile_ids(1));

      else
         common.public_header (rpt_title$);
         htp.header (3, 'Please select an affiliation for ' || common.get_user_name (pid) );
         htp.formOpen ('session_maint.save_chair', 'POST');
         htp.formHidden ('sid', sid);

         for i in 1..profile_ids.count LOOP
            htp.formRadio ('pro_id', profile_ids(i), selected);
            htp.p (affiliations(i));
            htp.br;
            selected := null;
         end loop;

         htp.para;
         htp.formSubmit;
         htp.formClose;
         common.footer;

      end if;
   end if;

end add_chair3;

-- ****************************************************************************
-- ****************************************************************************

procedure add_chair2 (sid varchar2, this_lname varchar2, this_email varchar2) is

MT_arr	common.ident_arr;
pids	common.int_arr := profile.find_search_db (this_lname, this_email, null, MT_arr);

begin

   if common.header (rpt_title$) then
      if pids.count > 0 then
         htp.header (3, 'The following profiles match your search criteria.');
         htp.formOpen ('session_maint.add_chair3', 'POST');
         htp.formHidden ('sid', sid);
         profile.show_profile_header (true);
         profile.show_search_results (this_lname, this_email, pids);
         htp.tableClose;
         htp.para;
         htp.formSubmit (null, 'Select Chair');
         htp.formClose;

      else
         htp.header (3, 'No profiles matched your search criteria.');
      end if;

      common.footer;
   end if;

end add_chair2;

-- ****************************************************************************
-- ****************************************************************************

procedure add_chair (sid varchar2) is

begin

   if common.header (rpt_title$) then
      search.show_session_HDR (sid);

      htp.formOpen ('session_maint.add_chair2', 'POST', cattributes=>'NAME="SESSION"');
      htp.formHidden ('sid', sid);
      profile.show_find_form;
      htp.formClose;
      common.form_focus ('SESSION', 'this_lname');
      common.footer;
   end if;

end add_chair;

-- ****************************************************************************
-- ****************************************************************************

procedure del2 (sid varchar2) is

begin

   delete from sessions where session_id = sid;
   common.redirect_URL ('session_maint.html');

end del2;

-- ****************************************************************************
-- ****************************************************************************

procedure del (sid varchar2) is

cursor	driver is
select	'an ABSTRACT'	dummy
from	abstract_sessions
where	session_id = sid
UNION
select	'a CLASSIFICATION CODE'	dummy
from	class_sessions
where	session_id = sid;

dummy		varchar2(50);
rec_found	boolean;

begin

   if common.header (rpt_title$) then
      open driver;
      fetch driver into dummy;
      rec_found := driver%FOUND;
      close driver;

      if rec_found then
         htp.header (3, 'Unable to Delete Session ' || sid);
         htp.p ('It is in use on ' || dummy || ' record.');
      else
         htp.formOpen ('session_maint.del2', 'POST');
         htp.formHidden ('sid', sid);
         htp.header (3, 'Are you sure you wish to delete Session ' || sid || '?');
         htp.formSubmit (null, 'Yes');
         htp.formClose;
      end if;

      htp.para;
      common.footer;
   end if;

end del;

-- ****************************************************************************
-- ****************************************************************************

procedure save (orig_sid varchar2, sid varchar2, this_presentation_option varchar2,
		sdate varchar2, btime varchar2, etime varchar2, stitle varchar2,
		this_location varchar2, ssort varchar2) is

this_date	date := common.conf_start_monday$ + sdate - 1;

unique_constraint	exception;
pragma exception_init	(unique_constraint, -1);
msg			varchar2(1000) := null;

begin

   if trim (sid) is null then
      msg := htf.header (3, 'You must supply a Session.');
   end if;

   if this_presentation_option is null then
      msg := msg || htf.header (3, 'You must supply a Presentation.');
   end if;

   if sdate = '0' then
      msg := msg || htf.header (3, 'You must supply a Date.');
   end if;

   if trim (stitle) is null then
      msg := msg || htf.header (3, 'You must supply a Title.');
   end if;

   if this_location is null then
      msg := msg || htf.header (3, 'You must supply a Location.');
   end if;

   if trim (btime) is null then
      msg := msg || htf.header (3, 'You must supply a Start Time.');
   elsif NOT common.validate_number (btime) then
      msg := msg || htf.header (3, 'Invalid Start Time: ' || btime || '. It must be numeric (no colons).');
   end if;

   if trim (etime) is null then
      msg := msg || htf.header (3, 'You must supply an End Time.');
   elsif NOT common.validate_number (etime) then
      msg := msg || htf.header (3, 'Invalid End Time: ' || etime || '. It must be numeric (no colons).');
   end if;

   if msg is null then
      if to_number (btime) >= to_number (etime) then
         msg := msg || htf.header (3, 'End Time must be after Start Time');
      end if;
   end if;

   if msg is null then

      if orig_sid is null then
         insert into sessions (SESSION_ID, TITLE, SESSION_DATE, LOCATION_CODE,
		BEG_TIME, END_TIME, PRESENTATION_option_CODE, SORT_ORDER)
         values (trim(sid), trim(stitle), this_date, this_location,
		btime, etime, this_presentation_option, ssort);

      else
         update	sessions
         set	SESSION_ID		= sid,
		TITLE			= stitle,
		SESSION_DATE		= this_date,
		LOCATION_CODE		= this_location,
		BEG_TIME		= btime,
		END_TIME		= etime,
		PRESENTATION_OPTION_CODE= this_presentation_option,
		SORT_ORDER		= ssort
         where	session_id		= orig_sid;

      end if;

      common.redirect_URL ('session_maint.html');

   else
      common.public_header (rpt_title$);
      htp.p (msg);
      htp.p (common.click_back$);
      common.footer;

   end if;

exception
   when unique_constraint then
      common.public_header (rpt_title$);
      htp.header (3, 'Unable to change the Session ID', cattributes=>common.red$);
      htp.bold ('Session ' || sid || ' already exists.');
      htp.p ('You can not duplicate Session IDs.');
      htp.p (common.click_back$);
      htp.para;
      common.footer;

end save;

-- ****************************************************************************
-- ****************************************************************************

procedure show_date_popup (this_date date) is

selected	varchar2(8) := null;
dow		date := common.conf_start_monday$;

begin

   htp.tableRowOpen ('LEFT', 'TOP');
   htp.tableHeader ('Date', 'RIGHT');
   htp.p ('<TD>');
   htp.formSelectOpen ('sdate', cattributes=>onChange$);

   htp.formSelectOption (null, cattributes=>'VALUE="0"');

   for i in 1..common.conf_len_days$ LOOP
      selected := null;
      if dow = this_date then
         selected := 'SELECTED';
      end if;

      htp.formSelectOption (to_char (dow, 'Day'), selected,
		cattributes=>'VALUE="' || i || '"');
      dow := dow + 1;
   end loop;

   htp.formSelectClose;
   htp.p ('</TD>');
   htp.tableRowClose;

end show_date_popup;

-- ****************************************************************************

procedure edit (sid varchar2) is

cursor	driver is
select	*
from	sessions
where	session_id = sid;

cursor	c2 is
select	count(1)	icount
from	abstract_sessions
where	session_id = sid;

driver_rec	driver%ROWTYPE;
icount		integer;
buffer		varchar2(50) := null;

begin

   if common.header (rpt_title$) then
      if common.auto_session_ids$ = 'Y' then
         htp.p ('<script language="JavaScript" src="' || common.server ||
		common.vdir$ || 'session_maint.js"></script>');
      end if;

      open driver;
      fetch driver into driver_rec;
      close driver;

      open c2;
      fetch c2 into icount;
      close c2;

      if icount > 0 then
         htp.header (3, 'This Session is in use on ' || icount || ' contributions.', cattributes=>common.red$);
      end if;

      if common.auto_session_ids$ = 'Y' then
         buffer := 'NAME="SESSION_MAINT" onSubmit="return validate()"';
      end if;
      htp.formOpen ('session_maint.save', 'POST', cattributes=>buffer);

      htp.formHidden ('orig_sid', sid);

      if common.auto_session_ids$ = 'Y' then
         htp.formHidden ('sid', sid);
      end if;

      htp.tableOpen;

      if common.auto_session_ids$ = 'Y' then
         common.show_data_row ('Session', htf.formText ('sid2', 10, 10, driver_rec.session_id, cattributes=>'DISABLED'));
      else
         common.show_data_row ('Session', htf.formText ('sid', 10, 10, driver_rec.session_id));
      end if;

      if icount = 0 then
         common.show_lookup_table ('presentation_option', 'Presentation', driver_rec.presentation_option_code, onchange=>onChange$);
      else
         common.show_data_row ('Type', common.decode_value ('presentation_option_descr', 'presentation_option_codes',
							'presentation_option_code', driver_rec.presentation_option_code) ||
				htf.formHidden ('this_presentation_option', driver_rec.presentation_option_code) );
      end if;

      if icount = 0 then
         show_date_popup (driver_rec.session_date);
      else
         common.show_data_row ('Date',	to_char (driver_rec.session_date, 'Day') ||
				htf.formHidden ('sdate', driver_rec.session_date - common.conf_start_monday$ + 1 ) );
      end if;

      common.show_data_row ('Start Time',	htf.formText ('btime',   4,  4, driver_rec.beg_time) || ' 24-hour format');
      common.show_data_row ('End Time',		htf.formText ('etime',   4,  4, driver_rec.end_time) || ' 24-hour format');
      common.show_data_row ('Title',		htf.formText ('stitle', 50, 100, driver_rec.title));

      if icount = 0 then
         common.show_lookup_table ('location', 'Location', driver_rec.location_code, onchange=>onChange$);
      else
         common.show_data_row ('Location',	common.decode_value ('location_descr', 'location_codes', 'location_code', driver_rec.location_code) ||
						htf.formHidden ('this_location', driver_rec.location_code) );
      end if;

      common.show_data_row ('Sort',		htf.formText ('ssort',   9,  9, driver_rec.sort_order));
      common.show_data_row (null,		htf.formSubmit (null, 'Save'));

      htp.tableClose;
      htp.formClose;
      common.footer;
   end if;

end edit;

-- ****************************************************************************
-- ****************************************************************************

procedure show_sessions is

cursor	driver is
select	*
from	sessions
order by
	sort_order, session_date, beg_time;

pid		integer;
buffer		varchar2(4000);
date_fmt	varchar2(50) := common.date_fmt_str$;

begin

   date_fmt := substr (date_fmt, 1, instr (date_fmt, ' '));
   htp.formOpen ('session_maint.edit', 'POST');
   htp.formHidden ('sid', '');
   htp.formSubmit (null, 'New Session');
   htp.formClose;

   htp.tableOpen ('BORDER', cattributes=>'CELLPADDING="3"');

   htp.tableData (common.space$);
   htp.tableHeader ('Session');
   htp.tableHeader ('Type');
   htp.tableHeader ('Date');
   htp.tableHeader ('Start', 'RIGHT');
   htp.tableHeader ('End', 'RIGHT');
   htp.tableHeader ('Title');
   htp.tableHeader ('Location');
   htp.tableHeader ('Chair');
   htp.tableHeader ('Sort', 'RIGHT');
   htp.tableData (common.space$);
   htp.tableRowClose;

   for driver_rec in driver LOOP
      buffer := null;
      if driver_rec.chair_profile_id is NOT null then
         buffer := ' (' || common.get_profile_affil (driver_rec.chair_profile_id) || ')' ||
			common.space2$ ||
			htf.anchor ('session_maint.del_chair?SID=' || driver_rec.session_id, 'Remove Chair');
      end if;
      pid := common.decode_value ('person_id', 'profiles', 'profile_id', driver_rec.chair_profile_id);

      htp.tableRowOpen ('LEFT', 'TOP');
      htp.tableData (htf.anchor ('session_maint.edit?sid=' || driver_rec.session_id, 'EDIT'));
      htp.tableData (driver_rec.session_id);
      htp.tableData (common.decode_value ('presentation_option_descr', 'presentation_option_codes', 'presentation_option_code', driver_rec.presentation_option_code));
      htp.tableData (to_char (driver_rec.session_date, 'Day ' || date_fmt), cnowrap=>'NOWRAP');
      htp.tableData (to_char (driver_rec.beg_time, '0000'), 'RIGHT');
      htp.tableData (to_char (driver_rec.end_time, '0000'), 'RIGHT');
      htp.tableData (driver_rec.title);
      htp.tableData (common.decode_value ('location_descr', 'location_codes',
			'location_code', driver_rec.location_code));

      htp.tableData (htf.anchor ('session_maint.add_chair?sid='		|| driver_rec.session_id,
				nvl (common.get_user_name (pid), 'Add Chair'))  || buffer);

      htp.tableData (driver_rec.sort_order, 'RIGHT');
      htp.tableData (htf.anchor ('session_maint.del?sid='|| driver_rec.session_id, 'Delete'));

      htp.tableRowClose;
   end loop;

   htp.tableClose;

end show_sessions;

-- ****************************************************************************

procedure html is

cursor	driver is
select	count(1)
from	location_codes;

dummy	integer;

begin

   if common.header (rpt_title$) then
      open driver;
      fetch driver into dummy;
      close driver;

      if dummy = 0 then
         htp.header (3, 'Error:  Unable to Create Sessions', cattributes=>common.red$);
         htp.p ('You must create locations before creating sessions.');
         htp.para;
      else
         show_sessions;
      end if;

      common.footer;
   end if;

end html;

-- ****************************************************************************

end session_maint;
/
show error

set define on

--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
