create or replace package body sync_app_privs as

-- *****************************************************************************************

procedure sync is

last_app_id	integer;
next_app_id	integer;

begin

	insert into privilege_codes
	select	*
	from	repo_privilege_codes
	where	privilege_code not in
	(	select	privilege_code
		from	privilege_codes);

	insert into function_codes
	select	*
	from	repo_function_codes
	where	function_code not in
	(	select	function_code
		from	function_codes);

	delete from application_privs;
	delete from applications;

	insert into applications
	select	*
	from	repo_applications
	where	application_id not in
	(	select	application_id
		from	applications);

	insert into application_privs
	select	*
	from	repo_application_privs
	where	(application_id, privilege_code) not in
	(	select	application_id, privilege_code
		from	application_privs);

        select max(application_id) into last_app_id from applications;
        select application_id_seq.nextval into next_app_id from dual;

        if last_app_id is not null then
           LOOP
              exit when next_app_id+1 >= last_app_id;
              select application_id_seq.nextval into next_app_id from dual;
           end loop;
        end if;

	insert into function_privileges
	select	*
	from	repo_function_privileges
	where	(function_code, privilege_code) not in
	(	select	function_code, privilege_code
		from	function_privileges);

	insert into user_functions
	select	*
	from	repo_user_functions	r
	where	(person_id, function_code) not in
	(	select	person_id, function_code
		from	user_functions)
	and	exists
	(	select	1
		from	persons		p
		where	p.person_id	= r.person_id);

end sync;

-- *****************************************************************************************

end sync_app_privs;
/
show error
