set define off

create or replace package body edot as

cursor	abstract_driver is
select	sa.session_id, sa.paper_id, a.status_code, a.referee_code,
	s.session_date, a.assignable, a.editor_id, a.abstract_id
from	abstracts		a,
	abstract_sessions	sa,
	sessions		s
where	sa.session_id		= s.session_id
and	a.abstract_id		= sa.abstract_id
order by s.session_date, s.session_id, sa.session_seq;

type		rec_type is table of abstract_driver%ROWTYPE index by binary_integer;
abs_recs	rec_type;

-- **********

cursor	status_driver is
select	*
from	status_codes
order by sort_order nulls last, status_code;

type		status_type is table of status_driver%ROWTYPE index by binary_integer;
status_recs	status_type;

-- **********

cursor	referee_driver is
select	*
from	referee_codes
order by sort_order nulls last, referee_code;

type		referee_type is table of referee_driver%ROWTYPE index by binary_integer;
referee_recs	referee_type;

-- **********

rpt_title$	varchar2(50)	:= 'Electronic Dot Board';

-- **************************************************************************************
-- **************************************************************************************

procedure js is

begin

htp.prn ('function newRequest() {

// create the XML data structures

  req = false;
  // For Safari, Firefox, and other non-MS browsers
  if (window.XMLHttpRequest) {
    try {
      req = new XMLHttpRequest();
      XML = new XMLHttpRequest();
    }
    catch (e) {
      req = false;
      XML = false;
    }
  }

  else if (window.ActiveXObject) {
    // For Internet Explorer on Windows
    try {
      req = new ActiveXObject("Msxml2.XMLHTTP");
      XML = new ActiveXObject("Msxml2.XMLHTTP");
    }
    catch (e) {
      try {
        req = new ActiveXObject("Microsoft.XMLHTTP");
        XML = new ActiveXObject("Microsoft.XMLHTTP");
      } catch (e) {
        req = false;
        XML = false;
} } } }

// *******************************************************************

function newData() {  // called when XML data is returned

  if (XML.readyState != 4) {
    return;
  }

// once the data is loaded reset the newDataLoaded flag for the diaplyData routine

  if (XML.status == 200) {
    if (XML.responseXML) {
      newDataLoaded = true;
      message.innerHTML = "";
    }
    else {
      message.innerHTML = "Error retrieving new XML data. (data is not XML)";
    }
  }
  else {
    message.innerHTML = "Error retrieving new XML data. (" + XML.status + ")";
  }

}

// *******************************************************************

function getXML(dontWait) {

  newDataLoaded	= false;
  XML.open("POST", "edot.xml", dontWait);

  if (dontWait) {
    XML.onreadystatechange = newData;
  }

  XML.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
  XML.send("");

  if (dontWait) {
    message.innerHTML = "";
  }
  else {
    req = XML;
  }

}

// *******************************************************************
// *******************************************************************

function parseData() {

   var xml = (req.responseXML);  // get the actuall XML data
   if (xml) {  // is it really XML data?

// extract the parameters
      params	= xml.getElementsByTagName("parameters");
      var this_param = params[0];

      rows	= this_param.attributes.getNamedItem("ROW_COUNT").value;
      cols	= this_param.attributes.getNamedItem("COLUMN_COUNT").value;
      dataTS	= this_param.attributes.getNamedItem("TIMESTAMP").value;
      pageCount	= this_param.attributes.getNamedItem("PAGE_COUNT").value;
      referesh	= this_param.attributes.getNamedItem("REFRESH_RATE").value;

// load the raw data into global data structures
      all_codes	= xml.getElementsByTagName("code");
      all_papers= xml.getElementsByTagName("paper");

// extract the sytle data
      var instr	= xml.getElementsByTagName("instr");
      var instr	= instr[0];
      var header= xml.getElementsByTagName("header");
      var header= header[0];
      var cells	= xml.getElementsByTagName("cells");
      var cells	= cells[0];

      var instrFontSize	= instr.attributes.getNamedItem("fontSize").value;
      var headerFontSize= header.attributes.getNamedItem("fontSize").value;
      var headerColor	= header.attributes.getNamedItem("color").value;
      var headerbgColor	= header.attributes.getNamedItem("bgColor").value;
      var cellsFontSize	= cells.attributes.getNamedItem("fontSize").value;

// set the styles based on the data extracted
      var hdr = document.getElementById ("HDR");
      hdr.style.fontSize	= headerFontSize;
      hdr.style.color		= headerColor;
      hdr.style.backgroundColor	= headerbgColor;

// set the attributes of the style sheets for the table cells
      var theRules = new Array();
      if (document.styleSheets[0].cssRules) {
         theRules = document.styleSheets[0].cssRules;
      }
      else if (document.styleSheets[0].rules) {
         theRules = document.styleSheets[0].rules;
      }

      theRules[0].style.fontSize = cellsFontSize;
      theRules[1].style.fontSize = instrFontSize;

// set the table cells background color style
      var all_statusColor = xml.getElementsByTagName("statusColor");

      for (var i = 0; i < all_statusColor.length; i++) {
         thisStatusColor = all_statusColor[i];
         var fgColor = thisStatusColor.attributes.getNamedItem("color").value;
         var bgColor = thisStatusColor.attributes.getNamedItem("backgroundColor").value;
         theRules[i+3].style.color		= fgColor;
         theRules[i+3].style.backgroundColor	= bgColor;
      }

   return (true);
   }

   return (false);

}

// *******************************************************************

function gen_cell_data (row, col) {

// write the paper data for a single element in the array (indx)
// get the data for this paper from the XML data structure
// indx is calculate based on the cells being built row by row
// whereas the paper data is displayed sorted column by column

var indx = ( (thisPage-1)*(rows*cols) ) + ((col-1)*rows) + row - 1

   if (indx <= all_papers.length-1 ) {  // else no more papers
      var this_paper	= all_papers[indx];
      var ID		= this_paper.attributes.getNamedItem("SESSION").value;
      var SEQ		= this_paper.attributes.getNamedItem("SEQUENCE").value;
      var CODE		= this_paper.attributes.getNamedItem("CODE").value;');

      if common.referee_conf$ = 'Y' then
htp.prn ('
      var RCODE = this_paper.attributes.getNamedItem("RCODE").value;
      bodyText = bodyText + ''<TD><SPAN CLASS='' + CODE + ''>'' + ID + ''</SPAN><SPAN CLASS='' + RCODE + ''>'' + SEQ + ''</SPAN></TD>'';
');
      else
htp.prn ('
      bodyText = bodyText + ''<TD CLASS='' + CODE + ''>'' + ID + SEQ + ''</TD>'';
');
      end if;
htp.prn ('
  }
}

// *******************************************************************

function displayData() {

// update the current data (req) with new data (XML)
  if (thisPage == 1) {
    if (newDataLoaded) {
       req = XML;
       parseData();
  } }

// create the table data

  bodyText = "<TABLE BORDER=\"0\" CELLPADDING=\"5\" CELLSPACING=\"5\">";

// loop through the rows and columns and write the data
  for (var i = 1; i <= rows; i++) {
    bodyText = bodyText + "<TR>";

    for (var j = 1; j <= cols; j++) {
       gen_cell_data(i, j);
    }
    bodyText = bodyText + "</TR>";
  }

  bodyText		= bodyText + "</TABLE>";
  bodyHTML.innerHTML	= bodyText;

// set some informative text
  pages.innerHTML	= "Page " + thisPage + " of " + pageCount;
  timestamp.innerHTML	= dataTS;

// requery the XML data; but do not wait; javascript keeps running
  if (thisPage == pageCount) {
    getXML(true);
  }

  thisPage = thisPage + 1;

// loop back to the first page after displaying the last page
  if (thisPage > pageCount) {
    thisPage	= 1;
  }

// Note: refresh rate in seconds, function requires milliseconds
  setTimeout ("displayData()", referesh*1000);

}

// *******************************************************************
// *******************************************************************

function loadDots() {

// message is needed to display any error messages on the web browser.
  message = document.getElementById ("MSG");

// create the data structures
  newRequest();
  if (!req) {
    message.innerHTML = "newRequest failed";
    return;
  }

// initial load of the XML data; wait for data to return
  getXML(false);
  if (req.status != 200) {
    message.innerHTML = "There was a communications error.";
    return;
  }

  if (parseData()) {
//  more browser text fiedls
    pages		= document.getElementById ("PAGES");
    timestamp		= document.getElementById ("TIMESTAMP");
    bodyHTML		= document.getElementById ("BODYHTML");

// initialization
    bodyText		= "";
    thisPage		= 1;
    newDataLoaded	= false;

// write the data into the table cells;  this kicks of an infinite loop
    displayData();
  }
  else {
    message.innerHTML = "Error parsing data.";
  }

} // end of function
');

end js;

-- **************************************************************************************
-- **************************************************************************************

procedure load_status_codes is

begin

   open status_driver;
   fetch status_driver BULK COLLECT into status_recs;
   close status_driver;

end load_status_codes;

-- **************************************************************************************

procedure load_referee_codes is

begin

   open referee_driver;
   fetch referee_driver BULK COLLECT into referee_recs;
   close referee_driver;

end load_referee_codes;

-- **************************************************************************************

function final_qa_code (abs_id integer) return varchar2 is

cursor	driver is
select	/*+ INDEX(l) */
	log_code
from	logs		l
where	abstract_id	= abs_id
and	log_code	in (common.final_QA_passed$, common.final_QA_failed$)
order by
	log_date desc;

rec	driver%ROWTYPE;

begin

   open driver;
   fetch driver into rec;
   close driver;

   return rec.log_code;

end final_qa_code;

-- **************************************************************************************

procedure write_papers is

begin

   htp.p ('<papers>');
   for i in 1..abs_recs.COUNT LOOP
      htp.p ('<paper');
      htp.p ('SESSION="'	|| abs_recs(i).session_id	|| '"');
      htp.p ('SEQUENCE="'	|| replace (abs_recs(i).paper_id, abs_recs(i).session_id, null)	|| '"');

      if abs_recs(i).editor_id is null and abs_recs(i).assignable >= common.file_weight_threshold$ then
         htp.p ('CODE="FILES"');
      else
         htp.p ('CODE="' || abs_recs(i).status_code	|| '"');
      end if;

      if common.referee_conf$ = 'Y' then
         htp.p ('RCODE="' || abs_recs(i).referee_code	|| '"');
      end if;

      htp.p ('QA="' || final_qa_code(abs_recs(i).abstract_id) || '"');

      htp.p ('/>');
   end loop;
   htp.p ('</papers>');


end write_papers;

-- **************************************************************************************

procedure write_cell_color_XML is

begin

   load_status_codes;
   for i in 1..status_recs.COUNT LOOP
      htp.p ('<statusColor '	||
		'color="'		|| status_recs(i).edot_fg_color	|| '" '	||
		'backgroundColor="'	|| status_recs(i).edot_bg_color	|| '" '	||
	     '/>');
   end loop;

   if common.referee_conf$ = 'Y' then
      load_referee_codes;
      for i in 1..referee_recs.COUNT LOOP
         htp.p ('<refereeColor '	||
		'color="'		|| referee_recs(i).edot_fg_color	|| '" '	||
		'backgroundColor="'	|| referee_recs(i).edot_bg_color	|| '" '	||
	     '/>');
      end loop;
   end if;

end write_cell_color_XML;

-- **************************************************************************************

procedure write_styles is

begin

   htp.p ('<styles>');
   htp.p ('<instr fontSize="' || common.edot_instr_font_size$	|| 'px" />');
   htp.p ('<header '	||
		'fontSize="'	|| common.edot_hdr_font_size$	|| 'px" '	||
		'color="'	|| common.edot_hdr_text_color$	|| '" '		||
		'bgColor="'	|| common.edot_hdr_back_color$	|| '" '		||
	  '/>');
   htp.p ('<cells fontSize="'	|| common.edot_cell_font_size$ || 'px" />');
   write_cell_color_XML;
   htp.p ('</styles>');

end write_styles;

-- **************************************************************************************

procedure write_parameters is

page_cnt	number;
now$		constant date := sysdate+ (common.tz_offset$/24);

begin

   page_cnt := abs_recs.COUNT / (common.edot_row_count$ * common.edot_column_count$);
   if page_cnt - trunc (page_cnt) > 0 then
      page_cnt := trunc (page_cnt) + 1;
   else
      page_cnt := trunc (page_cnt);
   end if;

   htp.p ('<parameters '		||
		'ROW_COUNT="'		|| common.edot_row_count$	|| '" '	||
		'COLUMN_COUNT="'	|| common.edot_column_count$	|| '" '	||
		'TIMESTAMP="'		|| to_char(now$, common.date_fmt_str$)	|| '" '	||
		'PAGE_COUNT="'		|| page_cnt			|| '" '	||
		'REFRESH_RATE="'	|| common.edot_refresh_rate$	|| '" />');

end write_parameters;

-- **************************************************************************************

procedure xml is

begin

   open abstract_driver;
   fetch abstract_driver BULK COLLECT into abs_recs;
   close abstract_driver;

-- owa_util.mime_header('text/xml', TRUE);
   xml2.header;
   write_parameters;
   write_styles;
   write_papers;
   xml2.footer;

end xml;

-- **************************************************************************************
-- **************************************************************************************

procedure write_table_cell_styles is

begin

   for i in 1..status_recs.COUNT LOOP
      htp.p ('   .' || status_recs(i).status_code || ' {');
      htp.p ('          COLOR: ' || status_recs(i).edot_fg_color || ';');
      htp.p ('          BACKGROUND-COLOR: ' || status_recs(i).edot_bg_color);
      htp.p ('         }');
   end loop;

   if common.referee_conf$ = 'Y' then
      for i in 1..referee_recs.COUNT LOOP
         htp.p ('   .' || referee_recs(i).referee_code || ' {');
         htp.p ('          COLOR: ' || referee_recs(i).edot_fg_color || ';');
         htp.p ('          BACKGROUND-COLOR: ' || referee_recs(i).edot_bg_color);
         htp.p ('         }');
      end loop;
   end if;

end write_table_cell_styles;

-- **************************************************************************************

procedure show_editor_instructions is

width$	constant integer := 100 / (status_recs.COUNT + 1);

begin


   htp.tableOpen (cattributes=>'WIDTH=100%');
   htp.tableRowOpen ('LEFT', 'TOP');

   for i in 1..status_recs.COUNT LOOP
      htp.tableData (status_recs(i).edot_board_text,
		cattributes=>	'CLASS="' || status_recs(i).status_code ||
				' INSTR" WIDTH="' || width$ || '%"');
   end loop;

   htp.tableData ('Ready for processing', cattributes=>'CLASS="files INSTR"');
   htp.tableRowClose;

   htp.tableClose;

end show_editor_instructions;

-- **************************************************************************************

procedure page_header is

msg_font_size$	constant integer := least (12, common.edot_instr_font_size$/2);

begin

   load_status_codes;
   if common.referee_conf$ = 'Y' then
      load_referee_codes;
   end if;

   htp.p ('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">');
   htp.htmlOpen;
   htp.headOpen;

   htp.meta ('Content-Type', null,	'text/html;CHARSET=' || common.charset$);
   htp.meta ('Author',	null,		'Matt Arena, Fermi National Accelerator Laboratory, Batavia, Illinois');
   htp.meta ('Pragma', null, 'no-cache');
   htp.title (common.conf_title$ || ' ' || rpt_title$);

   htp.p ('<SCRIPT LANGUAGE="JavaScript1.1" src="' || common.server || common.vdir$ || 'edot.js"></SCRIPT>');

--  Important.  Do not change the order of the style statements without changing the related javaScript
   htp.p ('<STYLE TYPE="text/css">');
   htp.p ('   td	{font-size: ' || common.edot_cell_font_size$	|| 'px}');
   htp.p ('   .instr	{font-size: ' || common.edot_instr_font_size$	|| 'px; text-align: center}');
   htp.p ('   .message	{font-size: ' || msg_font_size$			|| 'px}');
   write_table_cell_styles;
   htp.p ('   body {font-family: helvetica}');
   htp.p ('   .files        {BACKGROUND-COLOR: CCCCCC}');
   htp.p ('</STYLE>');

   htp.headClose;
   htp.bodyOpen;

-- **********

   htp.tableOpen ('BORDER="0"', cattributes=>'CELLPADDING="5" CELLSPACING="5" WIDTH="100%"');

   htp.tableRowOpen ('LEFT', 'TOP');
   htp.tableHeader (common.conf_title$ || ' Paper Processing Status'	|| common.mdash$ ||
			'<span ID="TIMESTAMP"></span>'			|| common.mdash$ ||
			'<span ID="PAGES"></span>'			||
			'<span ID="MSG" CLASS="MESSAGE"></span>',
			crowspan=>status_recs.COUNT+1, cattributes=>'ID="HDR" CLASS="HDR"');
    common.display_logo (status_recs.COUNT);

   htp.tableClose;

end page_header;

-- **************************************************************************************
-- **************************************************************************************

procedure html is

begin

   page_header;

-- **********
   htp.p ('<DIV ID="BODYHTML"></DIV>');
   htp.p ('<SCRIPT LANGUAGE="JavaScript1.1" type="text/javascript">');
   htp.p ('loadDots();');
   htp.p ('</SCRIPT>');

   show_editor_instructions;

   common.blank_footer;

end html;

-- **************************************************************************************
-- **************************************************************************************

end edot;
/
show error

set define on

--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>
