--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

-- ****************************************************************************************

set	heading	off pagesize 9999 feedback off
spool	t.sql

select	'alter index ' || index_name || ' rebuild;'
from	user_indexes
where	status not in ('VALID', 'N/A');

select	'alter ' || decode(object_type, 'PACKAGE BODY', 'PACKAGE', object_type) || ' ' ||
	object_name || ' compile ' ||
	decode (object_type, 'PACKAGE','SPECIFICATION', 'PACKAGE BODY','BODY', null)	|| ';'
from	user_objects
where	status		<> 'VALID'
and	object_type	<> 'TYPE BODY'
order by
	decode (object_type, 'VIEW',0, 'PACKAGE',1, 'PACKAGE BODY',2, 3);

spool	off
set	feedback on
set	heading	on

set echo on
@t
set echo off

col object_name format a30

select	object_type, object_name
from	user_objects
where	status		<> 'VALID'
and	object_type	<> 'TYPE BODY'
order by
	object_type,
	object_name;

set	heading	on pagesize 9999 feedback on
