set define off

CREATE OR REPLACE package body TOC is

-- ************************************************************************

procedure htm is

begin

   htp.print('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">');
   htp.htmlOpen;
   htp.headOpen;
   htp.meta('Author', null, 'Matt Arena - Fermi National Accelerator Laboratory');
   htp.title(common.conf_title$);
   htp.headClose;

   htp.print('<frameset cols="35%,*">');
   htp.print('<frame name="index" target="content" src="toc.left_frame">');
   htp.print('<frame name="content" src="toc.right_frame?p_session_id=" scrolling="auto">');
   htp.print('<noframes>');
   htp.print('<body>');

   htp.print('<p>This page uses frames, but your browser doesn''t support them.</p>');

   htp.print('</body>');
   htp.print('</noframes>');
   htp.print('</frameset>');

   htp.br;
   htp.bodyClose;
   htp.htmlClose;

end htm;

-- ************************************************************************

procedure left_frame is

cursor	c_sessions is
select	SESSION_ID, TITLE, SESSION_DATE, SORT_ORDER
from	SESSIONS
order by sort_order, session_date, beg_time;

begin

   common.public_header ('');
     
   htp.print('<table border="0" cellpadding="0" cellspacing="0" width="100%">');
   htp.print('<tr>');
   htp.print('<td align="center"><b><font face="Arial" size="3" color="#666699">Session&nbsp;Id</font></b></td>');
   htp.print('<td align="center">&nbsp;</td>');
   htp.print('<td align="center"><b><font face="Arial" size="3" color="#666699">Title</font></b></td>');
   htp.print('</tr>');
   htp.print('<tr>');
   htp.print('<td colspan="3" align="center"><hr></td>');
   htp.print('</tr>');
     
   for r_session in c_sessions loop
      htp.print('<tr>');
      htp.print('<td><font face="Arial" size="2" color="#0066CC"><a target="content" href="toc.right_frame?p_session_id='||r_session.SESSION_ID||'">'||r_session.SESSION_ID||'</a></font></td>');
      htp.print('<td>&nbsp;</td>');
      htp.print('<td><font face="Arial" size="1" color="#0066CC">'||r_session.TITLE||'</font></td>');
      htp.print('</tr>');
   end loop;
   htp.print('</table>');

   htp.br;
   htp.bodyClose;
   htp.htmlClose;     

end left_frame;

-- ************************************************************************

procedure right_frame (p_session_id in varchar2) is
	
cursor	c_sessions (c_session_id varchar2) is
select	SESSION_ID, TITLE, to_char(SESSION_DATE,'DD MONTH YYYY') SESSION_DATE,  SORT_ORDER
from	SESSIONS
where session_id = c_session_id
order by sort_order, session_date, beg_time;
	 
r_session c_sessions%rowtype;
	 
cursor	c_abstracts (c_session_id varchar2) is
select	a.ABSTRACT_ID, common.get_author_list2(a.ABSTRACT_ID) authors,
	a.PERSON_ID, a.TITLE, a.DESCRIPTION, sa.SESSION_ID, sa.SESSION_SEQ, sa.PAPER_ID
from	abstract_sessions	sa,
	ABSTRACTS		a
where	common.paper_OK_to_publish(a.ABSTRACT_ID)	='Yes'
and	sa.abstract_id		= a.abstract_id
and	sa.session_id		= c_session_id
order by sa.session_seq;

begin
	
   htp.print('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">');
   htp.htmlOpen;
   htp.headOpen;
   htp.meta('Author', null, 'Matt Arena - Fermi National Accelerator Laboratory');
   htp.headClose;
    
   If p_session_id is not null Then
      htp.print('<table border="0" cellpadding="0" cellspacing="0" width="100%">');
      open c_sessions (p_session_id);
      fetch c_sessions into r_session;
    
      If c_sessions%found Then
         htp.print('<tr>');
         htp.print('<td colspan="3"><b><font face="Arial" size="3" color="#666699">Session&nbsp;:&nbsp;'||r_session.session_id||' - '||r_session.SESSION_DATE||'</font></b></td>');
         htp.print('</tr>');
         htp.print('<tr>');
         htp.print('<td colspan="3"><b><font face="Arial" size="3" color="#666699">'||r_session.TITLE||'</font></b></td>');
         htp.print('</tr>');
         htp.print('</tr>');
         htp.print('<tr>');
         htp.print('<td colspan="3"><hr></td>');
         htp.print('</tr>');
      end if;
      close c_sessions;

      
      for r_abstract in c_abstracts (p_session_id) loop
         htp.print('<tr>');
         htp.print('<td><b><font face="Arial" size="3" color="#0066CC">'||r_abstract.TITLE||'</font></b></td>');
         htp.print('<td>&nbsp;</td>');
         htp.print('<td><b><font face="Arial" size="2" color="#0066CC"><a target="_blank" href="'||common.proceedings_base_URL$||r_abstract.PAPER_ID||'.PDF'||'">'||r_abstract.PAPER_ID||'.PDF</a></font></b></td>');
         htp.print('</tr>');
         htp.print('<tr>');
         htp.print('<td colspan="3"><i><font face="Arial" size="2">'||r_abstract.authors||'</font></i></td>');
         htp.print('</tr>');
         htp.print('<tr>');
         htp.print('<td colspan="3">&nbsp;</td>');
         htp.print('</tr>');
      end loop;

      htp.print('</table>');
   else
      htp.print('<p><center><font face="Arial" size="4" color="#0066CC">Click on a session id on the left frame...</font></center></p>');    
   end if;
    
   htp.br;
   htp.bodyClose;
   htp.htmlClose;     
   
end right_frame;

-- ************************************************************************

end TOC;
/

show error

set define on

--	Copyright (C) 2004 Joint Accelerator Conference Web Site
--	<http://www.jacow.org> by Matthew Arena, Fermilab
--
--   This program is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--   You can also get a copy of the license through the web at
--   <http://www.gnu.org/licenses/gpl.html>

-- ****************************************************************************************
